<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\FormField;

class JFormFieldFwAddons extends FormField {
	var	$type = 'fwaddons';

	function getInput() {
		$params = ComponentHelper::getParams('com_fwgallery');
		if (!$params->get('show_addons_menu_settings')) {
			return Text::_('FWMG_ALL_ENABLED_ADDONS_ARE_ENABLED');
		}
		if (!defined('FWMG_COMPONENT_SITE')) {
			define('FWMG_COMPONENT_SITE', JPATH_SITE.'/components/com_fwgallery');
		}
		$path = FWMG_COMPONENT_SITE.'/helpers/helper.php';
		if (!file_exists($path)) return;
		Factory::getLanguage()->load('com_fwgallery');
		require_once($path);
		fwgHelper::loadAdminStyles();

		if (!is_array($this->value)) {
			$this->value = array();
		}

		$itemid = Factory::getApplication()->input->getInt('id');
		ob_start();
		if ($list = fwgHelper::loadPlugins() and !empty($list['fwgallery'])) {
			$name = str_replace(array('[', ']'), array('_', ''), $this->name);
			$lang = Factory::getLanguage();
			foreach ($list['fwgallery'] as $row) {
				$lang->load('plg_'.$row->folder.'_'.$row->element.'.sys', JPATH_ADMINISTRATOR);
				$id = $name.$row->element;
				if (!isset($this->value[$row->element])) {
					$this->value[$row->element] = empty($itemid)?1:0;
				}
?>
<div class="control-group">
	<div class="control-label">
		<?php echo Text::_('PLG_FWGALLERY_'.$row->element); ?>
	</div>
	<div class="controls">
		<fieldset id="jform_<?php echo esc_attr($id); ?>" class="fwk-button-group radio radio-yn">
			<label for="jform_<?php echo esc_attr($id); ?>0" class="fwk-button<?php if (empty($this->value[$row->element])) { ?> active fwk-button-danger<?php } ?>">
				<input style="display:none;" type="radio" id="jform_<?php echo esc_attr($id); ?>0" name="<?php echo esc_attr($this->name); ?>[<?php echo esc_attr($row->element); ?>]" value="0"<?php if (empty($this->value[$row->element])) { ?> checked="checked"<?php } ?>>
				<?php echo Text::_('JNO'); ?>
			</label>
			<label for="jform_<?php echo esc_attr($id); ?>1" class="fwk-button<?php if (!empty($this->value[$row->element])) { ?> active fwk-button-success<?php } ?>">
				<input style="display:none;" type="radio" id="jform_<?php echo esc_attr($id); ?>1" name="<?php echo esc_attr($this->name); ?>[<?php echo esc_attr($row->element); ?>]" value="1"<?php if (!empty($this->value[$row->element])) { ?> checked="checked"<?php } ?>>
				<?php echo Text::_('JYES'); ?>
			</label>
		</fieldset>
	</div>
</div>
<?php
			}
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		$('#fieldset-basic .column-count-lg-3').removeClass('column-count-md-2 column-count-lg-3');

		$('fieldset.radio label').click(function() {
			var $btn = $(this);
			var $wrp = $btn.closest('.radio');
			if ($wrp.hasClass('radio-yn')) {
				var $inp = $btn.find('input');
				if ($inp.val() == 0) {
					$wrp.find('label.active').removeClass('active fwk-button-success');
					$btn.addClass('active fwk-button-danger');
				} else {
					$wrp.find('label.active').removeClass('active fwk-button-danger');
					$btn.addClass('active fwk-button-success');
				}
			} else {
				$wrp.find('label.active').removeClass('active fwk-button-success');
				$btn.addClass('active fwk-button-success');
			}
		});
    })(jQuery);
});
</script>
<?php
		}
		return ob_get_clean();
	}
}
