<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\FormField;

class JFormFieldFWGCategoryLayout extends FormField {
    var $type = 'fwgcategorylayout';

    function getInput() {
        if (!defined('FWMG_COMPONENT_SITE')) {
            define('FWMG_COMPONENT_SITE', JPATH_SITE.'/components/com_fwgallery');
        }
        $path = FWMG_COMPONENT_SITE.'/helpers/helper.php';
        if (!file_exists($path)) return;
        require_once($path);
        Factory::getLanguage()->load('com_fwgallery');

        $layouts = array(
            HTMLHelper::_('select.option', 'list', Text::_('DEFAULT'), 'id', 'name'),
            HTMLHelper::_('select.option', 'flat', Text::_('FLAT'), 'id', 'name')
        );
        Factory::getApplication()->triggerEvent('ongetCategoryLayouts', array('com_fwgallery', &$layouts));

        $name = str_replace(array('[', ']'), array('_', ''), $this->name);
        $is_module_params = (Factory::getApplication()->input->getString('option')=='com_modules');
        $lang_source = $is_module_params?'MODLAYOUT':'LAYOUTCATEGORY';

        ob_start();
?>
        <fieldset id="jform_<?php echo esc_attr($name); ?>" class="fwk-button-group radio">
<?php
            foreach ($layouts as $i=>$layout) {
                $id = $name.$layout->id;
                $active = ($this->value == $layout->id or (!$this->value and !$i));
?>
            <label for="jform_<?php echo esc_attr($id); ?>" class="fwk-button<?php if ($active) { ?> active fwk-button-success<?php } ?>"
            fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_'.$lang_source.'_LAYOUT_'.$layout->name.'_HINT')); ?>">
                <input style="display:none;" type="radio" id="jform_<?php echo esc_attr($id); ?>" name="<?php echo esc_attr($this->name); ?>" value="<?php echo esc_attr($layout->id); ?>"<?php if ($active) { ?> checked="checked"<?php } ?>>
<?php
                /** this is the text output from the language file - no escape check required, there is no user input here */
                echo Text::_('FWMG_DOC_ADMIN_'.$lang_source.'_LAYOUT_'.$layout->name);
?>
            </label>
<?php
            }
?>
        </fieldset>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
        var $wrp = $('#jform_<?php echo esc_js($name); ?>').closest('.column-count-lg-3');
        if ($wrp.length) {
            $wrp.removeClass('column-count-md-2 column-count-lg-3');
        }

        $('#jform_<?php echo esc_js($name); ?> label').click(function() {
            var $btn = $(this);
            $btn.closest('.radio').find('label.active').removeClass('active fwk-button-success');
            $btn.addClass('active fwk-button-success');
        });

        $('#jform_<?php echo esc_js($name); ?> input').change(function() {
            var $input = $(this);
            var $wrp = $input.closest('form');
            $wrp.find('.fwmg-layout').hide();
            $wrp.find('.fwmg-layout-'+$input.val()).show();
        });
         $('#jform_<?php echo esc_attr($name); ?> input:checked').change();
    })(jQuery);
});
</script>
<?php
        return ob_get_clean();
	}
}
