<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;

class JHTMLfwView {
	static function orderingListLinks($params) {
		$user = Factory::getUser();
		$app = Factory::getApplication();
		ob_start();
?>
<div class="fwk-flex-inline fwk-text-middle fwk-table-order">
<?php
		if ($app->isClient('site') or ($app->isClient('administrator') and $user->authorise('core.edit', 'com_fwgallery'))) {
			if (!empty($params['display_up'])) {
?>
	<a href="javascript:" onclick="return Joomla.listItemTask('cb<?php echo esc_js($params['num']); ?>','orderup')" class="fwk-button fwk-button-small"><span class="fwk-margin-small-top" fwk-icon="icon: chevron-left"></span></a>
<?php
		} else {
?>
	<div class="fwk-button fwk-button-small">&nbsp;</div>
<?php
			}
?>
	<input class="fwk-input fwk-text-center fwk-padding-remove-horizontal" placeholder="0" type="text" name="order[]" value="<?php echo esc_attr($params['value']); ?>">
<?php
		if (!empty($params['display_down'])) {
?>
	<a href="javascript:" onclick="return Joomla.listItemTask('cb<?php echo esc_js($params['num']); ?>','orderdown')" class="fwk-button fwk-button-small"><span class="fwk-margin-small-top" fwk-icon="icon: chevron-right"></span></a>
<?php
		} else {
?>
	<div class="fwk-button fwk-button-small">&nbsp;</div>
<?php
			}
		}
?>
</div>
<?php
		return ob_get_clean();
	}
	static function radioListLinks($params) {
		ob_start();
?>
<div class="fwk-button-group<?php if (!empty($params['wrapper_class'])) { ?> <?php echo esc_attr($params['wrapper_class']); } ?>" role="group">
<?php
		$row = $params['row'];
		foreach ($params['buttons'] as $button) {
			$key = $button['name'];
			$is_checked = $row->$key;
			$classes = array('fwk-button fwk-button-small');
			if ($is_checked) {
				$classes[] = 'active';
				if (!empty($button['active_class'])) $classes[] = $button['active_class'];
			}
?>
	<a href="javascript:" onclick="return Joomla.listItemTask('cb<?php echo esc_js($params['num']); ?>','<?php echo esc_attr($is_checked?$button['task_off']:$button['task_on']); ?>')" class="<?php echo esc_attr(implode(' ', $classes)); ?>" title="<?php echo esc_attr(Text::_($is_checked?$button['title_off']:$button['title_on'])); ?>"><i class="<?php echo esc_attr($button['icon_class']); ?>"></i></a>
<?php
		}
?>
</div>
<?php
		return ob_get_clean();
	}
	static function booleanListLink($params) {
		$user = Factory::getUser();
		$app = Factory::getApplication();
		if (empty($params['icon_on'])) {
			$params['icon_on'] = 'publish';
		}
		if (empty($params['icon_off'])) {
			$params['icon_off'] = 'close';
		}
		ob_start();
		if ($app->isClient('site') or ($app->isClient('administrator') and $user->authorise('core.edit', 'com_fwgallery'))) {
?>
<a href="javascript:" class="fwk-icon-button fwk-button-link fwk-button-small fwk-text-<?php echo esc_attr($params['value']?$params['class_on']:$params['class_off']); ?>" onclick="return Joomla.listItemTask('cb<?php echo esc_js($params['num']); ?>','<?php echo esc_js($params['value']?$params['task_off']:$params['task_on']); ?>')" title="<?php echo esc_attr(Text::_($params['value']?$params['title_off']:$params['title_on'])); ?>" fwk-icon="<?php echo esc_attr($params[$params['value']?'icon_on':'icon_off']); ?>"></a>
<?php
		} else {
?>
<span class="fwk-text-<?php echo esc_attr($params['value']?$params['class_on']:$params['class_off']); ?>" fwk-icon="<?php echo esc_attr($params[$params['value']?'icon_on':'icon_off']); ?>"></span>
<?php
		}
		return ob_get_clean();
	}
	static function menuItem($params) {
		ob_start();
?>
<div class="fwa-menu-item<?php if (!empty($params['active'])) { ?> active<?php } ?>">
	<a class="fwk-button <?php if (!empty($params['active'])) { ?> fwk-button-active<?php } ?>" href="<?php echo esc_attr($params['link']); ?>" title="<?php echo esc_attr($params['name']); ?>" fwk-tooltip>
		<i fwk-icon="icon:<?php echo esc_attr($params['icon_class']); ?>"></i>
	</a>
</div>
<?php
		return ob_get_clean();
	}
	static function radioGroup($name, $value, $params) {
		ob_start();
		$classes = array('fwk-button-group');
		if (!empty($params['wrapper_class'])) {
			$classes[] = $params['wrapper_class'];
		}
?>
<div class="<?php echo esc_attr(implode(' ', $classes)); ?>" role="group">
<?php
		foreach ($params['buttons'] as $button) {
			if (!isset($button['active_class'])) $button['active_class'] = '';
			$classes = array('fwk-button');
			if (!empty($button['class'])) {
				$classes[] = $button['class'];
			}
			if ($value == $button['value']) {
				$classes[] = 'active';
				if ($button['active_class']) {
					$classes[] = $button['active_class'];
				}
			}
?>
	<button type="button" class="<?php echo esc_attr(implode(' ', $classes)); ?>" data-value="<?php echo esc_attr($button['value']); ?>" data-active-class="<?php echo esc_attr($button['active_class']); ?>"><?php if (!empty($button['icon_class'])) { ?><i class="<?php echo esc_attr($button['icon_class']); ?>"></i><?php } if (!empty($button['title'])) { echo esc_html($button['title']); } ?></button>
<?php
		}
?>
</div>
<input type="hidden" name="<?php echo esc_attr($name); ?>" value="<?php echo esc_attr($value); ?>" />
<?php
		if (!defined('FW_RADIO_HANDLER_LOADED')) {
			define('FW_RADIO_HANDLER_LOADED', 1);
			HTMLHelper::_('jquery.framework');
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		$('.fwk-button-group button').click(function() {
			var $button = $(this);
			var $wrapper = $button.closest('.fwk-button-group');
			var $input = $wrapper.next();
			if ($input.length && $input.val() != $button.data('value')) {
				$wrapper.find('button').each(function() {
					var $btn = $(this);
					var active_class = $btn.data('active-class');
					if ($button[0] == $btn[0]) {
						$btn.addClass('active');
						if (active_class) {
							$btn.addClass(active_class);
						}
					} else {
						if ($btn.hasClass('active')) {
							$btn.removeClass('active');
						}
						if (active_class && $btn.hasClass(active_class)) {
							$btn.removeClass(active_class);
						}
					}
				});
				$input.val($button.data('value')).change();
			}
		});
    })(jQuery);
});
</script>
<?php
		}
		return ob_get_clean();
	}
	static function handleUploadButton($params) {
		ob_start();
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
<?php
		if (!defined('FWVIEW_UPLOAD_HANDLER_LOADED')) {
			define('FWVIEW_UPLOAD_HANDLER_LOADED', true);
?>
	$(document).on('change', '.fwcss input[type="file"]', function() {
		var $inp = $(this);
		var files = $inp.prop('files');
		if (files && files.length) {
			var buff = [];
			for (var i = 0; i < files.length; i++) {
				var file = files[i];
				if ('name' in file) {
					buff.push(file.name);
				} else {
					buff.push(file.fileName);
				}
			}
			$inp.next().val(buff.join(',')).addClass('fwk-file-selected');
		} else {
			$inp.next().val('').removeClass('fwk-file-selected');
		}
	});
	$('.fwcss input[type="file"]').change();
<?php
		}
?>
	$(document).on('click', '<?php echo esc_js($params['button']); ?>', function() {
		var form = this.form;
		var $button = $(this);
		var $input = $('<?php echo esc_js($params['input']); ?>');
		var filename = $input.val();
		if (filename != '') {
			var exts = [<?php if (!empty($params['exts'])) { foreach ($params['exts'] as $i=>$ext) { if ($i) { ?>,<?php } ?>'<?php echo esc_js($ext); ?>'<?php } } ?>];
			if (exts) {
				var ext = filename.split('.').pop().toLowerCase();
				var ext_found = false;
				for (var i = 0; i < exts.length; i++) {
					if (exts[i] == ext) {
						ext_found = true;
						break;
					}
				}
				if (!ext_found) {
					fwmg_alert('<?php echo esc_js(Text::sprintf('FWMG_EXTENSIONS_ALLOWED', implode(", ", $params['exts']))); ?>');
					return;
				}
			}
<?php
		if (!empty($params['submit_code'])) echo fwgHelper::escPluginsOutput($params['submit_code']);
?>
			var formdata = new FormData(form);
			<?php if (!empty($params['view'])) { ?>formdata.append('view', '<?php echo esc_js($params['view']); ?>');<?php } ?>
			formdata.append('layout', '<?php echo esc_js($params['layout']); ?>');
			formdata.append('format', 'json');
			formdata.append('task', '');
<?php
		if (!empty($params['post_data'])) {
			foreach ($params['post_data'] as $key=>$val) {
?>
			formdata.append('<?php echo $key ?>', '<?php echo $val; ?>');
<?php
			}
		}
		if (!empty($params['submit_code'])) echo fwgHelper::escPluginsOutput($params['submit_code']);
?>

			var $progress_bar = $('<progress class="fwk-progress" value="0" max="100"></progress>');
			$button.attr('disabled', true).after($progress_bar);

			$.ajax({
				xhr: function() {
					var xhr = new window.XMLHttpRequest();

					xhr.upload.addEventListener("progress", function(evt) {
						if (evt.lengthComputable) {
							var percentComplete = evt.loaded / evt.total;
							percentComplete = parseInt(percentComplete * 100);
							$progress_bar[0].value = percentComplete;
						}
					}, false);

					return xhr;
				},
				url: <?php if (empty($params['url'])) { ?>form.action<?php } else { ?>'<?php echo addcslashes($params['url'], "'"); ?>'<?php } ?>,
				type: "POST",
				data: formdata,
				dataType: 'json',
				contentType: false,
				processData: false,
				error: function(xhr, err) {
					$progress_bar.remove();
					$button.attr('disabled', false);
					fwmg_alert(err);
				},
				success: <?php if (empty($params['callback'])) { ?>function(result) {
					$progress_bar.remove();
					$button.attr('disabled', false);

					var $parent = $input.parent();
					$input.next().html('<?php echo Text::_('FWMG_CHOOSE_FILE', true); ?>');

					var input_html = $parent.html();
					$parent.html(input_html);

					var data;
					if (typeof result == 'object') {
						data = result;
					} else {
						data = $.parseJSON(result);
					}

					if (data) {
						if (data && data.data && data.data[0]) {
							data = data.data[0];
						}
						if (data.id) {
							$('input[name="oid"]').val(data.id);
						}
						if (data.image) {
							$('<?php echo esc_js($params['image']); ?>').attr('src', data.image);
<?php
		if (!empty($params['remove_button'])) {
?>
							$('<?php echo esc_js($params['remove_button']); ?>').attr('hidden', false);
<?php
		}
?>
						}
<?php
		if (!empty($params['response_code'])) echo fwgHelper::escPluginsOutput($params['response_code']);
?>
						if (data.msg) {
							fwmg_alert(data.msg);
						}
						if (data.msgs) {
							for (var i = 0; i < data.msgs.length; i++) {
								fwmg_alert(data.msgs[i].msg);
							}
						}
					}
				}
<?php
				} else echo fwgHelper::escPluginsOutput($params['callback']);
?>
			});
		}
	});
    })(jQuery);
});
</script>
<?php
		return ob_get_clean();
	}
	static function handleRemoveButton($params) {
		$id = empty($params['id_field'])?'oid':$params['id_field'];
		ob_start();
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$(document).on('click', '<?php echo esc_js($params['button']); ?>', function() {
		var form = this.form;
		var $button = $(this);

		$img = $('<div fwk-spinner></div>');
		$button.attr('disabled', true).after($img);
		$.ajax({
			url: <?php if (empty($params['url'])) { ?>form.action<?php } else { ?>'<?php echo esc_js($params['url']); ?>'<?php } ?>,
			type: 'post',
			dataType: 'json',
			data: {
				format: 'json',
				id: form.<?php echo esc_js($id); ?>.value,
				button_id: $button.data('id'),
<?php
		if (!empty($params['post_data'])) {
			foreach ($params['post_data'] as $key=>$val) {
?>
				<?php echo $key ?>: '<?php echo $val; ?>',
<?php
			}
		}

?>
				<?php if (!empty($params['view'])) { ?>view: '<?php echo esc_js($params['view']); ?>',<?php } ?>
				layout: '<?php echo esc_js($params['layout']); ?>'
			},
			success: <?php if (empty($params['callback'])) { ?>function(result) {
				$img.remove();
				$button.attr('disabled', false);
				var data;
				if (typeof result == 'object') {
					data = result;
				} else {
					data = $.parseJSON(result);
				}
				if (data && data.data && data.data[0]) {
					data = data.data[0];
				}
				if (data) {
					$button.attr('hidden', true);
					if (data.image) {
						$('<?php echo esc_js($params['image']); ?>').attr('src', data.image);
					}
					if (data.msg) {
						fwmg_alert(data.msg);
					}
				}
			}
<?php
			} else echo fwgHelper::escPluginsOutput($params['callback']);
?>
		});
	});
	})(jQuery);
});
</script>
<?php
		return ob_get_clean();
	}
}
