<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\Registry\Registry;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Version;

class com_fwgalleryInstallerScript {
	function postflight($type, $adaptor) {
		if (!defined('FWMG_COMPONENT_SITE')) {
			define('FWMG_COMPONENT_SITE', JPATH_SITE.'/components/com_fwgallery');
		}
		$db = Factory::getDBO();
		$tables = $db->getTableList();
		if (in_array($db->getPrefix().'fwsg_category', $tables)) {
			$db->setQuery('SHOW FIELDS FROM `#__fwsg_category`');
			$fields = $db->loadColumn();
			if (!in_array('is_public', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwsg_category` ADD COLUMN is_public TINYINT(3) UNSIGNED NOT NULL DEFAULT 0');
				$db->execute();
			}
		} else {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_category` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`published` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`is_public` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`parent` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`ordering` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`access` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`created` DATETIME NULL DEFAULT NULL,
	`updated` DATETIME NULL DEFAULT NULL,
	`user_id` INT(10) UNSIGNED NOT NULL,
	`name` VARCHAR(200) NOT NULL,
	`sys_filename` VARCHAR(40) NULL DEFAULT NULL,
	`filename` VARCHAR(200) NULL DEFAULT NULL,
	`metadescr` VARCHAR(200) NULL DEFAULT NULL,
	`metakey` VARCHAR(200) NULL DEFAULT NULL,
	`descr` TEXT NULL,
	`params` TEXT NULL,
	`alias` VARCHAR(200) NULL DEFAULT NULL,
	`hits` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`media` VARCHAR(20) NULL DEFAULT NULL,
	`media_code` VARCHAR(200) NULL DEFAULT NULL,
	`latitude` FLOAT NOT NULL DEFAULT '0',
	`longitude` FLOAT NOT NULL DEFAULT '0',
	PRIMARY KEY (`id`),
	INDEX `published` (`published`),
	INDEX `ordering` (`ordering`),
	INDEX `parent` (`parent`),
	INDEX `access` (`access`),
	INDEX `updated` (`updated`),
	INDEX `name` (`name`)
)");
			$db->execute();
		}
		if (!in_array($db->getPrefix().'fwsg_category_tag', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_category_tag` (
	`category_id` INT(10) UNSIGNED NOT NULL,
	`tag_id` INT(10) UNSIGNED NOT NULL,
	INDEX `category_id` (`category_id`),
	INDEX `tag_id` (`tag_id`)
)");
			$db->execute();
		}
		if (in_array($db->getPrefix().'fwsg_file', $tables)) {
			$db->setQuery('ALTER TABLE `#__fwsg_file` CHANGE COLUMN `copyright` `copyright` VARCHAR(200) NULL DEFAULT NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file` CHANGE COLUMN `metadescr` `metadescr` VARCHAR(200) NULL DEFAULT NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file` CHANGE COLUMN `metakey` `metakey` VARCHAR(200) NULL DEFAULT NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file` CHANGE COLUMN `name` `name` VARCHAR(200) NULL DEFAULT NULL');
			$db->execute();

			$db->setQuery('SHOW FIELDS FROM `#__fwsg_file`');
			$fields = $db->loadColumn();
			if (!in_array('featured', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwsg_file` ADD COLUMN featured TINYINT(3) UNSIGNED NOT NULL DEFAULT 0, ADD INDEX `featured` (`featured`)');
				$db->execute();
			}
		} else {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`type` ENUM('image','video','audio','file') NOT NULL DEFAULT 'image',
	`published` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`featured` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`ordering` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`access` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`created` DATETIME NULL DEFAULT NULL,
	`updated` DATETIME NULL DEFAULT NULL,
	`category_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`user_id` INT(10) UNSIGNED NOT NULL,
	`hits` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`downloads` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`name` VARCHAR(200) NOT NULL,
	`copyright` VARCHAR(200) NULL,
	`metadescr` VARCHAR(200) NULL,
	`metakey` VARCHAR(200) NULL,
	`descr` TEXT NULL,
	`params` TEXT NULL,
	`alias` VARCHAR(200) NULL DEFAULT NULL,
	PRIMARY KEY (`id`),
	INDEX `type` (`type`),
	INDEX `published` (`published`),
	INDEX `ordering` (`ordering`),
	INDEX `access` (`access`),
	INDEX `updated` (`updated`),
	INDEX `name` (`name`)
)");
			$db->execute();
		}
		if (!in_array($db->getPrefix().'fwsg_file_file', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_file` (
	`file_id` int unsigned not null,
	`sys_filename` varchar(50) null,
	`filename` varchar(200) null,
	`size` int unsigned,
	primary key (`file_id`)
)");
			$db->execute();
		} else {
			$db->setQuery('ALTER TABLE `#__fwsg_file_file` CHANGE COLUMN `filename` `filename` VARCHAR(200) NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file_file` CHANGE COLUMN `sys_filename` `sys_filename` VARCHAR(50) NULL');
			$db->execute();
		}
		if (!in_array($db->getPrefix().'fwsg_file_image', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_image` (
	`file_id` int unsigned not null,
	`sys_filename` varchar(50) null,
	`filename` varchar(200) null,
	`alt` varchar(200),
	`width` int unsigned,
	`height` int unsigned,
	`size` int unsigned,
	primary key (`file_id`),
	index (`filename`)
)");
			$db->execute();
		} else {
			$db->setQuery('ALTER TABLE `#__fwsg_file_image` CHANGE COLUMN `filename` `filename` VARCHAR(200) NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file_image` CHANGE COLUMN `sys_filename` `sys_filename` VARCHAR(50) NULL');
			$db->execute();
			$db->setQuery('SHOW INDEX FROM `#__fwsg_file_image` WHERE Key_name = \'filename\'');
			if (!$db->loadResult()) {
				$db->setQuery('ALTER TABLE `#__fwsg_file_image` ADD INDEX `filename` (`filename`)');
				$db->execute();
			}
		}
		if (in_array($db->getPrefix().'fwsg_file_location', $tables)) {
			$db->setQuery('ALTER TABLE `#__fwsg_file_location` CHANGE COLUMN `address` `address` VARCHAR(200) NULL DEFAULT NULL');
			$db->execute();
		} else {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_location` (
	`file_id` INT(10) UNSIGNED NOT NULL,
	`address` VARCHAR(200) NULL DEFAULT NULL,
	`latitude` double,
	`longitude` double,
	PRIMARY KEY (`file_id`)
)");
			$db->execute();
		}
		if (!in_array($db->getPrefix().'fwsg_file_tag', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_tag` (
	`file_id` int unsigned not null,
	`tag_id` int unsigned not null,
	key(`file_id`),
	key(tag_id)
)");
			$db->execute();
		}
		if (!in_array($db->getPrefix().'fwsg_file_video', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_video` (
	`file_id` INT(10) UNSIGNED NOT NULL,
	`sys_filename` VARCHAR(50) NULL,
	`filename` VARCHAR(200) NULL,
	`media` ENUM('youtube','vimeo','mp4') NULL DEFAULT NULL,
	`code` VARCHAR(200) NULL DEFAULT NULL,
	`size` INT(10) UNSIGNED NULL DEFAULT NULL,
	`width` int unsigned,
	`height` int unsigned,
	`duration` TIME,
	PRIMARY KEY (`file_id`)
)");
			$db->execute();
		} else {
			$db->setQuery('ALTER TABLE `#__fwsg_file_video` CHANGE COLUMN `filename` `filename` VARCHAR(200) NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file_video` CHANGE COLUMN `sys_filename` `sys_filename` VARCHAR(50) NULL');
			$db->execute();
			$db->setQuery('SHOW FIELDS FROM `#__fwsg_file_video`');
			$fields = $db->loadColumn();
			if (!in_array('width', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwsg_file_video` ADD COLUMN width INT UNSIGNED');
				$db->execute();
			}
			if (!in_array('height', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwsg_file_video` ADD COLUMN height INT UNSIGNED');
				$db->execute();
			}
			if (!in_array('duration', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwsg_file_video` ADD COLUMN duration TIME');
				$db->execute();
			}
		}
		if (!in_array($db->getPrefix().'fwsg_file_audio', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_audio` (
	`file_id` INT(10) UNSIGNED NOT NULL,
	`sys_filename` VARCHAR(50) NULL,
	`filename` VARCHAR(200) NULL,
	`size` INT(10) UNSIGNED NULL DEFAULT NULL,
	`duration` TIME,
	PRIMARY KEY (`file_id`)
)");
			$db->execute();
		} else {
			$db->setQuery('ALTER TABLE `#__fwsg_file_audio` CHANGE COLUMN `filename` `filename` VARCHAR(200) NULL');
			$db->execute();
			$db->setQuery('ALTER TABLE `#__fwsg_file_audio` CHANGE COLUMN `sys_filename` `sys_filename` VARCHAR(50) NULL');
			$db->execute();
			$db->setQuery('SHOW FIELDS FROM `#__fwsg_file_audio`');
			$fields = $db->loadColumn();
			if (!in_array('duration', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwsg_file_audio` ADD COLUMN duration TIME');
				$db->execute();
			}
		}
		if (!in_array($db->getPrefix().'fwsg_file_vote', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_file_vote` (
	`user_id` INT(10) UNSIGNED NOT NULL,
	`file_id` INT(10) UNSIGNED NOT NULL,
	`value` TINYINT(4) NOT NULL DEFAULT '0',
	`ipaddr` BIGINT(20) NULL DEFAULT NULL,
	KEY(`user_id`),
	KEY(`file_id`),
	KEY(`ipaddr`),
	KEY(`value`)
)");
			$db->execute();
		}
		if (!in_array($db->getPrefix().'fwsg_tag', $tables)) {
			$db->setQuery("
CREATE TABLE IF NOT EXISTS `#__fwsg_tag` (
	`id` int unsigned not null auto_increment,
	`published` tinyint unsigned not null default 0,
	`ordering` int unsigned not null default 0,
	`created` datetime,
	`user_id` int unsigned not null,
	`name` varchar(200) NOT NULL,
	`alias` varchar(200),
	`hits` int unsigned not null default 0,
	primary key (id),
	key(published),
	key(ordering),
	key(name)
)");
			$db->execute();
		}

		$db->setQuery('SELECT extension_id FROM `#__extensions` WHERE `element` = \'com_fwgallery\'');
		$extension_id = (int)$db->loadResult();

		$db->setQuery("SELECT * FROM `#__menu` WHERE `client_id` = 0 AND (`link` = 'index.php?option=com_fwgallery&view=gallery' OR `link` = 'index.php?option=com_fwgallery&view=galleries' OR `link` = 'index.php?option=com_fwgallerylight&view=gallery' OR `link` = 'index.php?option=com_fwgallerylight&view=galleries')");
		if ($list = $db->loadObjectList()) {
			foreach ($list as $row) {
				$params = new Registry($row->params);
				if ($id = $params->get('id')) {
					$params->set('gid', $id);
				}
				$db->setQuery("UPDATE `#__menu` SET link = 'index.php?option=com_fwgallery&view=fwgallery', params = ".$db->quote($params->toString()).", component_id = $extension_id WHERE id = ".$row->id);
				$db->execute();
			}
		}
		$db->setQuery("SELECT * FROM `#__menu` WHERE `client_id` = 0 AND (`link` = 'index.php?option=com_fwgallery&view=image' OR `link` = 'index.php?option=com_fwgallerylight&view=image')");
		if ($list = $db->loadObjectList()) {
			foreach ($list as $row) {
				$params = new Registry($row->params);
				if ($id = $params->get('id')) {
					$params->set('file_id', $id);
				}
				$db->setQuery("UPDATE `#__menu` SET link = 'index.php?option=com_fwgallery&view=item', params = ".$db->quote($params->toString()).", component_id = $extension_id WHERE id = ".$row->id);
				$db->execute();
			}
		}

		$now = Factory::getDate()->toSql();
		$db->setQuery('UPDATE `#__fwsg_category` SET created = '.$db->quote($now).' WHERE created = \'0000-00-00 00:00:00\'');
		$db->execute();
		$db->setQuery('UPDATE `#__fwsg_file` SET created = '.$db->quote($now).' WHERE created = \'0000-00-00 00:00:00\'');
		$db->execute();

		$params = ComponentHelper::getParams('com_fwgallery');
		$host_encoded = urlencode(Uri::root(false));
		if ($params) {
			if (class_exists('Joomla\CMS\Version')) {
				if ($update_code = $params->get('verified_code')) {
					$db->setQuery('UPDATE `#__update_sites` SET extra_query = '.$db->quote('code='.urlencode(trim($update_code)).'&host='.$host_encoded).', last_check_timestamp = 0 WHERE name LIKE \'FW Gallery%\'');
					$db->execute();
				}
				/* replacing dlid suffix with correct string */
				$filename = JPATH_ADMINISTRATOR.'/components/com_fwgallery/fwgallery.xml';
				if (file_exists($filename)) {
					$buff = file_get_contents($filename);
					if (preg_match('#<dlid.+suffix="([^"]+)"#', $buff, $match)) {
						$buff = str_replace($match[1], '&amp;host='.$host_encoded, $buff);
						file_put_contents($filename, $buff);
					}
				}
			}
			if ($params->get('extensions_data_time')) {
				$params->set('extensions_data_time', '');
				$db->setQuery('UPDATE `#__extensions` SET params = '.$db->quote($params->toString()).' WHERE `element` = \'com_fwgallery\' AND `type` = \'component\'');
		    	$db->execute();
			}
		}

		/* removing unneeded files and folders */
		$obsolete_files = array(
			'components/com_fwgallery/models/frontendmanager.php',
			'components/com_fwgallery/models/galleries.php',
			'components/com_fwgallery/models/gallery.php',
			'components/com_fwgallery/models/image.php',
			'components/com_fwgallery/models/tags.php',
			'components/com_fwgallery/models/tag.php',
			'components/com_fwgallery/assets/css/fwmg-design-styles.css',
			'components/com_fwgallery/assets/css/uikit.min.css',
			'components/com_fwgallery/assets/css/uikit-rtl.min.css',
			'components/com_fwgallery/assets/js/uikit-icons.min.js',
			'components/com_fwgallery/assets/js/uikit.min.js',
			'administrator/components/com_fwgallery/views/addon/tmpl/default_pagination.php',
		);
		foreach ($obsolete_files as $file) {
			$path = JPATH_SITE.'/'.$file;
			if (is_file($path) and is_writable($path)) {
				File::delete($path);
			}
		}

		$obsolete_folders = array(
			'components/com_fwgallery/layouts',
			'components/com_fwgallery/views/frontendmanager',
			'components/com_fwgallery/views/galleries',
			'components/com_fwgallery/views/gallery',
			'components/com_fwgallery/views/image',
			'components/com_fwgallery/views/tags',
			'components/com_fwgallery/views/tag',
			'plugins/fwgallery/admin/layouts/frontend',
			'plugins/fwgallery/admin/layouts/site',
			'plugins/fwgallery/cascading/layouts/site',
			'plugins/fwgallery/import/layouts/frontend',
			'plugins/fwgallery/import/layouts/site',
			'plugins/fwgallery/map/layouts/site',
			'plugins/fwgallery/meta/layouts/site',
			'plugins/fwgallery/slideshowview/layouts/site',
			'plugins/fwgallery/social/layouts/site',
			'plugins/fwgallery/tag/layouts/site',
			'plugins/fwgallery/vote/layouts/site',
			'plugins/fwgallerytype/audio/layouts/frontend',
			'plugins/fwgallerytype/audio/layouts/site',
			'plugins/fwgallerytype/video/layouts/frontend',
			'plugins/fwgallerytype/video/layouts/site',
		);
		foreach ($obsolete_folders as $folder) {
			$path = JPATH_SITE.'/'.$folder;
			if (is_dir($path) and is_writeable($path)) {
				Folder::delete($path);
			}
		}

		/* cleaning up update links of unpublished addons */
		$db->setQuery('DELETE FROM `#__update_sites` WHERE `location` LIKE \'%mod_fwg_map%\' OR `location` LIKE \'%plg_search_fwgallery%\'');
		$db->execute();
		/* cleaning up update links to the .net domain */
		$db->setQuery('SELECT update_site_id FROM `#__update_sites` WHERE `location` LIKE \'%fastw3b.net%\'');
		if ($ids = $db->loadColumn()) {
			$db->setQuery('UPDATE `#__update_sites` SET `location` = REPLACE(`location`, \'fastw3b.net\', \'fastw3b.com\') WHERE update_site_id IN ('.implode(',', $ids).')');
			$db->execute();
			$folders = array('modules', 'plugins');
			foreach ($folders as $folder) {
				if ($files = Folder::files(JPATH_SITE.'/'.$folder, '\.xml$', true, true)) {
					foreach ($files as $file) {
						if (strpos($file, 'fw') !== false and is_writable($file)) {
							$buff = file_get_contents($file);
							if (strpos($buff, 'fastw3b.net') !== false) {
								$buff = str_replace('fastw3b.net', 'fastw3b.com', $buff);
								file_put_contents($file, $buff);
							}
						}
					}
				}
			}
		}

		/* checking classic template, if no template configured */
		if (!$params or ($params and !$tmpl = $params->get('template') or $tmpl == 'common')) {
			if (!$params) {
				$params = new Registry;
			}
			$params->set('template', 'classic');
			$db->setQuery('UPDATE `#__extensions` SET params = '.$db->quote($params->toString()).' WHERE `element` = \'com_fwgallery\' AND `type` = \'component\'');
			$db->execute();
			$db->setQuery('UPDATE `#__extensions` SET `enabled` = 1 WHERE `name` = \'FW_GALLERY_CLASSIC\'');
			$db->execute();
		}
	}
}
