<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

HTMLHelper::_('behavior.core');

$menus = array(
    'fwgallery',
    'addon',
    'category',
    'file',
    'tag',
	'data',
	'css',
    'translation',
    'configuration'
);
$icons = array(
    'fwgallery' => 'tachometer',
    'category' => 'folder',
    'file' => 'image',
    'tag' => 'tag',
    'addon' => 'puzzle-piece',
	'data' => 'database',
    'translation' => 'world',
	'css' => 'code',
    'configuration' => 'settings'
);
$titles = array(
    'fwgallery' => 'DASHBOARD',
    'category' => 'CATEGORIES',
    'file' => 'FILES',
    'tag' => 'TAGS',
    'addon' => 'ADDONS',
	'data' => 'DATA_MANAGEMENT',
    'translation' => 'TRANSLATION',
    'css' => 'STYLES',
);

$view = $displayData['view'];

$addons = fwgHelper::getPluginsData();
$com_version = $com_remote_version = '';

$view->count_services = $view->addon_installed = $view->addon_not_installed = $view->available_addons = $view->count_addons = 0;
$view->updates = array();
foreach ($addons as $row) {
    if ($row->update_name == FWMG_UPDATE_NAME) {
        $com_version = $row->loc_version;
        if (!empty($row->rem_version)) {
            $com_remote_version = $row->rem_version;
        }
    } else {
        if ($row->type) {
            if (!empty($row->installable)) {
                $view->available_addons++;
                if (!$row->installed) {
                    $view->addon_not_installed++;
                }
            }
            if ($row->installed) {
                $view->addon_installed++;
            }
            if (!empty($row->rem_version) and !empty($row->loc_version) and $row->loc_version != 'x.x.x' and version_compare($row->loc_version, $row->rem_version, '<')) {
                $view->updates[] = $row->update_name;
            }
        }
        if ($row->subtype == 'service') {
            $view->count_services++;
        } elseif (!((empty($row->installed) and empty($row->installable)) or empty($row->type))) {
            $view->count_addons++;
        }
    }
}
$com_need_update = ($com_remote_version and $com_version != 'x.x.x' and version_compare($com_remote_version, $com_version, '>'));

$update_code = $view->params->get('update_code');
$verified_code = $view->params->get('verified_code');
$has_active_packages = $view->params->get('has_active_packages');

$account_verified = ($update_code and $update_code == $verified_code);
$user_name = $account_verified?$view->params->get('user_name'):'';
$user_avatar = $account_verified?$view->params->get('user_avatar'):'';
if (!$user_avatar) {
    $user_avatar = FWMG_ASSETS_URL.'images/user.jpg';
}
$package_name = $account_verified?$view->params->get('package_name'):'';
$date_end = $package_name?$view->params->get('date_end'):'';
$days_left = $date_end?floor((strtotime($date_end) - time())/86400):0;
?>
<div id="fw-admin" class="fwcss fw-admin-uikit">
    <div class="fwa-header">
        <div class="fwk-margin-bottom fwk-grid-small fwk-flex-middle" fwk-grid>
            <div class="fwk-width-1-4@m">
                <div class="fwk-flex fwk-flex-middle">
                    <div class="fwk-width-1-5 fwk-margin-right"> 
                        <img src="<?php echo FWMG_ADMIN_ASSETS_URL; ?>images/icon_fw_gallery_logo_200.png" />
                    </div>
                    <div>
                        <div class="fwa-header-product"><?php echo Text::_('COM_FWGALLERY'); ?></div>
                        <div>
                            v. <?php echo $com_version; ?>
<?php
    if ($com_need_update) {
?>
                            <button type="button" class="fwk-button fwk-button-secondary fwk-button-small fwk-margin-small-left fwa-update-com" data-addons='["com_fwgallery"]'>
                                <?php echo Text::_('COM_FWGALLERY_UPDATE_INSTALL'); ?> <?php echo $com_remote_version; ?>
                            </button>
<?php
}
?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="fwk-width-3-4@m fwa-account">
                <div class="fwk-grid-divider fwk-flex-middle fwk-float-right fwa-verified"<?php if (!$account_verified) { ?> hidden<?php } ?> fwk-grid>
                    <div>
                        <div class="fwk-flex">
                            <div class="fwk-width-1-5 fwk-margin-right">
                                <img class="fwk-border-circle fwa-client-avatar" src="<?php echo esc_attr($user_avatar); ?>" />
                            </div>
                            <div fwk-margin>
                                <div class="fwk-text-truncate">
                                    <?php echo Text::_('FWMG_VERIFIED_TO'); ?>
                                    <strong class="fwa-client-name"><?php echo $user_name; ?></strong>
                                </div>
                                <div class="fwk-text-small fwk-text-truncate">
                                    <span class="fwk-text-green fwk-margin-small-right" fwk-icon="website-check"></span>
                                    <?php echo str_ireplace(array('http://', 'https://'), '', fwgHelper::getHostName()); ?>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div fwk-margin>
                        <div>
<?php
$label_title = $package_name?$package_name:'FWMG_NO_PACKAGE_TITLE';
$label_class = $package_name?($has_active_packages?'primary':'secondary'):'danger';
$term_text = $package_name?Text::sprintf((($days_left > 0)?'FWMG_EXPIRES_IN':'FWMG_EXPIRED_AGO'), abs($days_left)):Text::_('FWMG_PAID_ADDONS_UNAVAILABLE');
?>
                            <span class="fwk-label fwk-label-<?php echo $label_class; ?> fwk-margin-small-right fwa-package-status"><?php echo Text::_($label_title); ?></span>
                            <span class="fwk-text-muted fwk-text-small fwa-package-expiration"><?php echo $term_text; ?></span>
                        </div>
                        <div>
                            <span class="fwk-margin-small-right fwk-text-bold"><?php echo Text::_('FWMG_SUPPORT'); ?></span>
<?php
$label_title = $has_active_packages?'FWMG_ACTIVE':'FWMG_INACTIVE';
$term_text = $package_name?'':Text::_('FWMG_SUBSCRIPTION_REQUIRED');
?>
                            <span class="fwk-label fwk-label-<?php echo $label_class; ?> fwk-margin-small-right"><?php echo Text::_($label_title); ?></span>
                            <span class="fwk-text-muted fwk-text-small"><?php echo $term_text; ?></span>
                            <a class="fwk-button fwk-button-small fwk-button-secondary fwa-package"<?php if (!$has_active_packages) { ?> hidden<?php } ?> href="<?php echo FWMG_UPDATE_SERVER; ?>/client-section/support?host=<?php echo urlencode(str_ireplace(array('http://', 'https://'), '', trim(fwgHelper::getHostName(), '/'))); ?>&product=<?php echo urlencode(FWMG_UPDATE_NAME); ?>" target="_blank"><?php echo Text::_('FWMG_SUBMIT_TICKET'); ?></a>
                        </div>
                    </div>
                    <div>
                        <div class="fwk-text-right fwa-verified" fwk-margin>
                            <div><button type="button" class="fwk-button fwk-button-small fwk-width-1-1 fwk-button-danger fwa-unverify"><?php echo Text::_('FWMG_UNVERIFY'); ?></button></div>
                            <div><a class="fwk-button fwk-button-small fwk-width-1-1 fwk-button-primary" href="https://fastw3b.com/client-section" target="_blank"><?php echo Text::_('FWMG_GO_TO_ACCOUNT'); ?></a></div>
                        </div>
                    </div>
                </div>
                <div class="fwk-align-right fwk-width-medium@m fwa-non-verified"<?php if ($account_verified) { ?> hidden<?php } ?>>
                    <div class="fwk-grid-small fwk-flex-middle" fwk-grid>
                        <div class="fwk-width-auto">
                            <a href="javascript:" class="fwk-icon-button" fwk-icon="icon:lock;" fwk-toggle="target: #fwmg-login-register"></a>
                        </div>
                        <div class="fwk-width-expand">
                            <a href="javascript:" fwk-toggle="target: #fwmg-login-register">
                                <div class="fwk-text-lead fwk-text-bold fwk-text-danger"><?php echo Text::_('FWMG_WEBSITE_NOT_VERIFIED'); ?></div>
                                <div class="fwk-text-small fwk-text-muted"><?php echo Text::sprintf('FWMG_WEBSITE_NOT_VERIFIED_URL_HINT', fwgHelper::getHostName()); ?></div>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="fwa-main-wrapper" fwk-grid>
        <div class="fwk-height-1-1 fwa-sidebar-wrapper">
            <div class="fwk-card fwk-card-default fwa-sidebar" fwk-sticky>
                <div class="fwa-sidebar-menu" fwk-margin>
<?php
foreach ($menus as $menu) {
    $active = ($menu == $view->menu);
	$name = Text::_('FWMG_'.(empty($titles[$menu])?$menu:$titles[$menu]));
    $has_updates = ($view->updates and $menu == 'addon');
?>
                    <div class="fwa-menu-item<?php if ($has_updates) { ?> fwk-position-relative<?php } if ($active) { ?> fwk-active<?php } ?>">
<?php
    if ($has_updates) {
?>
                        <span class="fwk-badge fwk-label-warning fwk-position-top-right fwa-update-all"><?php echo count($view->updates); ?></span>
<?php
    }
?>
                        <a class="fwk-button <?php if ($active) { ?> fwk-button-active<?php } ?>" href="index.php?option=com_fwgallery&view=<?php echo $menu; ?>" fwk-tooltip title="<?php echo esc_attr($name); ?>" fwk-icon="icon:<?php echo esc_attr($icons[$menu]); ?>;"></a>
                    </div>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwa-main fwk-width-expand">
            <div class="fwk-card fwk-card-default fwk-padding">
<?php
$title = ($view->menu == 'addon')?Text::sprintf('FWMG_DOC_ADMIN_ADDONS_AVAILABLE', $view->available_addons, $view->count_addons):$displayData['title'];
?>
                <div class="fwk-flex-middle fwk-grid-small fwa-main-header" fwk-grid>
                    <div class="fwk-width-3-5@m fwa-main-header-text">
                        <h1 class="fwk-text-black fwk-text-truncate" fwk-tooltip title="<?php echo esc_html($title); ?>">
                            <span class="fwk-margin-small-right fwk-text-green" fwk-icon="icon: <?php echo esc_attr($icons[$view->menu]); ?>; ratio: 1.5"></span> 
                            <?php echo esc_html($title); ?>
                        </h1>
<?php
if (!empty($displayData['title_hint'])) {
?>                    
                        <div class="fwk-text-muted fwk-text-lead fwk-text-light"><?php echo esc_html($displayData['title_hint']); ?></div>
<?php
}
if (!empty($displayData['title_info_alert'])) {
?>                    
                        <div class="fwk-alert fwk-alert-success"><?php echo esc_html($displayData['title_info_alert']); ?></div>
<?php
}
?>
                    </div>
                    <div class="fwk-width-2-5@m fwk-text-right fwa-right-panel">
<?php
if (!empty($displayData['right_panel'])) {
?>
                        <div class="fwa-toolbar">
                            <?php echo $displayData['right_panel']; ?>
                        </div>
<?php
}
$buttons = fwgButtons::getInstance()->getButtons();
if ($buttons) {
?>
                        <div class="fwa-toolbar-wrapper">
                            <div class="fwa-toolbar">
<?php
	foreach ($buttons as $button) {
		$onclick = '';
		if ($button->listSelect) {
			if (is_string($button->listSelect)) {
				$onclick = "if (document.adminForm.boxchecked.value == 0) { fwmg_alert('".Text::_('JLIB_HTML_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST', true)."'); } else { if (confirm('".Text::_($button->listSelect, true)."')) { Joomla.submitbutton('".$button->task."'); } }";
			} else {
				$onclick = "if (document.adminForm.boxchecked.value == 0) { fwmg_alert('".Text::_('JLIB_HTML_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST', true)."'); } else { Joomla.submitbutton('".$button->task."'); }";
			}
		} else {
			$onclick = "Joomla.submitbutton('".esc_js($button->task)."');";
		}
?>
						        <button type="button"<?php if ($button->task == 'add') { ?> id="fwmg-add-button"<?php } ?> class="fwk-button fwk-border-rounded<?php if (!empty($button->color)) { ?> fwk-button-<?php echo esc_attr($button->color); } ?>" onclick="<?php echo esc_attr($onclick); ?>" role="button" fwk-icon="<?php echo esc_attr($button->icon); ?>" fwk-tooltip="<?php echo esc_attr($button->alt); ?>"></button>
<?php
	}
?>
                            </div>
                        </div>
<?php
}
?>
                    </div>
                </div>
                <div class="fwa-main-body">
