<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;

$view = $displayData['view'];
?>
<div id="fwmg-batch-operations" class="fwk-modal-container" fwk-modal>
	<div class="fwk-modal-dialog">
		<div class="fwk-modal-header">
			<h5 class="fwk-modal-title"><?php echo Text::_('FWMG_BATCH_OPERATIONS'); ?></h5>
			<button class="fwk-modal-close-default" type="button" fwk-close></button>
		</div>
		<form action="index.php?option=com_fwgallery&amp;view=file&amp;tab=<?php echo esc_attr($view->tab); ?>" method="post" name="operationsForm" id="operationsForm">
			<div class="fwk-modal-body">
				<div class="fwk-child-width-1-2@m" fwk-grid>
					<div>
						<p>
							<label for="fwmg-category-batch"><?php echo Text::_('FWMG_BATCH_CATEGORY'); ?></label>
							<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'category_id', 0, 'id="fwmg-category-batch" class="fwk-select"', $multiple=false, $first_option=Text::_('FWMG_BATCH_KEEP_THE_SAME')); ?>
						</p>
					</div>
					<div>
						<p>
							<label for="fwmg-access-batch"><?php echo Text::_('FWMG_BATCH_ACCESS_LEVEL'); ?></label>
							<?php echo HTMLHelper::_('select.genericlist', array_merge(array(
								HTMLHelper::_('select.option', '-1', Text::_('FWMG_BATCH_KEEP_THE_SAME'), 'id', 'name')
							), fwgHelper::loadviewlevels()), 'access', 'class="fwk-select"', 'id', 'name', -1, 'fwmg-access-batch'); ?>
						</p>
					</div>
					<div>
						<p>
							<label for="fwmg-user-batch"><?php echo Text::_('FWMG_BATCH_OWNER'); ?></label>
							<?php echo HTMLHelper::_('select.genericlist', array_merge(array(
								HTMLHelper::_('select.option', '-1', Text::_('FWMG_BATCH_KEEP_THE_SAME'), 'id', 'name')
							), fwgHelper::loadUsers()), 'user_id', 'class="fwk-select"', 'id', 'name', -1, 'fwmg-user-batch'); ?>
						</p>
					</div>
					<div>
						<p>
							<label for="fwmg-copyright-batch" fwk-tooltip title="<?php echo Text::_('FWMG_COPYRIGHT_BATCH_HINT'); ?>"><?php echo Text::_('FWMG_BATCH_COPYRIGHT'); ?></label>
							<input type="text" class="fwk-input" id="fwmg-copyright-batch" name="copyright" />
						</p>
					</div>
<?php
$view->app->triggerEvent('onshowBachProcessingExtraFields', array('com_fwgallery', $view));
?>
				</div>
			</div>
			<div class="fwk-modal-footer">
				<button type="button" class="fwk-button fwk-modal-close"><?php echo Text::_('FWMG_CANCEL'); ?></button>
				<button type="submit" class="fwk-button fwk-button-success"><?php echo Text::_('FWMG_PROCESS'); ?></button>
			</div>
			<input type="hidden" name="task" value="dobatch" />
<?php
foreach ($view->fields as $field) {
	if ($view->$field) {
?>
			<input type="hidden" name="<?php echo esc_attr($field); ?>" value="<?php echo esc_attr($view->$field); ?>" />
<?php
	}
}
?>
		</form>
	</div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		$('#fwmg-batch-operations').on('show', function() {
			var $form = $(this).find('form');
			$form.find('input[name="cid[]"]').remove();
			var $cids = $('#adminForm input[name="cid[]"]:checked').each(function() {
				var $inp = $('<input />', {
					type: 'hidden',
					name: 'cid[]',
					'value': this.value
				});
				$form.append($inp);
			});
		});
	})(jQuery);
});
</script>
