<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;

$allusers = $displayData['allusers'];
$current_user = $displayData['current_user'];
$category = $displayData['category'];
$reload = $displayData['reload'];

$max_size = fwgHelper::getIniSize('upload_max_filesize');
$post_size = fwgHelper::getIniSize('post_max_size');

$exts = array('jpg', 'jpeg', 'png', 'gif');
Factory::getApplication()->triggerEvent('ongetAffordableExts', array('com_fwgallery', &$exts));
?>
<div id="fwmg-batch-upload" class="fwk-modal-container" fwk-modal>
	<div class="fwk-modal-dialog">
		<button class="fwk-modal-close-default" type="button" fwk-close></button>
		<div class="fwk-modal-header">
			<div class="fwk-modal-title"><?php echo Text::_('FWMG_BATCH_UPLOAD'); ?></div>
		</div>
		<div class="fwk-modal-body fwk-margin-top">
			<form action="index.php?option=com_fwgallery&amp;view=file" method="post" name="uploadForm" id="uploadForm" enctype="multipart/form-data">
				<div class="fwk-child-width-1-2" fwk-grid>
					<div>
						<div id="fwmg-batch-uploader" class="fwk-text-center" style="min-height:200px;"></div>
					</div>
					<div fwk-margin>
						<div class="fwk-flex">
							<div class="fwk-width-2-5@s">
								<?php echo Text::_('FWMG_GALLERY'); ?>
							</div>
							<div class="fwk-width-3-5@s fwk-flex fwk-flex-middle">
								<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'category_id', $category, 'class="required select-choices fwk-select"', $multiple=false, $first_option=Text::_('FWMG_SELECT_GALLERY')); ?>
							</div>
						</div>
						<div class="fwk-flex">
							<div class="fwk-width-2-5@s">
								<?php echo Text::_('FWMG_PUBLISHED'); ?>
							</div>
							<div class="fwk-width-3-5@s fwk-flex fwk-flex-middle">
								<?php echo HTMLHelper::_('fwView.radioGroup', 'published', 1, array(
									'wrapper_class' => 'fwk-width-expand',
									'buttons' => array(array(
										'active_class' => 'fwk-button-success',
										'title' => Text::_('JYES'),
										'value' => 1
									), array(
										'active_class' => 'fwk-button-danger',
										'title' => Text::_('JNO'),
										'value' => 0
									))
								)); ?>
							</div>
						</div>
						<div class="fwk-flex">
							<div class="fwk-width-2-5@s">
								<?php echo Text::_('FWMG_OWNER'); ?>
							</div>
							<div class="fwk-width-3-5@s fwk-flex fwk-flex-middle">
								<?php echo HTMLHelper::_('select.genericlist', (array)$allusers, 'user_id', 'class="required fwk-select"', 'id', 'name', $current_user->id); ?>
							</div>
						</div>
						<div class="mt-5 fwk-text-center">
							<button type="button" class="fwk-button fwk-button-large fwk-button-primary"><?php echo Text::_('FWMG_UPLOAD'); ?></button>
						</div>
					</div>
				</div>
				<input type="hidden" name="task" value="" />
			</form>
		</div>
	</div>
</div>
<script>
var fwmg_uploaded_files = [];
var fwmg_uploading_counter_success = fwmg_uploading_counter_error = 0;
var max_file_size = <?php echo (int)$max_size; ?>;
var max_post_size = <?php echo (int)$post_size; ?>

function completeHandler(event) {
	$('#fwmg-batch-wait-img').remove();
	$('#fwmg-batch-upload').data('images_uploaded', true);
	var data = $.parseJSON(event.target.responseText);
	if (data) {
		if (data.msg) fwmg_alert(data.msg);
<?php
if ($reload) {
?>
		$('#adminForm').submit();
<?php
} else {
?>
		fwkUIkit.modal('#fwmg-batch-upload').hide();
<?php
}
?>
	} else {
		fwmg_alert('<?php echo Text::_('FWMG_FILES_NOT_UPLOADED', true); ?>');
	}
}
function handleFileInput(input) {
	var form = document.uploadForm;

	var div = $('<div class="fwk-flex"></div>');
	$(form).append(div);
	div.append($('<div class="fwk-width-4-5">'+input.val()+'</div>'));
	div.append(input);
	input.css('display', 'none');
	var button = $('<div class="fwk-width-1-5"><button type="button" class="fwk-button fwk-button-danger btn-small" onclick="$(this).parent().parent().remove();">-</button></div>');
	div.append(button);

	var input = $('<input type="file" name="images[]" />');
	$(form).append(input);
	input.change(function() {
		handleFileInput($(this));
	});
}
function humanFileSize(size) {
    var i = Math.floor( Math.log(size) / Math.log(1024) );
    return ( size / Math.pow(1024, i) ).toFixed(2) * 1 + ' ' + ['B', 'kB', 'MB', 'GB', 'TB'][i];
};
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
<?php
if ($reload) {
?>
	$('#fwmg-batch-upload').on('hidden', function() {
		if ($(this).data('images_uploaded')) {
			location = location.replace(/#.*$/, '');
		}
	});
<?php
}
?>
	function fwmg_file_queue_upload($button, form, i = 0) {

		var formdata = new FormData();
		formdata.append('user_id', form.user_id.value);
		formdata.append('published', form.published.value);
		formdata.append('category_id', form.category_id.value);

		formdata.append('format', 'json');
		formdata.append('view', 'file');
		formdata.append('layout', 'batchupload');

		formdata.append('images[]', fwmg_uploaded_files[i]);

		$.ajax({
			url: form.action,
			type: 'post',
			dataType: 'json',
			processData: false,
			contentType: false,
			data: formdata
		}).done(function (data) {
			if (data.msg) {
				var $msg = $('<div><span class="fwk-badge fwk-badge-warning">'+data.msg+'</span></div>');
				$button.after($msg);
				setTimeout(function() {
					$msg.remove();
				}, 3000);
			}
			$('#fwmg-batch-uploader-drop-zone .fwmg-file-row:eq('+i+')').hide(300);
			if (fwmg_uploaded_files.length > i + 1) {
				fwmg_file_queue_upload($button, form, i + 1);
			} else {
				$('#fwmg-batch-wait-img').remove();
				$button.attr('disabled', false);
				$('#fwmg-batch-uploader-drop-zone .fwmg-file-row a').click();
<?php
if ($reload) {
?>
				setTimeout(function() {
					form.submit();
				}, 1000);
<?php
} else {
?>
				fwkUIkit.modal('#fwmg-batch-upload').hide();
<?php
}
?>
			}
		});
	}
	$('#uploadForm button.fwk-button-primary').click(function() {
		var $button = $(this);
		var form = document.uploadForm;
		if (form.category_id.value == 0) {
			fwmg_alert('<?php echo Text::_('FWMG_SELECT_GALLERY_FIRST', true); ?>');
			return;
		}
		if (typeof(window.FileReader) == 'undefined') {
			var files_added = false;
			$('input[type=file]', form).each(function(index, input) {
				if (input.value != '') files_added = true;
			});
			if (!files_added) {
				fwmg_alert('<?php echo Text::_('FWMG_NOTHING_TO_UPLOAD', true); ?>');
				return false;
			}
		} else {
			if (fwmg_uploaded_files.length > 0) {
				$button.attr('disabled', true);
				var $img = $('<div fwk-spinner></div>');
				$button.after($img);
				fwmg_file_queue_upload($button, form, 0);
			} else {
				fwmg_alert('<?php echo Text::_('FWMG_NOTHING_TO_UPLOAD', true); ?>');
			}
		}
	});
	var form = document.uploadForm;
	var bu = $('#fwmg-batch-uploader');
    if (typeof(window.FileReader) == 'undefined') {
		var input = $('<input type="file" name="images[]" />');
		$(form).append(input);
		input.change(function() {
			handleFileInput($(this));
		});
	} else {
		var div = $('<div id="fwmg-batch-uploader-wrapper"></div>');
		bu.append(div);
		var fr = $('<div id="fwmg-batch-uploader-drop-zone" class="fwk-placeholder" style="min-height:200px;line-height:200px;"></div>');
		div.append(fr);
		fr.html('<span fwk-icon="icon: cloud-upload"></span> <?php echo Text::_('FWMG_OR_DRAG_FILES_HERE', true); ?>');

		fr[0].ondragover = function() {
			fr.addClass('fwmg-drag-over');
			return false;
		};
		fr[0].ondragleave = function() {
			fr.removeClass('fwmg-drag-over');
			return false;
		};
		fr[0].ondrop = function(event) {
			event.preventDefault();
			fr.removeClass('fwmg-drag-over');
			fr.addClass('fwmg-drag-drop');

			var uploading_size = 0;
			for (var i = 0; i < fwmg_uploaded_files.length; i++) {
				uploading_size += fwmg_uploaded_files[i].size;
			}

			var errors = [];
			for (var i = 0; i < event.dataTransfer.files.length; i++) {
				var file = event.dataTransfer.files[i];
				if (file.name.match(/\.(<?php echo esc_js(implode('|', $exts)); ?>)$/i)) {
					if (file.size <= max_file_size) {
						if ((file.size + uploading_size) < max_post_size) {
							if (fr.html() == '<span fwk-icon="icon: cloud-upload"></span> <?php echo Text::_('FWMG_OR_DRAG_FILES_HERE', true); ?>') fr.html('');
							fr.css({'background-image':'none', 'line-height':'16px', 'text-align':'left'});
							var row = $('<div class="fwmg-file-row">'+file.name+'</div>');
							fr.append(row);
							var remove_button = $('<a href="javascript:" title="<?php echo Text::_('FWMG_REMOVE', true); ?>"><img src="<?php echo FWMG_ADMIN_ASSETS_URL; ?>images/delete16.png" alt="delete"/></a>');
							row.append(remove_button);
							var span = $('<span class="fwmg-file-size">'+humanFileSize(file.size)+'</span>');
							row.append(span);
							remove_button.click(function() {
								var current_button = this;
								var num = 0;
								var count = 0;
								$('.fwmg-file-row a').each(function(index, button) {
									if (button == current_button) num = index;
									count++;
								});
								if (fwmg_uploaded_files[num]) {
									fwmg_uploaded_files.splice(num, 1);
									$(current_button).parent().remove();
								}
								if (count == 1) {
									fr.html('<span fwk-icon="icon: cloud-upload"></span> <?php echo Text::_('FWMG_OR_DRAG_FILES_HERE', true); ?>');
									fr.css({'background-image':'', 'line-height':'200px', 'text-align':'center'});
								}
							});
							fwmg_uploaded_files.push(file);

							uploading_size += file.size;
						} else {
							errors.push(file.name + ' - <?php echo Text::_('FWMG_MAX_POST_SIZE_LIMIT_REACHED', true); ?>');
						}
					} else {
						errors.push(file.name + ' - <?php echo Text::_('FWMG_FILE_TOO_BIG', true); ?>');
					}
				} else {
					errors.push(file.name + ' - <?php echo Text::_('FWMG_NOT_ALLOWED_EXTENSION', true); ?>');
				}
			}
			if (errors.length) {
				fwmg_alert(errors.join('\n'));
			}
		}
		var input = $('<input type="file" multiple name="files[]" id="fwmg-upload-input" />');
		bu.append($('<p class="fwk-text-small fwk-text-muted"><?php echo Text::sprintf('FWMG_ALLOWED_FILES_TYPES', implode(', ', $exts)); ?>; <?php echo Text::_('FWMG_FILE_UPLOAD_SIZE_LIMIT', true).', '.fwgHelper::humanFileSize($max_size); ?>, <?php echo Text::_('FWMG_POST_SIZE_LIMIT', true).' '.fwgHelper::humanFileSize($post_size); ?></p><span><?php echo Text::_('FWMG_SELECT_FILES', true); ?>&nbsp;</span>')).append(input);

		input[0].onchange = function(event) {
			event.preventDefault();

			var uploading_size = 0;
			for (var i = 0; i < fwmg_uploaded_files.length; i++) {
				uploading_size += fwmg_uploaded_files[i].size;
			}

			var errors = [];
			for (var i = 0; i < event.target.files.length; i++) {
				var file = event.target.files[i];
				if (file.name.match(/\.(<?php echo esc_js(implode('|', $exts)); ?>)$/i)) {
					if (file.size <= max_file_size) {
						if ((file.size + uploading_size) < max_post_size) {
							if (fr.html() == '<span fwk-icon="icon: cloud-upload"></span> <?php echo Text::_('FWMG_OR_DRAG_FILES_HERE', true); ?>') fr.html('');
							fr.css({'background-image':'none', 'line-height':'16px', 'text-align':'left'});
							var row = $('<div class="fwmg-file-row">'+file.name+'</div>');
							fr.append(row);
							var remove_button = $('<a href="javascript:" title="<?php echo Text::_('FWMG_REMOVE', true); ?>"><img src="<?php echo FWMG_ADMIN_ASSETS_URL; ?>images/delete16.png" alt="delete"/></a>');
							row.append(remove_button);
							var span = $('<span class="fwmg-file-size">'+humanFileSize(file.size)+'</span>');
							row.append(span);
							remove_button.click(function() {
								var current_button = this;
								var num = 0;
								var count = 0;
								$('.fwmg-file-row a').each(function(index, button) {
									if (button == current_button) num = index;
									count++;
								});
								if (fwmg_uploaded_files[num]) {
									fwmg_uploaded_files.splice(num, 1);
									$(current_button).parent().remove();
								}
								if (count == 1) {
									fr.html('<span fwk-icon="icon: cloud-upload"></span> <?php echo Text::_('FWMG_OR_DRAG_FILES_HERE', true); ?>');
									fr.css({'background-image':'', 'line-height':'200px', 'text-align':'center'});
								}
							});
							fwmg_uploaded_files.push(file);

							uploading_size += file.size;
						} else {
							errors.push(file.name + ' - <?php echo Text::_('FWMG_MAX_POST_SIZE_LIMIT_REACHED', true); ?>');
						}
					} else {
						errors.push(file.name + ' - <?php echo Text::_('FWMG_FILE_TOO_BIG', true); ?>');
					}
				} else {
					errors.push(file.name + ' - <?php echo Text::_('FWMG_NOT_ALLOWED_EXTENSION', true); ?>');
				}
			}
			if (errors.length) {
				fwmg_alert(errors.join('\n'));
			}
		}
	}
	})(jQuery);
});
</script>
