<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;

$extra_link = empty($displayData['extra_link'])?'':$displayData['extra_link'];
?>
<div id="fwmg-quick-categories" fwk-modal>
    <div class="fwk-modal-dialog">
        <button class="fwk-modal-close-default" type="button" fwk-close></button>
        <div class="fwk-modal-header">
            <h5 class="fwk-modal-title">
                <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_MODAL_QUICK'); ?>
                <div class="fwk-text-small fwk-text-mute">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_MODAL_QUICK_HINT'); ?>
                </div>
            </h5>
        </div>
        <div class="fwk-modal-body">
            <div><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_MODAL_QUICK_TEXT'); ?></div>
            <textarea name="quick_categories" rows="10" class="fwk-textarea"
                placeholder="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORIES_MODAL_QUICK_TEXT_HINT')); ?>"></textarea>
        </div>
        <div class="fwk-modal-footer">
            <button type="button" class="fwk-button fwk-margin-right fwk-modal-close"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_MODAL_QUICK_BTN_CLOSE'); ?></button>
            <button type="button" class="fwk-button fwk-button-success"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_MODAL_QUICK_BTN_PROCESS'); ?></button>
        </div>
    </div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function () {
    (function ($) {
        $('#fwmg-quick-categories').on('show', function () {
            $(this).find('textarea').val('');
        });
        $('#fwmg-quick-categories button.fwk-button-success').click(function () {
            var $btn = $(this).attr('disabled', true);
            var $popup = $('#fwmg-quick-categories');
            $.ajax({
                dataType: 'json',
                data: {
                    format: 'json',
                    view: 'category',
                    task: '',
                    layout: 'quick_categories',
                    text: $popup.find('textarea').val()
                }
            }).done(function (data) {
                $btn.attr('disabled', false);
                if (data.msg) {
                    fwmg_alert(data.msg);
                }
                if (data.result) {
                    location = 'index.php?option=com_fwgallery&view=category' +
                        '<?php echo str_replace('&amp;', '&', $extra_link); ?>';
                }
            });
        });
    })(jQuery);
});
</script>
