<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseModel;
use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\Utilities\ArrayHelper;

class fwgalleryModelConfiguration extends BaseModel {
    function loadObject() {
    	$obj = new stdclass;
    	$obj->params = ComponentHelper::getParams('com_fwgallery');

        $app = Factory::getApplication();
        $app->triggerEvent('ongetExtraConfigData', array('com_fwgallery', $obj->params));

        return $obj;
    }
    function save() {
    	$params = ComponentHelper::getParams('com_fwgallery');
        $app = Factory::getApplication();

		$data = $app->input->getVar('config');
        $app->triggerEvent('onsetExtraConfigData', array('com_fwgallery', &$data));

	   	$params->loadArray($data);

		$wmf = $params->get('watermark_file');
		if ($app->input->getInt('delete_watermark') and $wmf) {
			if (file_exists(FWMG_STORAGE_PATH.$wmf)) File::delete(FWMG_STORAGE_PATH.$wmf);
			$params->set('watermark_file', '');
			$wmf = '';
		}

    	if ($file = $app->input->files->get('watermark_file', null, 'raw')
    	 and $name = ArrayHelper::getValue($file, 'name')
    	  and empty($file['error']) and preg_match('/\.png$/i', $name)
    	   and File::copy(ArrayHelper::getValue($file, 'tmp_name'), FWMG_STORAGE_PATH.$name)) {
			if ($wmf and $name != $wmf and file_exists(FWMG_STORAGE_PATH.$wmf)) {
				File::delete(FWMG_STORAGE_PATH.$wmf);
			}
    		$params->set('watermark_file', $name);
    	}

        return fwgHelper::storeConfig($params);
    }
}
