<?php
/**
 * FW Gallery 4.10.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\MVC\Model\BaseModel;
use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Editor\Editor;

class fwGalleryModelCss extends BaseModel {
	function getEditor() {
		$editor = '';
		$db = Factory::getDbo();
		$db->setQuery('SELECT `element` FROM `#__extensions` WHERE `element` IN (\'codemirror\',\'none\') AND `folder` = \'editors\' AND enabled = 1');
		if ($list = $db->loadColumn()) {
			if (in_array('codemirror', $list)) {
				$editor = 'codemirror';
			} else {
				$editor = 'none';
			}
		} else {
			$editor = Factory::getConfig()->get('editor');
		}
		return Editor::getInstance($editor);
	}
	function loadObject() {
		return (object)array(
			'params' => ComponentHelper::getParams('com_fwgallery')
		);
	}
	function loadTemplatesCSS() {
		$db = Factory::getDBO();
		$db->setQuery('SELECT name, enabled, element FROM `#__extensions` WHERE `folder` = \'fwgallerytmpl\' AND enabled = 1 ORDER BY name');
		if ($list = $db->loadObjectList()) {
			$lang = Factory::getLanguage();
			$i = 0;
			foreach ($list as $row) {
				if ($row->enabled) {
					$name = 'plg_fwgallerytmpl_'.$row->element;
					$lang->load($name);
					$list[$i]->name = Text::_($row->name);
					$list[$i]->path = FWMG_DESIGNS_PATH.$row->element.'/assets/css/fwmg-design-styles.css';
					if (file_exists($list[$i]->path)) {
						$list[$i]->css = file_get_contents($list[$i]->path);
					}
					$i++;
				}
			}
			return $list;
		}
	}
    function save() {
    	$params = ComponentHelper::getParams('com_fwgallery');
		$input = Factory::getApplication()->input;
		$data = (array)$input->getVar('config');

    	$fields = array(
			'additional_css'
		);
		foreach ($fields as $field) $data[$field] = $input->getVar($field);

	   	$params->loadArray($data);

		return fwgHelper::storeConfig($params, true);
	}
}
