<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license https://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link https://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseModel;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Pagination\Pagination;
use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\Table\Table;
use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\Version;

class fwGalleryModelFwGallery extends BaseModel {
	function localStat() {
		$data = null;
		if (is_null($data)) {
			$db = Factory::getDBO();
			$query = '
SELECT
	(SELECT COUNT(*) FROM `#__fwsg_category`) AS ct,
	(SELECT COUNT(*) FROM `#__fwsg_category` WHERE published = 1) AS cp,
	(SELECT COUNT(*) FROM `#__fwsg_file`) AS files_qty,
	'.(class_exists('Joomla\CMS\Version')?'(SELECT COUNT(*) FROM #__menu WHERE `client_id` = 0 AND `link` LIKE \'%com_fwgallery&view=fwgallery%\')':'1').' AS menus_qty,
	(SELECT COUNT(*) FROM `#__fwsg_file` WHERE `type` = \'image\') AS it,
	(SELECT COUNT(*) FROM `#__fwsg_file` WHERE `type` = \'image\' AND published = 1) AS ip,
	(SELECT SUM(`size`) FROM `#__fwsg_file_image` WHERE `size` IS NOT NULL) AS `is`';
			$app = Factory::getApplication();
			$app->triggerEvent('ongetLocalStatExtraFields', array('com_fwgallery', &$query));

			$db->setQuery($query);
			$data = $db->loadObject();
			$size = 0;
			foreach ($data as $key=>$val) {
				/* sum up all sizes */
				if ($key[strlen($key) - 1] == 's') {
					$size += $val;
					unset($data->$key);
				}
			}
			$data->fs = $size;
		}
		return $data;
	}
	function quickCheck($check_orphans=true) {
		$data = new stdclass;
		$path = str_replace('com_fwgallery/', '', FWMG_STORAGE_PATH);
		if (!file_exists($path)) {
			File::write($path.'index.html', $html='<html><body></body></html>');
		}
		$data->media_folder_exists = file_exists($path);
		$path .= 'com_fwgallery/';
		if (!file_exists($path)) {
			File::write($path.'index.html', $html='<html><body></body></html>');
		}
		$data->gallery_folder_exists = file_exists($path);
		$data->gallery_folder_writeable = is_writable($path);

		$path = JPATH_SITE.'/cache/fwgallery/images/';
		if (!file_exists($path)) {
			Folder::create($path);
		}
		$data->cache_folder_exists = file_exists($path);
		$data->cache_folder_writeable = is_writable($path);

		$data->gd_installed = function_exists('gd_info');
		$data->exif_installed = function_exists('exif_read_data');
		$data->version = fwgHelper::getAppVersion();

		$data->test_passed = true;
		foreach ($data as $key=>$val) {
			if (!$val) {
				$data->test_passed = false;
				break;
			}
		}

		$data->orphans = 0;
		if ($check_orphans and $files = $this->getUnregisteredFiles()) {
			foreach ($files as $file) {
				$data->orphans += filesize($file);
			}
		}

		return $data;
	}
	function deleteUnregisteredFiles() {
		$deleted = $skipped = 0;
		$msg = Text::_('FWMG_NO_FILES_WERE_DELETED');
		if ($files = $this->getUnregisteredFiles()) {
			foreach ($files as $file) {
				if (is_writable($file) and File::delete($file)) {
					$deleted++;
				} else {
					$skipped++;
				}
			}
			$msg = '';
			if ($deleted) {
				$msg = $deleted.' '.Text::_('FWMG_FILES_DELETED');
			}
			if ($skipped) {
				$msg = ($msg?', ':'').$skipped.' '.Text::_('FWMG_FILES_SKIPPED');
			}
		}
		$this->setError($msg);
		return $deleted;
	}
	function getUnregisteredFiles() {
		$path = FWMG_STORAGE_PATH;
		$files = Folder::files($path, '.', true, true, array('.svn', 'CVS', '.DS_Store', '__MACOSX', 'index.html'));
		
		foreach ($files as $i=>$file) {
			if (strpos(str_replace('\\', '/', $file), '/backups/')) {
				unset($files[$i]);
			}
		}

		$params = ComponentHelper::getParams('com_fwgallery');
		if ($waremark = $params->get('watermark_file')) {
			foreach ($files as $i=>$file) {
				if (strpos($file, $waremark)) {
					unset($files[$i]);
					break;
				}
			}
		}

        $app = Factory::getApplication();
		$db = Factory::getDBO();

        $extra_select = $app->triggerEvent('ongetFileExtraFields', array('com_fwgallery'));
        $extra_from = $app->triggerEvent('ongetFileExtraTables', array('com_fwgallery'));

		$types = array(
			"'image'"
		);
        if ($buff = $app->triggerEvent('ongetType', array('com_fwgallery'))) {
    		foreach ($buff as $val) {
    			if ($val) {
    				$types[] = $db->quote($val);
    			}
    		}
        }
		$where[] = "f.`type` IN (".implode(",", $types).")";

        $db->setQuery('
SELECT
    f.id,
    f.type,
	fi.sys_filename AS _sys_filename
    '.implode('', $extra_select).'
FROM
    `#__fwsg_file` AS f
    LEFT JOIN `#__fwsg_file_image` AS fi ON fi.file_id = f.id
    '.implode('', $extra_from).'
WHERE
	'.implode(' AND ', $where)
		);
		if ($list = $db->loadObjectList()) {
			foreach ($list as $row) {
				foreach ($files as $i=>$file) {
					if ($row->_sys_filename and strpos($file, $row->_sys_filename)) {
						unset($files[$i]);
					}
				}
				if ($row->type != 'image') {
					$app->triggerEvent('oncheckFileRegistration', array('com_fwgallery', $row, &$files));
				}
			}
		}

		$db->setQuery('SELECT DISTINCT media_code, sys_filename FROM `#__fwsg_category`');
		if ($list = $db->loadObjectList()) {
			foreach ($list as $row) {
				if ($row->sys_filename or $row->media_code) {
					foreach ($files as $i=>$file) {
						if ($row->media_code and strpos($file, $row->media_code)) {
							unset($files[$i]);
							break;
						} elseif ($row->sys_filename and strpos($file, $row->sys_filename)) {
							unset($files[$i]);
							break;
						}
					}
				}
			}
		}
		return $files;
	}
	function loadParamsObj() {
    	$obj = new stdclass;
    	$obj->params = ComponentHelper::getParams('com_fwgallery');
        return $obj;
	}
	function store($params) {
    	$db = Factory::getDBO();

		$db->setQuery('UPDATE `#__update_sites` SET extra_query = '.$db->quote('code='.urlencode(trim((string)$params->get('update_code'))).'&host='.urlencode(Uri::root(false))).' WHERE name LIKE \'FW Gallery%\'');
		$db->execute();

		$db->setQuery('TRUNCATE TABLE #__updates');
		$db->execute();
		$db->setQuery('UPDATE `#__update_sites` SET last_check_timestamp = 0');
		$db->execute();

		return fwgHelper::storeConfig($params);
	}
	function checkUpdate() {
		$data = new stdclass;
		$data->loc_version = fwgHelper::getAppVersion();
		if ($buff = fwgHelper::request(FWMG_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=package&format=raw&package='.FWMG_UPDATE_NAME.'&dummy=extension.xml')) {
			if (preg_match('#<extension.*version="([^"]*)"#', $buff, $match)) {
				$data->rem_version = $match[1];
			}
		} else $this->setError(Text::_('FWMG_NO_RESPONSE_FROM_REMOTE_SERVER'));
		return $data;
	}
	function verifyCode() {
		$result = new stdclass;
		$input = Factory::getApplication()->input;
		if ($code = $input->getString('access_code')) {
			$j_version = $langs_qty = '';
			if (class_exists('Joomla\CMS\Version')) {
				$jv = new Version();
				$j_version = $jv->getShortVersion();
			} else {
				global $wp_version;
			}
			$lang = Factory::getLanguage();
			$db = Factory::getDBO();
			$db->setQuery('SELECT COUNT(*) FROM `#__languages`');
			$langs_qty = $db->loadResult();
			$db->setQuery('SELECT COUNT(*) FROM `#__fwsg_category` AS c WHERE EXISTS(SELECT * FROM `#__fwsg_file` AS p WHERE p.published = 1 AND p.category_id = c.id)');
			$categories_qty = $db->loadResult();
			$db->setQuery('SELECT COUNT(*) FROM `#__fwsg_file` WHERE published = 1');
			$files_qty = $db->loadResult();

			$data = (object)array(
				'code' => $code,
				'package' => FWMG_UPDATE_NAME,
				'host' => Uri::root(false),
				'params' => array(
					'joomla_version' => $j_version,
					'wp_version' => empty($wp_version)?'':$wp_version,
					'version' => fwgHelper::getAppVersion(),
					'language' => $lang->getTag(),
					'langs_qty' => $langs_qty,
					'categories_qty' => $categories_qty,
					'files_qty' => $files_qty,
					'exts' => array()
				)
			);
			$db->setQuery('
SELECT
	`name`,
	`element`,
	`type`,
	`type` AS subtype,
	`folder`,
	`enabled`
FROM
	#__extensions
WHERE
	manifest_cache LIKE \'%Fastw3b%\'
	AND
	NOT `type` IN (\'package\', \'template\')
ORDER BY
	`type`,
	`folder`,
	`name`'
			);
			if ($list = $db->loadObjectList()) {
				foreach ($list as $i=>$row) {
					$list[$i]->name = Text::_($row->name);
					$filename = "";
					if ($row->type == "component") {
						$list[$i]->update_name = $row->element;
						$filename = FWMG_COMPONENT_ADMINISTRATOR."/".str_replace("com_", "", $row->element).".xml";
					} elseif ($row->type == "plugin") {
						$list[$i]->update_name = 'plg_'.$row->folder.'_'.$row->element;
						$filename = '';
						switch ($row->folder) {
							case 'fwgallery' :
								$filename = FWMG_PLUGINS_PATH;
								break;
							case 'fwgallerytmpl' :
								$filename = FWMG_DESIGNS_PATH;
								break;
							case 'fwgallerytype' :
								$filename = FWMG_TYPES_PATH;
								break;
						}
						$filename .= $row->element."/".$row->element.".xml";
					} elseif ($row->type == "module") {
						$list[$i]->update_name = $row->element;
						$filename = FWMG_MODULES_PATH.$row->element."/".$row->element.".xml";
					}
					if ($filename and file_exists($filename)) {
						$buff = file_get_contents($filename);
						if (preg_match("#<version>(.*?)</version>#msi", $buff, $match)) {
							$list[$i]->loc_version = $match[1];
						}
					}
				}
				$data->params["exts"] = $list;
			}
			if ($buff = fwgHelper::request(FWMG_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=verify_code&format=raw', 'post', $data)) {
				$tmp = json_decode((string)$buff);
				if ($tmp) {
					if (!empty($tmp->msg)) $this->setError($tmp->msg);
					$result->user_name = empty($tmp->user_name)?'':$tmp->user_name;
					$result->user_avatar = empty($tmp->user_avatar)?'':$tmp->user_avatar;
					$result->user_email = empty($tmp->user_email)?'':$tmp->user_email;
					if (!empty($tmp->verified)) {
						$params = ComponentHelper::getParams('com_fwgallery');

						$result->user_name = empty($tmp->user_name)?'':$tmp->user_name;
						$result->user_avatar = empty($tmp->user_avatar)?'':$tmp->user_avatar;
						$result->user_email = empty($tmp->user_email)?'':$tmp->user_email;
						$result->verified = 1;
						$result->package_name = empty($tmp->package_name)?'':$tmp->package_name;
						$result->date_end = empty($tmp->date_end)?'':$tmp->date_end;
						$result->days_left = empty($tmp->date_end)?0:floor((strtotime($tmp->date_end) - time())/86400);
						$result->installed = $data->params["exts"];
						$result->addons = empty($tmp->addons)?'':$tmp->addons;
						$result->has_packages = empty($tmp->packages)?0:$tmp->packages;
						$result->has_inactive_packages = empty($tmp->inactive_packages)?0:$tmp->inactive_packages;
						$result->has_active_packages = empty($tmp->active_packages)?0:$tmp->active_packages;

						$params->set('update_code', $code);
						$params->set('verified_code', $code);
						$params->set('package_name', $result->package_name);
						$params->set('date_end', $result->date_end);
						$params->set('user_name', $result->user_name);
						$params->set('user_avatar', $result->user_avatar);
						$params->set('user_email', $result->user_email);
						$params->set('has_packages', $result->has_packages);
						$params->set('has_inactive_packages', $result->has_inactive_packages);
						$params->set('has_active_packages', $result->has_active_packages);
						$this->store($params);
					}
				} elseif (preg_match('#<title>([^<]+)<#msi', $buff, $match)) {
					$this->setError($match[1]);
				}
			} else $this->setError(Text::_('FWMG_NO_RESPONSE_FROM_REMOTE_SERVER'));
		} else $this->setError(Text::_('FWMG_NO_CODE_TO_VERIFY'));
		return $result;
	}
	function getChangelog() {
		if ($buff = fwgHelper::request(FWMG_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=changelog&format=raw&package='.FWMG_UPDATE_NAME)) {
			$tmp = json_decode((string)$buff);
			if (!empty($tmp->msg)) $this->setError($tmp->msg);
			if ($tmp->result) {
				return $tmp->result;
			}
		}
	}
	function revokeCode() {
		$data = new stdclass;
		$params = ComponentHelper::getParams('com_fwgallery');
		$params->set('verified_code', '');
		$params->set('update_code', '');
		$data->result = $this->store($params);
		return $data;
	}

	/* modal support */
    function _collectFilesWhere() {
        $where = array(
            'f.type = \'image\''
        );
		$input = Factory::getApplication()->input;
        if ($data = $input->getString('search')) {
        	$db = Factory::getDBO();
            $where[] = '(f.name LIKE \'%'.$db->escape($data).'%\')';
        }
        if ($data = (int)$input->getInt('category_id')) {
            $where[] = 'f.category_id = '.$data;
        }
        return $where?('WHERE '.implode(' AND ', $where)):'';
    }
    function loadFiles() {
        $app = Factory::getApplication();
		$input = $app->input;
        $db = Factory::getDBO();
        $db->setQuery('
SELECT
    f.*,
    u.name AS _user_name,
    p.name AS _category_name
FROM
    `#__fwsg_file` AS f
    LEFT JOIN `#__fwsg_category` AS p ON f.category_id = p.id
    LEFT JOIN `#__users` AS u ON u.id = f.user_id
'.$this->_collectFilesWhere().'
ORDER BY
    p.ordering,
    f.ordering',
    		$input->getUInt('limitstart', 0),
    		$input->getUInt('limit', $app->getCfg('list_limit'))
		);
		return $db->loadObjectList();
	}
    function getFilesQty() {
        $db = Factory::getDBO();
        $db->setQuery('
SELECT
    COUNT(*)
FROM
    `#__fwsg_file` AS f
    LEFT JOIN `#__fwsg_category` AS p ON f.category_id = p.id
    '.$this->_collectFilesWhere());
        return $db->loadResult();
    }
	function getFilesPagination() {
        $app = Factory::getApplication();
        return new Pagination(
        	$this->getFilesQty(),
    		$app->input->getUInt('limitstart', 0),
    		$app->input->getUInt('limit', $app->getCfg('list_limit'))
    	);
	}
    function _collectGalleriesWhere() {
        $where = array();
        $db = Factory::getDBO();

		$input = Factory::getApplication()->input;
        if ($data = $input->getString('search')) {
            $where[] = "p.name LIKE '%".$db->escape($data)."%'";
        }

        return $where?('WHERE '.implode(' AND ', $where)):'';
    }
    function getGalleries() {
        $db = Factory::getDBO();
        $app = Factory::getApplication();
		$input = $app->input;
        $limitstart = (int)$input->getInt('limitstart', 0);
        $limit = (int)$input->getInt('limit', $app->getCfg('list_limit'));
		$list = array();

    	if ($where = $this->_collectGalleriesWhere()) {
	        $db->setQuery('
SELECT
    p.*,
	p.name AS treename,
	p.user_id AS _user_id,
    u.name AS _user_name,
	(SELECT g.title FROM #__viewlevels AS g WHERE g.id = p.`access`) AS _group_name,
	(SELECT COUNT(*) FROM `#__fwsg_file` AS f WHERE f.category_id = p.id AND f.`type` = \'image\') AS _qty
FROM
    `#__fwsg_category` AS p
    LEFT JOIN `#__users` AS u ON u.id = p.user_id
'.$where.'
ORDER BY
	p.parent,
    p.ordering',
    			$limitstart,
    			$limit
			);
	        $list = $db->loadObjectList();
    	} else {
	        $db->setQuery('
SELECT
    p.*,
    u.name AS _user_name,
	(SELECT g.title FROM #__viewlevels AS g WHERE g.id = p.`access`) AS _group_name,
	(SELECT COUNT(*) FROM `#__fwsg_file` AS f WHERE f.category_id = p.id) AS _qty
FROM
    `#__fwsg_category` AS p
    LEFT JOIN `#__users` AS u ON u.id = p.user_id
ORDER BY
	p.parent,
    p.ordering'
			);
	        if ($rows = $db->loadObjectList()) {
	            $children = array();
	            foreach ($rows as $v) {
	                $pt = $v->parent;
	                $list = @$children[$pt] ? $children[$pt] : array();
	                array_push( $list, $v );
	                $children[$pt] = $list;
	            }
		        $levellimit = 10;
	            $list = HTMLHelper::_('fwsgCategory.treerecurse', 0, '', array(), $children, max( 0, $levellimit-1 ) );
	            if ($limit) $list = array_slice($list, $limitstart, $limit);
	        }
    	}

        return $list;
	}
    function getGalleriesQty() {
        $db = Factory::getDBO();
        $db->setQuery('SELECT COUNT(*) FROM `#__fwsg_category` AS p '.$this->_collectGalleriesWhere());
        return $db->loadResult();
    }
	function getGalleriesPagination() {
        $app = Factory::getApplication();
        return new Pagination(
        	$this->getGalleriesQty(),
    		$app->input->getUInt('limitstart', 0),
    		$app->input->getUInt('limit', $app->getCfg('list_limit'))
    	);
	}
	function save() {
		$category = Table::getInstance('category', 'table');
        $user = Factory::getUser();
        if ($user->authorise('core.create', 'com_content')) {
			$input = Factory::getApplication()->input;
            $id = $input->post->getInt('oid');
            if ($id) {
				$category->load($id);
			}

            if ($category->bind($input->getArray(array(), null, 'RAW'), array('id', 'user_id', 'created', 'ordering', 'color')) and $category->check() and $category->store()) {
    			$this->setError(Text::sprintf('FWMG_GALLERY_SUCCESSFULLY_ADDED', $category->name));
    			return true;
    		} else $this->setError($category->getError());
        } else $this->setError(Text::_('FWMG_CONTENT_ADMINS_ONLY_ACCESS'));
	}
	function checkPreviousVersion() {
		$db = Factory::getDBO();
		$tables = $db->getTableList();
		if (in_array($db->getPrefix().'fwmg_projects', $tables)) {
			$db->setQuery('SELECT COUNT(*) FROM `#__fwmg_projects`');
			if ($db->loadResult()) {
				$size = 0;
				$path = JPATH_SITE.'/images/com_fwgallery';
				if (is_dir($path)) {
					$files = Folder::files($path, '.*', true, true);
					if ($files) {
						foreach ($files as $file) {
							$size += filesize($file);
						}
					}
				}
				return max(1, ceil($size/1048576))*1048576;
			}
		}
	}
	function importPrevData() {
		set_time_limit(1200);
        ini_set('memory_limit', '2G');

		fwgHelper::clearImageCache();

		$input = Factory::getApplication()->input;
		$db = Factory::getDBO();
		$tables = $db->getTableList();
		$errors = 0;
		$src_path = JPATH_SITE.'/images/com_fwgallery/files/';
		$trg_path = FWMG_STORAGE_PATH;

		if (!file_exists($trg_path) and !File::write($trg_path.'index.html', $buff = '<html><head><title></title></head><body></body></html>')) {
			$this->setError(Text::_('FWMG_CANT_CREATE_FOLDER').' '.$trg_path);
			return false;
		}
		if (!is_writable($trg_path)) {
			$this->setError(Text::_('FWMG_TARGET_FOLDER_NOT_WRITEABLE').' '.$trg_path);
			return false;
		}

		/* check watermark */
		$lparams = ComponentHelper::getParams('com_fwgallerylight');
		$params = ComponentHelper::getParams('com_fwgallery');
		if ($wmf = $lparams->get('watermark_file')) {
			$path = JPATH_SITE.'/images/com_fwgallery/';
			if (file_exists($path.$wmf)) {
				$params->set('watermark_file', $wmf);
				fwgHelper::storeConfig($params);

				if ($input->getInt('remove_previous_data')) {
					File::move($path.$wmf, $trg_path.$wmf);
				} else {
					File::copy($path.$wmf, $trg_path.$wmf);
				}
			}
		} elseif ($wmf = $params->get('watermark_file')) {
			$path = JPATH_SITE.'/images/com_fwgallery/';
			if (file_exists($path.$wmf)) {
				if ($input->getInt('remove_previous_data')) {
					File::move($path.$wmf, $trg_path.$wmf);
				} else {
					File::copy($path.$wmf, $trg_path.$wmf);
				}
			}
		}

		if (in_array($db->getPrefix().'fwmg_projects', $tables)) {
			$db->setQuery('SELECT * FROM `#__fwmg_projects`');
			if ($list = $db->loadObjectList()) {
				foreach ($list as $row) {
					$table = Table::getInstance('Category', 'Table');
					if ($table->load($row->id)) {
						$file_exists = (($table->media == 'none' and $table->sys_filename and $tmp_path = fwgHelper::getImagePath($table->sys_filename) and file_exists($tmp_path.$table->sys_filename)) or ($table->media == 'mp4' and $table->media_code and $tmp_path = fwgHelper::getImagePath($table->media_code) and file_exists($tmp_path.$table->media_code)));

						if ($table->name == $row->name and $file_exists) {
							continue;
						} else {
							$table->delete($row->id);
						}
					}

					$db->setQuery('INSERT INTO `#__fwsg_category` SET
	`id` = '.(int)$row->id.',
	`published` = '.(int)$row->published.',
	`parent` = '.(int)$row->parent.',
	`ordering` = '.(int)$row->ordering.',
	`access` = '.(int)$row->gid.',
	`created` = '.$db->quote($row->created).',
	`updated` = '.$db->quote($row->updated).',
	`user_id` = '.(int)$row->user_id.',
	`name` = '.$db->quote($row->name).',
	`sys_filename` = '.$db->quote($row->sys_filename).',
	`filename` = '.$db->quote($row->filename).',
	`descr` = '.$db->quote($row->descr).',
	`alias` = '.$db->quote(OutputFilter::stringURLSafe($row->name)).',
	`media` = '.$db->quote(empty($row->media)?'':$row->media).',
	`media_code` = '.$db->quote(empty($row->media_code)?'':$row->media_code).',
	`latitude` = '.$db->quote(empty($row->latitude)?'':$row->latitude).',
	`longitude` = '.$db->quote(empty($row->longitude)?'':$row->longitude)
					);
					if ($db->execute()) {
						if ($row->sys_filename and file_exists($src_path.$row->sys_filename)) {
							$trg_path = fwgHelper::getImagePath($row->sys_filename);
							if (!file_exists($trg_path) and !File::write($trg_path.'index.html', $buff = '<html><head><title></title></head><body></body></html>')) {
								$this->setError(Text::_('FWMG_CANT_CREATE_FOLDER').' '.$trg_path);
								return false;
							}

							if ($input->getInt('remove_previous_data')) {
								if (!File::move($src_path.$row->sys_filename, $trg_path.$row->sys_filename)) {
									$this->setError(Text::sprintf('FWMG_CANT_MOVE_FILE_FROM_TO', $src_path.$row->sys_filename, $trg_path.$row->sys_filename));
									return false;
								}
							} else {
								if (!File::copy($src_path.$row->sys_filename, $trg_path.$row->sys_filename)) {
									$this->setError(Text::sprintf('FWMG_CANT_COPY_FILE_FROM_TO', $src_path.$row->sys_filename, $trg_path.$row->sys_filename));
									return false;
								}
							}
						}
						if (!empty($row->media) and $row->media == 'mp4' and $row->media_code and file_exists($src_path.$row->media_code)) {
							$trg_path = fwgHelper::getImagePath($row->media_code);
							if (!file_exists($trg_path)) {
								File::write($trg_path.'index.html', $buff = '<html><head><title></title></head><body></body></html>');
							}
							if ($input->getInt('remove_previous_data')) {
								if (!File::move($src_path.$row->media_code, $trg_path.$row->media_code)) {
									$this->setError(Text::sprintf('FWMG_CANT_MOVE_FILE_FROM_TO', $src_path.$row->media_code, $trg_path.$row->media_code));
									return false;
								}
							} else {
								if (!File::copy($src_path.$row->media_code, $trg_path.$row->media_code)) {
									$this->setError(Text::sprintf('FWMG_CANT_COPY_FILE_FROM_TO', $src_path.$row->media_code, $trg_path.$row->media_code));
									return false;
								}
							}
						}
					} else {
						$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
						return false;
					}
				}
			}
		}

		if (in_array($db->getPrefix().'fwmg_files', $tables)) {
			$db->setQuery('SELECT f.*, (SELECT p.user_id FROM `#__fwmg_projects` AS p WHERE p.id = f.project_id LIMIT 1) AS _user_id FROM `#__fwmg_files` AS f');

			if ($list = $db->loadObjectList()) {
				foreach ($list as $row) {
					$table = Table::getInstance('File', 'Table');
					if ($table->load($row->id)) {
						/* skip copying if the name is same and file(s) attached */
						if ($table->name == $row->name and fwgHelper::fileDownloadable($table)) {
							continue;
						} else {
							$table->delete($row->id);
						}
					}

					$db->setQuery('INSERT INTO `#__fwsg_file` SET
	`id` = '.(int)$row->id.',
	`type` = '.$db->quote($row->type_id == 1?'image':'video').',
	`published` = '.(int)$row->published.',
	`ordering` = '.(int)$row->ordering.',
	`access` = 0,
	`created` = '.$db->quote($row->created).',
	`updated` = '.$db->quote($row->created).',
	`category_id` = '.(int)$row->project_id.',
	`user_id` = '.(int)$row->user_id.',
	`hits` = '.(int)(empty($row->hits)?0:$row->hits).',
	`downloads` = '.(int)(empty($row->downloads)?0:$row->downloads).',
	`name` = '.$db->quote($row->name).',
	`copyright` = '.$db->quote($row->copyright).',
	`descr` = '.$db->quote($row->descr).',
	`alias` = '.$db->quote(OutputFilter::stringURLSafe($row->name))
					);
					if ($db->execute()) {
						if ($row->latitude and $row->longitude) {
							$db->setQuery('INSERT INTO `#__fwsg_file_location` SET
	`file_id` = '.(int)$row->id.',
	`address` = \'\',
	`latitude` = '.$db->quote($row->latitude).',
	`longitude` = '.$db->quote($row->longitude)
							);
							if (!$db->execute()) {
								$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
								return false;
							}
						}
						if ($row->original_filename and file_exists($src_path.$row->_user_id.'/'.$row->original_filename)) {
							$trg_path = fwgHelper::getImagePath($row->original_filename);
							if (!file_exists($trg_path)) {
								File::write($trg_path.'index.html', $buff = '<html><head><title></title></head><body></body></html>');
							}
							if ($input->getInt('remove_previous_data')) {
								if (!File::move($src_path.$row->_user_id.'/'.$row->original_filename, $trg_path.$row->original_filename)) {
									$this->setError(Text::sprintf('FWMG_CANT_MOVE_FILE_FROM_TO', $src_path.$row->_user_id.'/'.$row->original_filename, $trg_path.$row->original_filename));
									return false;
								}
							} else {
								if (!File::copy($src_path.$row->_user_id.'/'.$row->original_filename, $trg_path.$row->original_filename)) {
									$this->setError(Text::sprintf('FWMG_CANT_COPY_FILE_FROM_TO', $src_path.$row->_user_id.'/'.$row->original_filename, $trg_path.$row->original_filename));
									return false;
								}
							}

							$info = (array)getimagesize($trg_path.$row->original_filename);
							$width = (int)ArrayHelper::getValue($info, 0);
							$height = (int)ArrayHelper::getValue($info, 1);
							$size = (int)filesize($trg_path.$row->original_filename);

							$db->setQuery('INSERT INTO `#__fwsg_file_image` SET
	`file_id` = '.$row->id.',
	`sys_filename` = '.$db->quote($row->original_filename).',
	`filename` = '.$db->quote($row->filename).',
	`alt` = '.$db->quote($row->name).',
	`width` = '.(int)$width.',
	`height` = '.(int)$height.',
	`size` = '.(int)$size
							);
							if (!$db->execute()) {
								$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
								return false;
							}
						}
						if ($row->type_id == 2) {
							if ($row->media == 'mp4') {
								if ($row->media_code and file_exists($src_path.$row->_user_id.'/'.$row->media_code)) {
									$trg_path = fwgHelper::getImagePath($row->media_code);
									if (!file_exists($trg_path)) {
										File::write($trg_path.'index.html', $buff = '<html><head><title></title></head><body></body></html>');
									}
									if ($input->getInt('remove_previous_data')) {
										if (!File::move($src_path.$row->_user_id.'/'.$row->media_code, $trg_path.$row->media_code)) {
											$this->setError(Text::sprintf('FWMG_CANT_MOVE_FILE_FROM_TO', $src_path.$row->_user_id.'/'.$row->media_code, $trg_path.$row->media_code));
											return false;
										}
									} else {
										if (!File::copy($src_path.$row->_user_id.'/'.$row->media_code, $trg_path.$row->media_code)) {
											$this->setError(Text::sprintf('FWMG_CANT_COPY_FILE_FROM_TO', $src_path.$row->_user_id.'/'.$row->media_code, $trg_path.$row->media_code));
											return false;
										}
									}

									$db->setQuery('INSERT INTO `#__fwsg_file_video` SET
	`file_id` = '.(int)$row->id.',
	`media` = \'mp4\',
	`sys_filename` = '.$db->quote($row->media_code).',
	`filename` = '.$db->quote($row->media_code).',
	`size` = '.(int)filesize($trg_path.$row->media_code)
									);
									if (!$db->execute()) {
										$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
										return false;
									}
								}
							} else {
								$db->setQuery('INSERT INTO `#__fwsg_file_video` SET
	`file_id` = '.(int)$row->id.',
	`media` = '.$db->quote($row->media).',
	`code` = '.$db->quote($row->media_code)
								);
								if (!$db->execute()) {
									$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
									return false;
								}
							}
						}
					} else {
						$errors++;
					}
				}
			}
		}

		if (in_array($db->getPrefix().'fwmg_files_vote', $tables)) {
			$db->setQuery('DELETE FROM `#__fwsg_file_vote`');
			$db->execute();
			$db->setQuery('SELECT * FROM `#__fwmg_files_vote`');
			if ($list = $db->loadObjectList()) {
				foreach ($list as $row) {
					$db->setQuery('INSERT INTO `#__fwsg_file_vote` SET
	`file_id` = '.(int)$row->file_id.',
	`user_id` = '.(int)$row->user_id.',
	`value` = '.(int)$row->value.',
	`ipaddr` = '.$db->quote($row->ipaddr)
					);
					if (!$db->execute()) {
						$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
						return false;
					}
				}
			}
		}
		if (in_array($db->getPrefix().'fwmg_files_thumbs_vote', $tables)) {
			$db->setQuery('SELECT * FROM `#__fwmg_files_thumbs_vote`');
			if ($list = $db->loadObjectList()) {
				foreach ($list as $row) {
					$db->setQuery('INSERT INTO `#__fwsg_file_vote` SET
	`file_id` = '.(int)$row->file_id.',
	`user_id` = '.(int)$row->user_id.',
	`value` = '.(int)(($row->value > 0)?5:1).',
	`ipaddr` = '.$db->quote($row->ipaddr)
					);
					if (!$db->execute()) {
						$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
						return false;
					}
				}
			}
		}
		if (in_array($db->getPrefix().'fwmg_tags', $tables)) {
			$db->setQuery('SELECT * FROM `#__fwmg_tags`');
			if ($list = $db->loadObjectList()) {
				foreach ($list as $i=>$row) {
					$db->setQuery('SELECT id, name FROM `#__fwsg_tag` WHERE id = '.$row->id);
					if ($obj = $db->loadObject()) {
						if ($obj->name == $row->name) {
							continue;
						} else {
							$table = Table::getInstance('Tag', 'Table');
							if ($table->load($row->id)) {
								$table->delete($row->id);
							}
						}
					}

					$db->setQuery('INSERT INTO `#__fwsg_tag` SET
	`id` = '.(int)$row->id.',
	`published` = 1,
	`ordering` = '.($i + 1).',
	`name` = '.$db->quote($row->name).',
	`alias` = '.$db->quote(OutputFilter::stringURLSafe($row->name))
					);
					if (!$db->execute()) {
						$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
						return false;
					}
				}
			}
		}
		if (in_array($db->getPrefix().'fwmg_projects_tags', $tables)) {
			$db->setQuery('DELETE FROM `#__fwsg_category_tag`');
			$db->execute();

			$db->setQuery('INSERT INTO `#__fwsg_category_tag` (category_id, tag_id) SELECT project_id, tag_id FROM `#__fwmg_projects_tags`');
			if (!$db->execute()) {
				$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
				return false;
			}
		}

		if (in_array($db->getPrefix().'fwmg_files_tags', $tables)) {
			$db->setQuery('DELETE FROM `#__fwsg_file_tag`');
			$db->execute();

			$db->setQuery('INSERT INTO `#__fwsg_file_tag` (file_id, tag_id) SELECT file_id, tag_id FROM `#__fwmg_files_tags`');
			if (!$db->execute()) {
				$this->setError(Text::_('FWMG_DB_ERROR').' '.$db->getError());
				return false;
			}
		}

		fwgHelper::clearImageCache('');

		if (!$errors) {
			if ($input->getInt('remove_previous_data')) {
				$list = array('files', 'files_tags', 'files_thumbs_vote', 'files_vote', 'file_prices', 'projects', 'projects_tags', 'tags', 'types');
				foreach ($list as $table) {
					if (in_array($db->getPrefix().'fwmg_'.$table, $tables)) {
						$db->setQuery('DROP TABLE #__fwmg_'.$table);
						$db->execute();
					}
				}
				Folder::delete($src_path);
			}
			$this->setError(Text::_('FWMG_DATA_IMPORT_COMPLETED'));
			return true;
		} else {
			$this->setError(Text::_('FWMG_THERE_WERE_ERRORS_CHECK_WRITE_ACCESS'));
		}
	}
	function checkCode($verify=true) {
		$params = ComponentHelper::getParams('com_fwgallery');
		if ($verify and $code = $params->get('verified_code')) {
			Factory::getApplication()->input->set('access_code', $code);
			$this->verifyCode();
		}
	}
	function clearCachedImages() {
		fwgHelper::clearImageCache();
		$this->setError(Text::_('FWMG_ADMIN_DASHBOARD_CACHE_CLEARED'));
	}
	function loadWizards() {
		$data = array(
			'wizards'=>array(),
			'install'=>array(),
			'update'=>array()
		);
		$params = ComponentHelper::getParams('com_fwgallery');
		$update_code = $params->get('update_code');
		if (!$update_code) {
			$data['wizards'][] = (object)array(
				'ordering'=>1,
				'active'=>1,
				'title'=>'<a href="javascript:" fwk-toggle="target: #fwmg-login-register">'.Text::_('FWMG_WIZARD_VERIFY_TITLE').'</a>',
				'text'=>Text::_('FWMG_WIZARD_VERIFY'),
				'icon'=>'user',
				'buttons'=>''
			);
		}
		$quickcheck = $this->quickCheck($check_orphans=false);
		if (!$quickcheck->test_passed) {
			$data['wizards'][] = (object)array(
				'ordering'=>2,
				'active'=>1,
				'title'=>'<a href="index.php?option=com_fwgallery&view=fwgallery#quick-check">'.Text::_('FWMG_WIZARD_QUICKCHECK_TITLE').'</a>',
				'text'=>Text::_('FWMG_WIZARD_QUICKCHECK'),
				'icon'=>'tasks',
				'buttons'=>''
			);
		}
		$stat = $this->localStat();
		if (empty($stat->ct)) {
			$data['wizards'][] = (object)array(
				'ordering'=>3,
				'active'=>1,
				'title'=>'<a href="javascript:" fwk-toggle="target: #fwmg-quick-categories">'.Text::_('FWMG_WIZARD_CATEGORIES_TITLE').'</a>',
				'text'=>Text::_('FWMG_WIZARD_CATEGORIES'),
				'icon'=>'folder',
				'buttons'=>''
			);
		}
		if (empty($stat->files_qty)) {
			$data['wizards'][] = (object)array(
				'ordering'=>4,
				'active'=>1,
				'title'=>'<a href="javascript:" fwk-toggle="target: #fwmg-batch-upload">'.Text::_('FWMG_WIZARD_FILES_TITLE').'</a>',
				'text'=>Text::_('FWMG_WIZARD_FILES'),
				'icon'=>'photo-video',
				'buttons'=>''
			);
		}
		if (empty($stat->menus_qty)) {
			$data['wizards'][] = (object)array(
				'ordering'=>5,
				'active'=>1,
				'title'=>'<a href="index.php?option=com_menus&view=item&client_id=0&layout=edit">'.Text::_('FWMG_WIZARD_MENU_TITLE').'</a>',
				'text'=>Text::_('FWMG_WIZARD_MENU'),
				'icon'=>'desktop',
				'buttons'=>''
			);
		}
		if ($update_code) {
			if (empty($params->get('template'))) {
				$data['wizards'][] = (object)array(
					'ordering'=>3,
					'active'=>0,
					'title'=>'<a href="'.(class_exists('Joomla\CMS\Version')?'index.php?option=com_fwgallery&view=':'admin.php?page=fwmg-').'addon">'.Text::_('FWMG_WIZARD_DESING_TITLE').'</a>',
					'text'=>Text::_('FWMG_WIZARD_DESIGN'),
					'icon'=>'folder',
					'buttons'=>''
				);
			}
			$addons = fwgHelper::getPluginsData();
			if ($addons) {
				foreach ($addons as $row) {
					if ($row->loc_version and $row->rem_version and $row->loc_version != 'x.x.x' and $row->loc_version != $row->rem_version) {
						$data['update'][] = (object)array('name'=>$row->name, 'update_name'=>$row->update_name);
					}
					if (empty($row->installed) and !empty($row->installable)) {
						$data['install'][] = (object)array('name'=>$row->name, 'update_name'=>$row->update_name);
					}
				}
			}
			$has_current_subscr = false;
			if ($subscr = json_decode((string)$params->get('subscr_data')) and is_array($subscr)) {
				$now = time();
				foreach ($subscr as $row) {
					if ($row->time_end > $now) {
						$has_current_subscr = true;
						break;
					}
				}
			}
			if (!$has_current_subscr) {
				$data['wizards'][] = (object)array(
					'ordering'=>6,
					'active'=>1,
					'title'=>'<a href="https://fastw3b.com/products/fw-gallery#pricing" target="_blank">'.Text::_('FWMG_WIZARD_ADDONS_TITLE').'</a>',
					'text'=>Text::_('FWMG_WIZARD_ADDONS'),
					'icon'=>'puzzle-piece',
					'buttons'=>''
				);
    		}
			$data['wizards'][] = (object)array(
				'ordering'=>7,
				'active'=>1,
				'title'=>'<a href="https://fastw3b.com/services/custom-development-business-automation" target="_blank">'.Text::_('FWMG_WIZARD_CUSTOM_TITLE').'</a>',
				'text'=>Text::_('FWMG_WIZARD_CUSTOM'),
				'icon'=>'code',
				'buttons'=>''
			);
			if ($data['update']) {
				$data['wizards'][] = (object)array(
					'ordering'=>8,
					'active'=>1,
					'title'=>'<a href="javascript:" fwk-toggle="target: #fwmg-update">'.Text::_('FWMG_WIZARD_UPDATE_TITLE').'</a>',
					'text'=>Text::_('FWMG_WIZARD_UPDATE'),
					'icon'=>'sync',
					'buttons'=>''
				);
			}
			if ($data['install']) {
				$data['wizards'][] = (object)array(
					'ordering'=>9,
					'active'=>1,
					'title'=>'<a href="javascript:" fwk-toggle="target: #fwmg-install">'.Text::_('FWMG_WIZARD_INSTALL_TITLE').'</a>',
					'text'=>Text::_('FWMG_WIZARD_INSTALL'),
					'icon'=>'download',
					'buttons'=>''
				);
		    }
			if ($remote_langs = json_decode($params->get('langs_data', '[]'))) {
				$langs = array();
				$list = fwgHelper::getInstalledLanguages();

				foreach ($list as $row) {
					if ($params->get('translation_requested_'.$row->tag) and !empty($remote_langs->{$row->tag})) {
						$params->set('translation_requested_'.$row->tag, 0);
						fwgHelper::storeConfig($params);
						$langs[] = $row->name;
					}
				}
				if ($langs) {
					$data['wizards'][] = (object)array(
						'ordering'=>10,
						'active'=>1,
						'title'=>'<a href="index.php?option=com_fwgallery&view=translation">'.Text::_('FWMG_WIZARD_TRANSLATION_TITLE').'</button>',
						'text'=>Text::sprintf('FWMG_WIZARD_TRANSLATION', implode(', ', $langs)),
						'icon'=>'download',
						'buttons'=>''
					);
				}
			}
		}
		ArrayHelper::sortObjects($data['wizards'], 'ordering');
		return $data;
	}
	function getLanguages() {
		$langs = fwgHelper::getInstalledLanguages();
		foreach ($langs as $i=>$lang) {
			$overrides_qty = 0;
			$filename = FWMG_LANGUAGE_SITE.'/language/overrides/'.$lang->tag.'.override.ini';
			if (file_exists($filename)) {
				$buff = file_get_contents($filename);
				$overrides_qty += substr_count($buff, 'FWMG_');
			}
			$filename = FWMG_LANGUAGE_ADMINISTRATOR.'/language/overrides/'.$lang->tag.'.override.ini';
			if (file_exists($filename)) {
				$buff = file_get_contents($filename);
				$overrides_qty += substr_count($buff, 'FWMG_');
			}
			$filename = FWMG_LANGUAGE_SITE.'/language/'.$lang->tag.'/'.$lang->tag.'.com_fwgallery.ini';
			$langs[$i]->md5 = file_exists($filename)?md5_file($filename):'';
			$langs[$i]->installed = file_exists($filename);
			$langs[$i]->overrides_qty = $overrides_qty;
		}

		return $langs;
	}
}
