<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\Model\BaseModel;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Pagination\Pagination;

class fwGalleryModelTag extends BaseModel {
    function getUserState($name, $def='', $type='cmd') {
        $app = Factory::getApplication();
        return $app->getUserStateFromRequest('com_fwgallery.tag.'.$name, $name, $def, $type);
    }
    function getPagination() {
        $app = Factory::getApplication();
        return new Pagination(
        	$this->loadQty(),
    		$app->input->getInt('limitstart'),
    		$app->input->getInt('limit', $app->getCfg('list_limit'))
    	);
    }
    function getFileTypes() {
        $types = array((object)array('id'=>'image', 'name'=>Text::_('FWMG_IMAGE')));
        $buff = Factory::getApplication()->triggerEvent('ongetType', array('com_fwgallery'));
        if ($buff) {
            foreach ($buff as $type) {
                if ($type) {
                    $types[] = (object)array('id'=>$type, 'name'=>Text::_('FWMG_'.$type));
                }
            }
        }
        return $types;
    }
    function loadList() {
        $app = Factory::getApplication();
        $list = array();
        $app->triggerEvent('onloadList', array('com_fwgallery.tag', $this, &$list));
        return $list;
    }
    function loadQty() {
        $app = Factory::getApplication();
        $qty = 0;
        $app->triggerEvent('onloadQty', array('com_fwgallery.tag', $this, &$qty));
        return $qty;
    }
    function save() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onsave', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function remove() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onremove', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function saveorder() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onsaveorder', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function orderdown() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onorderdown', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function orderup() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onorderup', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function publish() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onpublish', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function unpublish() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onunpublish', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function select() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onselect', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function unselect() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onunselect', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function install() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('oninstall', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
    function loadObject() {
        $app = Factory::getApplication();
        $data = $app->triggerEvent('onloadObject', array('com_fwgallery.tag', $this));
        if ($data) {
            foreach ($data as $row) {
                if ($row) {
                    return $row;
                }
            }
        }
    }
}
