<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

echo LayoutHelper::render('common.menu_begin', array(
    'title' => '',
    'title_hint' => Text::_('FWMG_DOC_ADMIN_ADDONS_HINT'),
    'right_panel' => $this->loadTemplate('right_panel'),
    'view' => $this,
), FWMG_COMPONENT_ADMINISTRATOR);
$statuses = array(
    HTMLHelper::_('select.option', '', Text::_('FWMG_DOC_ADMIN_ADDONS_FILTER_STATUS'), 'id', 'name')
);
if ($this->addon_installed) {
    $statuses[] = HTMLHelper::_('select.option', 'installed+', Text::_('FWMG_ADDON_INSTALLED'), 'id', 'name');
    $statuses[] = HTMLHelper::_('select.option', 'enabled', Text::_('FWMG_ENABLED'), 'id', 'name');
    $statuses[] = HTMLHelper::_('select.option', 'disabled', Text::_('FWMG_DISABLED'), 'id', 'name');
}
if ($this->addon_not_installed) {
    $statuses[] = HTMLHelper::_('select.option', 'noninstalled', Text::_('FWMG_ADDON_NOT_INSTALLED'), 'id', 'name');
}
if ($this->updates) {
    $statuses[] = HTMLHelper::_('select.option', 'update', Text::_('FWMG_CAN_BE_UPDATED'), 'id', 'name');
}
?>
<form class="fwa-add-ons" action="index.php?option=com_fwgallery&amp;view=addon" id="adminForm" name="adminForm" method="post">
    <div class="fwk-grid-divider" fwk-grid>
        <div class="fwk-width-expand">
            <div class="fwk-margin-top fwk-flex-between" fwk-grid>
                <div class="fwk-width-expand@s">
                    <div class="fwk-position-relative fwk-width-1-2@s">
                        <span class="fwk-form-icon fwk-text-green" fwk-icon="icon: search"></span>
                        <input class="fwk-input" placeholder="<?php echo Text::_('FWMG_DOC_ADMIN_ADDONS_FILTER_SEARCH'); ?>" name="search" type="text" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_ADDONS_FILTER_SEARCH_HINT'); ?>" />
                    </div>
                </div>
                <div class="fwk-width-auto@s">
                    <div class="fwk-flex">
<?php
if ($this->updates) {
?>
                        <div class="fwk-position-relative"><button type="button" class="fwk-button fwk-button-small fwk-text-nowrap fwk-button-secondary fwa-update-all fwk-margin-small-right" data-exts="<?php echo esc_attr(implode(',', $this->updates)); ?>"><?php echo Text::_('FWMG_UPDATE_ALL'); ?></button></div>
<?php
}
?>
                        <?php echo HTMLHelper::_('select.genericlist', $statuses, 'status', 'class="fwk-select"  fwk-tooltip="'.esc_attr(Text::_('FWMG_DOC_ADMIN_ADDONS_FILTER_STATUS_HINT')).'"', 'id', 'name', '', 'fwmg-status'); ?>
                    </div>
                </div>
            </div>

            <div id="fwmg-addons-wrp" class="fwk-margin-top" fwk-margin>
<?php
foreach ($this->addons as $row) {
    if ($row->type and $row->update_name != FWMG_UPDATE_NAME) {
        $classes = array('fwk-background-muted fwk-border-rounded fwk-padding-small');
        $image = $row->image?$row->image:(FWMG_ADMIN_ASSETS_URL.'images/def_addon.png');
        $installed = empty($row->installed)?'':$row->installed;
        $installable = empty($row->installable)?'':$row->installable;
        $loc_version = empty($row->loc_version)?'':$row->loc_version;
        $rem_version = empty($row->rem_version)?'':$row->rem_version;
        $update = ($loc_version and $loc_version != 'x.x.x' and $rem_version and version_compare($loc_version, $rem_version, '<'));

        $loc_version_class = $installed?($update?'warning':'green-warm'):'muted';
        $status = $installed?($row->enabled?($update?'update enabled installed+':'enabled installed+'):'disabled installed+'):($installable?'noninstalled':'');
?>
                <div class="<?php echo implode(' ', $classes); ?>" data-search="<?php echo $this->escape($row->name); ?>" data-status="<?php echo $status; ?>" data-ext="<?php echo $this->escape($row->update_name); ?>">
                    <div class="fwk-grid-small" fwk-grid>
                        <div class="fwk-width-auto@m">
<?php
        if (!empty($row->link)) {
?>
                            <a href="<?php echo $row->link; ?>" target="_blank">
<?php
        }
?>
                            <div class="fwk-cover-container fwk-border-rounded" style="width: 88px; height: 60px;">
                                <img class="" src="<?php echo $image; ?>" alt="<?php echo $this->escape($row->name); ?>" fwk-cover>
                            </div>
<?php
        if (!empty($row->link)) {
?>
                            </a>
<?php
        }
?>
                        </div>
                        <div class="fwk-width-expand@m">
                            <div>
                                <strong><?php echo $row->name; ?></strong>
                                <span class="fwk-margin-small-left fwa-addon-version fwk-text-<?php echo $loc_version_class; ?> fwk-text-bold"><?php echo $loc_version; ?></span>
<?php
        if ($update) {
?>
                                <span class="fwk-margin-small-left fwk-label fwk-label-secondary fwa-update-version"><?php echo Text::_('FWMG_UPDATE'); ?> v.<?php echo $rem_version; ?></span>
<?php
        }
        if (!empty($row->_required)) {
?>
                                <span class="fwk-margin-small-left fwk-text-danger" fwk-tooltip title="<?php echo $this->escape(implode(', ', $row->_required)); ?> <?php echo $this->escape(Text::_('FWMG_REQUIRED')); ?>"><span fwk-icon="warning"></span></span>
<?php
        }
        if (!empty($row->_com_version)) {
            $version_match = ($this->com_version == 'x.x.x' or version_compare($this->com_version, $row->_com_version, '>='));
?>
                                <span class="fwk-margin-small-left fwk-text-<?php if ($version_match) { ?>success<?php } else { ?>danger<?php } ?>" fwk-tooltip title="<?php echo $this->escape(Text::_('FWMG_MAIN_COMPONENT_REQUIRED_VERSION')); ?>: <?php echo $this->escape($row->_com_version); ?>">
                                    <span fwk-icon="icon:cube;"></span>
                                </span>
<?php
        }
?>
                            </div>
                            <div class="fwk-text-muted fwk-text-small fwk-margin-xsmall-top"><?php echo fwgHelper::stripTags($row->description, 120, false, true); ?></div>
                        </div>
                        <div class="fwk-width-auto@m fwk-flex fwk-flex-middle fwa-addon-info">
<?php
        if (!empty($row->link)) {
?>
                            <a href="<?php echo $row->link; ?>" target="_blank" class="fwk-button fwk-button-square fwk-margin-small-right<?php if ($installed) { ?> fwk-button-green<?php } ?>" fwk-icon="fwa-document" fwk-tooltip title="<?php echo $this->escape(Text::_('FWMG_VIEW_ADDON_DETALED_VIEW')); ?>"></a>
<?php
        }
        if (!empty($row->doc_link)) {
?>
                            <a class="fwk-button fwk-button-square fwk-margin-small-right fwa-addon-docs<?php if ($installed) { ?> fwk-button-blue<?php } ?>" href="<?php echo $row->doc_link; ?>" target="_blank" fwk-tooltip title="<?php echo Text::_('FWMG_DOCUMENTATION'); ?>" fwk-icon="book"></a>
<?php
        }
        if (!empty($row->frontend_demo_link)) {
?>
                            <a class="fwk-button fwk-button-square fwk-margin-small-right fwa-addon-demo<?php if ($installed) { ?> fwk-button-orange<?php } ?>" href="<?php echo $row->frontend_demo_link; ?>" target="_blank" fwk-tooltip title="<?php echo Text::_('FWMG_DEMO_LINK'); ?>" fwk-icon="presentation"></a>
<?php
        }
?>
                        </div>
<?php
$btn_classes = array('fwk-button fwk-width-1-1');
        $btn_hint_classes = array('fwk-text-center fwa-addon-button-hint');
        $btn_title = '';
        $btn_hint = '';
        if ($installed) {
            if ($row->enabled) {
                $btn_title = 'FWMG_DISABLE';
                $btn_hint = 'FWMG_DISABLE_HINT';
                $btn_classes[] = 'fwk-button-muted fwmg-addon-disable';
                $btn_hint_classes[] = 'fwk-text-green';
            } else {
                $btn_title = 'FWMG_ENABLE';
                $btn_hint = 'FWMG_ENABLE_HINT';
                $btn_classes[] = 'fwk-button-primary fwmg-addon-enable';
                $btn_hint_classes[] = 'fwk-text-muted';
            }
        } else {
            if ($installable) {
                $btn_title = 'FWMG_INSTALL';
                $btn_hint = 'FWMG_INSTALL_HINT';
                $btn_classes[] = 'fwk-button-secondary fwmg-addon-install';
                $btn_hint_classes[] = 'fwk-text-secondary';
            }
        }
        if ($btn_title) {
?>
                        <div class="fwk-width-auto@m fwk-flex fwk-flex-middle fwa-addon-actions">
                            <div>
                                <div class="fwk-position-relative">
                                    <button type="button" class="<?php echo implode(' ', $btn_classes); ?>"><?php echo Text::_($btn_title); ?></button>
                                    <div class="<?php echo implode(' ', $btn_hint_classes); ?> fwk-text-small fwk-margin-xsmall-top"><?php echo Text::_($btn_hint); ?></div>
                                </div>
<?php
            if ($installed) {
?>
<?php
                if ($update) {
?>
                                <div>
                                    <button type="button" class="fwk-button fwk-button-secondary fwk-margin-small-top fwmg-addon-update"><?php echo Text::_('FWMG_UPDATE'); ?></button>
                                </div>
<?php
                }
    ?>
                                <div>
                                    <button type="button" class="fwk-button fwk-button-danger fwk-margin-small-top fwmg-addon-remove"<?php if ($row->enabled) { ?> hidden<?php } ?>><?php echo Text::_('FWMG_REMOVE'); ?></button>
                                </div>
<?php
            }
?>

                            </div>
                        </div>
<?php
        }
?>
                    </div>
                </div>
<?php
    }
}
?>
            </div>
        </div>
<?php
if ($this->count_services) {
?>
        <div class="fwa-addons-services">
            <h3 class="fwk-margin-top"><?php echo Text::_('FWMG_DOC_ADMIN_ADDONS_SERVICES_NOPARAMS'); ?></h3>
            <div fwk-margin>
<?php
	foreach ($this->addons as $row) {
		if ($row->subtype == 'service') {
			$image = $row->image?$row->image:(FWMG_ADMIN_ASSETS_URL.'images/def_service.png');
?>
                <div>
                    <div class="fwk-card fwk-card-default">
                        <div class="fwk-card-media-top">
                            <img src="<?php echo $image; ?>" alt="<?php echo $this->escape($row->name); ?>">
                        </div>
                        <div class="fwk-card-body" fwk-margin>
                            <h3 class="fwk-margin-bottom fwa-service-name"><?php echo $this->escape($row->name); ?></h3>
                            <div class="fwk-text-muted fwk-text-light fwk-margin fwa-service-description"><?php echo $row->description; ?></div>
                            <div class="fwk-grid-collapse fwk-flex-between" fwk-grid>
                                <div>
                                    <div class="fwk-text-bold fwk-text-green-warm">$<?php echo ((int)$row->price) ? number_format($row->price, 2) : 'TBD'; ?></div>
                                    <div><?php echo ($row->days) ? ($row->days.' '.Text::_('FWA_DAYS')) : 'TBD'; ?></div>
                                </div>
                                <div>
                                    <a class="fwk-button fwk-button-primary" href="<?php echo $row->link; ?>" target="_blank">
                                        <?php echo Text::_('FWMG_ADMIN_ADDONS_PREORDER_SERVICE'); ?>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
<?php
		}
	}
?>
            </div>
        </div>
<?php
}
?>
    </div>

    <input type="hidden" name="task" value="" />
    <input type="hidden" name="boxchecked" value="" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
        window.fwmg_addons_search = function() {
            var search = $('input[name="search"]').val().trim().toLowerCase();
            var status = $('select[name="status"]').val();
            setCookie('fwmg-addons-search', search);
            setCookie('fwmg-addons-status', status);
            var $wrp = $('#fwmg-addons-wrp');
            if (search == '' && status == '') {
                $wrp.find('>div').attr('hidden', false);
            } else {
                $wrp.find('>div').each(function() {
                    var $row = $(this);
                    var hide = !((search != '' && $row.data('search').toLowerCase().indexOf(search) != -1) || (status != '' && $row.data('status').indexOf(status) != -1));
                    $row.attr('hidden', hide);
                });
            }
        }
        $('input[name="search"]').keyup(fwmg_addons_search);
        $('select[name="status"]').change(fwmg_addons_search);

        var search = getCookie('fwmg-addons-search');
        var status = getCookie('fwmg-addons-status');

        if (search || status) {
            if (search) $('input[name="search"]').val(search);
            if (status) $('select[name="status"]').val(status);
            fwmg_addons_search();
        }

        $('button.fwa-update-all').click(function() {
            var $btn = $(this).attr('disabled', false);
            var $img = $('<div class="fwk-margin-small-left fwk-position-center" fwk-spinner></div>');
            $btn.after($img);
            var exts = $btn.data('exts').split(',');
            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    format: 'json',
                    view: 'addon',
                    layout: 'update',
                    ext: exts
                }
            }).done(function(data) {
                if (data.result && data.result.length) {
                    var diff = exts.length - data.result.length;
                    if (diff == 0) {
                        $('.fwa-update-all').remove();
                    } else {
                        $('span.fwa-update-all').html(diff);
                    }
                    for (var i = 0; i < data.result.length; i++) {
                        var row = data.result[i];
                        var $wrp = $('div[data-ext="'+row.update_name+'"]');

                        $wrp.data('status', $wrp.data('status').replace('update ', ''));
                        $wrp.find('.fwmg-addon-update').remove();
                        $wrp.find('.fwa-update-version').remove();
                        $wrp.find('.fwa-addon-version').html(row.version).removeClass('fwk-text-warning').addClass('fwk-text-green-warm');
                        if (diff > 0) {
                            var index = exts.indexOf(row.update_name);
                            if (index !== -1) {
                                exts.splice(index, 1);
                            }
                        }
                    }
                    if (diff > 0) {
                        $btn.data('exts', exts.join(','));
                    }
                }
                if (data.msgs) {
                    for (var i = 0; i < data.msgs.length; i++) {
                        fwmg_alert(data.msgs[i]);
                    }
                }
            }).always(function() {
                $btn.attr('disabled', false);
                $img.remove();
            });
        });

        $('.fwmg-addon-install,.fwmg-addon-update,.fwmg-addon-enable,.fwmg-addon-disable,.fwmg-addon-remove').click(function() {
            var $btn = $(this);
            if ($btn.attr('disabled')) return;

            var action = '';
            if ($btn.hasClass('fwmg-addon-install')) {
                action = 'install';
            } else if ($btn.hasClass('fwmg-addon-enable')) {
                action = 'enable';
            } else if ($btn.hasClass('fwmg-addon-disable')) {
                action = 'disable';
            } else if ($btn.hasClass('fwmg-addon-update')) {
                action = 'update';
            } else if ($btn.hasClass('fwmg-addon-remove')) {
                action = 'remove';
            }

            if (action == '') return;

            $btn.attr('disabled', true);

            var $wrp = $btn.closest('[data-ext]');
            var $img = $('<div class="fwk-margin-small-left fwk-position-absolute" fwk-spinner></div>');
            $btn.after($img);
            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    format: 'json',
                    view: 'addon',
                    layout: action,
                    ext: [$wrp.data('ext')]
                }
            }).done(function(data) {
                if (data.result && data.result.length) {
                    for (var i = 0; i < data.result.length; i++) {
                        var row = data.result[i];
                        var msg_title = '', btn_hint = '', btn_hint_class = '', data_status = $wrp.data('status');
                        switch (row.action) {
                            case 'install' :
                                msg_title = '<?php echo Text::_('FWMG_INSTALLING_RESULT', true); ?>';
                                btn_hint = '<?php echo Text::_('FWMG_DISABLE_HINT', true); ?>';
                                btn_hint_class = 'fwk-text-success';
                                data_status = 'enabled installed+';
                                $btn.removeClass('fwk-button-secondary fwmg-addon-install').addClass('fwk-button-muted fwmg-addon-disable').html('<?php echo Text::_('FWMG_DISABLE', true); ?>');
                                $wrp.find('.fwa-addon-details').addClass('fwk-button-green');
                                $wrp.find('.fwa-addon-docs').addClass('fwk-button-blue');
                                $wrp.find('.fwa-addon-demo').addClass('fwk-button-orange');
                                $wrp.find('.fwa-addon-version').html(row.version).removeClass('fwk-text-muted').addClass('fwk-text-green-warm');
                            break;
                            case 'enable' :
                                msg_title = '<?php echo Text::_('FWMG_ENABLING_RESULT', true); ?>';
                                btn_hint = '<?php echo Text::_('FWMG_DISABLE_HINT', true); ?>';
                                btn_hint_class = 'fwk-text-success';
                                data_status = 'enabled installed+';
                                $btn.removeClass('fwk-button-primary fwmg-addon-enable').addClass('fwk-button-muted fwmg-addon-disable').html('<?php echo Text::_('FWMG_DISABLE', true); ?>');
                                $wrp.find('.fwmg-addon-remove').attr('hidden', true);
                            break;
                            case 'disable' :
                                msg_title = '<?php echo Text::_('FWMG_DISABLING_RESULT', true); ?>';
                                btn_hint = '<?php echo Text::_('FWMG_ENABLE_HINT', true); ?>';
                                btn_hint_class = 'fwk-text-muted';
                                data_status = 'disabled installed+';
                                $btn.removeClass('fwk-button-muted fwmg-addon-disable').addClass('fwk-button-primary fwmg-addon-enable').html('<?php echo Text::_('FWMG_ENABLE', true); ?>');
                                $wrp.find('.fwmg-addon-remove').attr('hidden', false);
                            break;
                            case 'update' :
                                msg_title = '<?php echo Text::_('FWMG_UDPATING_RESULT', true); ?>';
                                data_status = data_status.replace('update ', '');
                                $btn.remove();
                                $wrp.find('.fwa-update-version').remove();
                                $wrp.find('.fwa-addon-version').html(row.version).removeClass('fwk-text-warning').addClass('fwk-text-green-warm');
                            break;
                            case 'remove' :
                                msg_title = '<?php echo Text::_('FWMG_UNINSTALLING_RESULT', true); ?>';
                                $wrp.remove();
                            break;
                        }
                        if (btn_hint != '') {
                            $wrp.data('status', data_status).attr('data-status', data_status).find('.fwa-addon-button-hint').html(btn_hint).removeClass('fwk-text-muted fwk-text-danger fwk-text-success').addClass(btn_hint_class);
                        }
                        fwmg_alert(data.msg, msg_title);
                    }
                } else if (data.msg) {
                    fwmg_alert(data.msg);
                }
            }).always(function() {
                $btn.attr('disabled', false);
                $img.remove();
            });
        });

    })(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
