<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

if ($this->current_user->authorise('core.create', 'com_fwgallery')) { 
	fwgButtonsHelper::addNew('add', 'FWMG_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_NEW');
    fwgButtonsHelper::custom('folder-tree', 'purple', 'FWMG_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_QUICKCATEGORIES', 'quick', false);
}
if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
	fwgButtonsHelper::editList('edit', 'FWMG_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_EDIT');
}
if ($this->current_user->authorise('core.delete', 'com_fwgallery')) {
	fwgButtonsHelper::deleteList(Text::_('FWMG_ADMIN_CATEGORIES_TOOLBAR_BTN_DELETE_MSG'), 'remove', 'FWMG_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_DELETE');
}
if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
	fwgButtonsHelper::publish('publish', 'FWMG_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_PUBLISH');
	fwgButtonsHelper::unpublish('unpublish', 'FWMG_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_UNPUBLISH');
}

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => Text::_('FWMG_DOC_ADMIN_CATEGORIES'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_CATEGORIES_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<hr/>
<form action="index.php?option=com_fwgallery&amp;view=category" id="adminForm" name="adminForm"
    method="post">
    <div class="fwa-filter-bar" fwk-grid>
        <div class="fwk-width-1-2@m">
			<div class="fwk-position-relative">
    			<span class="fwk-form-icon fwk-text-green" fwk-icon="icon: search"></span>
                <input class="fwk-input" placeholder="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_FILTER_SEARCH'); ?>" name="search" value="<?php echo esc_attr($this->search); ?>" type="text" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_FILTER_SEARCH_HINT'); ?>" />
            </div>
        </div>
        <div class="fwk-width-1-4@m" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_FILTER_PARENT_CATEGORY_HINT'); ?>">
            <?php echo HTMLHelper::_('fwsgCategory.parent', (object)array('category'=>$this->category), 'category', 'class="fwk-select" onchange="with(this.form){if(this.form.limitstart){limitstart.value=0;}submit();}"', 'FWMG_DOC_ADMIN_CATEGORIES_FILTER_PARENT_CATEGORY'); ?>
        </div>
        <div class="fwk-width-1-4@m" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_FILTER_OWNER_HINT'); ?>">
            <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
                HTMLHelper::_('select.option', '', Text::_('FWMG_DOC_ADMIN_CATEGORIES_FILTER_OWNER'), 'id', 'name')
            ), $this->users), 'user', 'class="fwk-select" onchange="with(this.form){if(this.form.limitstart){limitstart.value=0;}submit();}"', 'id', 'name', $this->user); ?>
        </div>
    </div>
    <table class="fwk-table fwk-table-striped fwmg-galleries-table">
        <thead>
            <tr>
                <th><input name="toggle" class="fwk-checkbox" value="" onclick="Joomla.checkAll(this);" type="checkbox"></th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_ID_HINT'); ?>">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_ID'); ?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_COVER_HINT'); ?>">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_COVER'); ?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_NAMEINFO_HINT'); ?>">
                    <a href="index.php?option=com_fwgallery&view=category<?php echo str_replace(array('&amp;ordering=created', '&amp;ordering=name', '&amp;ordering=ordering'), '', $this->extra_link).'&amp;ordering=created'; ?>">
                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_NAMEINFO'); ?>
                    </a>
                </th>
                <th width="40%" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_DESCRIPTION_HINT'); ?>">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_DESCRIPTION'); ?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_ACCESS_HINT'); ?>">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_ACCESS'); ?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_FILES_HINT'); ?>">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_FILES'); ?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_ORDER_HINT'); ?>">
                    <a href="index.php?option=com_fwgallery&view=category<?php echo str_replace(array('&amp;ordering=created', '&amp;ordering=name', '&amp;ordering=ordering'), '', $this->extra_link).'&amp;ordering=ordering'; ?>">
                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_ORDER'); ?>
                    </a>
<?php
if ($this->current_user->authorise('core.edit', 'com_fwgallery') and $this->order == 'ordering') {
?>
                    <a class="fwk-button" href="javascript:" onclick="Joomla.saveorder(<?php echo (int)count($this->list)-1; ?>, 'saveorder')">
                        <span fwk-icon="save"></span>
                    </a>
<?php
}
?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_PUBLISHED_HINT'); ?>">
                    <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORIES_COLUMN_PUBLISHED'); ?>
                </th>
            </tr>
        </thead>
        <tbody>
<?php
if ($this->list) {
    $num = 0;
    foreach ($this->list as $row) {
?>
            <tr>
                <td><?php echo HTMLHelper::_('grid.id', $num, $row->id ); ?></td>
                <td><?php echo (int)$row->id; ?></td>
                <td><img class="fwk-border-rounded"
                        src="<?php echo Uri::root(true); ?>/index.php?option=com_fwgallery&amp;view=fwgallery&amp;layout=img&amp;format=raw&amp;w=80&amp;h=60&amp;id=<?php echo (int)$row->id; ?>&amp;rand=<?php echo rand(); ?>">
                </td>
                <td>
<?php
		if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
?>
                <a href="index.php?option=com_fwgallery&amp;view=category&amp;task=edit&amp;cid[]=<?php echo esc_attr($row->id.$this->extra_link); ?>"><?php echo esc_html($row->treename); ?></a>
<?php
		} else {
            echo esc_html($row->treename);
		}
?>

                    <div><small><?php echo Text::_('FWMG_OWNER'); ?>:
                        <?php echo esc_html($row->_user_name); ?></small></div>
                    <div><small><?php echo Text::_('FWMG_CREATED'); ?>:
                        <?php echo HTMLHelper::date($row->created, 'd M Y H:i'); ?></small></div>
<?php
		fwgHelper::triggerEvent('onshowCategoryListExtraFields', array('com_fwgallery', $row));
?>
                </td>
                <td><?php echo fwgHelper::stripTags($row->descr, 200, $show_counter=true); ?></td>
                <td><?php echo esc_html($row->_group_name); ?></td>
                <td>
                    <?php if ($row->_images_qty) : ?>
                    <div><span fwk-icon="image"></span> <?php echo (int)$row->_images_qty; ?></div>
                    <?php endif; ?>
                    <?php echo fwgHelper::escPluginsOutput(implode('', fwgHelper::triggerEvent('ongetCategoryAdminListExtraCounters', array('com_fwgallery', $row)))); ?>
                </td>
                <td class="order">
<?php
        if ($this->order == 'ordering') {
?>
                    <?php echo HTMLHelper::_('fwView.orderingListLinks', array(
                        'num' => $num,
                        'value' => $row->ordering,
                        'display_up' => fwgHelper::checkPrevCategory($row),
                        'display_down' => fwgHelper::checkNextCategory($row)
                    )); ?>
<?php
        } else echo (int)$row->ordering;
?>
                </td>
                <td>
                    <?php echo HTMLHelper::_('fwView.booleanListLink', array(
                        'num' => $num,
                        'value' => $row->published,
                        'task_on' => 'publish',
                        'task_off' => 'unpublish',
                        'title_on' => Text::_('FWMG_PUBLISH'),
                        'title_off' => Text::_('FWMG_UNPUBLISH'),
                        'class_on' => 'green',
                        'class_off' => 'muted'
                    )); ?>
                </td>
            </tr>
<?php
        $num++;
    }
} else {
?>
            <tr>
                <td colspan="9">
<?php
    echo Text::_($this->search?'FWMG_NO_GALLERIES_FOUND':'FWMG_NO_GALLERIES');
?>
                </td>
            </tr>
<?php
}
?>
        </tbody>
    </table>
    <div class="fwk-grid-small fwk-flex-middle fwa-pagination" fwk-grid>
        <div class="fwk-width-auto">
            <?php echo $this->pagination->getResultsCounter(); ?>
        </div>
        <div class="fwk-width-expand fwk-text-center">
            <?php echo $this->pagination->getListFooter(); ?>
        </div>
        <div class="fwk-width-auto">
            <?php echo $this->pagination->getLimitBox(); ?>
        </div>
    </div>
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="ordering" value="<?php echo esc_attr($this->order); ?>" />
    <input type="hidden" name="boxchecked" value="" />
</form>

<script>
document.addEventListener('DOMContentLoaded', function () {
    (function ($) {
        Joomla.submitbutton = function (pressbutton) {
            if (pressbutton == 'quick') {
                fwkUIkit.modal('#fwmg-quick-categories').show();
                return;
            }
            document.adminForm.task.value = pressbutton;
            document.adminForm.submit();
        }
        $('#toolbar-upload button').addClass('fwk-button-primary');
		$('input[name="search"]').keyup(function(ev) {
			if (ev.keyCode == 13) {
				if (this.form.limitstart) {
					this.form.limitstart.value = 0;
				}
				this.form.submit();
			}
		});
		$('input[name="cid[]"]').on('click change', function() {
			var $row = $(this).closest('tr');
			if (this.checked) {
				$row.addClass('fwk-selected-row');
			} else {
				$row.removeClass('fwk-selected-row');
			}
		});
		$('input[name="toggle"]').click(function() {
			$('input[name="cid[]"]').trigger('change');
		});
    })(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR)
;
