<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
	fwgButtonsHelper::apply('apply','FWMG_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_SAVE');
}
fwgButtonsHelper::save('save', 'FWMG_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_SAVECLOSE');
if ($this->object->id) {
	fwgButtonsHelper::custom('upload', 'purple', 'FWMG_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_UPLOAD', 'import', false);
}
fwgButtonsHelper::cancel('cancel', 'FWMG_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_CANCEL');

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/jquery.datetimepicker.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/jquery.datetimepicker.full.min.js');

$editor = fwgHelper::getEditor();

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => $this->object->id?(Text::sprintf('FWMG_ADMIN_CATEGORYEDIT_EDIT', $this->object->name)):Text::_('FWMG_ADMIN_CATEGORYEDIT_NEW'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<form action="index.php?option=com_fwgallery&amp;view=category" id="adminForm" name="adminForm" method="post" enctype="multipart/form-data">
    <ul class="fwk-margin-medium-top" fwk-tab>
        <li class="fwk-active">
            <a href="#fwmg-gallery-general"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL'); ?></a>
        </li>
        <li>
            <a href="#fwmg-gallery-category-design"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY'); ?></a>
        </li>
        <li>
            <a href="#fwmg-gallery-file-design"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES'); ?></a>
        </li>
    </ul>
    <div class="fwk-switcher">
        <div>
            <div class="fwa-main-body">
                <div class="fwk-child-width-1-2@m fwa-mb-cardbox" fwk-grid="masonry: true;">
                        <!-- Genral -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_PUBLISHED'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'published', $this->object->id?$this->object->published:1, array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('JYES'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('JNO'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_PUBLISHED_HINT'); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <input class="fwk-input" type="text" name="name" value="<?php echo esc_attr($this->object->name); ?>">
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_CATEGORY'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwsgCategory.parent', $this->object, 'parent', 'class="fwk-select"'); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_CATEGORY_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_DATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-group-date">
                                            <input class="fwk-input" type="text" name="created" value="<?php echo esc_attr($this->object->id?substr($this->object->created, 0, 16):date('Y-m-d H:i')); ?>">
                                            <button class="fwk-button" type="button"><span fwk-icon="calendar"></span></button>
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_DATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadUsers(), 'user_id', 'class="fwk-select"', 'id', 'name', $this->object->id?$this->object->user_id:$this->current_user->id); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_ACCESS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadviewlevels(), 'access', 'class="fwk-select"', 'id', 'name', $this->object->access); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_ACCESS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_WATERMARK'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'params[use_watermark]', $this->object->params->get('use_watermark', 'def'), array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
												'active_class' => 'fwk-button-success',
												'title' => Text::_('FWMG_DEFAULT'),
												'value' => 'def'
											), array(
												'active_class' => 'fwk-button-success',
												'title' => Text::_('JYES'),
												'value' => '1'
											), array(
												'active_class' => 'fwk-button-danger',
												'title' => Text::_('JNO'),
												'value' => '0'
											))
										)); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_WATERMARK_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowCategoryEditExtraFields', array('com_fwgallery', $this->object));
?>
                            </div>
                        </div>
                        </div>
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_COVER'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_COVER_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_COVER_TYPE'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'none', Text::_('FWMG_IMAGE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'mp4', Text::_('FWMG_SELF_HOSTED'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'youtube', 'YouTube', 'id', 'name'),
                                            HTMLHelper::_('select.option', 'vimeo', 'Vimeo', 'id', 'name'),
                                        ), 'media', 'class="fwk-select"', 'id', 'name', $this->object->media?$this->object->media:'none'); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_COVER_TYPE_HINT')); ?>"></span>
									</div>
								</div>
								<div class="fwmg-media fwmg-vimeo fwmg-youtube" style="display:none;" fwk-grid>
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_VIDEO_ID'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input class="fwk-input" type="text" name="remote_code" value="<?php if ($this->object->media != 'mp4') echo esc_attr($this->object->media_code); ?>" />
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_VIDEO_ID_DESCR')); ?>"></span>
									</div>
								</div>
                                <div class="fwmg-media fwmg-mp4 fwmg-none">
                                    <div class="col-form-label clearfix">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_COVER_FILE'); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_COVER_FILE_HINT')); ?>"></span>
                                    </div>
                                    <div class="fwk-child-width-1-2@m" id="fwmg-image-container" fwk-grid>
                                        <div>
                                            <img class="img-thumbnail" src="<?php echo Uri::root(true); ?>/index.php?option=com_fwgallery&amp;view=fwgallery&amp;layout=img&amp;format=raw&amp;w=266&amp;h=200&amp;id=<?php echo (int)$this->object->id; ?>&amp;rand=<?php echo rand(); ?>" />
                                        </div>
                                        <div>
                                            <div class="fwk-grid-collapse fwk-grid-match fwk-margin-bottom" fwk-grid>
                                                <div class="fwk-width-expand" fwk-form-custom>
                                                    <input type="file" id="fwmg-image" name="image" />
                                                    <input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo Text::_('FWMG_CHOOSE_FILE'); ?>" disabled="">
                                                </div>
                                                <div class="fwk-width-auto">
                                                    <button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo Text::_('FWMG_UPLOAD'); ?></button>
                                                </div>
                                            </div>
                                            <div class="fwk-text-muted"><small><?php echo Text::sprintf('FWMG_MAX_IMAGE_SIZE_LONG', ini_get('post_max_size')); ?></small></div>
                                            <div class="fwk-margin-top">
                                                <button type="button" class="fwk-button fwk-button-danger fwmg-remove"<?php if (!$this->object->sys_filename) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></i><?php echo Text::_('FWMG_REMOVE'); ?></button>
                                                <?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
                                                    'button' => '#fwmg-image-container .fwmg-remove',
                                                    'image' => '#fwmg-image-container img',
                                                    'view' => 'category',
                                                    'layout' => 'delete_image'
                                                )); ?>
                                            </div>
                                        </div>
                                        <?php echo HTMLHelper::_('fwView.handleUploadButton', array(
                                            'button' => '#fwmg-image-container .fwmg-upload',
                                            'remove_button' => '#fwmg-image-container .fwmg-remove',
                                            'input' => '#fwmg-image',
                                            'image' => '#fwmg-image-container img',
                                            'exts' => array('gif', 'jpg', 'jpeg', 'png'),
                                            'view' => 'category',
                                            'layout' => 'upload'
                                        )); ?>
                                    </div>
                                </div>
								<div class="fwmg-media fwmg-mp4" style="display:none;" fwk-grid>
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_VIDEO_FILE'); ?>
									</div>
									<div class="fwk-width-3-5@s" id="fwmg-video-container">
										<div class="fwk-margin-bottom">
<?php
$video_exists = fwgHelper::fileExists($this->object->media_code);
if ($video_exists) {
?>
											<strong><?php echo esc_html($this->object->media_code); ?></strong> <span><?php echo fwgHelper::humanFileSize($this->object->_video_size); ?></span>
<?php
} else {
?>
											<strong></strong> <span></span>
<?php
}
?>
										</div>
                                        <div class="fwk-grid-collapse fwk-grid-match fwk-margin-bottom fwk-margin-bottom" fwk-grid>
                                            <div class="fwk-width-expand" fwk-form-custom>
                                                <input type="file" id="fwmg-video" name="file" />
                                                <input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo Text::_('FWMG_CHOOSE_FILE'); ?>" disabled="">
                                            </div>
                                            <div class="fwk-width-auto">
                                                <button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo Text::_('FWMG_UPLOAD'); ?></button>
                                            </div>
                                        </div>
										<div class="text-muted"><small><?php echo Text::sprintf('FWMG_MAX_VIDEO_SIZE_LONG', ini_get('post_max_size')); ?></small></div>
										<?php echo HTMLHelper::_('fwView.handleUploadButton', array(
											'button' => '#fwmg-video-container .fwmg-upload',
											'input' => '#fwmg-video',
											'image' => '#fwmg-video-container img',
											'exts' => array('mp4'),
                                            'view' => 'category',
											'layout' => 'upload',
											'callback' => 'function(data) {
	$progress_bar.remove();
	$button.attr(\'disabled\', false);

	var $parent = $input.parent();
	$input.next().html(\''.Text::_('FWMG_CHOOSE_FILE', false).'\');

	var input_html = $parent.html();
	$parent.html(input_html);

    if (data.id) {
        $(\'input[name="oid"]\').val(data.id);
    }
    if (data.media_code) {
        $(\'#fwmg-video-container strong:eq(0)\').html(data.media_code);
        $(\'#fwmg-video-container .fwk-button-danger\').attr(\'hidden\', false);
    }
    if (data._video_size) {
        $(\'#fwmg-video-container span:eq(0)\').html(data._video_size);
    }

    if (data.msg) {
        fwmg_alert(data.msg);
    }
}'
										)); ?>
                                        <button type="button" class="fwk-button fwk-button-danger"<?php if (!$video_exists) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></i><?php echo Text::_('FWMG_REMOVE'); ?></button>
                                        <?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
                                            'button' => '#fwmg-video-container .fwk-button-danger',
                                            'image' => '#fwmg-video-container img',
                                            'view' => 'category',
                                            'layout' => 'delete_video',
                                            'callback' => 'function(data) {
	$img.remove();
	$button.attr(\'disabled\', false).attr(\'hidden\', true);
    if (data.id) {
        $(\'#fwmg-video-container .fwk-margin-bottom\').find(\'span,strong\').html(\'\');
    }
    if (data.msg) fwmg_alert(data.msg);
}'
                                        )); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_VIDEO_FILE_DESCR')); ?>"></span>
									</div>
                                </div>
                            </div>
                        </div>
                        </div>
                        
<?php
                        fwgHelper::triggerEvent('onshowCategoryEditExtraCards', array('com_fwgallery', $this->object));
?>

                        <div>
                            <div class="fwk-card fwk-card-default fwk-card-grey">
                                <div class="fwk-card-header">
                                    <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_DESCRIPTION_DESCRIPTION'); ?></div>
                                    <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_DESCRIPTION_DESCRIPTION_HINT'); ?></div>
                                </div>
                                <div class="fwk-card-body" fwk-margin>
                                    <?php echo $editor->display('descr', $this->object->descr, '100%', 150, 60, 7); ?>
                                </div>
                            </div>
                        </div>
                </div>
            </div>
        </div>
        <!-- FWSG Gallery Design -->
        <div>
            <div class="fwa-main-body">
                <div class="fwk-child-width-1-2@m fwa-mb-cardbox" fwk-grid="masonry: true;">
                        <!-- Gallery Layout -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_name]', $this->object->params->get('show_gallery_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_update_date]', $this->object->params->get('show_gallery_update_date', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_owner]', $this->object->params->get('show_gallery_owner', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowCategoryEditCategoryDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_COUNTER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_counter]', $this->object->params->get('show_gallery_counter', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_COUNTER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_description]', $this->object->params->get('show_gallery_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_DESCPOSITION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[gallery_descr_position]', $this->object->params->get('gallery_descr_position', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_TOP'),
                                                'value' => 'top'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_RIGHT'),
                                                'value' => 'right'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_DESCPOSITION_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_BREADCRUMBS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_breadcrumbs]', $this->object->params->get('show_gallery_breadcrumbs', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_HEADER_BREADCRUMBS_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Grid item  -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_DESIGN'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getThemesList()), 'params[template]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('template', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_DESIGN_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_SHOWINFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getLayoutsList()), 'params[gallery_layout]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_layout', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_SHOWINFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_HOVER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'none', Text::_('FWMG_NONE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'kenburns', Text::_('FWMG_KENBURNS'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'linear', Text::_('FWMG_LINEAR'), 'id', 'name'),
                                        ), 'params[gallery_hover]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_hover', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_HOVER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_name]', $this->object->params->get('show_gallery_item_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_update_date]', $this->object->params->get('show_gallery_item_update_date', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_owner]', $this->object->params->get('show_gallery_item_owner', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowCategoryEditCategoryListingDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_COUNTER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_counter]', $this->object->params->get('show_gallery_item_counter', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_COUNTER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_description]', $this->object->params->get('show_gallery_item_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_DESCLENGTH'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input type="text" class="fwk-input" name="params[description_length]" value="<?php echo esc_attr($this->object->params->get('description_length', 20)); ?>" size="20"/>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_DESCLENGTH_HINT')); ?>"></span>
									</div>
								</div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_VIDEOPLAY'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[dont_gallery_item_video_autoplay]', $this->object->params->get('dont_gallery_item_video_autoplay', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('JYES'),
                                                'value' => '0'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('JNO'),
                                                'value' => '1'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRIDITEM_VIDEOPLAY_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        
                        <!-- Gallery Layout -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_COLUMNS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '1', '1', 'id', 'name'),
                                            HTMLHelper::_('select.option', '2', '2', 'id', 'name'),
                                            HTMLHelper::_('select.option', '3', '3', 'id', 'name'),
                                            HTMLHelper::_('select.option', '4', '4', 'id', 'name'),
                                            HTMLHelper::_('select.option', '5', '5', 'id', 'name'),
                                            HTMLHelper::_('select.option', '6', '6', 'id', 'name'),
                                        ), 'params[gallery_columns]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_columns', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_COLUMNS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_ROWS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <input class="fwk-input" type="text" name="params[gallery_rows]" value="<?php echo esc_attr($this->object->params->get('gallery_rows', 4)); ?>" />
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_ROWS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_LIMIT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_limit]', $this->object->params->get('show_gallery_limit', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_LIMIT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_ORDERING'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_ordering]', $this->object->params->get('show_gallery_ordering', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_ORDERING_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_ORDERINGDEFAULT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ordering', Text::_('FWMG_ORDERING'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'alpha', Text::_('FWMG_APLHABETICALLY'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'new', Text::_('FWMG_NEWEST_FIRST'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'old', Text::_('FWMG_OLDEST_FIRST'), 'id', 'name'),
                                        ), 'params[gallery_default_ordering]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_default_ordering', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_ORDERINGDEFAULT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_PAGINATION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'standard', Text::_('FWMG_STANDARD'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ajax', Text::_('FWMG_AJAX_LOAD_MORE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '', Text::_('FWMG_HIDE'), 'id', 'name'),
                                        ), 'params[gallery_pagination_type]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_pagination_type', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_CATEGORY_SECTION_GRID_PAGINATION_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        
				</div>
			</div>
		</div>

        <div>
            <div class="fwa-main-body">
                <div class="fwk-child-width-1-2@m fwa-mb-cardbox" fwk-grid="masonry: true;">
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_GRID'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getGridsList()), 'params[files_grid]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_grid', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_GRID_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_COLUMNS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '1', '1', 'id', 'name'),
                                            HTMLHelper::_('select.option', '2', '2', 'id', 'name'),
                                            HTMLHelper::_('select.option', '3', '3', 'id', 'name'),
                                            HTMLHelper::_('select.option', '4', '4', 'id', 'name'),
                                            HTMLHelper::_('select.option', '5', '5', 'id', 'name'),
                                            HTMLHelper::_('select.option', '6', '6', 'id', 'name'),
                                        ), 'params[files_columns]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_columns', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_COLUMNS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_ROWS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <input class="fwk-input" type="text" name="params[files_rows]" value="<?php echo esc_attr($this->object->params->get('files_rows', 4)); ?>" />
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_ROWS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_OPEN'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
<?php
$file_open_as = array(array(
    'title' => Text::_('FWMG_DEFAULT'),
    'value' => 'def'
), array(
    'title' => Text::_('FWMG_PAGE'),
    'value' => 'link'
), array(
    'title' => Text::_('FWMG_LIGHTBOX'),
    'value' => 'popup'
));
fwgHelper::triggerEvent('onFileOpenAsGetVariants', array('com_fwgallery', &$file_open_as, $this));
?>
                                        <?php echo HTMLHelper::_('select.genericlist', $file_open_as, 'params[file_open_as]', 'class="fwk-select"', 'value', 'title', $this->object->params->get('file_open_as', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_OPEN_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_LIMIT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_limit]', $this->object->params->get('show_files_limit', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_LIMIT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_ORDERING'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_ordering]', $this->object->params->get('show_files_ordering', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_ORDERING_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_ORDERINGDEFAULT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ordering', Text::_('FWMG_ORDERING'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'alpha', Text::_('FWMG_APLHABETICALLY'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'new', Text::_('FWMG_NEWEST_FIRST'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'old', Text::_('FWMG_OLDEST_FIRST'), 'id', 'name'),
                                        ), 'params[files_default_ordering]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_default_ordering', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_ORDERINGDEFAULT_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowCategoryEditFileListingOrderingExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_PAGINATION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'standard', Text::_('FWMG_STANDARD'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ajax', Text::_('FWMG_AJAX_LOAD_MORE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '', Text::_('FWMG_HIDE'), 'id', 'name'),
                                        ), 'params[files_pagination_type]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_pagination_type', 'def')); ?>
                                        <span fwk-icon="info"class="fwk-align-right" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRID_PAGINATION_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Items Listing Design -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getLayoutsList()), 'params[file_layout]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('file_layout', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_INFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_HOVER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'none', Text::_('FWMG_NONE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'kenburns', Text::_('FWMG_KENBURNS'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'linear', Text::_('FWMG_LINEAR'), 'id', 'name'),
                                        ), 'params[file_hover]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('file_hover', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_HOVER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_name]', $this->object->params->get('show_files_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_update]', $this->object->params->get('show_files_update', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_owner]', $this->object->params->get('show_files_owner', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_description]', $this->object->params->get('show_files_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DESCLENGTH'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input type="text" class="fwk-input" name="params[image_description_length]" value="<?php echo esc_attr($this->object->params->get('image_description_length', 100)); ?>" size="20"/>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DESCLENGTH_HINT')); ?>"></span>
									</div>
								</div>
<?php
		fwgHelper::triggerEvent('onshowCategoryEditFileListingDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DOWNLOAD'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_download]', $this->object->params->get('show_files_download', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DOWNLOAD_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DOWNLOADACCESSLEVEL'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
                                            HTMLHelper::_('select.option', 'def', Text::_('FWMG_DEFAULT'), 'id', 'name')
                                        ), fwgHelper::loadviewlevels()), 'params[download_access]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('download_access', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_DOWNLOADACCESSLEVEL_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_FILEINFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_info]', $this->object->params->get('show_files_info', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_FILEINFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_ICON'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_icon]', $this->object->params->get('show_file_icon', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_GRIDITEM_ICON_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- File view  -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_FULLSCREEN'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_fullscreen]', $this->object->params->get('show_file_fullscreen', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_FULLSCREEN_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_THUMBS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_slideshow]', $this->object->params->get('show_file_slideshow', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_THUMBS_HINT')); ?>"></span>
                                    </div>
                                </div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_CATGEORY'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_back_link]', $this->object->params->get('show_back_link', 'def'), array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
												'active_class' => 'fwk-button-success',
												'title' => Text::_('JYES'),
												'value' => '1'
											), array(
												'active_class' => 'fwk-button-danger',
												'title' => Text::_('JNO'),
												'value' => '0'
											))
										)); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_CATGEORY_HINT')); ?>"></span>
									</div>
								</div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_info]', $this->object->params->get('show_file_info', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_INFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_name]', $this->object->params->get('show_file_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_update]', $this->object->params->get('show_file_update', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_owner]', $this->object->params->get('show_file_owner', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_description]', $this->object->params->get('show_file_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowCategoryEditFileDesignExtraFields', array('com_fwgallery', $this->object));
?>

                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_DOWNLOAD'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_download]', $this->object->params->get('show_file_download', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_CATEGORYEDIT_TAB_FILES_SECTION_FILE_DOWNLOAD_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                    
                </div>
            </div>
        </div>
    </div>

    <input type="hidden" name="oid" value="<?php echo (int)$this->object->id; ?>" />
    <input type="hidden" name="task" value="" />
<?php
foreach ($this->fields as $field) {
	if ($this->$field) {
?>
    <input type="hidden" name="<?php echo esc_attr($field); ?>" value="<?php echo esc_attr($this->$field); ?>" />
<?php
	}
}
?>
</form>
<script>
var size_limits = [];
<?php
$sizes = fwgHelper::getGridsSizeLimits();
foreach ($sizes as $name=>$size) {
?>
size_limits.push({name:'<?php echo esc_js($name); ?>',sizes:{min_cols: <?php echo (int)$size['min_cols']; ?>, min_rows: <?php echo (int)$size['min_rows']; ?>}});
<?php
}
?>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
        $('#paramsfiles_grid').change(function() {
            $('input[name="params[files_rows]"]').change();
            $('input[name="params[files_columns]"]').change();
        });
        $('input[name="params[files_rows]"]').change(function() {
            var $inp = $(this);
            var grid = $('#paramsfiles_grid').val();
            for (var i = 0; i < size_limits.length; i++) {
                if (size_limits[i].name == grid) {
                    if ($inp.val() * 1 < size_limits[i].sizes.min_rows) {
                        $inp.val(size_limits[i].sizes.min_rows);
                    }
                    break;
                }
            }
        });
        $('input[name="params[files_columns]"]').change(function() {
            var $inp = $(this);
            var grid = $('#paramsfiles_grid').val();
            for (var i = 0; i < size_limits.length; i++) {
                if (size_limits[i].name == grid) {
                    if ($inp.val() * 1 < size_limits[i].sizes.min_cols) {
                        $inp.parent().find('button[data-value="'+size_limits[i].sizes.min_cols+'"]').click();
                    }
                    break;
                }
            }
        });
        $('select[name="media"]').change(function() {
            var media = this.value;
            $('.fwmg-media').hide();
            $('.fwmg-'+media).show();
        }).change();
        $('input[name="created"]').datetimepicker({
            format: 'Y-m-d H:i'
        });
        $('input[name="created"]').next().click(function() {
            $('input[name="created"]').focus();
        })
        Joomla.submitbutton = function(pressbutton) {
            if (pressbutton) {
                if (pressbutton == 'import') {
                    fwkUIkit.modal('#fwmg-batch-upload').show();
                } else {
                    document.adminForm.task.value=pressbutton;
                    document.adminForm.submit();
                }
            }
        }
    })(jQuery);
});
</script>
<?php
if ($this->object->id) {
	echo LayoutHelper::render('utilites.batchupload', array(
		'allusers'=>$this->users,
		'current_user'=>$this->current_user,
		'category'=>$this->object->id,
		'reload'=>false
	), FWMG_COMPONENT_ADMINISTRATOR);
}
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
