<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Language\Text;

class fwGalleryViewCategory extends HtmlView {
    function display($tmpl = null) {
        $this->menu = 'category';
        $model = $this->getModel();

        $this->app = Factory::getApplication();
		$this->current_user = Factory::getUser();

		$this->fields = array('search', 'category', 'user', 'limit', 'limitstart', 'ordering');
        switch ($this->getLayout()) {
            case 'edit' :
            $this->object = $model->loadObject();
            if ((!$this->object->id and !$this->current_user->authorise('core.create', 'com_fwgallery')) or ($this->object->id and !$this->current_user->authorise('core.edit', 'com_fwgallery'))) {
				throw new Exception(Text::_('JERROR_ALERTNOAUTHOR'));
			}
			$this->groups = fwgHelper::loadviewlevels();
			$this->users = $model->loadUsers($load_all = true);
			foreach ($this->fields as $field) {
				$this->$field = (string)$this->app->input->getString($field);
			}
            break;
            default:
            $this->order = $model->getOrdering();
			$this->list = $model->loadList();
			$this->pagination = $model->getPagination();
			$this->users = $model->loadUsers();
			$this->extra_link = '';
			foreach ($this->fields as $field) {
				$this->$field = (string)$this->app->input->getString($field);
				if ($this->$field) {
					$this->pagination->setAdditionalUrlParam($field, $this->$field);
					$this->extra_link .= '&'.$field.'='.urlencode($this->$field);
				}
			}
        }
		$this->params = ComponentHelper::getParams('com_fwgallery');
        parent::display($tmpl);
    }
}
