<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));
fwgButtonsHelper::apply('save', 'FWMG_DOC_ADMIN_SETTINGS_TOOLBAR_BTN_SAVE');

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => Text::_('FWMG_DOC_ADMIN_SETTINGS'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_SETTINGS_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<form action="index.php?option=com_fwgallery&amp;view=configuration" id="adminForm" name="adminForm" method="post" enctype="multipart/form-data">
    <ul class="fwk-margin-medium-top" fwk-tab>
        <li class="fwk-active" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_HINT'); ?>" >
            <a href="#fwmg-settings-general"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL'); ?></a>
        </li>
        <li fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_HINT'); ?>" >
            <a href="#fwmg-settings-galleries"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY'); ?></a>
        </li>
        <li fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_HINT'); ?>" >
            <a href="#fwmg-settings-items"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES'); ?></a>
        </li>
        <li fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_ADDONS_HINT'); ?>" >
            <a href="#fwmg-settings-plugins"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_ADDONS'); ?></a>
        </li>
    </ul>
    <div class="fwk-switcher">
        <div>
            <div class="fwmg-settings-general">
                <div class="fwk-child-width-1-2@l fwa-mb-cardbox" fwk-grid="masonry: true;">

                        <!-- Genral -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_DATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s">
                                        <div class="fwk-flex">
                                            <div class="fwk-with-expand">
                                                <input class="fwk-input" type="text" name="config[date_format]" value="<?php echo esc_attr($this->object->params->get('date_format', 'F d, Y')); ?>" />
                                                <div class=""><a href="https://www.php.net/manual/en/datetime.format.php#refsect1-datetime.format-parameters" target="_blank"><?php echo Text::_('FWMG_DATE_FORMAT_HINT'); ?> <span fwk-icon="link"></span></a></div>
                                            </div>
                                            <div class="fwk-with-auto">
                                                <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_DATE_HINT')); ?>"></span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_ADMIN_DARK_MODE'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex fwk-flex-middle">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'config[not_use_dark_mode]', (int)$this->object->params->get('not_use_dark_mode'), array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
												'active_class' => 'fwk-button-primary',
												'title' => Text::_('FWMG_AUTO'),
												'value' => 0
											), array(
												'active_class' => 'fwk-button-danger',
												'title' => Text::_('JNO'),
												'value' => 1
											))
										)); ?>
										<i fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $this->escape(Text::_('FWFM_ADMIN_DARK_MODE_HINT')); ?>"></i>
									</div>
								</div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_FONT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo Text::_('FWMG_ADMIN_PX'); ?></span>
                                            <input class="fwk-input" value="<?php echo esc_attr($this->object->params->get('font_size', 16)); ?>" type="text" name="config[font_size]" />
                                        </div>								
                                        <span fwk-icon="info" class="fwk-margin-left fwk-preserve-width" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_FONT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_ADDONS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_addons_menu_settings]', (int)$this->object->params->get('show_addons_menu_settings'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_ADDONS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_AUTOUPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[auto_update]', (int)$this->object->params->get('auto_update'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('JYES'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('JNO'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_AUTOUPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Comments -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMENTS'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMENTS_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMENTS_SYSTEM'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('select.genericlist', array(
											HTMLHelper::_('select.option', '', Text::_('FWMG_None'), 'id', 'name'),
											HTMLHelper::_('select.option', 'disqus', 'Disqus', 'id', 'name'),
											HTMLHelper::_('select.option', 'komento', 'Komento', 'id', 'name')
										), 'config[comments_type]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('comments_type'), 'fwmg-comments'); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMENTS_SYSTEM_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="comments_type comments_type-disqus" style="display:none;" fwk-grid>
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMENTS_DISQUS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
										<input type="text" class="fwk-input" name="config[disqus_domain]" value="<?php echo esc_attr($this->object->params->get('disqus_domain')); ?>" size="20"/>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMENTS_DISQUS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
        $('#fwmg-comments').change(function() {
            var $wrp = $(this).closest('.card-body');
            var class_name = 'comments_type-'+this.value;
            $wrp.find('.comments_type').each(function() {
                var $el = $(this);
                if ($el.hasClass(class_name)) {
                    $el.show();
                } else {
                    $el.hide();
                }
            });
        }).change();
    })(jQuery);
});                                </script>
                            </div>
                        </div>
                        </div>
<?php
		fwgHelper::triggerEvent('onshowConfigGeneralLeftExtraCards', array('com_fwgallery', $this->object));
?>
                        <!-- Images Sizes -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header clearfix">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_MAX'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_WIDTH')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_width]" value="<?php echo esc_attr($this->object->params->get('image_width', 2048)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_HEIGHT')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_height]" value="<?php echo esc_attr($this->object->params->get('image_height', 2048)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_MAX_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_COVER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_WIDTH')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_width_cover]" value="<?php echo esc_attr($this->object->params->get('image_width_cover', 600)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_HEIGHT')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_height_cover]" value="<?php echo esc_attr($this->object->params->get('image_height_cover', 400)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_COVER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_THUMB'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_WIDTH')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_width_listing]" value="<?php echo esc_attr($this->object->params->get('image_width_listing', 600)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_HEIGHT')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_height_listing]" value="<?php echo esc_attr($this->object->params->get('image_height_listing', 400)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_THUMB_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_FILE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_WIDTH')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_width_lightbox]" value="<?php echo esc_attr($this->object->params->get('image_width_lightbox', 1200)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <div class="fwk-inline">
                                            <span class="fwk-form-icon"><?php echo esc_attr(Text::_('FWMG_ADMIN_HEIGHT')); ?></span>
                                            <span class="fwk-form-icon fwk-form-icon-flip"><?php echo esc_attr(Text::_('FWMG_ADMIN_PX')); ?></span>
                                            <input type="text" name="config[image_height_lightbox]" value="<?php echo esc_attr($this->object->params->get('image_height_lightbox', 800)); ?>" class="fwk-input fwk-text-center" size="4" />
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_SIZES_FILE_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Watermark -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title">
                                    <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK'); ?>
                                    <button type="button" onclick="Joomla.submitbutton('save');" class="fwk-button fwk-button-primary fwk-float-right"><?php echo Text::_('FWMG_SAVE_APPLY'); ?></button>
                                </div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_USE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'config[use_watermark]', $this->object->params->get('use_watermark'), array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
												'active_class' => 'fwk-button-success',
												'title' => Text::_('JYES'),
												'value' => 1
											), array(
												'active_class' => 'fwk-button-danger',
												'title' => Text::_('JNO'),
												'value' => 0
											))
										)); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_USE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DOWNLOADFILE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[download_with_watermark]', $this->object->params->get('download_with_watermark', '0'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_ORIGINAL'),
                                                'value' => 0
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_ORIGINAL_WITH_WATERMARK'),
                                                'value' => 1
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DOWNLOADFILE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_POSITION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('select.genericlist', array(
											HTMLHelper::_('select.option', 'center', Text::_('FWMG_CENTER'), 'id', 'name'),
											HTMLHelper::_('select.option', 'left top', Text::_('FWMG_LEFT_TOP'), 'id', 'name'),
											HTMLHelper::_('select.option', 'right top', Text::_('FWMG_RIGHT_TOP'), 'id', 'name'),
											HTMLHelper::_('select.option', 'left bottom', Text::_('FWMG_LEFT_BOTTOM'), 'id', 'name'),
											HTMLHelper::_('select.option', 'right bottom', Text::_('FWMG_RIGHT_BOTTOM'), 'id', 'name')
										), 'config[watermark_position]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('watermark_position', 'left bottom')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left fwk-preserve-width" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_POSITION_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex fwmg-watermark">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_IMAGE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div>
<?php
$wmf = $this->object->params->get('watermark_file');
if ($wmf) {
	if ($path = fwgHelper::getWatermarkFilename()) {
?>
                                            <img src="<?php echo esc_attr(Uri::root(true)); ?>/<?php echo esc_attr($path); ?>" /><br/>
                                            <input type="checkbox" class="fwk-checkbox" name="delete_watermark" value="1" /> <?php echo Text::_('FWMG_REMOVE_WATERMARK'); ?><br/>
<?php
	} else {
?>
    										<p style="color:#f00;"><?php echo Text::sprintf('FWMG_WATERMARK_FILE_NOT_FOUND', $wmf); ?></p>
<?php
	}
}
?>
                                            <div fwk-form-custom>
                                                <input type="file" id="watermark_file" name="watermark_file" />
                                                <input class="fwk-input fwk-width-expand" type="text" placeholder="<?php echo Text::_('FWMG_CHOOSE_FILE'); ?>" disabled="">
                                            </div>
                                            <div class="text-muted"><small><?php echo Text::_('FWMG_MAXIMUM_FILE_SIZE'); ?> <?php echo fwgHelper::humanFileSize(fwgHelper::getIniSize('upload_max_filesize')); ?></small></div>
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left fwk-preserve-width" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_IMAGE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_TEXT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div>
                                            <input type="text" class="fwk-input" name="config[watermark_text]" value="<?php echo esc_attr($this->object->params->get('watermark_text')); ?>" />
                                            <div class="text-muted"><small><?php echo Text::_('FWMG_WATERMARK_TEXT_HINT'); ?></small></div>
                                        </div>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_WATERMARK_TEXT_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                    
                </div>
            </div>
        </div>
        <!-- FWG Settings Galleries -->
        <div>
            <div class="fwmg-settings-galleries">
                <div class="fwk-child-width-1-2@l fwa-mb-cardbox" fwk-grid="masonry: true;">
                    
                        <!-- Gallery Header -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_name]', $this->object->params->get('show_gallery_name', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_update_date]', $this->object->params->get('show_gallery_update_date', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_owner]', $this->object->params->get('show_gallery_owner', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowConfigCategoryDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_COUNTER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_counter]', $this->object->params->get('show_gallery_counter', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_COUNTER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_description]', $this->object->params->get('show_gallery_description', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_DESCPOSITION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[gallery_descr_position]', $this->object->params->get('gallery_descr_position', 'top'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_TOP'),
                                                'value' => 'top'
                                            ), array(
                                                'active_class' => 'fwk-button-warning',
                                                'title' => Text::_('FWMG_RIGHT'),
                                                'value' => 'right'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_DESCPOSITION_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_BREADCRUMBS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_breadcrumbs]', $this->object->params->get('show_gallery_breadcrumbs', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_HEADER_BREADCRUMBS_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Gallery Listing Layout -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_DESIGN'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::getThemesList(), 'config[template]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('template', 'common')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_DESIGN_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_SHOWINFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::getLayoutsList(), 'config[gallery_layout]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_layout', 'bottom')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_SHOWINFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_HOVER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'none', Text::_('FWMG_NONE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'kenburns', Text::_('FWMG_KENBURNS'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'linear', Text::_('FWMG_ENLARGE'), 'id', 'name'),
                                        ), 'config[gallery_hover]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_hover', 'none')); ?>
                                        <span fwk-icon="info" class="fwk-align-right" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_HOVER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_item_name]', $this->object->params->get('show_gallery_item_name', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_item_update_date]', $this->object->params->get('show_gallery_item_update_date', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_item_owner]', $this->object->params->get('show_gallery_item_owner', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowConfigCategoryListingDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_COUNTER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_item_counter]', $this->object->params->get('show_gallery_item_counter', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_COUNTER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_item_description]', $this->object->params->get('show_gallery_item_description', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_DESCLENGTH'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input type="text" class="fwk-input" name="config[description_length]" value="<?php echo esc_attr($this->object->params->get('description_length', 100)); ?>" size="20"/>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_DESCLENGTH_HINT')); ?>"></span>
									</div>
								</div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_VIDEOPLAY'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[dont_gallery_item_video_autoplay]', $this->object->params->get('dont_gallery_item_video_autoplay', 0), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('JYES'),
                                                'value' => 0
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('JNO'),
                                                'value' => 1
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRIDITEM_VIDEOPLAY_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Gallery Layout -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_COLUMNS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', '1', '1', 'id', 'name'),
                                            HTMLHelper::_('select.option', '2', '2', 'id', 'name'),
                                            HTMLHelper::_('select.option', '3', '3', 'id', 'name'),
                                            HTMLHelper::_('select.option', '4', '4', 'id', 'name'),
                                            HTMLHelper::_('select.option', '5', '5', 'id', 'name'),
                                            HTMLHelper::_('select.option', '6', '6', 'id', 'name'),
                                        ), 'config[gallery_columns]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_columns', '4')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_COLUMNS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_ROWS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-width-expand">
                                            <input class="fwk-input" type="text" name="config[gallery_rows]" value="<?php echo esc_attr($this->object->params->get('gallery_rows', 4)); ?>" />
                                        </div>
                                        <div class="fwk-width-auto">
                                            <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_ROWS_HINT')); ?>"></span>
                                        </div>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_LIMIT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_limit]', $this->object->params->get('show_gallery_limit', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_LIMIT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_ORDERING'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_gallery_ordering]', $this->object->params->get('show_gallery_ordering', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_ORDERING_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_ORDERINGDEFAULT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'ordering', Text::_('FWMG_ORDERING'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'alpha', Text::_('FWMG_APLHABETICALLY'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'new', Text::_('FWMG_NEWEST_FIRST'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'old', Text::_('FWMG_OLDEST_FIRST'), 'id', 'name'),
                                        ), 'config[gallery_default_ordering]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_default_ordering', 'ordering')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_ORDERINGDEFAULT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_PAGINATION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'standard', Text::_('FWMG_STANDARD'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ajax', Text::_('FWMG_AJAX_LOAD_MORE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '', Text::_('FWMG_HIDE'), 'id', 'name'),
                                        ), 'config[gallery_pagination_type]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('gallery_pagination_type', 'standard')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY_SECTION_GRID_PAGINATION_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                    
                </div>
            </div>
        </div>
        <!-- FWG Settings Items -->
        <div>
            <div class="fwmg-settings-items">
                <div class=" fwk-child-width-1-2@l fwa-mb-cardbox" fwk-grid="masonry: true;">
                    
                        <!-- Items Listing Layout -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_GRID'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::getGridsList(), 'config[files_grid]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_grid', 'standard')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_GRID_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_COLUMNS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', '1', '1', 'id', 'name'),
                                            HTMLHelper::_('select.option', '2', '2', 'id', 'name'),
                                            HTMLHelper::_('select.option', '3', '3', 'id', 'name'),
                                            HTMLHelper::_('select.option', '4', '4', 'id', 'name'),
                                            HTMLHelper::_('select.option', '5', '5', 'id', 'name'),
                                            HTMLHelper::_('select.option', '6', '6', 'id', 'name'),
                                        ), 'config[files_columns]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_columns', '4')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_COLUMNS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_ROWS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <div class="fwk-width-expand">
                                            <input class="fwk-input" type="text" name="config[files_rows]" value="<?php echo esc_attr($this->object->params->get('files_rows', 4)); ?>" />
                                        </div>    
                                        <div class="fwk-width-auto">
                                            <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_ROWS_HINT')); ?>"></span>
                                        </div>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_OPEN'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
<?php
$file_open_as = array(array(
    'title' => Text::_('FWMG_PAGE'),
    'value' => 'link'
), array(
    'title' => Text::_('FWMG_LIGHTBOX'),
    'value' => 'popup'
));
fwgHelper::triggerEvent('onFileOpenAsGetVariants', array('com_fwgallery', &$file_open_as, $this));
?>
                                        <?php echo HTMLHelper::_('select.genericlist', $file_open_as, 'config[file_open_as]', 'class="fwk-select"', 'value', 'title', $this->object->params->get('file_open_as', 'link')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_OPEN_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_LIMIT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_limit]', $this->object->params->get('show_files_limit', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_LIMIT_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_ORDERING'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_ordering]', $this->object->params->get('show_files_ordering', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_ORDERING_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_ORDERINGDEFAULT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'ordering', Text::_('FWMG_ORDERING'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'alpha', Text::_('FWMG_APLHABETICALLY'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'new', Text::_('FWMG_NEWEST_FIRST'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'old', Text::_('FWMG_OLDEST_FIRST'), 'id', 'name'),
                                        ), 'config[files_default_ordering]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_default_ordering', 'ordering')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_ORDERINGDEFAULT_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowConfigFileListingOrderingExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_PAGINATION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'standard', Text::_('FWMG_STANDARD'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ajax', Text::_('FWMG_AJAX_LOAD_MORE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '', Text::_('FWMG_HIDE'), 'id', 'name'),
                                        ), 'config[files_pagination_type]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('files_pagination_type', 'standard')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRID_PAGINATION_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Items Listing Design -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::getLayoutsList(), 'config[file_layout]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('file_layout', 'bottom')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_INFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_HOVER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'none', Text::_('FWMG_NONE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'kenburns', Text::_('FWMG_KENBURNS'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'linear', Text::_('FWMG_ENLARGE'), 'id', 'name'),
                                        ), 'config[file_hover]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('file_hover', 'none')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_HOVER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_name]', $this->object->params->get('show_files_name', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_UPDATE'); ?>
                                        <span class="fwk-align-right" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_UPDATE_HINT')); ?>"></span>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_update]', $this->object->params->get('show_files_update', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_OWNER'); ?>
                                        <span class="fwk-align-right" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_OWNER_HINT')); ?>"></span>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_owner]', $this->object->params->get('show_files_owner', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_description]', $this->object->params->get('show_files_description', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DESCLENGTH'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input type="text" class="fwk-input" name="config[image_description_length]" value="<?php echo esc_attr($this->object->params->get('image_description_length', 100)); ?>" size="20"/>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DESCLENGTH_HINT')); ?>"></span>
									</div>
								</div>
<?php
		fwgHelper::triggerEvent('onshowConfigFileListingDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DOWNLOAD'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_download]', $this->object->params->get('show_files_download', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DOWNLOAD_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DOWNLOADACCESSLEVEL'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadviewlevels(), 'config[download_access]', 'class="fwk-select"', 'id', 'name', $this->object->params->get('download_access')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_DOWNLOADACCESSLEVEL_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_ITEM_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_files_info]', $this->object->params->get('show_files_info', '1'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_ITEM_INFO_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_ICON'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_icon]', $this->object->params->get('show_file_icon', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_GRIDITEM_ICON_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                        <!-- Single Item Design -->
                        <div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE'); ?></div>
                                <div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_FULLSCREEN'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_fullscreen]', $this->object->params->get('show_file_fullscreen', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_FULLSCREEN_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_THUMBS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_slideshow]', $this->object->params->get('show_file_slideshow', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_THUMBS_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_CATGEORY'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_back_link]', $this->object->params->get('show_back_link'), array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
												'active_class' => 'fwk-button-success',
												'title' => Text::_('FWMG_SHOW'),
												'value' => 1
											), array(
												'active_class' => 'fwk-button-danger',
												'title' => Text::_('FWMG_HIDE'),
												'value' => 0
											))
										)); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_CATGEORY_HINT')); ?>"></span>
									</div>
								</div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_info]', $this->object->params->get('show_file_info', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_INFO_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_name]', $this->object->params->get('show_file_name', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_NAME_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_UPDATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_update]', $this->object->params->get('show_file_update', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_UPDATE_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_owner]', $this->object->params->get('show_file_owner', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_OWNER_HINT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_description]', $this->object->params->get('show_file_description', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_DESCRIPTION_HINT')); ?>"></span>
                                    </div>
                                </div>
<?php
		fwgHelper::triggerEvent('onshowConfigFileDesignExtraFields', array('com_fwgallery', $this->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_DOWNLOAD'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'config[show_file_download]', $this->object->params->get('show_file_download', 1), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => Text::_('FWMG_SHOW'),
                                                'value' => 1
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => Text::_('FWMG_HIDE'),
                                                'value' => 0
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES_SECTION_FILE_DOWNLOAD_HINT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        </div>
                    
                </div>
            </div>
        </div>
        <!-- FWG Settings Plugins -->
        <div>
            <div class="fwmg-settings-plugins">
                <div class=" fwk-child-width-1-2@l fwa-mb-cardbox fwa-settings-plugins-list" fwk-grid="masonry: true">
<?php
ob_start();
$buff = fwgHelper::triggerEvent('onshowConfigExtraCards', array('com_fwgallery', $this->object, $this));
$output = ob_get_clean();
foreach ($buff as $data) {
?>
                    <div>
<?php
	echo fwgHelper::escPluginsOutput($data);
?>
                    </div>
<?php
}
echo fwgHelper::escPluginsOutput($output);
?>
                </div>
            </div>
        </div>
    </div>

    <input type="hidden" name="oid" value="" />
    <input type="hidden" name="task" value="" />
</form>
<script>
var size_limits = [];
<?php
$sizes = fwgHelper::getGridsSizeLimits();
foreach ($sizes as $name=>$size) {
?>
size_limits.push({name:'<?php echo esc_js($name); ?>',sizes:{min_cols: <?php echo (int)$size['min_cols']; ?>, min_rows: <?php echo (int)$size['min_rows']; ?>}});
<?php
}
?>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
        $('#watermark_file').change(function() {
            var $inp = $(this);
            var files = $inp.prop('files');
            if (files && files.length) {
                var buff = [];
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];
                    if ('name' in file) {
                        buff.push(file.name);
                    } else {
                        buff.push(file.fileName);
                    }
                }
                $inp.next().val(buff.join(',')).addClass('fwk-file-selected');
            } else {
                $inp.next().val('').removeClass('fwk-file-selected');
            }
        });
        $('#configfiles_grid').change(function() {
            $('input[name="config[files_rows]"]').change();
            $('input[name="config[files_columns]"]').change();
        });
        $('input[name="config[files_rows]"]').change(function() {
            var $inp = $(this);
            var grid = $('#configfiles_grid').val();
            for (var i = 0; i < size_limits.length; i++) {
                if (size_limits[i].name == grid) {
                    if ($inp.val() * 1 < size_limits[i].sizes.min_rows) {
                        $inp.val(size_limits[i].sizes.min_rows);
                    }
                    break;
                }
            }
        });
        $('input[name="config[files_columns]"]').change(function() {
            var $inp = $(this);
            var grid = $('#configfiles_grid').val();
            for (var i = 0; i < size_limits.length; i++) {
                if (size_limits[i].name == grid) {
                    if ($inp.val() * 1 < size_limits[i].sizes.min_cols) {
                        $inp.parent().find('button[data-value="'+size_limits[i].sizes.min_cols+'"]').click();
                    }
                    break;
                }
            }
        });
    })(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR)
;
