<?php
/**
 * FW Gallery 4.10.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));
fwgButtonsHelper::apply('apply', 'FWMG_DOC_ADMIN_CSS_TOOLBAR_BTN_SAVE');

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => Text::_('FWMG_DOC_ADMIN_CSS'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_CSS_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<form id="adminForm" name="adminForm" class="css-styles" method="post" action="index.php?option=com_fwgallery&view=css" enctype="multipart/form-data">
	<ul class="fwk-margin-medium-top" fwk-tab>
		<li class="fwk-active"><a href="#fwmg-custom-css"><?php echo Text::_('FWMG_DOC_ADMIN_CSS_TAB_CUSTOM') ?></a></li>
<?php
if ($this->tmpls) {
    foreach ($this->tmpls as $tmpl) {
        if (empty($tmpl->css)) continue;
?>
		<li><a href="#fwmg-<?php echo esc_attr($tmpl->element); ?>-css"><?php echo esc_html($tmpl->name); ?></a></li>
<?php
    }
}
?>
	</ul>
	<div class="fwk-switcher">
		<div>
			<div class="fwk-alert fwk-alert-default"><?php echo Text::_('FWMG_DOC_ADMIN_CSS_TAB_CUSTOM_HINT'); ?></div>
			<div>
				<?php echo $this->editor->display('additional_css', $this->object->params->get('additional_css'), '100%', 400, 80, 7, false, 'additional_css'); ?>
			</div>
		</div>
<?php
if ($this->tmpls) {
    foreach ($this->tmpls as $i=>$tmpl) {
        if (empty($tmpl->css)) continue;
?>
        <div>
			<div class="fwk-alert fwk-alert-secondary">			
				<div class="fwk-card-subtitle pb-2"><?php echo Text::sprintf('FWMG_FWGALLERY_TEMPLATE_CSS_HINT', $tmpl->name); ?></div>
				<div class="fwk-text-muted"><?php echo str_replace('\\', '/', $tmpl->path); ?></div>
			</div>
			<div>
				<?php echo $this->editor->display('none'.$i, $tmpl->css, '100%', 400, 80, 7, false, 'none'.$i, $asset = null, $author = null, $params = ['readonly' => true]); ?>
			</div>
		</div>
<?php
    }
}
?>
	</div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="oid" value="1" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		$('ul[fwk-tab] a').click(function() {
			$('.CodeMirror').each(function(i, el){
				setTimeout(function() {
					el.CodeMirror.refresh();
				}, 100);
			});
		});
		$('#adminForm').submit(function(ev) {
			ev.preventDefault();
			ev.stopImmediatePropagation();
			if (Joomla.editors.instances['additional_css']) {
				this.additional_css.value = Joomla.editors.instances['additional_css'].getValue();
			}
<?php
if ($this->tmpls) {
    foreach ($this->tmpls as $i=>$tmpl) {
        if (empty($tmpl->css)) continue;
?>
			this['none<?php echo $i; ?>'].value = '';
<?php
	}
}
?>
			this.submit();
        });
	})(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR)
;
