<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;

ToolbarHelper::title(fwgHelper::jtext('COM_FWGALLERY'));

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => fwgHelper::jtext('FWMG_DOC_ADMIN_DATA'),
    'title_hint' => fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<ul class="fwk-margin-medium-top" fwk-tab>
<?php
$tab_displayed = false;
if ($this->current_user->authorise('core.create', 'com_fwgallery')) {
	$tab_displayed = true;
?>
	<li class="fwk-active">
		<a href="#fwmg-restore"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_RESTORE'); ?></a>
	</li>
<?php
}
?>
	<li <?php if (!$tab_displayed) { ?>class="fwk-active"<?php } ?>>
		<a href="#fwmg-backup"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_BACKUP'); ?></a>
	</li>
<?php
if ($this->current_user->authorise('core.create', 'com_fwgallery')) {
?>
	<li <?php if (!$tab_displayed) { ?>class="fwk-active"<?php } ?>>
		<a href="#fwmg-data"><?php echo fwgHelper::jtext('FWMG_ADMIN_DATA_TAB_ADDONS'); ?></a>
	</li>
<?php
}
?>
</ul>
<div class="fwk-switcher">
<?php
$tab_displayed = false;
if ($this->current_user->authorise('core.create', 'com_fwgallery')) {
	$tab_displayed = true;
?>
	<div id="fwmg-restore">
		<div class="fwa-main-body">
			<form action="index.php?option=com_fwgallery&amp;view=data" method="post" name="adminForm">
				<div class="mb-cardbox uk fwk-child-width-1-2@l" fwk-gridchild-width-1-2" fwk-grid>
					<div>
						<div class="fwk-card fwk-card-default fwk-card-grey">
							<div class="fwk-card-header">
								<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_RESTORE_RESTORE'); ?></div>
								<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_RESTORE_RESTORE_HINT'); ?></div>
								<div class="fwk-margin-small-top text-muted"><em><?php echo fwgHelper::jtext('FWMG_ADMIN_DATA_TAB_RESTORE_RESTORE_HINT'); ?> <?php echo str_replace('\\', '/', FWMG_STORAGE_PATH); ?>backups</em></div>
							</div>
							<div class="fwk-card-body" fwk-margin>
								<table class="fwk-table">
									<tbody id="fwmg-import-files">
<?php
if ($this->backups) {
	foreach ($this->backups as $file) {
?>
										<tr>
											<td><a href="<?php echo FWMG_MEDIA_URL; ?>com_fwgallery/backups/<?php echo esc_attr($file); ?>"><?php echo esc_html($file); ?></a> (<?php echo fwgHelper::humanFileSize(filesize(FWMG_STORAGE_PATH.'backups/'.$file)); ?>)</td>
											<td>
												<button type="button" class="fwk-icon-button fwk-button-primary" title="<?php echo $this->escape(fwgHelper::jtext('FWMG_RESTORE')); ?>" fwk-icon="check" fwk-tooltip></button>
												<button type="button" class="fwk-icon-button fwk-button-danger" title="<?php echo $this->escape(fwgHelper::jtext('FWMG_DELETE')); ?>" fwk-icon="trash" fwk-tooltip></button>
											</td>
										</tr>
<?php
	}
}
?>
									</tbody>
								</table>

								<div class="mt-5"><?php echo fwgHelper::jtext('FWMG_IMPORT_UPLOAD_HINT'); ?></div>
								<div class="fwk-grid-collapse fwk-grid-match" fwk-grid>
									<div class="fwk-width-expand" fwk-form-custom>
										<input type="file" id="fwmg-input-import" name="upload" />
										<input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo fwgHelper::jtext('FWMG_CHOOSE_FILE'); ?>" disabled="">
									</div>
									<div class="fwk-width-auto">
										<button type="button" class="fwk-button fwk-button-primary" id="fwmg-import-upload"><?php echo fwgHelper::jtext('FWMG_UPLOAD'); ?></button>
									</div>
								</div>
								<div class="fwk-text-muted fwk-text-small"><?php echo fwgHelper::sprintf('FWMG_MAX_ZIP_SIZE_LONG', ini_get('post_max_size')); ?></div>

								<div class="fwk-margin-top fwmg-data-import-result"></div>
								<?php echo HTMLHelper::_('fwView.handleUploadButton', array(
									'button' => '#fwmg-import-upload',
									'input' => '#fwmg-input-import',
									'image' => '',
									'exts' => array('zip', 'tar'),
									'view' => 'data',
									'layout' => 'backup_upload',
									'callback' => 'function(html) {
	$progress_bar.remove();
	$button.attr(\'disabled\', false);
	$input.next().html(\''.fwgHelper::jtext('FWMG_CHOOSE_FILE', false).'\');

	var $parent = $input.parent();
	var input_html = $parent.html();
	$parent.html(input_html);

	var $cont = $(\'#fwmg-import-files\');
	var data = $.parseJSON(html);
	if (data) {
		if (data.result) {
			$(\'.fwmg-data-import-result\').html(\''.fwgHelper::jtext('FWMG_EXPORT_FILE_CREATED', true).'\'+data.result.name);
			var $row = $(\'<tr>\\
	<td><a href="'.FWMG_MEDIA_URL.'com_fwgallery/backups/\'+data.result.name+\'">\'+data.result.name+\'</a> (\'+data.result.size+\')</td>\\
	<td>\\
	<button type="button" class="fwk-icon-button fwk-button-primary" title="'.$this->escape(fwgHelper::jtext('FWMG_RESTORE', true)).'" fwk-icon="check" fwk-tooltip></button>\\
		<button type="button" class="fwk-icon-button fwk-button-danger" title="'.$this->escape(fwgHelper::jtext('FWMG_DELETE', true)).'" fwk-icon="trash" fwk-tooltip></button>\\
	</td>\\
</tr>\');
			$(\'#fwmg-import-files\').append($row);
		}
		if (data.msg) fwmg_alert(data.msg);
	}
}'
								)); ?>
							</div>
						</div>
					</div>
				</div>
			</form>
		</div>
	</div>
<?php
}
?>
	<div id="fwmg-backup">
		<div class="fwa-main-body">
			<form action="index.php?option=com_fwgallery&amp;view=data" method="post" name="adminForm">
				<div class="fwa-mb-cardbox fwk-child-width-1-2@l" fwk-grid>
					<div>
						<div class="fwk-card fwk-card-default fwk-card-grey">
							<div class="fwk-card-header">
								<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_BACKUP_BACKUP'); ?></div>
								<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_BACKUP_BACKUP_HINT'); ?></div>
								<div class="fwk-margin-small-top text-muted"><em><?php echo fwgHelper::jtext('FWMG_ADMIN_DATA_TAB_BACKUP_BACKUP_HINT'); ?> <?php echo str_replace('\\', '/', FWMG_STORAGE_PATH); ?>backups</em></div>
							</div>
							<div class="fwk-card-body" fwk-margin>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_BACKUP_BUCONTENT'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<div class="fwk-width-expand"  fwk-margin>
											<div>
												<input type="checkbox" class="fwk-checkbox" id="fwmg-pdata" name="pdata" value="1" checked="checked" disabled="disabled" />
												<label for="fwmg-pdata"><?php echo fwgHelper::jtext('FWMG_ADMIN_DATA_TAB_BACKUP_DATA'); ?></label>
											</div>
											<div>
												<input type="checkbox" class="fwk-checkbox" id="fwmg-pimages" name="pimages" value="1" checked="checked" />
												<label for="fwmg-pimages"><?php echo fwgHelper::jtext('FWMG_ADMIN_DATA_TAB_BACKUP_FILES'); ?></label>
											</div>
										</div>
										<div class="fwk-width-auto">
											<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(fwgHelper::jtext('FWMG_DOC_ADMIN_DATA_TAB_BACKUP_BUCONTENT_HINT')); ?>"></span>
										</div>

									</div>
								</div>
								<button type="button" id="fwmg-data-export" class="fwk-button fwk-button-primary"><?php echo fwgHelper::jtext('FWMG_BACKUP'); ?></button>
								<div class="fwk-margin-top fwmg-data-export-result" fwk-margin></div>
							</div>
						</div>
					</div>
				</div>
			</form>
		</div>
	</div>
<?php
if ($this->current_user->authorise('core.create', 'com_fwgallery')) {
?>
	<div>
		<div class="fwa-main-body fwa-mb-cardbox fwk-child-width-1-2@m" fwk-grid>
<?php
if ($this->plugins) {
	foreach ($this->plugins as $i=>$plugin) {
		if ($plugin) echo fwgHelper::escPluginsOutput($plugin);
	}
}
?>
		</div>
	</div>
<?php
}
?>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		var hash = location.hash;
		if (hash != '') {
			if (hash == '#_=_') {
				$('a[href="#fwmg-data"').click();
			} else {
				$('a[href="'+hash+'"').click();
			}
		}
		$('.fwa-filter-bar a.nav-link').click(function() {
			if ($(this).attr('href') == '#fwmg-data') {
				location.hash = '#_=_';
			} else {
				location.hash = $(this).attr('href');
			}
		});
		$('#fwmg-import-files').on('click', '.fwk-button-primary', function() {
			var $row = $(this).closest('tr');
			var file = $(this).closest('td').prev().find('a').html();
			var $output = $('.fwmg-data-import-result').html('');
			if (confirm('<?php echo fwgHelper::jtext('FWMG_ARE_YOU_SURE_BACKUP_RESTORE', true); ?> '+file)) {
				$('#fwmg-import-files').find('button').attr('disabled', true);
				$output.addClass('fwk-alert').html('<div><?php echo fwgHelper::jtext('FWMG_BACKUP_UNPACKING_AND_APPLYING', true); ?></div><div fwk-spinner></div>');
				$.ajax({
					dataType: 'json',
					data: {
						format: 'json',
						view: 'data',
						layout: 'backup_restore',
						filename: file
					}
				}).done(function (data) {
					$('#fwmg-import-files').find('button').attr('disabled', false);
					$output.find('[fwk-spinner]').remove();
					if (data.result) {
						$output.append($('<div class="fwk-text-success"><?php echo fwgHelper::jtext('FWMG_BACKUP_SUCCESFULLY_INSTALLED', true); ?></div>'));
					}
					if (data.msg) {
						$output.append($('<div class="fwk-text-danger">'+data.msg+'</div>'));
					}
				}).fail(function(xhr, thrownError) {
					$output.find('[fwk-spinner]').remove();
					$output.append($('<div class="fwk-text-danger"><?php echo fwgHelper::jtext('FWMG_ERROR', true); ?> '+xhr.status+' - '+thrownError+'</div>'));
				});
			}
		}).on('click', '.fwk-button-danger', function() {
			var $row = $(this).closest('tr');
			var file = $(this).closest('td').prev().find('a').html();
			var $output = $('.fwmg-data-import-result').html('');
			if (confirm('<?php echo fwgHelper::jtext('FWMG_ARE_YOU_SURE_BACKUP_DELETE', true); ?> '+file)) {
				$row.find('button').attr('disabled', true);
				$.ajax({
					dataType: 'json',
					data: {
						format: 'json',
						view: 'data',
						layout: 'backup_delete',
						filename: file
					}
				}).done(function (data) {
					$row.find('button').attr('disabled', false);
					if (data.result) {
						$row.remove();
					}
					if (data.msg) {
						fwmg_alert(data.msg);
					}
				});
			}
		});
		$('#fwmg-data-export').click(function() {
			var $btn = $(this);
			var $form = $(this.form);

			var $output = $('.fwmg-data-export-result').html('');
			if ($form.find('input:checked').length) {
				$btn.attr('disabled', true);
				$output.addClass('fwk-alert').html('<div><?php echo fwgHelper::jtext('FWMG_EXPORT_DATABASE_DATA', true); ?></div><div fwk-spinner></div>');
				$.ajax({
					dataType: 'json',
					data: {
						format: 'json',
						view: 'data',
						layout: 'export_data'
					}
				}).done(function(data) {
					if (data.result) {
						var images = $form.find('input[name="pimages"]:checked').length;
						$output.find('[fwk-spinner]').remove();
						$output.append($('<div>'+(images?'<?php echo fwgHelper::jtext('FWMG_ZIPPING_DATA_IMAGES', true); ?>':'<?php echo fwgHelper::jtext('FWMG_ZIPPING_DATA', true); ?>')+'</div><div fwk-spinner></div>'));
						$.ajax({
							dataType: 'json',
							data: {
								format: 'json',
								view: 'data',
								layout: 'store_export_data',
								images: images,
								folder: data.result
							}
						}).done(function(data) {
							$btn.attr('disabled', false);
							$output.find('[fwk-spinner]').remove();
							if (data.result) {
								$output.append($('<div class="fwk-text-success"><?php echo fwgHelper::jtext('FWMG_EXPORT_FILE_CREATED', true); ?> '+data.result.name+'</div>'));
								var $row = $('<tr>\
	<td><a href="<?php echo FWMG_MEDIA_URL; ?>com_fwgallery/backups/'+data.result.name+'">'+data.result.name+'</a> ('+data.result.size+')</td>\
	<td>\
		<button type="button" class="fwk-icon-button fwk-button-primary" title="<?php echo $this->escape(fwgHelper::jtext('FWMG_RESTORE', true)); ?>" fwk-icon="check" fwk-tooltip></button>\
		<button type="button" class="fwk-icon-button fwk-button-danger" title="<?php echo $this->escape(fwgHelper::jtext('FWMG_DELETE', true)); ?>" fwk-icon="trash" fwk-tooltip></button>\
	</td>\
</tr>');
								$('#fwmg-import-files').append($row);
							}
							if (data.msg) {
								$output.append('<div class="fwk-text-danger">'+data.msg+'</div>');
							}
						});
					}
					if (data.msg) {
						$output.append('<div class="fwk-text-danger">'+data.msg+'</div>');
					}
				}).fail(function(xhr, thrownError) {
					$output.find('[fwk-spinner]').remove();
					$output.append($('<div class="fwk-text-danger"><?php echo fwgHelper::jtext('FWMG_ERROR', true); ?> '+xhr.status+' - '+thrownError+'</div>'));
				});
			} else {
				fwmg_alert('<?php echo fwgHelper::jtext('FWMG_SELECT_WHAT_TO_EXPORT', true); ?>');
			}
		});
	})(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR)
;
