<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

if ($this->current_user->authorise('core.create', 'com_fwgallery')) {
	fwgButtonsHelper::addNew('add', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_NEW');
	fwgButtonsHelper::custom('upload', 'purple', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_UPLOAD', 'import', false);
}
if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
	fwgButtonsHelper::editList('edit', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_EDIT');
}
if ($this->current_user->authorise('core.delete', 'com_fwgallery')) {
	fwgButtonsHelper::deleteList(Text::_('FWMG_ADMIN_FILES_TOOLBAR_BTN_DELETE_MSG'), 'remove' , 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_DELETE');
}
if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
	fwgButtonsHelper::publish('publish', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_PUBLISH');
	fwgButtonsHelper::unpublish('unpublish', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_UNPUBLISH');
	fwgButtonsHelper::custom('box-check', 'blue', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_BATCH', 'batch', true);
	fwgButtonsHelper::custom('save', 'green', 'FWMG_DOC_ADMIN_FILES_TOOLBAR_BTN_SAVEALL', 'saveall', false);
}

fwgHelper::triggerEvent('ongetFilesListingAdditionalTopButtons', array('com_fwgallery'));

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => Text::_('FWMG_DOC_ADMIN_FILES'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_FILES_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<hr/>
<form action="index.php?option=com_fwgallery&amp;view=file" id="adminForm" name="adminForm" method="post">
    <div class="fwa-filter-bar" fwk-grid>
        <div class="fwk-width-expand@m">
			<div class="fwk-position-relative">
    			<span class="fwk-form-icon fwk-text-green" fwk-icon="icon: search"></span>
                <input type="text" class="fwk-input" placeholder="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_SEARCH'); ?>" type="text" name="search" value="<?php echo esc_attr($this->search); ?>" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_SEARCH_HINT'); ?>" />
            </div>
        </div>
        <div class="fwk-width-auto@m" placeholder="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_CATEGORY'); ?>" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_CATEGORY_HINT'); ?>">
            <?php echo HTMLHelper::_('fwsgCategory.getCategories', 'category', $this->category, 'class="fwk-select" onchange="with(this.form){if(this.form.limitstart){limitstart.value=0;}submit();}"', false, 'FWMG_SELECT_GALLERY'); ?>
        </div>
        <div class="fwk-width-auto@m" placeholder="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_OWNER'); ?>" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_OWNER_HINT'); ?>">
            <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
                HTMLHelper::_('select.option', '', Text::_('FWMG_SELECT_OWNER'), 'id', 'name')
            ), $this->users), 'user', 'class="fwk-select" onchange="with(this.form){if(this.form.limitstart){limitstart.value=0;}submit();}"', 'id', 'name', $this->user); ?>
        </div>
<?php
if (count($this->types) > 1) { 
?>
        <div class="fwk-width-auto@m fwk-margin-remove-top" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_FILTER_TYPES_HINT'); ?>">
            <?php echo HTMLHelper::_('select.genericlist', $this->types, 'tab', 'class="fwk-select"', 'value', 'title', $this->tab); ?>
        </div>
<?php
}
?>
    </div>
    <table class="fwk-table fwk-table-middle fwk-table-striped fwmg-admin-images">
        <thead>
            <tr>
                <th><input class="fwk-checkbox" name="toggle" value="" onclick="Joomla.checkAll(this);" type="checkbox"></th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_PREVIEW_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_PREVIEW'); ?></th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_FILE_HINT'); ?>">
                    <a href="index.php?option=com_fwgallery&view=file<?php echo str_replace(array('&amp;ordering=created', '&amp;ordering=name', '&amp;ordering=ordering'), '', $this->extra_link).'&amp;ordering=created'; ?>">
                        <?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_FILE'); ?>
                    </a>
                </th>
                <!-- <th width="25%" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_DESCRIPTION_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_DESCRIPTION'); ?></th> -->
                <!-- <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_CATEGORY_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_CATEGORY'); ?></th> -->
<?php
fwgHelper::triggerEvent('onshowFileListExtraHeaders', array('com_fwgallery', $this));
?>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_ORDER_HINT'); ?>">
                    <a href="index.php?option=com_fwgallery&view=file<?php echo str_replace(array('&amp;ordering=created', '&amp;ordering=name', '&amp;ordering=ordering'), '', $this->extra_link).'&amp;ordering=ordering'; ?>">
                    	<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_ORDER'); ?>
                    </a>
<?php
if ($this->current_user->authorise('core.edit', 'com_fwgallery') and $this->order == 'ordering') {
?>
                	<a class="fwk-button" href="javascript:"  onclick="Joomla.saveorder(<?php echo (int)count($this->list)-1; ?>, 'saveorder')"><span fwk-icon="save"></span></a>
<?php
}
?>
                </th>
                <th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_STATS_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_FILES_COLUMN_STATS'); ?></th>
                <th class="fwk-table-shrink"></th>
            </tr>
        </thead>
        <tbody>
<?php
if ($this->list) {
    $num = 0;
    foreach ($this->list as $row) {
        if ($row->type == 'image') {
?>

            <tr>
                <td><?php echo HTMLHelper::_('grid.id', $num, $row->id); ?></td>
                <td class="fwk-text-center">
                    <img class="fwk-border-rounded" src="<?php echo Uri::root(true); ?>/index.php?option=com_fwgallery&amp;view=item&amp;layout=img&amp;format=raw&amp;w=90&amp;h=60&amp;id=<?php echo (int)$row->id; ?>&amp;rand=<?php echo rand(); ?>">
                    <div class="fwk-text-small fwk-text-muted fwk-margin-small-top">ID: <?php echo (int)$row->id; ?></div>
                </td>
                <td class="fwmg-admin-images-file" fwk-margin>
                    <div>
<?php
    		if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
?>
                        <a href="index.php?option=com_fwgallery&amp;view=file&amp;task=edit&amp;cid[]=<?php echo esc_attr($row->id.$this->extra_link); ?>"><?php echo esc_html($row->name); ?></a>
<?php
	    	} else {
?>
					    <?php echo esc_html($row->name); ?>
<?php
		    }
?>
<?php
            if (!empty($row->descr)) {
?>
                        <div class="fwk-display-inline-block fwg-admin-file-description">
                            <span class="fwk-margin-small-left" fwk-icon="icon:file-text"></span>
                            <span><?php echo strlen($row->descr); ?></span>
                            <div class="fwk-width-large fwk-height-max-medium fwk-overflow-auto" fwk-dropdown="pos: bottom-center; animation: fwk-animation-slide-top-small; duration: 300;">
                                <?php echo esc_html($row->descr); ?>
                            </div>
                        </div>    
<?php
            }
?>
                    </div>
                    <div class="fwk-grid-small fwk-text-small" fwk-grid>
                        <div>
                            <span class="fwk-margin-small-right" fwk-icon="calendar"></span> <?php echo HTMLHelper::date($row->created, 'd M y, H:i'); ?>
                        </div>
                        <div>
                            <span class="fwk-margin-small-right" fwk-icon="folder"></span> <?php echo esc_html($row->_category_name); ?>
                        </div>
<?php
            if ($row->_user_name) {
?>
                        <div>
                            <span class="fwk-margin-small-right" fwk-icon="user"></span> <?php echo esc_html($row->_user_name); ?>
                        </div>
<?php
            }
?>
                        <div>
                            <span class="fwk-margin-small-right" fwk-icon="lock"></span> <?php echo esc_html($row->access?$row->_group_name:Text::_('FWMG_PUBLIC')); ?>
                        </div>
                    </div>
                    
                    <div class="">
                        <div class="fwk-text-small"><span class="fwk-margin-small-right" fwk-icon="image"></span> <?php echo esc_html($row->_filename); ?> </div>
                        <div class="fwk-text-small">
                        </div>
<?php
            fwgHelper::triggerEvent('onshowFileListExtraFields', array('com_fwgallery', $row));
?>
                    </div>
<?php
		    if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
?>
                    <div>
                        <div class="fwk-inline" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_ALT_TEXT')); ?>">
                            <span class="fwk-form-icon fwk-form-icon-flip" fwk-icon="bolt"></span>
                            <input class="fwk-input" type="text" name="alt_texts[<?php echo (int)$row->id; ?>]" value="<?php echo esc_attr($row->_alt); ?>">
                        </div>
                    </div>
<?php
		    }
?>
                </td>
<?php
		    fwgHelper::triggerEvent('onshowFileListExtraColumns', array('com_fwgallery', $this, $num, $row));
?>
                <td class="order">
<?php
            if ($this->order == 'ordering') {
?>
                    <?php echo HTMLHelper::_('fwView.orderingListLinks', array(
                        'num' => $num,
                        'value' => $row->ordering,
                        'display_up' => ($num > 0),
                        'display_down' => (($num + 1) < count($this->list))
                    )); ?>
<?php
            } else {
                echo (int)$row->ordering;
            }
?>
                </td>
                <td>
<?php
            if ($row->hits) {
?>
					<div><span fwk-icon="eye"></span> <?php echo (int)$row->hits; ?></div>
<?php
            }
            if ($row->downloads) {
?>
					<div><span fwk-icon="download"></span> <?php echo (int)$row->downloads; ?></div>
<?php
            }
            fwgHelper::triggerEvent('onshowFileListHitsExtraFields', array('com_fwgallery', $row, $this->params));
?>
                </td>
                <td>
<?php
		    if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
?>
                    <?php echo HTMLHelper::_('fwView.booleanListLink', array(
                        'num' => $num,
                        'value' => $row->published,
                        'task_on' => 'publish',
                        'task_off' => 'unpublish',
                        'title_on' => Text::_('FWMG_PUBLISH'),
                        'title_off' => Text::_('FWMG_UNPUBLISH'),
                        'class_on' => 'green',
                        'class_off' => 'muted'
                    )); ?>
<?php
                fwgHelper::triggerEvent('ongetFilesListingAdditionalListingButtons', array('com_fwgallery', $row, $this->tab, $this->extra_link, $num));
		    }
?>
                </td>
            </tr>
<?php
        } else {
            fwgHelper::triggerEvent('onshowFileListRow', array('com_fwgallery.'.$row->type, $this, $num, $row));
        }
        $num++;
    }
} else {
?>
            <tr>
                <td colspan="10">
<?php
    echo Text::_($this->search?'FWMG_NO_FILES_FOUND':'FWMG_NO_FILES');
?>
                </td>
            </tr>
<?php
}
?>
        </tbody>
    </table>
    <div class="fwk-grid-small fwk-flex-middle fwa-pagination" fwk-grid>
        <div class="fwk-width-auto">
            <?php echo $this->pagination->getResultsCounter(); ?>
        </div>
        <div class="fwk-width-expand fwk-text-center">
            <?php echo $this->pagination->getListFooter(); ?>
        </div>
        <div class="fwk-width-auto">
            <?php echo $this->pagination->getLimitBox(); ?>
        </div>
    </div>
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="type" value="image" />
    <input type="hidden" name="ordering" value="<?php echo esc_attr($this->order); ?>" />
    <input type="hidden" name="boxchecked" value="" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
    Joomla.submitbutton = function(pressbutton) {
        if (pressbutton) {
            if (pressbutton == 'import') {
                fwkUIkit.modal('#fwmg-batch-upload').show();
            } else if (pressbutton == 'batch') {
                fwkUIkit.modal('#fwmg-batch-operations').show();
            } else {
                if (pressbutton == 'saveall') {
                    $('.fwmg-admin-images input[name="cid[]"]').prop('checked', true);
                }
                document.adminForm.task.value=pressbutton;
                document.adminForm.submit();
            }
        }
    }
    $('select[name="tab"]').change(function() {
        with(this.form) {
            limitstart.value = 0;
            submit();
        }
    });
	if (!$('#adminForm input[name="limitstart"]').length) {
		$('#adminForm').append($('<input type="hidden" name="limitstart">'));
	}
<?php
if (count($this->types) > 2) {
?>
    var $btn = $('#fwmg-add-button').attr('onclick', '');
    $btn.wrap('<div class="fwk-inline"></div>');
    var $dropdown = $('<ul class="fwk-nav fwk-dropdown-nav" fwk-margin></ul>');
    $btn.after($dropdown);
    $btn.addClass('dropdown-toggle');
<?php
    for ($i = 1; $i < count($this->types); $i++) {
        $value = $this->types[$i]['value'];
        $icon = '';
        switch ($value) {
            case 'audio' : $icon = 'music'; break;
            case 'video' : $icon = 'video-camera'; break;
            default: $icon = $value;
        }
?>
    var $row = '<li><a href="javascript:" onclick="document.adminForm.type.value=\'<?php echo esc_js($value); ?>\';Joomla.submitbutton(\'add\');"><span fwk-icon="<?php echo $icon; ?>" class="fwk-margin-small-right"></span> <?php echo Text::_('FWMG_ADD_'.$value, true); ?></a></li>';
    $dropdown.append($row);
<?php
    }
?>
    $dropdown.wrap('<div fwk-dropdown="mode: click;pos: bottom-left"></div>');
<?php
}
?>
		$('input[name="search"]').keyup(function(ev) {
			if (ev.keyCode == 13) {
				if (this.form.limitstart) {
					this.form.limitstart.value = 0;
				}
				this.form.submit();
			}
		});
		$('input[name="cid[]"]').on('click change', function() {
			var $row = $(this).closest('tr');
			if (this.checked) {
				$row.addClass('fwk-selected-row');
			} else {
				$row.removeClass('fwk-selected-row');
			}
		});
		$('input[name="toggle"]').click(function() {
			$('input[name="cid[]"]').trigger('change');
		});
    })(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchoperations', array(
	'view'=>$this
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->allusers,
	'current_user'=>$this->current_user,
	'category'=>$this->category,
	'reload'=>true
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR)
;
