<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => $this->object->id?(Text::sprintf('FWMG_ADMIN_FILEEDIT_EDIT', $this->object->name)):Text::_('FWMG_ADMIN_FILEEDIT_NEW'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_FILEEDIT_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);

$plugin_installed = fwgHelper::pluginInstalled('audio', 'fwgallerytype');
$plugin_enabled = fwgHelper::pluginEnabled('audio', 'fwgallerytype');

if (!$plugin_installed or !$plugin_enabled) {
?>
<div class="fwk-alert fwk-alert-danger">
<?php
    if (!$plugin_installed) {
        echo Text::_('FWMG_AUDIO_PLUGIN_NOT_INSTALLED');
    } else {
        echo Text::_('FWMG_AUDIO_PLUGIN_NOT_ENABLED');
    }
?>
</div>
<?php
} else {
    echo LayoutHelper::render('admin.audio.edit', array('view'=>$this), FWMG_TYPES_PATH.'audio/layouts');
}

echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
