<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

if ($this->current_user->authorise('core.edit', 'com_fwgallery')) {
	fwgButtonsHelper::apply('apply', 'FWMG_DOC_ADMIN_FILEEDIT_TOOLBAR_BTN_SAVE');
}
fwgButtonsHelper::save('save', 'FWMG_DOC_ADMIN_FILEEDIT_TOOLBAR_BTN_SAVECLOSE');
fwgButtonsHelper::cancel('cancel', 'FWMG_DOC_ADMIN_FILEEDIT_TOOLBAR_BTN_CANCEL');

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/jquery.datetimepicker.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/jquery.datetimepicker.full.min.js');

$editor = fwgHelper::getEditor();

$max_size = fwgHelper::getIniSize('upload_max_filesize');
$post_size = fwgHelper::getIniSize('post_max_size');

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => $this->object->id?(Text::sprintf('FWMG_ADMIN_FILEEDIT_EDIT', $this->object->name)):Text::_('FWMG_ADMIN_FILEEDIT_NEW'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_FILEEDIT_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);

?>
<hr/>
<form action="index.php?option=com_fwgallery&amp;view=file" id="adminForm" name="adminForm" method="post" enctype="multipart/form-data">
	<div>
		<div class="fwa-main-body">
			<div class="fwa-mb-cardbox fwk-child-width-1-2@m" fwk-grid="masonry: true;">

					<!-- Genral -->
					<div>
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL'); ?></div>
							<div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_HINT'); ?></div>
						</div>
						<div class="fwk-card-body" fwk-margin>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_PUBLISHED'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('fwView.radioGroup', 'published', $this->object->id?$this->object->published:1, array(
										'wrapper_class' => 'fwk-width-expand',
										'buttons' => array(array(
											'active_class' => 'fwk-button-success',
											'title' => Text::_('JYES'),
											'value' => 1
										), array(
											'active_class' => 'fwk-button-danger',
											'title' => Text::_('JNO'),
											'value' => 0
										))
									)); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_PUBLISHED_HINT')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_NAME'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<input class="fwk-input" name="name" value="<?php echo esc_attr($this->object->name); ?>" type="text">
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_NAME_HINT')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_CATEGORY'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'category_id', $this->object->category_id?$this->object->category_id:$this->category, 'class="fwk-select"', false, null); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_CATEGORY_HINT')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_COPYRIGHT'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<textarea class="fwk-textarea" name="copyright" rows="2"><?php echo esc_textarea($this->object->copyright); ?></textarea>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_COPYRIGHT_HINT')); ?>"></span>
								</div>
							</div>
<?php
		fwgHelper::triggerEvent('onshowFileEditExtraFields', array('com_fwgallery', $this->object));
?>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_DATE'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<div class="fwk-group-date">
										<input class="fwk-input" type="text" name="created" value="<?php echo esc_attr($this->object->id?substr($this->object->created, 0, 16):date('Y-m-d H:i')); ?>">
										<button class="fwk-button" type="button"><span fwk-icon="calendar"></span></button>
									</div>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_DATE_HINT')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_OWNER'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadUsers(), 'user_id', 'class="fwk-select"', 'id', 'name', $this->object->id?$this->object->user_id:$this->current_user->id); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_OWNER_HINT')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_ACCESS'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadviewlevels(), 'access', 'class="fwk-select"', 'id', 'name', $this->object->access); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_ACCESS_HINT')); ?>"></span>
								</div>
							</div>
						</div>
					</div>
					</div>

					<!-- Image -->
					<div>
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_IMAGE_IMAGE'); ?></div>
							<div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_IMAGE_IMAGE_HINT'); ?>, <?php echo Text::_('FWMG_FILE_UPLOAD_SIZE_LIMIT', true).' '.fwgHelper::humanFileSize($max_size); ?>, <?php echo Text::_('FWMG_POST_SIZE_LIMIT', true).' '.fwgHelper::humanFileSize($post_size); ?></div>
						</div>
						<div class="fwk-card-body" id="fwmg-image-container">
							<div class="fwk-margin-bottom">
								<img class="fwk-border-rounded" src="<?php echo Uri::root(true); ?>/index.php?option=com_fwgallery&amp;view=item&amp;layout=img&amp;format=raw&amp;w=491&amp;h=300&amp;id=<?php echo (int)$this->object->id; ?>&amp;rand=<?php echo rand(); ?>" />
								<button type="button" class="fwk-button fwk-button-link fwk-button-small fwk-text-danger fwmg-remove"<?php if (!$this->object->_sys_filename) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></span><?php echo Text::_('FWMG_REMOVE'); ?></button>
								<?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
									'button' => '#fwmg-image-container .fwmg-remove',
									'image' => '#fwmg-image-container img',
									'view' => 'file',
									'layout' => 'delete_image'
								)); ?>
							</div>
							<div class="input-group fwk-margin-bottom">
								<div class="" fwk-form-custom>
									<input type="file" id="fwmg-image" name="image" />
									<input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo Text::_('FWMG_CHOOSE_FILE'); ?>" disabled="">
								</div>
								<div class="input-group-append">
									<button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo Text::_('FWMG_UPLOAD'); ?></button>
								</div>
							</div>
<?php
$response_code = '$(\'input[name="name"]\').val(data.name);$(\'input[name="alias"]\').val(data.alias);$(\'textarea[name="copyright"]\').val(data.copyright);$(\'textarea[name="metakey"]\').val(data.metakey);$(\'textarea[name="metadescr"]\').val(data.metadescr);$(\'textarea[name="descr"]\').val(data.descr);Joomla.editors.instances[\'descr\'].setValue(data.descr);';
fwgHelper::triggerEvent('ongetResponseJsForUploadedImage', array('com_fwgallery', &$response_code));
?>
							<?php echo HTMLHelper::_('fwView.handleUploadButton', array(
								'button' => '#fwmg-image-container .fwmg-upload',
								'remove_button' => '#fwmg-image-container .fwmg-remove',
								'input' => '#fwmg-image',
								'image' => '#fwmg-image-container img',
								'exts' => array('gif', 'jpg', 'jpeg', 'png'),
								'view' => 'file',
								'layout' => 'upload',
								'response_code' => $response_code
							)); ?>
						</div>
					</div>
					</div>
					<!-- Descripton -->
					<div>
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_DESCRIPTION_DESCRIPTION'); ?></div>
							<div class="fwk-text-muted"><?php echo Text::_('FWMG_DOC_ADMIN_FILEEDIT_SECTION_DESCRIPTION_DESCRIPTION_HINT'); ?></div>
						</div>
						<div class="fwk-card-body" fwk-margin>
							<?php echo $editor->display('descr', $this->object->descr, '100%', 150, 60, 7); ?>
						</div>
					</div>
					</div>

<?php
					fwgHelper::triggerEvent('onshowFileEditExtraCards', array('com_fwgallery', $this->object));
?>

					
			</div>
		</div>
	</div>
    <input type="hidden" name="oid" value="<?php echo (int)$this->object->id; ?>" />
    <input type="hidden" name="type" value="image" />
    <input type="hidden" name="task" value="" />
<?php
foreach ($this->fields as $field) {
	if ($this->$field) {
?>
    <input type="hidden" name="<?php echo esc_attr($field); ?>" value="<?php echo esc_attr($this->$field); ?>" />
<?php
	}
}
?>
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    $('input[name="created"]').datetimepicker({
        format: 'Y-m-d H:i'
    });
    $('input[name="created"]').next().click(function() {
        $('input[name="created"]').focus();
    });
	})(jQuery);
});
</script>
<?php
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
