<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

echo LayoutHelper::render('common.menu_begin', array(
    'view' => $this,
    'title' => Text::_('FWMG_DOC_ADMIN_DASHBOARD'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_DASHBOARD_HINT')
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<hr/>
<div class="fwk-child-width-1-3@m fwk-grid-small fwa-dashboard" fwk-grid="masonry: true;">

<?php
if ($this->prev_data) {
?>
    <div>
		<!-- Previous version FW Gallery import  -->
		<div class="fwk-card fwk-card-default fwk-card-green-pale">
			<div class="fwk-card-header">
				<div class="fwk-card-title"><?php echo Text::_('FWMG_DATA_IMPORT'); ?></div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="">
					<?php echo Text::_('FWMG_DATA_IMPORT_TEXT'); ?>
				</div>
				<div class="fwk-margin-medium-top">
					<button class="fwk-button fwk-button-primary fwk-text-center fwmg-import-prev-data" data-move="1">
						<span class="fwk-text-large"><?php echo Text::_('FWMG_DATA_MOVE_BUTTON'); ?></span>
					</button>
				</div>
				<div class="fwk-text-small">
					<?php echo Text::_('FWMG_DATA_MOVE_TEXT'); ?>
				</div>
				<div class="fwk-margin-medium-top">
					<button class="fwk-button fwk-button-secondary fwk-text-lead fwk-text-center fwmg-import-prev-data" data-move="0">
						<span class="fwk-text-large"><?php echo Text::_('FWMG_DATA_COPY_BUTTON'); ?></span>
					</button>
				</div>
				<div class="fwk-text-small">
<?php
	echo Text::_('FWMG_DATA_COPY_TEXT_BEGIN');
	echo fwgHelper::humanFileSize($this->prev_data);
	echo Text::_('FWMG_DATA_COPY_TEXT_END');
?>
				</div>
			</div>
		</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
	$('.fwmg-import-prev-data').click(function() {
		var $btn = $(this);
		if (confirm('<?php echo Text::_('FWMG_ARE_YOU_SURE', true); ?>')) {
			var $img = $('<div class="fwk-margin-left" fwk-spinner></div>');
			$('.fwmg-import-prev-data').attr('disabled', true);
			$btn.after($img);
			$.ajax({
				dataType: 'json',
                type: 'post',
				data: {
					format: 'json',
	    			view: 'fwgallery',
					layout: 'import_prev_data',
					remove_previous_data: $btn.data('move')
				}
			}).done(function(data) {
				$('.fwmg-import-prev-data').attr('disabled', false);
				$img.remove();
				if (data.result && $btn.data('move') == 1) {
					$btn.closest('.card').remove();
				}
				if (data.msg) {
					fwmg_alert(data.msg);
				}
			}).fail(function(xhr, thrownError) {
				$('.fwmg-import-prev-data').attr('disabled', false);
				$img.remove();
				fwmg_alert('Error '+xhr.status+' - '+thrownError);
			});
		}
	});
    })(jQuery);
});
</script>
    </div>
<?php
}
?>

	<div>
		<!-- Wizard -->
        <div class="fwk-card fwk-card-default fwk-card-blue-pale">
			<div class="fwk-card-header">
				<div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_NOTIFICATIONS'); ?></div>
			</div>
			<div class="fwk-card-body" id="fwa-wizard-body" fwk-margin></div>
		</div>
	</div>

    <div>
        <a name="quick-check"></a>
		<div class="fwk-card fwk-card-default fwk-card-green-pale fwa-check check-<?php if ($this->qch->test_passed) { ?>success<?php } else { ?>fail<?php } ?>">
			<div class="fwk-card-header">
                <div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_SYSTEMCHECK'); ?></div>
            </div>
            <div class="fwk-card-body" fwk-margin>
<?php
$pass = 0;
$fail = 0;
if ($this->qch->media_folder_exists) {
    $pass++;
} else {
    $fail++;
}
if ($this->qch->gallery_folder_exists) {
    $pass++;
} else {
    $fail++;
}
if ($this->qch->gallery_folder_writeable) {
    $pass++;
} else {
    $fail++;
}
if ($this->qch->cache_folder_exists) {
    $pass++;
} else {
    $fail++;
}
if ($this->qch->cache_folder_writeable) {
    $pass++;
} else {
    $fail++;
}
if ($this->qch->gd_installed) {
    $pass++;
} else {
    $fail++;
}
if ($this->qch->exif_installed) {
    $pass++;
} else {
    $fail++;
}    
?>
                <div class="fwk-grid-small fwk-child-width-1-2 fwk-margin-bottom" fwk-grid>
<?php
if ($fail) {
?>
					<div>
						<a class="fwk-button fwk-width-expand" href="#fwmg-system-check" fwk-toggle>
							<div class="fwk-flex fwk-flex-between fwk-flex-middle">
								<div class="fwk-width-expand fwk-text-left">
									<div class="fwk-text-lead">
										<span class="fwk-text-danger" fwk-icon="icon:fwa-close-mark;"></span> 
										<span class="fwk-text-decoration-none"><?php echo $fail; ?></span>
									</div>
									<div><?php echo Text::_('FWMG_TEST_FAILED'); ?></div>
								</div>
								<div>
									<span class="fwk-preserve-width fwk-text-muted" fwk-icon="chevron-right"></span>
								</div>
							</div>
						</a>
					</div>
<?php
}
if ($pass) {
?>
					<div>
						<a class="fwk-button" href="#fwmg-system-check" fwk-toggle>
							<div class="fwk-flex fwk-flex-between fwk-flex-middle">
								<div class="fwk-width-expand fwk-text-left">
									<div class="fwk-text-lead">
										<span class="fwk-text-green" fwk-icon="icon:fwa-check-mark;"></span> 
										<span class="fwk-text-decoration-none"><?php echo $pass; ?></span>
									</div>
									<div><?php echo Text::_('FWMG_TEST_PASSED'); ?></div>
								</div>
								<div>
									<span class="fwk-preserve-width fwk-text-muted" fwk-icon="chevron-right"></span>
								</div>
							</div>
						</a>
					</div>
<?php
}
?>	
				</div>
				<div class="">
					<span fwk-icon="fwa-info-comment" class="fwk-margin-small-right fwk-text-green fwk-margin-small-right"></span> 
					<a href="javascript:" class="fwk-text-green"><?php echo Text::_('FWMG_PHP_SERVER_SETTING'); ?></a>
					<div fwk-drop="mode: click;pos: top-center" class="fwk-border-rounded fwk-padding-small fwk-background-yellow-light">
						<div fwk-margin>
							<div class="fwk-border-rounded fwk-background-white fwk-padding-small">
								<div class="fwk-flex-middle fwk-grid-small" fwk-grid>
									<div class="fwk-width-expand">
										<?php echo Text::_('FWMG_MAX_TOTAL_POST_SIZE'); ?>
									</div>
									<div class="fwk-width-1-4 fwk-text-bold">
										<?php echo fwgHelper::humanFileSize(fwgHelper::getIniSize('post_max_size')); ?>
									</div>
								</div>
							</div>
							<div class="fwk-border-rounded fwk-background-white fwk-padding-small">
								<div class="fwk-flex-middle fwk-grid-small" fwk-grid>
									<div class="fwk-width-expand">
										<?php echo Text::_('FWMG_MAX_FILE_SIZE'); ?>
									</div>
									<div class="fwk-width-1-4 fwk-text-bold">
										<?php echo fwgHelper::humanFileSize(fwgHelper::getIniSize('upload_max_filesize')); ?>
									</div>
								</div>
							</div>
							<div class="fwk-border-rounded fwk-background-white fwk-padding-small">
								<div class="fwk-flex-middle fwk-grid-small" fwk-grid>
									<div class="fwk-width-expand">
										<?php echo Text::_('FWMG_MAX_FILES_PER_POST'); ?>
									</div>
									<div class="fwk-width-1-4 fwk-text-bold">
										<?php echo ini_get('max_file_uploads'); ?>
									</div>
								</div>
							</div>
						</div>


                    </div>
                </div>

            </div>
        </div>
    </div>

    <div>
		<!-- add-ons -->
		<div class="fwk-card fwk-card-default fwk-card-purple">
			<div class="fwk-card-header">
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=addon"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_ADDONS'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-grid-small fwk-child-width-1-2" fwk-grid>
<?php
$services = $installed = $noninstalled = $available = 0;
$plugins = fwgHelper::getPluginsData();
foreach ($plugins as $row) {
	if ($row->subtype == 'service') {
		$services++;
	} elseif (!empty($row->type) and $row->update_name != FWMG_UPDATE_NAME) {
		if (!empty($row->installable)) {
			$available++;
			if (empty($row->installed)) {
				$noninstalled++;
			}
		}
		if ($row->installed) {
			$installed++;
		}
		
	}
}
if ($installed) {
?>
					<div>
						<a class="fwk-button" href="index.php?option=com_fwgallery&view=addon#installed-addons">
							<div class="fwk-text-lead">
								<span class="fwk-text-green-warm" fwk-icon="icon:fwa-gear;"></span> <?php echo $installed; ?>
							</div>
							<div class="fwk-text-underline">
								<?php echo strtolower(Text::_('FWMG_ADDONS_INSTALLED')); ?>
							</div>
						</a>
					</div>
<?php
}
if ($noninstalled) {
?>
					<div>
						<a class="fwk-button" href="index.php?option=com_fwgallery&view=addon#noninstalled-addons">
							<div class="fwk-text-lead">
								<span class="fwk-text-muted" fwk-icon="icon:fwa-gear;"></span> <?php echo $noninstalled; ?>
							</div>
							<div class="fwk-text-underline">
								<?php echo strtolower(Text::_('FWMG_ADDONS_NOT_INSTALLED')); ?>
							</div>
						</a>
					</div>
<?php
}
?>
				</div>
				<div>
					<a class="fwk-button" href="index.php?option=com_fwgallery&view=addon#services">
						<span class="fwk-text-lead"><span class="fwk-text-purple" fwk-icon="icon:fwa-service;"></span> <?php echo $services; ?></span> 
						<span class="fwk-margin-small-left fwk-text-underline"><?php echo Text::_('FWMG_SERVICES_AVAILABLE'); ?></span>
					</a>
				</div>
			</div>
		</div>
	</div>

    <div>
		<!-- categories -->
		<div class="fwk-card fwk-card-default fwk-card-purple">
			<div class="fwk-card-header">
				<div class="fwk-float-right">
					<span class="fwk-text-purple fwk-margin-small-right fwk-text-middle" fwk-icon="fwa-categories"></span> <?php echo Text::_('FWMG_TOTAL'); ?>:
					<span class="fwk-text-bold"><?php echo $this->locstat->ct; ?></span>
				</div>
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=category"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_CATEGORIES'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-height-max-medium" fwk-margin fwk-overflow-auto>
<?php
foreach ($this->categories as $row) {
?>
					<span class="fwk-label"><a class="fwk-light" href="index.php?option=com_fwgallery&view=category&task=edit&cid[]=<?php echo $row->id; ?>"><?php echo $row->name; ?></a></span>
<?php
}
?>
				</div>
			</div>
		</div>
	</div>

    <div>
		<!-- files -->
		<div class="fwk-card fwk-card-default fwk-card-yellow">
			<div class="fwk-card-header">
				<div class="fwk-float-right">
					<span class="fwk-text-yellow fwk-margin-small-right fwk-text-middle" fwk-icon="fwa-document"></span><?php echo Text::_('FWMG_TOTAL'); ?>:
					<span class="fwk-text-bold"><?php echo $this->locstat->files_qty; ?></span>
				</div>
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=file"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_FILES'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-grid-small fwk-child-width-1-3" fwk-grid>
                    <div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=file&tab=image">
							<div class="fwk-text-lead">
								<span class="fwk-text-yellow" fwk-icon="icon:fwa-images;"></span> <?php echo $this->locstat->it; ?>
							</div>
							<div class="fwk-text-underline"> 
								<?php echo Text::_('FWMG_IMAGES'); ?>
							</div>
						</a>
					</div>
<?php
$this->app->triggerEvent('onshowStatExtraButtons', array('com_fwgallery', $this));
?>
                </div>
            </div>
        </div>
    </div>
<?php
$this->app->triggerEvent('onShowDashboardCards', array('com_fwgallery.tag', $this));
?>

	<div>
		<!-- Clear cache  -->
		<div class="fwk-card fwk-card-default fwk-card-yellow">
			<div class="fwk-card-header">
				<div class="fwk-card-title"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_CACHE'); ?></div>
			</div>
			<div class="fwk-card-body" fwk-margin>
                <div>
                    <button type="button" class="fwk-button fwk-button-secondary fwk-text-center" id="fwmg-clear-cached-files">
                        <?php echo Text::_('FWMG_ADMIN_DASHBOARD_CACHE_BTN'); ?></button>
                </div>
                <div class="fwk-alert fwk-alert-secondary">
                    <?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_CACHE_HINT'); ?>
                </div>
			</div>
		</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
    $('#fwmg-clear-cached-files').click(function() {
        var $btn = $(this);
        var $wait = $('<div fwk-spinner></div>');
        $btn.attr('disabled', true).after($wait);
        $.ajax({
            type: 'post',
            dataType: 'json',
            data: {
                format: 'json',
                view: 'fwgallery',
                layout: 'clear_cached_files'
            }
        }).done(function(data) {
            $btn.attr('disabled', false);
            $wait.remove();
            if (data.msg) {
                fwmg_alert(data.msg);
            }
        });
    });
    })(jQuery);
});
</script>
    </div>

	<div>
		<!-- languages -->
		<div class="fwk-card fwk-card-default fwk-card-red-pale">
			<div class="fwk-card-header">
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=translation"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_LANGUAGES'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-height-max-medium" fwk-margin fwk-overflow-auto>
<?php
$langs = json_decode($this->params->get('langs_data', '[]'));
$not_installed_language_exists = false;
foreach ($this->languages as $row) {
?>
					<a class="fwk-button" href="index.php?option=com_fwgallery&view=translation&layout=translation&lang=<?php echo $row->tag; ?>" data-id="<?php echo $row->tag; ?>">
						<div>
							<img class="fwk-margin-small-right" src="<?php echo FWMG_MEDIA_URL; ?>mod_languages/images/<?php echo str_replace('-', '_', strtolower($row->tag)); ?>.gif" />
							<?php echo $row->name; ?>
						</div>
						<div class="fwk-margin-small-top">
<?php
		if (!$row->installed) {
			$not_installed_language_exists = true;
?>
							<span class="fwk-text-muted"><span fwk-icon="fwa-close-circle"></span> <?php echo strtolower(Text::_('FWMG_NOT_INSTALLED')); ?></span> <button type="button" class="fwk-button-link fwk-margin-small-left fwmg-lang-request"><?php echo  Text::_('FWMG_REQUEST'); ?></button>
<?php
		} else {
			$remote_md5 = empty($langs->{$row->tag})?'':$langs->{$row->tag};
?>
							<span class="fwk-text-green"><span fwk-icon="fwa-check-circle"></span>&nbsp; <?php echo strtolower(Text::_('FWMG_INSTALLED')); ?></span>
<?php
			if ($row->tag != 'en-GB' and $remote_md5 and $remote_md5 != $row->md5) {
?>
							<span class="fwk-text-danger fwk-margin-small-left"><?php echo Text::_('FWMG_NOTUPTODATE'); ?>
<?php
			}
			if ($row->overrides_qty) {
?>
							<span class="fwk-text-danger"><span fwk-icon="fwa-close-circle"></span> <?php echo $row->overrides_qty; ?> <?php echo strtolower(Text::_('FWMG_OVERRIDES')); ?></span>
<?php
			}
		}
?>
						</div>
					</a>
<?php
	}
?>
				</div>
			</div>
		</div>
	</div>

<?php
if ($this->qch->orphans) {
?>
    <div>
		<!-- Unlinked files cleanup -->
		<div class="fwk-card fwk-card-default fwk-card-green-pale">
			<div class="fwk-card-header">
				<div class="fwk-card-title"><?php echo Text::_('FWMG_ORPHAN_FILES_DETECTED'); ?></div>
			</div>
			<div class="fwk-card-body" fwk-margin>
                <div class="fwk-child-width-1-2 fwk-flex-middle" fwk-grid>
                    <div>
                        <div><?php echo Text::_('FWMG_UNREGISTERED_FILES_TAKE_UP'); ?> <strong><?php echo fwgHelper::humanFileSize($this->qch->orphans); ?></strong></div>
                    </div>
                    <div class="fwk-text-right">
                        <button type="button" class="fwk-button fwk-button-danger fwk-text-center fwk-height-1-1" id="fwmg-delete-unregistered-files">
                            <?php echo Text::_('FWMG_DELETE_FILES'); ?>
                        </button>
                    </div>
                </div>
                <div class="fwk-alert fwk-alert-danger">
                    <?php echo Text::_('FWMG_UNREGISTERED_FILES_HINT'); ?>
                </div>
			</div>
		</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
    $('#fwmg-delete-unregistered-files').click(function() {
        var $btn = $(this);
        if (confirm('<?php echo Text::_('FWMG_ARE_YOU_SURE', true); ?>')) {
            var $wait = $('<div fwk-spinner></div>');
            $btn.attr('disabled', true).after($wait);
            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    format: 'json',
	    			view: 'fwgallery',
                    layout: 'delete_unregistered_files'
                }
            }).done(function(data) {
                $btn.attr('disabled', false);
                $wait.remove();
                if (data.result) {
                    $btn.closest('.card').remove();
                }
                if (data.msg) {
                    fwmg_alert(data.msg);
                }
            });
        }
    });
    })(jQuery);
});
</script>
	</div>
<?php
}
?>

    <div>
		<!-- data -->
		<div class="fwk-card fwk-card-default fwk-card-green-lime">
			<div class="fwk-card-header">
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=data"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_DATAMANAGEMENT'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-child-width-1-3 fwk-grid-small fwk-match-height" fwk-grid>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=data#fwmg-backup">
							<div class="fwk-margin-small-top fwk-text-green-warm"><span fwk-icon="icon:fwa-backup;"></span></div>
							<div class="fwk-margin-small-top"><?php echo Text::_('FWMG_BACKUP'); ?></div>
						</a>
					</div>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=data#fwmg-restore">
							<div class="fwk-margin-small-top fwk-text-green-warm"><span fwk-icon="icon:fwa-restore;"></span></div>
							<div class="fwk-margin-small-top"><?php echo Text::_('FWMG_RESTORE'); ?></div>
						</a>
					</div>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=data#fwmg-data">
							<div class="fwk-margin-small-top fwk-text-green-warm"><span fwk-icon="icon:fwa-puzzle; ratio:1.5"></span></div>
							<div class="fwk-margin-small-top"><?php echo Text::_('FWMG_ADDONS'); ?></div>
						</a>
					</div>
				</div>
			</div>
		</div>
	</div>

	<div>
		<!-- settings -->
		<div class="fwk-card fwk-card-default fwk-card-blue-pale">
			<div class="fwk-card-header">
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=configuration"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_SETTINGS'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-child-width-1-2 fwk-grid-small" fwk-grid>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=configuration#fwmg-settings-general">
							<div class="fwk-margin-small-top">
								<span class="fwk-text-blue" fwk-icon="icon:fwa-dropdown;"></span>
								<span>&nbsp;&nbsp;<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_GENERAL'); ?></span>
							</div>
						</a>
					</div>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=configuration#fwmg-settings-galleries">
							<div class="fwk-margin-small-top">
								<span class="fwk-text-blue" fwk-icon="icon:fwa-categories;"></span>
								<span>&nbsp;&nbsp;<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_CATEGORY'); ?></span>
							</div>
						</a>
					</div>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=configuration#fwmg-settings-items">
							<div class="fwk-margin-small-top">
								<span class="fwk-text-blue" fwk-icon="icon:fwa-images;"></span>
								<span>&nbsp;&nbsp;<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_FILES'); ?></span>
							</div>
						</a>
					</div>
					<div>
						<a class="fwk-button fwk-text-center" href="index.php?option=com_fwgallery&view=configuration#fwmg-settings-plugins">
							<div class="fwk-margin-small-top">
								<span class="fwk-text-blue" fwk-icon="icon:fwa-puzzle;"></span>
								<span>&nbsp;&nbsp;<?php echo Text::_('FWMG_DOC_ADMIN_SETTINGS_TAB_ADDONS'); ?></span>
							</div>
						</a>
					</div>
				</div>
			</div>
		</div>
	</div>

	<div>
		<!-- css -->
		<div class="fwk-card fwk-card-default fwk-card-yellow">
			<div class="fwk-card-header">
				<div class="fwk-card-title">
					<a href="index.php?option=com_fwgallery&view=css"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_CSS'); ?> <span fwk-icon="chevron-right"></span></a>
				</div>
			</div>
			<div class="fwk-card-body" fwk-margin>
				<div class="fwk-grid-small fwk-child-width-1-2" fwk-grid>
<?php
$custom_css = 0;
if ($buff = trim($this->params->get('additional_css', ''))) {
	$custom_css = count(explode("\n", $buff));
}
$template = $this->obj->params->get('template');
?>
					<div>
						<a class="fwk-button" href="index.php?option=com_fwgallery&view=css#fwmg-custom-css">
							<div class="fwk-text-large fwk-text-purple">
								<?php echo $custom_css; ?> <?php echo Text::_('FWMG_CSS_LINES'); ?>
							</div>
							<div><?php echo Text::_('FWMG_CUSTOM_CSS'); ?></div>
						</a>
					</div>
<?php
if ($this->tmpls) {
	foreach ($this->tmpls as $row) {
		$design_css = empty($row->css)?0:count(explode("\n", $row->css));
?>
					<div>
						<a class="fwk-button" href="index.php?option=com_fwgallery&view=css#fwmg-<?php echo $row->element; ?>-css">
							<div class="fwk-text-large fwk-text-muted">
								<?php echo $design_css; ?> <?php echo Text::_('FWMG_CSS_LINES'); ?>
							</div>
							<div class="fwk-text-muted"><?php echo Text::sprintf('FWMG_ORIGINAL_DEMO_CSS', $row->name); ?></div>
						</a>
					</div>
<?php
	}
}
?>
				</div>
			</div>
		</div>
	</div>

</div>

<div id="fwmg-system-check" class="fwk-flex-top" fwk-modal>
    <div class="fwk-modal-dialog fwk-modal-body fwk-margin-auto-vertical fwk-background-yellow-light">
		<button class="fwk-modal-close-default" type="button" fwk-close></button>
        <h2 class="fwk-modal-title"><?php echo Text::_('FWMG_DOC_ADMIN_DASHBOARD_SYSTEMCHECK'); ?></h2>

		<div fwk-margin>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-expand">
                    <?php echo Text::_('FWMG_JOOMLA_MEDIA_FOLDER'); ?>
					<div class="fwk-text-small fwk-text-muted fwk-text-truncate" fwk-tooltip="<?php echo str_replace('/com_fwgallery/', '', FWMG_STORAGE_PATH); ?>"><?php echo str_replace('/com_fwgallery/', '', FWMG_STORAGE_PATH); ?></div>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->media_folder_exists) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_EXISTS_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_EXISTS_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-expand">
                    <?php echo Text::_('FWMG_IMAGES_FOLDER'); ?>
					<div class="fwk-text-small fwk-text-muted fwk-text-truncate" fwk-tooltip="<?php echo rtrim(FWMG_STORAGE_PATH, '\\/'); ?>"><?php echo rtrim(FWMG_STORAGE_PATH, '\\/'); ?></div>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->gallery_folder_exists) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_EXISTS_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_EXISTS_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-expand">
                    <?php echo Text::_('FWMG_IMAGES_FOLDER'); ?>
					<div class="fwk-text-small fwk-text-muted fwk-text-truncate" fwk-tooltip="<?php echo rtrim(FWMG_STORAGE_PATH, '\\/'); ?>"><?php echo rtrim(FWMG_STORAGE_PATH, '\\/'); ?></div>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->gallery_folder_writeable) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_WRITABLE_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_WRITABLE_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-3-4">
                    <?php echo Text::_('FWMG_IMAGES_CACHE_FOLDER'); ?>
					<div class="fwk-text-small fwk-text-muted fwk-text-truncate" fwk-tooltip="<?php echo JPATH_SITE; ?>/cache/fwgallery/images"><?php echo JPATH_SITE; ?>/cache/fwgallery/images</div>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->cache_folder_exists) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_EXISTS_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_EXISTS_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-3-4">
                    <?php echo Text::_('FWMG_IMAGES_CACHE_FOLDER'); ?>
					<div class="fwk-text-small fwk-text-muted fwk-text-truncate" fwk-tooltip="<?php echo JPATH_SITE; ?>/cache/fwgallery/images"><?php echo JPATH_SITE; ?>/cache/fwgallery/images</div>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->cache_folder_writeable) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_WRITABLE_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_WRITABLE_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-3-4">
                    <?php echo Text::_('FWMG_GD2_PHP_EXTENSION'); ?>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->gd_installed) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_INSTALLED_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_INSTALLED_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
        <div class="fwk-border-rounded fwk-background-white fwk-padding-small">
            <div class="fwk-flex-middle fwk-grid-small" fwk-grid>
                <div class="fwk-width-3-4">
                    <?php echo Text::_('FWMG_EXIF_PHP_EXTENSION'); ?>
                </div>
                <div class="fwk-width-1-4 fwk-text-bold">
<?php
if ($this->qch->exif_installed) {
?>
                    <span fwk-icon="fwa-check-mark" class="fwk-text-green fwk-margin-small-right"></span> <?php echo Text::_('FWMG_INSTALLED_SMALL'); ?>
<?php
} else {
?>
                    <span fwk-icon="fwa-close-mark" class="fwk-text-danger fwk-margin-small-right"></span> <?php echo Text::_('FWMG_NOT_INSTALLED_SMALL'); ?>
<?php
}
?>
                </div>
            </div>
        </div>
		</div>
    </div>
</div>
<?php
if ($not_installed_language_exists) {
?>
<script>
jQuery(function($) {
	$('.fwmg-lang-request').click(function(ev) {
		ev.stopImmediatePropagation();
		var $btn = $(this);
		if ($btn.data('wip')) return;
		$btn.data('wip', true);
		var $wait = $('<div fwk-spinner></div>');
		$btn.after($wait);
		$.ajax({
			type: 'post',
			dataType: 'json',
			data: {
				format: 'json',
				view: 'translation',
				layout: 'lang_request',
				lang: $btn.closest('a[data-id]').data('id')
			}
		}).done(function(data) {
			if (data.result) {
				$btn.parent().remove();
			}
			if (data.msg) {
				fwmg_alert(data.msg);
			}
		}).always(function() {
			$wait.remove();
			$btn.data('wip', false);
		});
	});
});
</script>
<?php
}
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
