<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\MVC\View\HtmlView;

class fwGalleryViewFwGallery extends HtmlView {
    function display($tmpl=null) {
        $model = $this->getModel();
		$data = new stdclass;
    	switch ($this->getLayout()) {
			case 'get_changelog' :
				$this->list = $model->getChangelog();
				$data->result = $this->loadTemplate();
				break;
			case 'import_prev_data' :
				$data->result = $model->importPrevData();
				break;
			case 'check_update' :
				$data = (object)$model->checkUpdate();
				break;
			case 'verify_code' :
				$data->result = $model->verifyCode();
				if (!empty($data->result->verified)) {
					if (!$data->result->user_avatar) {
						$data->result->user_avatar = Uri::root(true).'/components/com_fwgallery/assets/images/user.jpg';
					}
					$this->package = $data->result->package_name?(object)array(
						'name' => $data->result->package_name,
						'date_end' => $data->result->date_end,
						'days_left' => $data->result->days_left
					):null;
					if ($data->result->package_name) {
						$data->result->days_left = Text::sprintf((($data->result->days_left > 0)?'FWMG_EXPIRES_IN':'FWMG_EXPIRED_AGO'), abs($data->result->days_left));
					}
					$this->addons = $data->result->addons;
					$this->installed = $data->result->installed;
					$this->addons_update = array();
					$data->html = $this->loadTemplate();
					$data->result->addons_update = $this->addons_update;
					unset($data->result->addons);
					unset($data->result->installed);
				}
				break;
			case 'revoke_code' :
				$data = (object)$model->revokeCode();
				break;
			case 'save' :
				$data->result = $model->save();
				break;
            case 'delete_unregistered_files' :
				$data->result = $model->deleteUnregisteredFiles();
				break;
			case 'clear_cached_files' :
				$model->clearCachedImages();
				break;
			case 'load_wizards' :
				$data->result = $model->loadWizards();
				break;
		}
        $data->msgs = $model->getErrors();
        $data->msg = implode("\n", $data->msgs);
    	die(json_encode($data));
    }
}
