<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Factory;
use Joomla\CMS\Component\ComponentHelper;

class fwGalleryViewTag extends HtmlView {
    function display($tmpl = null) {
        $this->menu = 'tag';
        $model = $this->getModel();

        $this->app = Factory::getApplication();
        $this->current_user = Factory::getUser();
        $this->users = fwgHelper::loadUsers();
        $this->current_user = Factory::getUser();

        $this->plugin_installed = fwgHelper::pluginInstalled('tag');
        $this->plugin_enabled = fwgHelper::pluginEnabled('tag');

		$this->fields = array('ordering', 'search', 'status', 'type', 'limit', 'limitstart');

        switch ($this->getLayout()) {
            case 'edit' :
			$this->object = $model->loadObject();
            foreach ($this->fields as $field) {
                $this->$field = (string)$this->app->input->getString($field);
            }
			fwgHelper::triggerEvent('onLoadMainMenu', array('com_fwgallery', 'tag', $this));
            break;
            default:
			$this->list = $model->loadList();
			$this->pagination = $model->getPagination();
            $this->types = $model->getFileTypes();
			$this->extra_link = '';
            foreach ($this->fields as $field) {
                $this->$field = (string)$this->app->input->getString($field);
				if (is_string($this->$field)) {
					$this->extra_link .= '&amp;'.$field.'='.urlencode($this->$field);
    				$this->pagination->setAdditionalUrlParam($field, $this->$field);
    			}
            }
			fwgHelper::triggerEvent('onLoadMainMenu', array('com_fwgallery', 'tags', $this));
        }
		$this->params = ComponentHelper::getParams('com_fwgallery');
        parent::display($tmpl);
    }
}
