<?php
/**
 * FW Gallery 8.0.0
 * @copyright C 2022 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

echo LayoutHelper::render('common.menu_begin', array(
    'title' => Text::_('FWMG_DOC_ADMIN_LANG'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_LANG_HINT'),
	'view' => $this
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<hr/>
<form action="index.php?option=com_fwgallery&view=translation" method="post" class="fwa-translation form-validate" name="adminForm" id="adminForm">
    <div class="fwa-separate-box">
        <table class="fwk-table fwk-table-middle fwk-table-striped fwg-admin-languages-list">
            <thead>
                <tr>
                    <th><?php echo Text::_('FWMG_LANGUAGE'); ?></th>
                    <th><?php echo Text::_('FWMG_INSTALLATION_STATUS'); ?></th>
                    <th></th>
                    <th><?php echo Text::_('FWMG_ACTION'); ?></th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
<?php
$langs = json_decode($this->params->get('langs_data', '[]'));

foreach ($this->languages as $lang) {
    $remote_md5 = empty($langs->{$lang->tag})?'':$langs->{$lang->tag};
    $path = FWMG_LANGUAGE_ADMINISTRATOR.'/language/'.$lang->tag.'/'.$lang->tag.'.com_fwgallery.ini';
    $installed = file_exists($path);
    $local_md5 = $installed?md5_file($path):'';
    $uptodate = ($lang->tag == 'en-GB' or ($remote_md5 and $remote_md5 == $local_md5));

    $button_enabled = true;
    $button_text = $button_class = '';
    if ($uptodate) {
        $button_enabled = false;
        $button_text = 'FWMG_TRANSLATION_UPTODATE';
        $button_class = ' fwk-button-secondary';
    } elseif ($remote_md5 and $local_md5 and $remote_md5 != $local_md5) {
        $button_text = 'FWMG_TRANSLATION_REINSTALL';
        $button_class = ' fwk-button-secondary fwg-lang-reinstall';
    } elseif (!$local_md5 and $remote_md5) {
        $button_text = 'FWMG_TRANSLATION_INSTALL';
        $button_class = ' fwk-button-primary fwg-lang-install';
    } else {
        if (!$local_md5 and $this->params->get('translation_requested_'.$lang->tag)) {
            $button_enabled = false;
            $button_text = 'FWMG_TRANSLATION_REQUESTED';
            $button_class = '';
        } else {
            $button_text = 'FWMG_TRANSLATION_REQUEST';
            $button_class = ' fwk-button-primary fwg-lang-request';
        }
    }
?>
                <tr data-id="<?php echo $lang->tag; ?>">
                    <td><img class="fwk-margin-right" src="<?php echo FWMG_MEDIA_URL; ?>mod_languages/images/<?php echo str_replace('-', '_', strtolower($lang->tag)); ?>.gif" /> <?php echo $lang->name; ?></td>
                    <td>
                        <span class="fwk-label fwk-label-<?php echo $installed?'primary':'danger'; ?>"><?php echo Text::_('FWMG_'.($installed?'INSTALLED':'NOT_INSTALLED')); ?></span>
<?php
    if ($installed and $remote_md5) {
?>
                        <div class="fwk-text-small fwk-margin-small-top fwk-text-<?php if ($uptodate) { ?>muted<?php } else { ?>danger<?php } ?>"><?php echo Text::_('FWMG_'.($uptodate?'':'NOT').'UPTODATE'); ?></div>
<?php
    }
?>
                    </td>
                    <td><a href="index.php?option=com_fwgallery&view=translation&layout=translation&lang=<?php echo $lang->tag; ?>" class="fwk-button fwk-button-secondary"><?php echo Text::_('FWMG_EDIT'); ?></a></td>
                    <td>
                        <div><?php echo Text::_($button_text.'_HINT'); ?></div>
                    </td>
                    <td>
                        <button type="button" class="fwk-button<?php echo $button_class; ?>"<?php if (!$button_enabled) { ?> disabled="disabled"<?php } ?>><?php echo Text::_($button_text); ?></button>
                    </td>
                </tr>
<?php
}
?>
            </tbody>
        </table>
    </div>

	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
        Joomla.submitbutton = function(pressbutton) {
            if (pressbutton == 'translation') {
                location = 'index.php?option=com_fwgallery&view=translation&layout=translation';
            }
        }
        $('#adminForm').on('click', '.fwg-lang-request', function() {
            var $btn = $(this).attr('disabled', true).html('<?php echo esc_js(Text::_('FWMG_TRANSLATION_REQUESTED')); ?>');
            $btn.next().html('<?php echo esc_js(Text::_('FWMG_TRANSLATION_REQUESTED_HINT')); ?>');
            var $wait = $('<div fwk-spinner></div>');
            $btn.after($wait);
            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    format: 'json',
                    view: 'translation',
                    layout: 'lang_request',
                    lang: $btn.closest('tr').data('id')
                }
            }).done(function(data) {
                if (data.result) {
                    $btn.removeClass('fwk-button-primary fwk-button-success fwk-button-warning fwg-lang-request').addClass('fwk-button-secondary').html('<?php echo esc_js(Text::_('FWMG_TRANSLATION_UPTODATE')); ?>');
                    $btn.next().html('');
                    $btn.closest('td').prev().html('<?php echo fwgHelper::jtext('FWMG_TRANSLATION_UPTODATE_HINT', true); ?>');
                    $btn.closest('td').prev().prev().find('span').removeClass('fwk-label-danger').addClass('fwk-label-primary').html('<?php echo fwgHelper::jtext('FWMG_INSTALLED', true); ?>');
                }
                if (data.msg) {
                    fwmg_alert(data.msg);
                }
            }).always(function() {
                $wait.remove();
            });
        });
        $('#adminForm').on('click', '.fwg-lang-reinstall', function() {
            var $btn = $(this).attr('disabled', true);
            var $wait = $('<div fwk-spinner></div>');
            $btn.after($wait);
            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    format: 'json',
                    view: 'translation',
                    layout: 'lang_reinstall',
                    lang: $btn.closest('tr').data('id')
                }
            }).done(function(data) {
                $wait.remove();
                if (data.result) {
                    $btn.removeClass('fwk-button-primary fwk-button-success fwk-button-warning fwg-lang-request').addClass('fwk-button-secondary').html('<?php echo esc_js(Text::_('FWMG_TRANSLATION_UPTODATE')); ?>');
                    $btn.next().html('');
                    $btn.closest('td').prev().find('span').removeClass('text-danger').addClass('text-success');
                } else {
                    $btn.attr('disabled', false);
                }
                if (data.msg) {
                    fwmg_alert(data.msg);
                }
            });
        });
        $('#adminForm').on('click', '.fwg-lang-install', function() {
            var $btn = $(this).attr('disabled', true);
            var $wait = $('<div fwk-spinner></div>');
            $btn.after($wait);
            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    format: 'json',
                    view: 'translation',
                    layout: 'lang_request',
                    lang: $btn.closest('tr').data('id')
                }
            }).done(function(data) {
                $wait.remove();
                if (data.result) {
                    $btn.removeClass('fwk-button-primary fwk-button-success fwk-button-warning fwg-lang-request').addClass('fwk-button-secondary').html('<?php echo esc_js(Text::_('FWMG_TRANSLATION_UPTODATE')); ?>');
                    $btn.next().html('');
                    $btn.closest('td').prev().html('<?php echo fwgHelper::jtext('FWMG_TRANSLATION_UPTODATE_HINT', true); ?>');
                    $btn.closest('td').prev().prev().find('span').removeClass('fwk-label-danger').addClass('fwk-label-primary').html('<?php echo fwgHelper::jtext('FWMG_INSTALLED', true); ?>');
                } else {
                    $btn.attr('disabled', false);
                }
                if (data.msg) {
                    fwmg_alert(data.msg);
                }
            });
        });
    })(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
