<?php
/**
 * FW Gallery 8.0.0
 * @copyright C 2022 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Layout\LayoutHelper;

ToolbarHelper::title(Text::_('COM_FWGALLERY'));

fwgButtonsHelper::custom('copy', 'blue', 'FWMG_DOC_ADMIN_LANG_TOOLBAR_BTN_OVERRIDES', 'copy', true);
if (file_exists($this->path_overrides)) {
	fwgButtonsHelper::custom('upload', 'purple', 'FWMG_UPLOAD_TRANSLATION', 'upload', false);
}

echo LayoutHelper::render('common.menu_begin', array(
    'title' => Text::_('FWMG_DOC_ADMIN_LANG'),
    'title_hint' => Text::_('FWMG_DOC_ADMIN_LANG_HINT'),
	'view' => $this
), FWMG_COMPONENT_ADMINISTRATOR);
?>
<hr/>
<form action="index.php?option=com_fwgallery&amp;view=translation" method="post" class="fwmg-translations form-validate" name="adminForm" id="adminForm" enctype="multipart/form-data">
	<div class="fwa-filter-bar" fwk-grid>
		<div class="fwk-width-expand@m">
			<div class="fwk-position-relative">
    			<span class="fwk-form-icon fwk-text-green" fwk-icon="icon: search"></span>
				<input class="fwk-input" placeholder="<?php echo esc_attr(Text::_('FWMG_DOC_ADMIN_LANG_FILTER_SEARCH')); ?>" type="text" name="search" value="<?php echo esc_attr($this->search); ?>" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_FILTER_SEARCH_HINT'); ?>">
			</div>
		</div>
		<div class="fwk-width-small@m" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_FILTER_LANG_HINT'); ?>">
			<div class="select-style">
				<?php echo HTMLHelper::_('select.genericlist', $this->languages, 'lang', 'class="fwk-select" onchange="this.form.task.value=\'\';if(this.form.limitstart){this.form.limitstart.value=0;}this.form.submit();" style="float:none;"', 'id', 'name', $this->language); ?>
			</div>
		</div>
		<div class="fwk-width-small@m">
			<div class="select-style" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_FILTER_ADDON_HINT'); ?>">
				<?php echo HTMLHelper::_('select.genericlist', $this->extensions, 'extension', 'class="fwk-select" onchange="this.form.task.value=\'\';this.form.submit();"', 'element', 'name', $this->extension); ?>
			</div>
		</div>
	</div>
    <div class="fwk-grid-small" fwk-grid>
		<div class="fwk-width-2-5@m">
			<div class="fwk-alert fwk-alert-default">
				<?php echo Text::_('FWMG_DOC_ADMIN_LANG_HINTHOWTOUSE'); ?>: <?php echo esc_html($this->path); ?>
			</div>
		</div>
		<div class="fwk-width-expand@m">
			<div class="fwk-alert fwk-alert-success">
				<?php echo Text::_('FWMG_ADMIN_LANG_HINT_MAIN'); ?>: <?php echo esc_html($this->path); ?>
			</div>
			<div class="fwk-alert fwk-alert-danger">
			<?php echo Text::_('FWMG_ADMIN_LANG_HINT_OVERRIDE'); ?>: <?php echo esc_html($this->path_overrides); ?>
			</div>
		</div>
	</div>
	<table class="fwk-table fwk-table-striped">
		<thead>
			<tr>
                <th width="20px"><input type="checkbox" class="fwk-checkbox" name="toggle" value="" onclick="Joomla.checkAll(this);" /></th>
				<th width="25%" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_SOURCE_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_SOURCE'); ?> (en-GB)</th>
                <th width="30px" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_OVERRIDES_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_OVERRIDES'); ?></th>
				<th fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_OUTCOME_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_OUTCOME'); ?> (<?php echo esc_html($this->languages[$this->language]->tag); ?>)</th>
                <th width="10%" class="fwk-text-center" fwk-tooltip="<?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_TOOVERRIDES_HINT'); ?>"><?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_TOOVERRIDES') ?></th>
			</tr>
		</thead>
		<tbody id="fwmg-translations-list">
<?php
$num = 0;
foreach ($this->data as $const=>$row) {
?>
			<tr>
                <td><?php echo HTMLHelper::_('grid.id', $num, $const); ?></td>
				<td>
                    <?php echo fwgHelper::escPluginsOutput($row['src']); ?>
                    <div class="small text-muted fwk-margin-small-top">
                        <?php echo esc_html($const); ?>
                    </div>
                </td>
                <td class="fwk-text-center"><?php if (isset($row['override'])) { ?><span fwk-tooltip title="<?php echo esc_attr(Text::_('FWMG_OVERRIDES_HINT')); ?>" fwk-icon="check" class="fwk-text-success"></span><?php } ?></td>
				<td><textarea type="text" class="fwk-textarea" name="lang_data[<?php echo esc_attr($const); ?>]"><?php echo htmlspecialchars($row['trg']); ?></textarea></td>
                <td class="fwk-text-center"><button class="fwk-button fwk-button-secondary" type="button" hidden><?php echo Text::_('FWMG_DOC_ADMIN_LANG_COLUMN_TOOVERRIDES_BTN_SAVE') ?></button></td>
			</tr>
<?php
}
?>
		</tbody>
	</table>
    <div class="fwk-grid-small fwk-flex-middle fwa-pagination" fwk-grid>
        <div class="fwk-width-auto">
            <?php echo $this->pagination->getResultsCounter(); ?>
        </div>
        <div class="fwk-width-expand fwk-text-center">
            <?php echo $this->pagination->getListFooter(); ?>
        </div>
        <div class="fwk-width-auto">
            <?php echo $this->pagination->getLimitBox(); ?>
        </div>
    </div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="format" value="html" />
	<input type="hidden" name="layout" value="translation" />
	<input type="hidden" name="boxchecked" value="0" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		Joomla.submitbutton = function(pressbutton) {
			if (pressbutton) {
				with (document.adminForm) {
					if (pressbutton == 'download') {
						layout.value = 'download';
						format.value = 'raw';
						task.value = '';
						document.adminForm.submit();
						layout.value = 'translation';
						format.value = 'html';
					} else if (pressbutton == 'upload') {
						var $wait = $('<div fwk-spinner></div>');
						var $btn = $('.fwa-toolbar button:has(\'[fwk-icon="upload"]\')').attr('disabled', true).after($wait);
						$.ajax({
							dataType: 'json',
							data: {
								format: 'json',
								view: 'translation',
								layout: 'upload',
								extension: '<?php echo esc_js($this->extension); ?>',
								lang: '<?php echo esc_js($this->language); ?>',
								type: $('input[name="type"]').val()
							}
						}).done(function(data) {
							if (data.msg) {
								fwmg_alert(data.msg);
							}
						}).always(function() {
							$btn.attr('disabled', false);
							$wait.remove();
						});
					} else {
						layout.value = 'translation';
						format.value = 'html';
						task.value = pressbutton;
						document.adminForm.submit();
					}
				}
			}
		}
		$('#fwmg-translations-list textarea').on('input', function() {
			$(this).closest('tr').find('button').attr('hidden', false);
		});
		$('#fwmg-translations-list button').click(function() {
			var $btn = $(this).attr('disabled', true);
			var $wait = $('<div class="fwk-margin-small-left fwk-position-absolute" fwk-spinner></div>');
			$btn.after($wait);
			var $row = $btn.closest('tr');

			var id = $row.find('textarea').attr('name').replace('lang_data[', '').replace(']', '');
			var lang_data = {};
			lang_data[id] = $row.find('textarea').val();
			$.ajax({
				dataType: 'json',
				data: {
					format: 'json',
					view: 'translation',
					layout: 'copy_to_overrides',
					lang: '<?php echo esc_js($this->language); ?>',
					type: $('input[name="type"]').val(),
					cid: [id],
					lang_data: lang_data
				}
			}).done(function(data) {
				if (data.result) {
					$btn.parent().prev().prev().html('<span fwk-tooltip title="<?php echo Text::_('FWMG_OVERRIDES_HINT', true); ?>" fwk-icon="check" class="fwk-text-success"></span>');
					$btn.attr('hidden', true);
				}
				if (data.msg) {
					fwmg_alert(data.msg);
				}
			}).always(function() {
				$wait.remove();
				$btn.attr('disabled', false);
			}).fail(function(xhr, msg) {
				fwmg_alert(msg);
			});
		});
		if (!$('#adminForm input[name="limitstart"]').length) {
			$('#adminForm').append($('<input type="hidden" name="limitstart">'));
		}
		$('input[name="search"]').keyup(function(ev) {
			if (ev.keyCode == 13) {
				if (this.form.limitstart) {
					this.form.limitstart.value = 0;
				}
				this.form.submit();
			}
		});
		$('input[name="cid[]"]').on('click change', function() {
			var $row = $(this).closest('tr');
			if (this.checked) {
				$row.addClass('fwk-selected-row');
			} else {
				$row.removeClass('fwk-selected-row');
			}
		});
		$('input[name="toggle"]').click(function() {
			$('input[name="cid[]"]').trigger('change');
		});
        window.fwmg_resize_texareas = function() {
            $('#fwmg-translations-list textarea').each(function() {
                var $el = $(this);
                $el.css('height', $el.parent().height()+'px');
                console.log();
            });
        }
        fwmg_resize_texareas();
        window.resize(fwmg_resize_texareas);
	})(jQuery);
});
</script>
<?php
echo LayoutHelper::render('utilites.batchupload', array(
	'allusers'=>$this->users,
	'current_user'=>$this->current_user,
	'category'=>'',
	'reload'=>false
), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('utilites.quickcategories', array(), FWMG_COMPONENT_ADMINISTRATOR);
echo LayoutHelper::render('common.menu_end', array(), FWMG_COMPONENT_ADMINISTRATOR);
