<?php
/**
 * FW Gallery 8.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Component\ComponentHelper;

class fwGalleryViewTranslation extends HtmlView {
    function display($tmpl = null) {
        $this->menu = 'translation';
        $model = $this->getModel();
        $model->checkTranslations();

        $this->users = fwgHelper::loadUsers();
        $this->current_user = Factory::getUser();

		$this->app = Factory::getApplication();
        $this->language = fwgHelper::getLanguage();
        $this->languages = fwgHelper::getInstalledLanguages();
        $this->params = ComponentHelper::getParams('com_fwgallery');
        switch ($this->getLayout()) {
            case 'translation' :
                $this->search = $model->getUserState('search', '', 'string');
                $this->extensions = $model->loadExtensions();
                $this->extension = $model->getUserState('extension', 'com_fwgallery', 'string');
                $this->obj = $model->getExtension($this->extensions, $this->extension);
                $this->data = $model->getLanguageData($this->obj);
                $this->pagination = $model->getPagination($this->data);
                $fields = array('search', 'limit', 'layout');
                foreach ($fields as $field) {
                    if ($buff = $this->app->input->getString($field)) {
                        $this->pagination->setAdditionalUrlParam($field, $buff);
                    }
                }
                $this->path = $model->getLanguageFilename();
                $this->path_overrides = $model->getLanguageOverridesFilename();
                break;
        }
        fwgHelper::triggerEvent('onLoadMainMenu', array('com_fwgallery', $this->menu, $this));
        parent::display($tmpl);
    }
}
