
jQuery(function($) {
    $('body').on('click', 'a.fwmg-modal', function(ev) {
        ev.preventDefault();
		/* prevent open modal on audio player click */
		if (ev.target.tagName.toLowerCase() == 'svg') {
			return;
		}
        var $link = $(this);
        var $popup = $('#fwmg-one-file');
        if (!$popup.length) {
            $popup = $('<div id="fwmg-one-file" class="fwk-modal-container" fwk-modal>\
    <div class="fwk-modal-dialog">\
		<div class="fwk-modal-header">\
			<h5 class="fwk-modal-title"></h5>\
			<button class="fwk-modal-close-default" type="button" fwk-close></button>\
		</div>\
		<div class="fwk-modal-body"></div>\
    </div>\
</div>');
            var $wrp = $('<div/>', {
                'class': 'fwcss'
            });
            $('body').append($wrp);
            $wrp.append($popup);
        }
        $popup.find('.fwk-modal-body').html('<div fwk-spinner></div>').load($link.attr('href'), {
            'format': 'raw'
        });
        $popup.on('show', function() {
            $(this).data('title', $('title').html());
        }).on('hide', function() {
			$('title').html($(this).data('title'));
        });
		fwkUIkit.modal($popup[0]).show();
    });
   // Load more
   $('.fwmg-more-block a').each(function() {
	  var $link = $(this);
      var $wrp = $link.closest('.fwmg-galleries .fwmg-files');
	  var limit = $link.data('items-per-page');
	  var total = parseInt($link.data('total'));
	  var selector = $link.data('selector');
	  var loaded = $wrp.find(selector).length;
	  var qty = Math.min(limit, total - loaded);
	  $('span:eq(1)', $link).html(qty);
    });
	$('.fwmg-galleries').on('mouseenter', '.fwmg-grid-item-autoplay:has("iframe")', function() {
		var $ifr = $(this).find('iframe');
		var src = $ifr.attr('src');
		if (src.indexOf('youtube') == -1) {
			$ifr.attr('src', src+'?autoplay=1');
		} else {
			$ifr.attr('src', src+'&amp;autoplay=1&amp;mute=1');
		}
	}).on('mouseleave', '.fwmg-grid-item-autoplay:has("iframe")', function() {
		var $ifr = $(this).find('iframe');
		var src = $ifr.attr('src');
		if (src.indexOf('youtube') == -1) {
			$ifr.attr('src', src.replace('?autoplay=1', ''));
		} else {
			$ifr.attr('src', src.replace('&amp;autoplay=1&amp;mute=1', ''));
		}
	}).on('mouseenter', '.fwmg-grid-item-autoplay:has("video")', function() {
		$(this).find('video').get(0).play().catch(function() {});
	}).on('mouseleave', '.fwmg-grid-item-autoplay:has("video")', function() {
		$(this).find('video').get(0).pause();
	});

	var buff = location.toString().split('#');
	if (buff.length == 2 && $('.fwmg-files a.fwmg-modal').length) {
		$.ajax({
		  url: '',
		  type: 'post',
		  dataType: 'json',
		  data: {
			  format: 'json',
			  view: 'item',
			  layout: 'get_item_link',
			  link: buff[1]
		  }
		}).done(function(data) {
			if (data.result) {
				var $link = $('<a />', {
					'href': data.result,
					'class': 'fwmg-modal',
					'style': 'display:none'
				});
				$('#fwgallery').append($link);
				$link.click();
				setTimeout(function() {
					$link.remove();
				}, 300);
			}
		});
	}
});
function fwmg_alert(msg, title = '', status = 'info') {
	if (title == '' && window.fwmg_alert_default_title) {
		title = fwmg_alert_default_title;
	}
	var $el = jQuery('<div aria-live="assertive" aria-atomic="true" class="toast toast-' + status + '" data-autohide="false">\
  <div class="toast-header">\
  	<span fwk-icon="bell"></span>\
    <strong>'+ title + '</strong>\
  </div>\
  <div class="toast-body">'+ msg + '</div>\
</div>');
	var $wrp = jQuery('#fwmg-toast-stack');
	if (!$wrp.length) {
		$wrp = jQuery('<div />', {
			id: 'fwmg-toast-stack'
		});
		jQuery('body').append($wrp);
		$wrp.wrap('<div class="fwcss"></div>');
	}
	$wrp.append($el);
	$el.animate({ 'opacity': 1 }, 500);
	setTimeout(function () {
		$el.animate({ 'opacity': 0 }, 500, function () {
			$el.remove();
		});
	}, 5000);
}
