<?php
/**
 * FW Gallery 8.0.0
 * @copyright(C) 2018 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Language\LanguageHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Http\HttpFactory;
use Joomla\Registry\Registry;
use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\Editor\Editor;
use Joomla\Utilities\ArrayHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Version;

PluginHelper::importPlugin('fwgallery');
PluginHelper::importPlugin('fwgallerytmpl');
PluginHelper::importPlugin('fwgallerytype');

if (!defined('FWMG_STORAGE')) {
	define('FWMG_STORAGE', 'media/com_fwgallery/');
}
if (!defined('FWMG_STORAGE_PATH')) {
	define('FWMG_STORAGE_PATH', JPATH_SITE.'/'.FWMG_STORAGE);
}
if (!defined('FWMG_MEDIA_PATH')) {
	define('FWMG_MEDIA_PATH', JPATH_SITE.'/media/');
}
if (!defined('FWMG_MEDIA_URL')) {
	define('FWMG_MEDIA_URL', URI::root(true).'/media/');
}

define('FWMG_UPDATE_NAME', 'com_fwgallery');
define('FWMG_UPDATE_SERVER', 'https://fastw3b.com');

/* WP integration */
if (!defined('FWMG_LANGUAGE_SITE')) {
	define('FWMG_LANGUAGE_SITE', JPATH_SITE);
}
if (!defined('FWMG_LANGUAGE_ADMINISTRATOR')) {
	define('FWMG_LANGUAGE_ADMINISTRATOR', JPATH_ADMINISTRATOR);
}
if (!defined('FWMG_COMPONENT_SITE')) {
	define('FWMG_COMPONENT_SITE', JPATH_SITE.'/components/com_fwgallery');
}
if (!defined('FWMG_COMPONENT_ADMINISTRATOR')) {
	define('FWMG_COMPONENT_ADMINISTRATOR', JPATH_ADMINISTRATOR.'/components/com_fwgallery');
}
if (!defined('FWMG_COMPONENT_ADMINISTRATOR')) {
	define('FWMG_COMPONENT_ADMINISTRATOR', JPATH_ADMINISTRATOR.'/components/com_fwgallery');
}
if (!defined('FWMG_ASSETS_URL')) {
	define('FWMG_ASSETS_URL', Uri::root(true).'/components/com_fwgallery/assets/');
}
if (!defined('FWMG_ADMIN_ASSETS_PATH')) {
	define('FWMG_ADMIN_ASSETS_PATH', JPATH_SITE.'/administrator/components/com_fwgallery/assets/');
}
if (!defined('FWMG_ADMIN_ASSETS_URL')) {
	define('FWMG_ADMIN_ASSETS_URL', Uri::root(true).'/administrator/components/com_fwgallery/assets/');
}
if (!defined('FWMG_DESIGNS_PATH')) {
	define('FWMG_DESIGNS_PATH', JPATH_SITE.'/plugins/fwgallerytmpl/');
}
if (!defined('FWMG_TYPES_PATH')) {
	define('FWMG_TYPES_PATH', JPATH_SITE.'/plugins/fwgallerytype/');
}
if (!defined('FWMG_PLUGINS_PATH')) {
	define('FWMG_PLUGINS_PATH', JPATH_SITE.'/plugins/fwgallery/');
}
if (!defined('FWMG_MODULES_PATH')) {
	define('FWMG_MODULES_PATH', JPATH_SITE.'/modules/');
}

define('FWMG_ASSETS_PATH', FWMG_COMPONENT_SITE.'/assets/');

/* Joomla 3 compatibility */
if (class_exists('Joomla\CMS\Version') and !class_exists('Joomla\CMS\MVC\Model\BaseModel')) {
	include_once(FWMG_COMPONENT_SITE.'/helpers/patches/basemodel.php');
}

class fwgView {
	var $layout = 'default';
	function setView($view) {
		$this->view = $view;
	}
	function getView() {
		return $this->view;
	}
	function setLayout($layout) {
		$this->layout = $layout;
	}
	function getLayout() {
		return $this->layout;
	}
	function loadTemplate($tmpl='') {
		$app = Factory::getApplication();
		if ($tmpl) $tmpl = '_'.$tmpl;
		$path = JPATH_SITE.'/templates/'.$app->getTemplate().'/html/com_fwgallery/'.$this->view.'/'.$this->layout.$tmpl.'.php';
		ob_start();
		if (file_exists($path)) {
			include($path);
		} else {
			$path = FWMG_COMPONENT_SITE.'/views/'.$this->view.'/tmpl/'.$this->layout.$tmpl.'.php';
			include($path);
		}
		return ob_get_clean();
	}
	function display() {
		echo $this->loadTemplate();
	}
	function escape($text) {
		return htmlspecialchars($text);
	}
	function getPaginationLinks($pagination, $options = array()) {
		$list = array(
			'prefix'       => $pagination->prefix,
			'limit'        => $pagination->limit,
			'limitstart'   => $pagination->limitstart,
			'total'        => $pagination->total,
			'limitfield'   => $pagination->getLimitBox(),
			'pagescounter' => $pagination->getPagesCounter(),
			'pages'        => $pagination->getPaginationPages(),
			'pagesTotal'   => $pagination->pagesTotal,
		);
		return fwgHelper::loadTemplate('pagination.links', array('view' => $this, 'list' => $list, 'options' => $options));
	}
}

class fwgParams {
	var $params = null;
	var $parent_categories = null;
	function __construct($params, $parent_categories=null) {
		if (is_object($params)) {
			$this->params = clone($params);
		} else {
			$this->params = new Registry($params);
		}
		if ($parent_categories) {
			$this->parent_categories = $parent_categories;
		}
	}
	function load($params) {
		if (is_null($this->params)) {
			$this->params = $params;
		} else {
			$this->params->loadArray($params->toArray());
		}
	}
	function set($key, $val) {
		$this->params->set($key, $val);
	}
	function get($key, $def=null) {
		$val = $this->params->get($key, 'def');
		if ($val == 'def') {
			if ($this->parent_categories) {
				foreach ($this->parent_categories as $category) {
					$val = $category->params->get($key, 'def');
					if ($val != 'def') {
						return $val;
					}
				}
			}
			$app = Factory::getApplication();
			if ($app->isClient('site') and $app->input->getCmd('option') == 'com_fwgallery') {
				$val = $app->getParams()->get($key, 'def');
				if ($val == 'def') {
					$val = ComponentHelper::getParams('com_fwgallery')->get($key, $def);
				}
			} else {
				$val = ComponentHelper::getParams('com_fwgallery')->get($key, $def);
			}
		} elseif (is_null($val)) {
			$val = ComponentHelper::getParams('com_fwgallery')->get($key, $def);
		}
		return $val;
	}
}

class fwgMessages {
	static function getInstance() {
		static $instance = null;
		if (is_null($instance)) {
			$instance = new fwgMessages();
		}
		return $instance;
	}
	function add($msg, $status='warning') {
		$messages = $this->getAll();
		$messages[] = (object)array(
			'msg' => $msg,
			'status' => $status
		);
		$this->set($messages);
	}
	function getLast() {
		if ($messages = $this->getAll()) {
			return $messages[count($messages)-1];
		}
	}
	function clearAll() {
		$this->set(array());
	}
	function set($messages) {
		Factory::getApplication()->setUserState('com_fwgallery.messages', $messages);
	}
	function getAll() {
		return Factory::getApplication()->getUserState('com_fwgallery.messages', array());
	}
}

class fwgButtons {
	var $buttons = array();
	static function getInstance() {
		static $btns;
		if (!is_object($btns)) {
			$btns = new fwgButtons;
		}
		return $btns;
	}
	function addButton($icon, $color, $alt, $task, $listSelect) {
		$btn = (object)array(
			'icon' => $icon,
			'color' => $color,
			'alt' => Text::_($alt),
			'task' => $task,
			'listSelect' => $listSelect
		);
		$this->buttons[] = $btn;
	}
	function getButtons() {
		return $this->buttons;
	}
}
class fwgButtonsHelper {
	static function addNew($task='add', $alt="JTOOLBAR_APPLY") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='file-plus', $color='primary', $alt, $task, $listSelect=false);
	}
	static function custom($icon, $color, $alt, $task, $listSelect) {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon, $color, $alt, $task, $listSelect);
	}
	static function editList($task='edit', $alt="JTOOLBAR_EDIT") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='pen-to-square', $color='secondary', $alt, $task, $listSelect=true);
	}
	static function deleteList($listSelect='', $task='remove', $alt="JTOOLBAR_DELETE") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='trash-can', $color='danger', $alt, $task, $listSelect);
	}
	static function publish($task='publish', $alt="JTOOLBAR_PUBLISH", $listSelect=true) {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='circle-arrow-up-right', $color='', $alt, $task, $listSelect);
	}
	static function unpublish($task='unpublish', $alt="JTOOLBAR_UNPUBLISH", $listSelect=true) {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='circle-arrow-down-left', $color='', $alt, $task, $listSelect);
	}
	static function apply($task='apply', $alt="JTOOLBAR_APPLY") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='floppy-disk', $color='primary', $alt, $task, $listSelect=false);
	}
	static function save($task='save', $alt="JTOOLBAR_SAVE") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='floppy-disk-close', $color='primary', $alt, $task, $listSelect=false);
	}
	static function save2new($task='savenew', $alt="JTOOLBAR_SAVE_AND_NEW") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='floppy-disk-plus', $color='secondary', $alt, $task, $listSelect=false);
	}
	static function cancel($task='cancel', $alt="JTOOLBAR_CANCEL") {
		$btns = fwgButtons::getInstance();
		$btns->addButton($icon='close', $color='danger', $alt, $task, $listSelect=false);
	}
}

class fwgHelper {
	static function getHostName() {
		$host = Uri::root(false);
		if (method_exists('Joomla\CMS\Factory', 'getContentFolder')) {
			$host = str_replace('/'.Factory::getContentFolder().'/plugins/fw-gallery', '', $host);
		}
		return $host;
	}
	static function getPluginsData() {
		static $data;
		if (!is_array($data)) {
			$lang = Factory::getLanguage();
			$db = Factory::getDBO();
			$db->setQuery('
SELECT
	`name`,
	`element`,
	`type`,
	`type` AS subtype,
	`folder`,
	`enabled`,
	0 AS installed,
	manifest_cache,
	5 AS _ordering,
	\'\' AS loc_version,
	\'\' AS rem_version,
	\'\' AS update_name,
	\'\' AS description,
	\'\' AS image
FROM
	`#__extensions`
WHERE
	manifest_cache LIKE \'%Fastw3b%\'
	AND
	(name LIKE \'%gallery%\' OR name LIKE \'%fwg%\' OR name LIKE \'%fwmg%\')
	AND
	NOT (
		`type` IN (\'package\', \'template\')
		OR
		`folder` IN (\'editors-xtd\', \'search\')
		OR
		(`element` = \'map\' and `folder` = \'fwgallery\')
		OR
		(`element` = \'fwgallerycategory\' and `folder` = \'finder\')
	)
ORDER BY
	`type`,
	`folder`,
	`name`');
			$data = $db->loadObjectList();
			foreach ($data as $i=>$row) {
				$data[$i]->_badges = array();
				$data[$i]->update_name = ($row->type == 'plugin')?('plg_'.$row->folder.'_'.$row->element):$row->element;
				$path = ($row->type == 'module')?JPATH_SITE:JPATH_ADMINISTRATOR;
				$lang->load($data[$i]->update_name, $path);
				$data[$i]->name = Text::_($row->name);
				if ($row->element == 'com_fwgallery') {
					$data[$i]->image = FWMG_ADMIN_ASSETS_URL.'images/icon_fw_gallery_logo_200.png';
				} else {
					$fname = 'images/'.$data[$i]->update_name.'.jpg';
					$data[$i]->image = FWMG_ADMIN_ASSETS_URL.(file_exists(FWMG_ADMIN_ASSETS_PATH.$fname)?$fname:'images/def_addon.png');
				}
				$manifest = json_decode($row->manifest_cache);

				$filename = '';
				if ($row->type == 'component') {
					$filename = FWMG_COMPONENT_ADMINISTRATOR.'/'.str_replace('com_', '', $row->element).'.xml';
					if ($row->element == 'com_fwgallery') {
						$data[$i]->update_name = urldecode(FWMG_UPDATE_NAME);
					}
				} elseif ($row->type == 'plugin') {
					$filename = '';
					switch ($row->folder) {
						case 'fwgallery' :
							$filename = FWMG_PLUGINS_PATH;
							break;
						case 'fwgallerytmpl' :
							$filename = FWMG_DESIGNS_PATH;
							break;
						case 'fwgallerytype' :
							$filename = FWMG_TYPES_PATH;
							break;
					}
					$filename .= $row->element."/".$row->element.".xml";
				} elseif ($row->type == 'module') {
					$filename = FWMG_MODULES_PATH.$row->element.'/'.$row->element.'.xml';
				}
				if ($filename and file_exists($filename)) {
					$data[$i]->installed = 1;
					$buff = file_get_contents($filename);
					if (preg_match('#<description><\!\[CDATA\[(.*?)\]\]></description>#msi', $buff, $match)) {
						$data[$i]->description = Text::_($match[1]);
					}
					if (preg_match('#<version>(.*?)</version>#msi', $buff, $match)) {
						$data[$i]->loc_version = $match[1];
					}
				}

				if ($row->folder == 'fwgallerytype') {
					$row->subtype = 'datatype';
				} elseif ($row->folder == 'fwgallerytmpl') {
					$row->subtype = 'design';
				} elseif ($row->type == 'component') {
					$row->subtype = 'component';
				}
				if (empty($data[$i]->description) and !empty($manifest->description)) {
					$data[$i]->description = Text::_($manifest->description);
				}
			}
			$params = ComponentHelper::getParams('com_fwgallery');
			$remote_data = json_decode((string)$params->get('extensions_data'));
			$time = $params->get('extensions_data_time');

			if ($time < time()) {
				$remote_data = array();
				$langs = array();
				$list = fwgHelper::getInstalledLanguages();
				foreach ($list as $row) {
					$langs[] = $row->tag;
				}
				$buff = json_decode(fwgHelper::request(FWMG_UPDATE_SERVER.'/index.php?option=com_fwsales&view=fwsales&layout=get_addons&format=json&product='.FWMG_UPDATE_NAME.'&version='.fwgHelper::getAppVersion().'&cms='.(class_exists('Joomla\CMS\Version')?'joomla':'wp').'&langs='.urlencode((string)implode('|',$langs)).'&host='.urlencode(fwgHelper::getHostName()).'&access_code='.urlencode($params->get('update_code', ''))));
				if (isset($buff->deals)) {
					$params->set('deals_data', json_encode($buff->deals));
				}
				if (isset($buff->langs)) {
					$params->set('langs_data', json_encode($buff->langs));
				}
				if (isset($buff->subscr)) {
					$params->set('subscr_data', json_encode($buff->subscr));
				}
				if (isset($buff->months)) {
					$params->set('subscription_months', $buff->months);
				}
				if (isset($buff->days)) {
					$params->set('subscription_days', $buff->days);
				}

				if (!empty($buff->result)) {
					foreach ($buff->result as $row) {
						$remote_data[] = $row;
					}
					$params->set('extensions_data', json_encode($remote_data));
				}
				$params->set('extensions_data_time', time() + 60);

				if (empty($buff->verified)) {
					$params->set('verified_code', '');
				}
				$params->set('has_packages', empty($buff->has_packages)?0:1);
				$params->set('has_inactive_packages', empty($buff->has_inactive_packages)?0:1);
				$params->set('has_active_packages', empty($buff->has_active_packages)?0:1);

				fwgHelper::storeConfig($params);
				if (!empty($buff->msg)) {
					Factory::getApplication()->enqueueMessage($buff->msg);
				}
			}

			if ($remote_data) {
				foreach ($remote_data as $r_row) {
					if ($r_row->update_name == 'pkg_fwgallery_map') {
						$r_row->update_name = 'mod_fwg_map';
					}
					$product_found = false;
					foreach ($data as $i=>$row) {
						$l_ext = explode('_', $row->update_name);
						$r_ext = explode('_', $r_row->update_name);

						if ($row->update_name == $r_row->update_name or ($r_ext[0] == 'pkg' and $l_ext[count($l_ext) - 1] == $r_ext[count($r_ext) - 1])) {
							if ($r_row->frontend_demo_link) {
								$data[$i]->frontend_demo_link = $r_row->frontend_demo_link;
							}
							if ($r_row->link) {
								$data[$i]->link = $r_row->link;
							}
							if ($r_row->doc_link) {
								$data[$i]->doc_link = $r_row->doc_link;
							}
							if (!empty($r_row->_badges)) {
								$data[$i]->_badges = $r_row->_badges;
							}
							if ($r_row->_ordering) {
								$data[$i]->_ordering = $r_row->_ordering;
							}
							if ($r_row->short) {
								$data[$i]->description = $r_row->short;
							}
							if ($r_row->image) {
								$data[$i]->image = $r_row->image;
							}
							if ($r_row->name) {
								$data[$i]->name = $r_row->name;
							}
							if ($r_row->_related) {
								$data[$i]->_related = $r_row->_related;
							}
							if ($r_row->_required) {
								$data[$i]->_required = $r_row->_required;
							}
							$data[$i]->days = $r_row->days;
							$data[$i]->price = $r_row->price;
							$data[$i]->version_price = $r_row->version_price;
							if ($r_row->_addon_type) {
								$data[$i]->subtype = strtolower($r_row->_addon_type);
							}
							if ($r_row->_version) {
								$data[$i]->rem_version = $r_row->_version;
							}
							$data[$i]->_comp_version = empty($r_row->_comp_version)?'':$r_row->_comp_version;
							if (!empty($r_row->_installable)) {
								$data[$i]->installable = $r_row->_installable;
							}
							$product_found = true;
							break;
						}
					}
					if (!$product_found) {
						$type = '';
						$buff = explode('_', $r_row->update_name, 2);
						switch ($buff[0]) {
							case 'com' : $type = 'component'; break;
							case 'mod' : $type = 'module'; break;
							case 'plg' : $type = 'plugin'; break;
						}
						$data[] = (object)array(
							'name' => $r_row->name,
							'subtype' => strtolower($r_row->_addon_type),
							'type' => $type,
							'_ordering' => $r_row->_ordering,
							'_badges' => empty($r_row->_badges)?array():$r_row->_badges,
							'enabled' => 0,
							'installed' => 0,
							'frontend_demo_link' => $r_row->frontend_demo_link,
							'doc_link' => $r_row->doc_link,
							'update_name' => $r_row->update_name,
							'description' => $r_row->short,
							'image' => $r_row->image,
							'days' => $r_row->days,
							'price' => $r_row->price,
							'version_price' => $r_row->version_price,
							'_required' => $r_row->_required,
							'_related' => $r_row->_related,
							'loc_version' => '',
							'rem_version' => $r_row->_version,
							'_comp_version' => empty($r_row->_comp_version)?'':$r_row->_comp_version,
							'installable' => !empty($r_row->_installable),
							'link' => $r_row->link
						);
					}
				}
	            $data = ArrayHelper::sortObjects($data, 'name');
	            $data = ArrayHelper::sortObjects($data, 'enabled', -1);
			}
		}
		return $data;
	}
	static function getAppVersion() {
		$buff = file_get_contents(FWMG_COMPONENT_ADMINISTRATOR.'/fwgallery.xml');
		if (preg_match('#<version>(.*?)</version>#msi', $buff, $match)) {
			return $match[1];
		}
	}
	static function getLanguageOverrides() {
		static $buff = null;
		if (is_null($buff)) {
			$lang = fwgHelper::getLanguage();
			$admin_override = FWMG_LANGUAGE_ADMINISTRATOR.'/language/overrides/'.$lang.'.override.ini';
			if (file_exists($admin_override)) {
				$admin_buff = explode("\n", file_get_contents($admin_override));
				foreach ($admin_buff as $tmp) {
					$row = explode('=', $tmp, 2);
					if (!empty($row[1])) {
						$buff[$row[0]] = trim($row[1], '"');
					}
				}
			}
			$site_override = FWMG_LANGUAGE_SITE.'/language/overrides/'.$lang.'.override.ini';
			if (file_exists($site_override)) {
				$site_buff = explode("\n", file_get_contents($site_override));
				foreach ($site_buff as $tmp) {
					$row = explode('=', $tmp, 2);
					if (!empty($row[1])) {
						$buff[$row[0]] = trim($row[1], '"');
					}
				}
			}
		}
		return $buff;
	}
	static function jtext($const, $use_js=false) {
		$buff = fwgHelper::getLanguageOverrides();
		return empty($buff[$const])?Text::_($const, $use_js):($use_js?esc_js($buff[$const]):$buff[$const]);
	}
	static function sprintf($const) {
		$args  = \func_get_args();
		$buff = fwgHelper::getLanguageOverrides();
		if (!empty($buff[$const])) {
			$args[0] = $buff[$const];
			$args[0] = preg_replace('/\[\[%([0-9]+):[^\]]*\]\]/', '%\1$s', $args[0]);
			return \call_user_func_array('sprintf', $args);
		} else {
			return \call_user_func_array(array('Joomla\CMS\Language\Text', 'sprintf'), $args);
		}
	}
	static function route($url, $b1=true, $b2=0) {
		static $j4r = null, $mid = null;
		if (is_null($j4r) and class_exists('Joomla\CMS\Version')) {
			$active = Factory::getApplication()->getMenu()->getActive();
			if ($active and !empty($active->query['option']) and $active->query['option'] == 'com_fwgallery') {
				$mid = $active->id;
			}
			$ver = new Version;
			$j4r = $ver->isCompatible('4');
		}
		if (is_null($j4r)) $j4r = false;
		if ($j4r) {
			$itemid = $mid;
			if (!$itemid) {
				if (strpos($url, 'view=fwgallery') !== false) {
					$id = 0;
					if (preg_match('#id\=(\d+)#', $url, $match)) {
						$id = $match[1];
					}
					$itemid = fwgHelper::getItemid('fwgallery', $id?array('gids'=>$id):null);
				} elseif (strpos($url, 'view=item') !== false) {
					$itemid = fwgHelper::getItemid('fwgallery');
				}
			}
			if ($itemid) {
				if (strpos($url, 'Itemid=') === false) {
					$url .= '&amp;Itemid='.$itemid;
				} else {
					$url = preg_replace('#Itemid\=(\d*)#', 'Itemid='.$itemid, $url);
				}
			} else {
				$url = str_replace(array('option=com_fwgallery&amp;', 'option=com_fwgallery&'), '', $url);
			}
		}
		return Route::_($url, $b1, $b2);
	}
	static function getItemid($view='fwgallery', $id=array(), $default=0, $option='com_fwgallery') {
    	$menu = Factory::getApplication()->getMenu();
    	$item = null;
		if ($id and !is_array($id)) $id = array('id'=>$id);
    	if ($items = $menu->getItems('link', 'index.php?option='.$option.'&view='.$view)) {
			$key = $val = 0;
			if ($id) {
				$key = key($id);
				$val = $id[$key];
	    		foreach ($items as $menuItem) {
					$params = $menuItem->getParams();
					$buff = $params->get($key);
		    		if ((is_array($buff) and in_array($val, $buff)) or (is_numeric($buff) and $buff == $val)) {
		    			$item = $menuItem;
		    			break;
		    		}
	    		}
				if (!$item) {
					if ($view == 'fwgallery') {
						$ids = array();
						if ($buff = fwgHelper::getParentGalleries($val)) {
							foreach ($buff as $row) {
								$ids[] = $row->id;
							}
						}
						foreach ($items as $menuItem) {
							$params = $menuItem->getParams();
							$buff = $params->get($key);
							if ((is_array($buff) and array_intersect($ids, $buff)) or (is_numeric($buff) and in_array($buff, $ids))) {
								$item = $menuItem;
								break;
							}
						}
					}
					if (!$item) {
						foreach ($items as $menuItem) {
							$params = $menuItem->getParams();
							$buff = $params->get($key);
							if (empty($buff) or (is_array($buff) and (in_array(0, $buff))) or (is_numeric($buff) and $buff == $val)) {
								$item = $menuItem;
								break;
							}
						}
					}
				}
			}
	    	if (!$item) $item = $items[0];
    	}
    	if (!$item) $item = $menu->getItems('link', 'index.php?option=com_fwgallery&view=fwgallery', true);

    	if ($item) return $item->id;
    	elseif ($default) return $default;
    	elseif ($item = $menu->getActive()) return $item->id;
    }
	static function triggerEvent($event, $params) {
		$data = Factory::getApplication()->triggerEvent($event, $params);
		static $modals = array();
		$plugins = array(
			'plg_fwgallery_admin',
			'plg_fwgallery_cascading',
			'plg_fwgallery_featured',
			'plg_fwgallery_import',
			'plg_fwgallery_map',
			'plg_fwgallery_meta',
			'plg_fwgallery_seobooster',
			'plg_fwgallery_slideshowview',
			'plg_fwgallery_social',
			'plg_fwgallery_tag',
			'plg_fwgallery_vote',
		);
		$path = FWMG_COMPONENT_ADMINISTRATOR.'/layouts/addons/';
		foreach ($plugins as $plugin) {
			$buff = explode('_', $plugin);
			if (!fwgHelper::pluginEnabled($buff[count($buff) - 1]) and file_exists($path.$plugin.'/'.strtolower($event).'.php')) {
				if (!isset($modals[$plugin])) {
					if (file_exists($path.$plugin.'/modal_advert.php')) {
?>
<div id="fwmg-modal-advert-<?php echo esc_attr($plugin); ?>" class="fwk-flex-top" fwk-modal>
  <div class="fwk-modal-dialog fwk-margin-auto-vertical">
	  <button class="fwk-modal-close-default" type="button" fwk-close></button>
      <div class="fwk-modal-header">
        <h5 class="fwk-modal-title"><?php echo Text::_('FWMG_ADDON_'.$plugin); ?></h5>
      </div>
      <div class="fwk-modal-body">
        <?php include($path.$plugin.'/modal_advert.php'); ?>
      </div>
  </div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function () {
    (function ($) {
		$('#fwmg-modal-advert-<?php echo esc_js($plugin); ?>').on('show', function() {
			$(this).addClass('show');
		}).on('hide', function() {
			$(this).removeClass('show');
		});
    })(jQuery);
});
</script>
<?php
					}
					$modals[$plugin] = true;
				}
?>
<div class="fwa-modal-advert" fwk-toggle="target: #fwmg-modal-advert-<?php echo esc_attr($plugin); ?>"><?php include($path.$plugin.'/'.strtolower($event).'.php'); ?></div>
<?php
			}
		}
		return $data;
	}
	static function fixDescriptionImagesLinks($text) {
		if (preg_match_all('#(src\=")(images/)#', $text, $matches, PREG_SET_ORDER)) {
			$base = Uri::root(true).'/';
			foreach ($matches as $match) {
				$text = str_replace($match[0], $match[1].$base.$match[2], $text);
			}
		}
		return $text;
	}
	static function messageEscape($text) {
		return esc_js(str_replace(array("\r\n", "\n", "\r"), '<br/>', $text));
	}
	static function addMessage($msg, $status='warning') {
		$messages = fwgMessages::getInstance();
		$messages->add($msg, $status);
	}
	static function getMessage() {
		$messages = fwgMessages::getInstance();
		return $messages->getLast();
	}
	static function getMessages() {
		$messages = fwgMessages::getInstance();
		$data = $messages->getAll();
		$messages->clearAll();
		return $data;
	}
	static function clearMessages() {
		$messages = fwgMessages::getInstance();
		return $messages->clearAll();
	}
	static function loadAdminStyles() {
		if (Factory::getLanguage()->isRtl()) {
			HTMLHelper::stylesheet('components/com_fwgallery/assets/css/fw-uikit-rtl-3.21.5.min.css');
		} else {
			HTMLHelper::stylesheet('components/com_fwgallery/assets/css/fw-uikit-3.21.5.min.css');
		}
		HTMLHelper::stylesheet('administrator/components/com_fwgallery/assets/css/fw-admin-uikit.css', array('version'=>'v=103'));
		if (!ComponentHelper::getParams('com_fwgallery')->get('not_use_dark_mode')) {
			HTMLHelper::stylesheet('administrator/components/com_fwgallery/assets/css/fw-admin-uikit-dark.css', array('version'=>'v=100'));
		}
		HTMLHelper::stylesheet('administrator/components/com_fwgallery/assets/css/fwg-admin-custom.css', array('version'=>'v=101'));
		HTMLHelper::script('components/com_fwgallery/assets/js/fw-uikit-3.21.5.min.js');
		HTMLHelper::script('components/com_fwgallery/assets/js/fw-uikit-icons-3.21.5.min.js');
		HTMLHelper::script('components/com_fwgallery/assets/js/custom-icons.js', array('version'=>'v=103'));
		HTMLHelper::script('administrator/components/com_fwgallery/assets/js/custom.js', array('version'=>'v=125'));
		if (Factory::getApplication()->input->getCmd('option') == 'com_fwgallery') {
			Factory::getDocument()->addStyleDeclaration('#subhead-container {display: none;}');
		}
	}
	static function loadSiteStyles() {
		if (!defined('FWMG_STYLES_LOADED')) {
			define('FWMG_STYLES_LOADED', true);
			HTMLHelper::_('jquery.framework');
			$com_params = ComponentHelper::getParams('com_fwgallery');
			if (!defined('FW_UIKIT_LOADED')) {
				define('FW_UIKIT_LOADED', true);
				if (Factory::getLanguage()->isRtl()) {
					HTMLHelper::stylesheet('components/com_fwgallery/assets/css/fw-uikit-rtl-3.21.5.min.css');
				} else {
					HTMLHelper::stylesheet('components/com_fwgallery/assets/css/fw-uikit-3.21.5.min.css');
				}
				HTMLHelper::script('components/com_fwgallery/assets/js/fw-uikit-3.21.5.min.js');
				HTMLHelper::script('components/com_fwgallery/assets/js/fw-uikit-icons-3.21.5.min.js');
			}
			HTMLHelper::script('components/com_fwgallery/assets/js/list.js', array('version'=>'v=115'));
			HTMLHelper::script('components/com_fwgallery/assets/js/custom-icons.js', array('version'=>'v=103'));
			$buff = $com_params->get('additional_css');
			$font_size = (int)$com_params->get('font_size', 16);
			if (!$font_size) $font_size = 16;
			$buff = 'html {font-size: '.$font_size.'px;}'.$buff;
			$doc = Factory::getDocument();
			$doc->addStyleDeclaration($buff);

			/* komento */
			if ($com_params->get('comments_type') == 'komento' and file_exists(JPATH_ROOT.'/components/com_komento/bootstrap.php')) {
				require_once(JPATH_ROOT.'/components/com_komento/bootstrap.php');
				KT::initialize();
			}
		}
	}
	static function colorpicker() {
		HTMLHelper::_('jquery.framework');
		HTMLHelper::stylesheet('components/com_fwgallery/assets/css/jquery.minicolors.css');
		HTMLHelper::script('components/com_fwgallery/assets/js/jquery.minicolors.min.js');
		Factory::getDocument()->addScriptDeclaration('
document.addEventListener(\'DOMContentLoaded\', function() {
	(function($) {
	$(\'.minicolors\').each(function() {
		$(this).minicolors({
			control: $(this).attr(\'data-control\') || \'hue\',
			format: $(this).attr(\'data-validate\') === \'color\'
				? \'hex\'
				: ($(this).attr(\'data-format\') === \'rgba\'
					? \'rgb\'
					: $(this).attr(\'data-format\'))
				|| \'hex\',
			keywords: $(this).attr(\'data-keywords\') || \'\',
			opacity: $(this).attr(\'data-format\') === \'rgba\' ? true : false || false,
			position: $(this).attr(\'data-position\') || \'default\',
			theme: \'bootstrap\'
		});
	});
	})(jQuery);
});');
	}
	static function getEditor() {
		$editor = Factory::getConfig()->get('editor');
		return Editor::getInstance($editor);
	}
	static function getSearchData() {
		return Factory::getApplication()->getUserStateFromRequest('com_fwgallery.search', 'search');
	}
	static function checkTime($time) {
		return preg_match('/^(?:[01][0-9]|2[0-3]):[0-5][0-9]:[0-5][0-9]$/', $time);
	}
	static function getArrayValue($data, $key, $def=null) {
		if (isset($data[$key])) return $data[$key];
		return $def;
	}
	static function getCategoryParams($cid) {
		static $data = array();
		if (!isset($data[$cid])) {
			$cats = fwgHelper::loadCategories();
			$params = null;
			if ($cid) {
				foreach ($cats as $cat) {
					if ($cat->id == $cid) {
						$data[$cid] = new fwgParams($cat->params, fwgHelper::getParentGalleries($cat->parent));
						break;
					}
				}
			}
			if (!isset($data[$cid])) {
				$data[$cid] = new fwgParams(new Registry);
			}
		}
		return $data[$cid];
	}
	static function getGridsList() {
		return array(
			HTMLHelper::_('select.option', 'standard', Text::_('FWMG_GRID_STANDARD'), 'id', 'name'),
			HTMLHelper::_('select.option', 'waterfall', Text::_('FWMG_GRID_WATERFALL'), 'id', 'name'),
//			HTMLHelper::_('select.option', 'masonry', Text::_('FWMG_GRID_MASONRY'), 'id', 'name'),
			HTMLHelper::_('select.option', 'justified', Text::_('FWMG_GRID_JUSTIFIED'), 'id', 'name'),
			HTMLHelper::_('select.option', 'custom', Text::_('FWMG_GRID_CUSTOM'), 'id', 'name'),
		);
	}
	static function getGridsSizeLimits() {
		return array(
			'custom' => array(
				'min_cols' => 5,
				'min_rows' => 4
			)
		);
	}
	static function getLimitQty($cols, $rows, $grid) {
		$num = $cols * $rows;
		if ($grid == 'custom') {
			$num -= 8;
		}
		return $num;
	}
	static function getLimitOptions($cols, $rows, $grid, $limit, $total) {
		$data = array();
		$num = fwgHelper::getLimitQty($cols, $rows, $grid);
		if ($total >= $num) {
			for ($i = 1; $i < 4; $i++) {
				$data[] = HTMLHelper::_('select.option', $num * $i, $num * $i, 'id', 'name');
			}
		}
		return $data;
	}
	static function splitSql($sql) {
		$start = 0;
		$open = false;
		$char = '';
		$end = strlen($sql);
		$queries = array();

		for ($i = 0; $i < $end; $i++)
		{
			$current = substr($sql, $i, 1);

			if (($current == '"' || $current == '\''))
			{
				$n = 2;

				while (substr($sql, $i - $n + 1, 1) == '\\' && $n < $i)
				{
					$n++;
				}

				if ($n % 2 == 0)
				{
					if ($open)
					{
						if ($current == $char)
						{
							$open = false;
							$char = '';
						}
					}
					else
					{
						$open = true;
						$char = $current;
					}
				}
			}

			if (($current == ';' && !$open) || $i == $end - 1)
			{
				$queries[] = substr($sql, $start, ($i - $start + 1));
				$start = $i + 1;
			}
		}

		return $queries;
	}
	static function fileDownloadable($file) {
		if ($file->type == 'image') {
			if ($file->_sys_filename) {
				$path = fwgHelper::getImagePath($file->_sys_filename);
				return file_exists($path.$file->_sys_filename);
			}
		} else {
			$buff = Factory::getApplication()->triggerEvent('onfileDownloadable', array('com_fwgallery.'.$file->type, $file));
			if ($buff) {
				foreach ($buff as $value) {
					if ($value) return true;
				}
			}
		}
	}
	static function stripTags($text, $limit=null, $show_counter=false, $do_not_use_nl2br=false) {
		if (!$limit) return;
		$text = strip_tags(preg_replace(array('#\{[^\}]+\}#', '#^<p>|</p>$#', '#\r\n\r\n#', '#\n\n#', '#\&nbsp;#'), array('', '', "\n", "\n", ' '), trim((string)$text)));
		if (is_numeric($limit) and $limit > 0 and mb_strlen($text) > $limit) {
			$text = mb_substr($text, 0, $limit).'&hellip;'.($show_counter?(' ['.mb_strlen($text).']'):'');
		}
		return $do_not_use_nl2br?$text:nl2br($text);
	}
	static function loadCategories() {
		static $cats;
		if (!is_array($cats)) {
			$db = Factory::getDBO();
			$db->setQuery('
SELECT
    c.id,
	c.parent,
	c.published,
	c.name,
	c.params
FROM
    `#__fwsg_category` AS c
ORDER BY
    `parent`,
    ordering');
			$cats = (array)$db->loadObjectList('id');
			foreach ($cats as $i=>$cat) {
				$cats[$i]->params = new Registry($cat->params);
			}
		}
		return $cats;
	}
	static function checkPrevCategory($c) {
		$items = fwgHelper::loadCategories();
		$cats = array();
		foreach ($items as $item) {
			if ($item->parent == $c->parent) {
				$cats[$item->id] = $item;
			}
		}

		$prev_id = 0;
		foreach ($cats as $cat) {
			if ($cat->id == $c->id) {
				return !(!$prev_id or ($prev_id and $cats[$prev_id]->parent != $cat->parent));
			}
			$prev_id = $cat->id;
		}
	}
	static function checkNextCategory($c) {
		$items = fwgHelper::loadCategories();
		$cats = array();
		foreach ($items as $item) {
			if ($item->parent == $c->parent) {
				$cats[$item->id] = $item;
			}
		}

		$ids = array_keys($cats);
		$next_id = 0;
		for ($i = count($ids) - 1; $i >= 0; $i--) {
			if ($cats[$ids[$i]]->id == $c->id) {
				return !(!$next_id or ($next_id and $cats[$next_id]->parent != $cats[$ids[$i]]->parent));
			}
			$next_id = $cats[$ids[$i]]->id;
		}
	}
	static function getInstalledLanguages() {
		static $languages;
		if (!is_array($languages)) {
			$buff = LanguageHelper::getKnownLanguages();
			foreach ($buff as $row) {
				$lang = new stdclass;
				$lang->id = $row['tag'];
				$lang->tag = $row['tag'];
				$lang->name = $row['name'];
				$languages[$row['tag']] = $lang;
			}
		}
		return $languages;
	}
	static function getLanguage() {
		static $lang = null;
		if (!$lang) {
			$db = Factory::getDBO();
			$app = Factory::getApplication();
			$lang = $app->getUserStateFromRequest('com_fwgallery.language', 'lang');
			if ($lang and strlen($lang) == 2) {
				$db->setQuery('SELECT `lang_code` FROM `#__languages` WHERE `sef` = '.$db->quote($lang));
				$lang = $db->loadResult();
			}
			if (!$lang) {
				$lang  = Factory::getLanguage()->getTag();
			}
			if (!$lang or ($lang and !in_array($lang, array_keys(fwgHelper::getInstalledLanguages())))) {
				$db->setQuery('SELECT `lang_code` FROM `#__languages` WHERE `published` = 1 AND `ordering` = 1');
				$lang = $db->loadResult();
				if (!$lang) {
					$lang = 'en-GB';
				}
			}
		}
		return $lang;
	}
	static function storeConfig($params, $do_not_clear_images_cache = false) {
		$cache = Factory::getCache('_system', 'callback');
    	$cache->clean();

		if (!$do_not_clear_images_cache) {
			fwgHelper::clearImageCache();
		}

    	$db = Factory::getDBO();
    	$db->setQuery('UPDATE `#__extensions` SET params = '.$db->quote($params->toString()).' WHERE `element` = \'com_fwgallery\' AND `type` = \'component\'');
    	return $db->execute();
	}
	static function encodeDate($date) {
		if (!$date or (is_string($date) and $date[0]=='0')) {
			return '';
		} else {
			$params = ComponentHelper::getParams('com_fwgallery');
			$date_format = str_replace(array(
				'%Y',
				'%d',
				'%B'
			), array(
				'Y',
				'd',
				'F'
			), $params->get('date_format', 'F d, Y'));
			return HTMLHelper::date($date, $date_format);
		}
	}
	static function decodeDate($date) {
		if ($buff = explode('/', $date) and count($buff) == 3) {
			return $buff[2].'-'.$buff[0].'-'.$buff[1];
		} elseif ($date = @strtotime($date)) {
			return date('Y-m-d', $date);
		} else {
			return '';
		}
	}
	static function getIniSize($name) {
		$size = ini_get($name);
		$unit = preg_replace('/[^bkmgtpezy]/i', '', $size);
		$size = preg_replace('/[^0-9\.]/', '', $size);
		if ($unit) {
			return round($size * pow(1024, stripos('bkmgtpezy', $unit[0])));
		} else {
			return round($size);
		}
	}
    static function loadCategoriesPath($category_id = 0, $itemid = 0) {
		static $categories_above = array();
		if (!isset($categories_above[$category_id])) {
			$categories_above[$category_id] = array();
			if ($category_id) {
				$db = Factory::getDBO();
				$parent = new stdclass;
				$parent->parent = $category_id;
				do {
					$db->setQuery('SELECT id, parent, name FROM `#__fwsg_category` WHERE id = '.(int)$parent->parent);
					if ($parent = $db->loadObject()) {
                        $parent->link = 'index.php?option=com_fwgallery&view=fwgallery&id='.$parent->id.':'.OutputFilter::stringURLSafe($parent->name).'&Itemid='.$itemid;
                        $categories_above[$category_id][] = $parent;
                    }
				} while ($parent);

				$categories_above[$category_id] = array_reverse($categories_above[$category_id]);
			}
			$menu = Factory::getApplication()->getMenu();
			if ($active = $menu->getActive()) {
				$ids = (array)$active->getParams()->get('gids');

				$add_root = true;
				if ($ids and $categories_above[$category_id]) {
					$qty = count($categories_above[$category_id]) - 1;
					for ($i = $qty; $i >= 0; $i--) {
						if (!isset($categories_above[$category_id][$i])) break;
						$cat = $categories_above[$category_id][$i];
						if (in_array($cat->id, $ids)) {
							$add_root = false;
							if ($i == $qty) {
								$categories_above[$category_id] = array();
							} else {
								$categories_above[$category_id] = array_slice($categories_above[$category_id], $i);
							}
						}
					}
				}
				if ($add_root) {
					array_unshift($categories_above[$category_id], (object)array(
						'id' => 0,
						'alias' => $active->alias,
						'name' => $active->title,
						'link' => 'index.php?Itemid='.$active->id
					));
				}
			}
		}
		return $categories_above[$category_id];
    }
	static function getImageLink($image) {
		$prefix = substr($image, 0, 2);
		return Uri::root(true).'/'.FWMG_STORAGE.$prefix.'/';
	}
	static function getImagePath($image) {
		$prefix = substr($image, 0, 2);
		return FWMG_STORAGE_PATH.$prefix.'/';
	}
	static function getThemesList() {
		$themes = array();
		$db = Factory::getDBO();
		$db->setQuery("SELECT name, `element` FROM `#__extensions` WHERE `type` = 'plugin' AND `folder` = 'fwgallerytmpl' AND `enabled` = 1");
		if ($list = $db->loadObjectList()) {
			$lang = Factory::getLanguage();
			foreach ($list as $row) {
				$lang->load('plg_fwgallerytmpl_'.$row->element, JPATH_ADMINISTRATOR);
				$themes[] = HTMLHelper::_('select.option', $row->element, Text::_($row->name), 'id', 'name');
			}
		}
		return $themes;
	}
	static function getLayoutsList() {
		return array(
			HTMLHelper::_('select.option', 'hide', Text::_('FWMG_LAYOUT_HIDE'), 'id', 'name'),
			HTMLHelper::_('select.option', 'top', Text::_('FWMG_LAYOUT_TOP'), 'id', 'name'),
			HTMLHelper::_('select.option', 'right', Text::_('FWMG_LAYOUT_RIGHT'), 'id', 'name'),
			HTMLHelper::_('select.option', 'bottom', Text::_('FWMG_LAYOUT_BOTTOM'), 'id', 'name'),
			HTMLHelper::_('select.option', 'left', Text::_('FWMG_LAYOUT_LEFT'), 'id', 'name'),
			HTMLHelper::_('select.option', 'over_slide_up', Text::_('FWMG_LAYOUT_OVER_SLIDE_UP'), 'id', 'name'),
			HTMLHelper::_('select.option', 'over_full_hover', Text::_('FWMG_LAYOUT_OVER_FULL_HOVER'), 'id', 'name'),
		);
	}
	static function getHoverList() {
		$layouts = array();
		if ($files = Folder::files(FWMG_COMPONENT_SITE.'/layouts/common/hover')) {
			foreach ($files as $file) {
				$key = str_ireplace('.php', '', $file);
				$value = str_replace('_', ' ', $key);
				$layouts[] = HTMLHelper::_('select.option', $key, ucfirst(strtolower($value)), 'id', 'name');
			}
		}
		return $layouts;
	}
	static function request($url, $method='get', $data=null, $headers=array(), $timeout = 5) {
		$method = strtolower($method);
		if (!in_array($method, array('get', 'post', 'put', 'delete'))) {
			$method = 'get';
		}
		if ($data and in_array($method, array('get', 'delete'))) {
			$buff = http_build_query($data);
			$url .= (strpos($url, '?') === false ? '?' : '&') . $buff;
		}

		$result = '';
		try {
			$opts = array();
			if (defined('CURLOPT_SSL_VERIFYHOST')) {
				$opts['transport.curl'] = array(CURLOPT_SSL_VERIFYHOST=>0, CURLOPT_SSL_VERIFYPEER=>0);
			}
			$http = HttpFactory::getHttp(new Registry($opts));
			switch ($method) {
				case 'get':
					$result = $http->get($url, $headers, $timeout);
					break;
				case 'post':
					$result = $http->post($url, $data, $headers, $timeout);
					break;
				case 'put':
					$result = $http->put($url, $data);
					break;
				case 'delete':
					$result = $http->delete($url);
					break;
			}
		} catch (Exception $e) {
			fwgHelper::addMessage($e->getMessage(), 'danger');
		}
		return $result ? $result->body : '';
	}
    static function detectIphone() {
        if ($user_agent = ArrayHelper::getValue($_SERVER, 'HTTP_USER_AGENT')) {
            $mobile_oses = array('iPhone','iPod','iPad','iPaid');
            foreach ($mobile_oses as $wos) if (strpos($user_agent, $wos) !== false) {
                return true;
            }
        }
    }
    static function humanFileSize($val) {
        if ($val > 1073741824) return round($val / 1073741824, 2).' Gb';
        if ($val > 1048576) return round($val / 1048576, 2).' Mb';
        elseif ($val > 1024) return round($val / 1024, 2).' Kb';
        elseif ($val and is_numeric($val)) return $val.' b';
        else return $val;
    }
    static function clearImageCache($id = null) {
		$cache_path = JPATH_SITE.'/cache/fwgallery/images/';
        if (is_dir($cache_path)) {
            if ($files = Folder::files($cache_path, $id?('^'.$id.'_'):'.*')) {
                foreach ($files as $file) {
                    File::delete($cache_path.$file);
                }
            }
        }
    }
    static function findUnicFilename($path, $filename) {
        $ext = strtolower(File::getExt($filename));
        $name = strtolower(trim(File::makeSafe(File::stripExt($filename)), '-'));
        $result = '';
        $index = 0;
        do {
            $result = $name.(($index > 0)?('-'.$index):'').($ext?('.'.$ext):'');
            $index++;
        } while (file_exists($path.$result));
        return $result;
    }
    static function findRandUnicFilename($path, $ext) {
        $result = '';
        do {
            $result = md5(rand()).($ext?('.'.$ext):'');
        } while (file_exists($path.$result));
        return $result;
    }
    static function getGps($exifCoord, $hemi) {
        $degrees = count($exifCoord) > 0 ? fwgHelper::gps2Num($exifCoord[0]) : 0;
        $minutes = count($exifCoord) > 1 ? fwgHelper::gps2Num($exifCoord[1]) : 0;
        $seconds = count($exifCoord) > 2 ? fwgHelper::gps2Num($exifCoord[2]) : 0;
        $flip =($hemi == 'W' or $hemi == 'S') ? -1 : 1;
        return floatval($flip *($degrees +($minutes/60)+($seconds/3600)));
    }
    static function gps2Num($coordPart) {
        $parts = explode('/', $coordPart);
        if (count($parts) <= 0) {
            return 0;
        } else if (count($parts) == 1) {
            return $parts[0];
        } else {
            return floatval($parts[0]) / floatval($parts[1]);
        }
    }
    static function getIP() {
        if (getenv('HTTP_CLIENT_IP') && strcasecmp(getenv('HTTP_CLIENT_IP'), 'unknown'))
            $ip = getenv('HTTP_CLIENT_IP');
        elseif (getenv('REMOTE_ADDR') && strcasecmp(getenv('REMOTE_ADDR'), 'unknown'))
            $ip = getenv('REMOTE_ADDR');
        elseif (getenv('HTTP_X_FORWARDED_FOR') && strcasecmp(getenv('HTTP_X_FORWARDED_FOR'), 'unknown'))
            $ip = getenv('HTTP_X_FORWARDED_FOR');
        elseif (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], 'unknown'))
            $ip = $_SERVER['REMOTE_ADDR'];
        else
            $ip = '127.0.0.1';
        return $ip;
    }
	static function getChildGalleriesIDS($ids) {
		$galleries = fwgHelper::loadCategories();
		if ($ids) {
			do {
				$found = false;
				foreach ($galleries as $gallery) {
					if (!in_array($gallery->id, $ids) and in_array($gallery->parent, $ids)) {
						$ids[] = $gallery->id;
						$found = true;
					}
				}
			} while($found);
		}
		return $ids;
	}
	static function getParentGalleries($id) {
		$galleries = fwgHelper::loadCategories();
		$data = array();
		if ($id) {
			foreach ($galleries as $gallery) {
				if ($gallery->id == $id) {
					$data[(int)$gallery->parent] = $gallery;
				}
			}
			do {
				$found = false;
				$ids = array_keys($data);
				foreach ($galleries as $gallery) {
					if (!isset($data[$gallery->parent]) and in_array($gallery->id, $ids)) {
						$data[$gallery->parent] = $gallery;
						$found = true;
					}
				}
			} while($found);
		}
		return $data;
	}
	static function fileExists($filename) {
		if ($filename) {
			$path = fwgHelper::getImagePath($filename);
			return file_exists($path.$filename);
		}
	}
	static function getModuleLayoutPath($module, $layout = 'default') {
		$app = Factory::getApplication();
        $templateObj   = $app->getTemplate(true);
        $defaultLayout = $layout;
        $template      = $templateObj->template;

        if (strpos($layout, ':') !== false) {
            // Get the template and file name from the string
            $temp = explode(':', $layout);
            $template = $temp[0] === '_' ? $template : $temp[0];
            $layout = $temp[1];
            $defaultLayout = $temp[1] ?: 'default';
        }

        // If the template has a layout override use it
		$tPath = JPATH_THEMES.'/'.$template.'/html/'.$module.'/'.$layout.'.php';
        if (is_file($tPath)) {
            return $tPath;
        }

        // If the template has a layout override in a child theme use it
        if (!empty($templateObj->parent)) {
			$iPath = JPATH_THEMES.'/'.$templateObj->parent.'/html/'.$module.'/'.$layout.'.php';
			if (is_file($iPath)) {
				return $iPath;
			}
        }

        // If the template has a layout override in a FWMG design plugin use it
		$com_params = ComponentHelper::getParams('com_fwgallery');
		if ($tmpl = $com_params->get('template')) {
			$pPath = FWMG_DESIGNS_PATH.$tmpl.'/modules/'.$module.'/'.$defaultLayout.'.php';
			if (is_file($pPath)) {
				if (file_exists(FWMG_DESIGNS_PATH.$tmpl.'/assets/css/fwmg-design-styles.css') and !defined('FWMG_SITE_PLUGIN_DESIGN_LOADED')) {
					define('FWMG_SITE_PLUGIN_DESIGN_LOADED', true);
					HTMLHelper::stylesheet('plugins/fwgallerytmpl/'.$tmpl.'/assets/css/fwmg-design-styles.css', array('version'=>'v=100'));
				}
				return $pPath;
			}
		}
	}
    static function loadTemplate($layout, $displayData, $path=null) {
        $app = Factory::getApplication();
		$com_params = ComponentHelper::getParams('com_fwgallery');

		$tmpl = '';
		$template = $app->input->getCmd('t', empty($displayData['view']->params)?$com_params->get('template'):$displayData['view']->params->get('template'));
		if (in_array($template, array('', 'def', 'common'))) $template = $com_params->get('template');
		$tmpl_path = FWMG_DESIGNS_PATH;

		$buff = explode('.', $layout);
		$filename = array_pop($buff).'.php';
		$layout_path = implode('/', $buff);

		/* check for existing of plugin template override */
		if ($buff[0] == 'site') {
			/* the new template plugin folder scheme check */
			$buff[0] = 'plugins';
			$override_path = implode('/', $buff);
			if (is_file($tmpl_path.$template.'/'.$override_path.'/'.$filename)) {
				$layout_path = $override_path;
			} else {
				/* previous template plugin folder scheme check */
				$buff[0] = 'site';
				$override_path = implode('/', $buff);
				if (is_file($tmpl_path.$template.'/'.$override_path.'/'.$filename)) {
					$layout_path = $override_path;
				}
			}
		}

		if (is_null($path)) {
			if ($template and is_dir($tmpl_path.$template)) {
				$tmpl = $template;
				$path = $tmpl_path;
			} else {
				$tmpl = 'common';
				$path = FWMG_COMPONENT_SITE.'/layouts/';
			}
		} else {
			if (is_file($tmpl_path.$template.'/'.$layout_path.'/'.$filename)) {
				$tmpl = $template;
				$path = $tmpl_path;
			}
		}
		if ($app->input->getCmd('format', 'html') == 'html') {
			fwgHelper::loadSiteStyles();
			if (file_exists($path.$tmpl.'/assets/css/fwmg-design-styles.css') and !defined('FWMG_SITE_PLUGIN_DESIGN_LOADED')) {
				define('FWMG_SITE_PLUGIN_DESIGN_LOADED', true);
				HTMLHelper::stylesheet('plugins/fwgallerytmpl/'.$tmpl.'/assets/css/fwmg-design-styles.css', array('version'=>'v=100'));
			}
		}

		/* if requested file exists in global template, use it */
		$j_path = JPATH_SITE.'/templates/'.$app->getTemplate().'/html/layouts/fwgallery/';
		if (file_exists($j_path.$tmpl.'/'.$layout_path.'/'.$filename)) {
			$path = $j_path;
		}

		$full_path = $path.$tmpl.'/'.$layout_path.'/'.$filename;
		$tmpl_found = file_exists($full_path);
		if (!$tmpl_found and $tmpl != 'common') {
            $full_path = FWMG_COMPONENT_SITE.'/layouts/common/'.$layout_path.'/'.$filename;
			$tmpl_found = file_exists($full_path);
		}
		if ($tmpl_found) {
			ob_start();
			include($full_path);
			return ob_get_clean();
		} elseif ($tmpl == 'common') {
			return '<div class="fwk-alert fwk-alert-danger">'.Text::_('FWMG_DESING_ADDON_NOT_CONFIGURED').'</div><!-- layout '.$layout.' not found -->';
		} else {
			return 'template '.$tmpl.', layout '.$layout.' not found';
		}
    }
	static function getTmplOverridesPath() {
		$global_tmpl = Factory::getApplication()->getTemplate(true)->template;
		$template = ComponentHelper::getParams('com_gallery')->get('template');
		$path = JPATH_THEMES.'/'.$global_tmpl.'/html/com_gallery/layouts/'.$template;
		if (file_exists($path)) {
			return $path;
		}
	}
	static function loadUsers() {
        static $users;
        if (!is_array($users)) {
            $db = Factory::getDBO();
            $db->setQuery('SELECT u.id, u.name FROM `#__users` AS u ORDER BY u.name');
            $users =(array)$db->loadObjectList();
        }
        return $users;
    }
	static function loadviewlevels() {
        static $viewlevels;
        if (!is_array($viewlevels)) {
            $db = Factory::getDBO();
			$db->setQuery('
SELECT
	id,
	title AS name
FROM
	`#__viewlevels`
ORDER BY
	ordering');
			$viewlevels = $db->loadObjectList();
        }
        return $viewlevels;
    }
    static function loadPlugins() {
        static $plugins;
        if (!is_array($plugins)) {
			$plugins = array();

            $db = Factory::getDBO();
            $db->setQuery('
SELECT
    `element`,
    `enabled`,
	`folder`
FROM
    `#__extensions`
WHERE
    `type` = \'plugin\'
    AND
    `folder` IN (\'fwgallery\', \'fwgallerytype\', \'fwgallerytmpl\')');
            if ($data = $db->loadObjectList()) {
				foreach ($data as $row) {
					if (!isset($plugins[$row->folder])) {
						$plugins[$row->folder] = array();
					}
					$plugins[$row->folder][$row->element] = $row;
				}
			}
        }
        return $plugins;
    }
    static function pluginInstalled($name, $type = 'fwgallery') {
        $plugins = fwgHelper::loadPlugins();
        return isset($plugins[$type][$name]);
    }
    static function pluginEnabled($name, $type = 'fwgallery') {
        $plugins = fwgHelper::loadPlugins();
        if (!empty($plugins[$type][$name])) {
            return $plugins[$type][$name]->enabled;
        }
    }
    static function getWatermarkFilename() {
        $params = ComponentHelper::getParams('com_fwgallery');
        if ($watermark = $params->get('watermark_file')) {
            if (file_exists(FWMG_STORAGE_PATH.$watermark)) {
                return FWMG_STORAGE.$watermark;
            }
        }
    }
	static function checkLink($link) {
		$app = Factory::getApplication();
		if ($app->getCfg('sef') and !$app->getCfg('sef_rewrite') and strpos($link, 'index.php') === false) {
			$root = Uri::root(false);
			if (strpos($link, $root) !== false) {
				$link = str_replace($root, $root.'index.php/', $link);
			} else {
				$link = '/index.php'.$link;
			}
		}
		return $link;
	}
	static function pluginDisabledViaMenu($plugin) {
	    $app = Factory::getApplication();
	    if ($app->isClient('site')) {
    		$params = $app->getParams();
			if ($params->get('show_addons_menu_settings')) {
				$disabled_addons = $params->get('plugins', array($plugin=>1));
				return empty($disabled_addons[$plugin]);
			}
	    }
	}
	static function escPluginsOutput($plugins_output) {
		static $tags = null;
		if (false and function_exists('wp_kses')) {
			if (is_null($tags)) {
				$tags = wp_kses_allowed_html();
				$tags['h1'] = array('class'=>1, 'id'=>1, 'data-title'=>1, 'data-toggle'=>1, 'itemprop'=>1);
				$tags['form'] = array('class'=>1, 'id'=>1, 'name'=>1, 'action'=>1);
				$tags['input'] = array('id'=>1, 'class'=>1, 'type'=>1, 'name'=>1, 'value'=>1);
				$tags['textarea'] = array('id'=>1, 'class'=>1, 'cols'=>1, 'rows'=>1, 'style'=>1, 'name'=>1, 'value'=>1);
				$tags['select'] = array('id'=>1, 'class'=>1, 'type'=>1, 'name'=>1, 'data-toggle'=>1, 'data-title'=>1);
				$tags['button'] = array('id'=>1, 'class'=>1, 'type'=>1, 'name'=>1, 'data-toggle'=>1, 'data-title'=>1, 'data-dismiss'=>1, 'data-bs-dismiss'=>1, 'data-filter'=>1, 'data-value'=>1, 'data-active-class'=>1);
				$tags['iframe'] = array('id'=>1, 'class'=>1, 'src'=>1, 'name'=>1, 'frameborder'=>1, 'allow'=>1, 'webkitallowfullscreen'=>1, 'mozallowfullscreen'=>1, 'allowfullscreen'=>1, 'allowautoplay'=>1);
				$tags['i'] = array('class'=>1, 'id'=>1);
				$tags['span'] = array('class'=>1, 'id'=>1);
				$tags['div'] = array('id'=>1, 'class'=>1, 'data-toggle'=>1, 'data-target'=>1);
				$tags['p'] = array('id'=>1, 'class'=>1);
				$tags['label'] = array('id'=>1, 'class'=>1);
				$tags['script'] = array();
				$tags['option'] = array('value'=>1);
				$tags['video'] = array('poster', 'preload', 'controls', 'height', 'width', 'class', 'id', 'data-setup');
				$tags['source'] = array('src', 'type');

				$tags['a'] = array('class'=>1, 'id'=>1, 'href'=>1, 'data-layout'=>1, 'data-target'=>1, 'data-selector'=>1, 'data-items-per-page'=>1, 'data-total'=>1, 'data-order'=>1, 'data-tmpl'=>1);
			}
			return str_replace('&amp;&amp;', '&&', wp_kses($plugins_output, $tags));
		} else return $plugins_output;
	}
}

if (!function_exists('apache_request_headers')) {
    function apache_request_headers() {
        $arh = array();
        $rx_http = '/\AHTTP_/';
        foreach ($_SERVER as $key => $val) {
            if (preg_match($rx_http, $key)) {
                $arh_key = preg_replace($rx_http, '', $key);
                $rx_matches = array();
                // do some nasty string manipulations to restore the original letter case
                // this should work in most cases
                $rx_matches = explode('_', $arh_key);
                if (count($rx_matches) > 0 and strlen($arh_key) > 2) {
                    foreach ($rx_matches as $ak_key => $ak_val) $rx_matches[$ak_key] = ucfirst($ak_val);
                    $arh_key = implode('-', $rx_matches);
                }
                $arh[$arh_key] = $val;
            }
        }
        return($arh);
    }
}
if(!function_exists('mime_content_type')) {
    function mime_content_type($filename) {
        $mime_types = array(
            'txt' => 'text/plain',
            'htm' => 'text/html',
            'html' => 'text/html',
            'php' => 'text/html',
            'css' => 'text/css',
            'js' => 'application/javascript',
            'json' => 'application/json',
            'xml' => 'application/xml',
            'swf' => 'application/x-shockwave-flash',
            'flv' => 'video/x-flv',

            // images
            'png' => 'image/png',
            'jpe' => 'image/jpeg',
            'jpeg' => 'image/jpeg',
            'jpg' => 'image/jpeg',
            'gif' => 'image/gif',
            'bmp' => 'image/bmp',
            'ico' => 'image/vnd.microsoft.icon',
            'tiff' => 'image/tiff',
            'tif' => 'image/tiff',
            'svg' => 'image/svg+xml',
            'svgz' => 'image/svg+xml',

            // archives
            'zip' => 'application/zip',
            'rar' => 'application/x-rar-compressed',
            'exe' => 'application/x-msdownload',
            'msi' => 'application/x-msdownload',
            'cab' => 'application/vnd.ms-cab-compressed',

            // audio/video
            'mp3' => 'audio/mpeg',
            'qt' => 'video/quicktime',
            'mov' => 'video/quicktime',

            // adobe
            'pdf' => 'application/pdf',
            'psd' => 'image/vnd.adobe.photoshop',
            'ai' => 'application/postscript',
            'eps' => 'application/postscript',
            'ps' => 'application/postscript',

            // ms office
            'doc' => 'application/msword',
            'rtf' => 'application/rtf',
            'xls' => 'application/vnd.ms-excel',
            'ppt' => 'application/vnd.ms-powerpoint',

            // open office
            'odt' => 'application/vnd.oasis.opendocument.text',
            'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
        );

        $ext = strtolower(File::getExt($filename));
        if (array_key_exists($ext, $mime_types)) {
            return $mime_types[$ext];
        }
        elseif (function_exists('finfo_open')) {
            $finfo = finfo_open(FILEINFO_MIME);
            $mimetype = finfo_file($finfo, $filename);
            finfo_close($finfo);
            return $mimetype;
        }
        else {
            return 'application/octet-stream';
        }
    }
}

if (!function_exists('esc_attr')) {
	function esc_attr($text) {
		return htmlspecialchars((string)$text);
	}
}
if (!function_exists('esc_html')) {
	function esc_html($text) {
		return $text;
	}
}
if (!function_exists('esc_js')) {
	function esc_js($text) {
		return addcslashes((string)$text, "'");
	}
}
if (!function_exists('esc_textarea')) {
	function esc_textarea($text) {
		return htmlspecialchars((string)$text, ENT_QUOTES);
	}
}
if (!function_exists('esc_url')) {
	function esc_url($text) {
		return urlencode((string)$text);
	}
}
if (!function_exists('esc_url_raw')) {
	function esc_url_raw($text) {
		return $text?rawurlencode($text):'';
	}
}
