<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/
/** @var Type $displayData */

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Filter\OutputFilter;

$view = $displayData['view'];
$params = $view->params;
$displayData['row'] = $row = $view->item;
$displayData['link'] = Uri::getInstance()->toString();

if ($params->get('show_back_link', 1)) {
    $id = $name = null;
    if ($view->category) {
        $id = $view->category->id;
        $name = $view->category->name;
    } else {
        $id = $row->category_id;
        $name = $row->_category_name;
    }
    if ($id) {
        $link = 'index.php?option=com_fwgallery&view=fwgallery&id='.$id.':'.OutputFilter::stringURLSafe($name).'&Itemid='.$view->app->input->getInt('Itemid');
        $view->app->triggerEvent('onaddCategoryLinkParameters', array('com_fwgallery', &$link));
?>
	<div class="fwmg-file-gallery-name">
		<span fwk-icon="folder"></span>
		<a href="<?php echo fwgHelper::route($link); ?>">
			<?php echo esc_html($name); ?>
		</a>
	</div>
<?php
    }
}
if ($params->get('show_file_update', 1)) {
?>
            <div class="fwmg-file-date">
                <span fwk-icon="calendar"></span> <?php echo fwgHelper::encodeDate($row->updated); ?>
            </div>
<?php
}
if ($params->get('show_file_owner', 1)) {
?>
            <div class="fwmg-file-owner">
                <span fwk-icon="user"></span> <?php echo esc_html($row->_user_name); ?>
            </div>
<?php
}
if ($params->get('show_file_description', 1)) {
?>
            <div class="fwmg-file-description"><?php echo fwgHelper::escPluginsOutput($row->descr); ?></div>
<?php
}

$view->app->triggerEvent('onshowFileExtraFields', array('com_fwgallery', $displayData));

$show_download = ($view->params->get('show_file_download', 1) and ($access = $view->params->get('download_access', 1) and in_array($access, $view->user->getAuthorisedViewLevels())) and fwgHelper::fileDownloadable($row));
if ($show_download) {
?>
            <div class="fwmg-file-download">
                <a class="fwk-button fwk-button-lg fwk-button-primary" href="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=item&format=raw&layout=download&id='.$row->id)); ?>">
					<?php echo fwgHelper::jtext('FWMG_DOWNLOAD'); ?><span fwk-icon="chevron-right"></span>
                </a>
<?php
}
if ($params->get('show_file_info', 1)) {
    $file_info = '';
    $view->app->triggerEvent('ongetFileInfo', array('com_fwgallery', $row, $view, &$file_info));
?>
				<div class="fwmg-file-download-details">
<?php
    if ($file_info) {
        echo fwgHelper::escPluginsOutput($file_info);
    } else {
?>
					<span fwk-icon="expand-arrows" class="fwk-margin-small-right"></span> <?php echo (int)$row->_width; ?> * <?php echo (int)$row->_height; ?>px
					<span fwk-icon="database" class="fwk-margin-left fwk-margin-small-right"></i> <?php echo fwgHelper::humanFileSize($row->_size); ?>
<?php
    }
?>
				</div>
<?php
}
//echo 'access: "'.$view->params->get('download_access').'"';
if ($show_download) {
?>
            </div>
<?php
}
if (ComponentHelper::getParams('com_fwgallery')->get('comments_type')) {
	echo fwgHelper::loadTemplate('item.comments', $displayData);
}
