<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Uri\Uri;

$view = $displayData['view'];
$pagination_type = $view->params->get('gallery_pagination_type', 'standard');
$show_ordering = $view->params->get('show_gallery_ordering', 0);
$show_limit = $view->params->get('show_gallery_limit', 0);
$opts = null;
if ($show_limit) {
	$opts = fwgHelper::getLimitOptions(
		$view->params->get('gallery_columns', 4),
		$view->params->get('gallery_rows', 4),
		'standard',
		$view->subcategoriesPagination->limit,
		$view->subcategoriesPagination->total
	);
	$show_limit = (bool)$opts;
}
?>
<div class="fwmg-galleries-footer">
    <div class="fwk-grid-small"<?php if ($show_limit or $show_ordering) { ?> fwk-grid<?php } ?>>
		<div class="fwmg-galleries-footer-pagination fwk-text-center@s fwk-text-left@m<?php if ($show_limit or $show_ordering) { ?> fwk-width-3-4@m<?php } ?>">
<?php
if ($pagination_type and $view->subcategoriesPagination->total > $view->subcategoriesPagination->limit) {
	if ($pagination_type != 'ajax') {
?>
			<?php echo $view->getPaginationLinks($view->subcategoriesPagination, array('showLimitBox'=>false, 'showLimitStart'=>false)); ?>
<?php
	} else {
		echo fwgHelper::loadTemplate('listing.pagination_scripts', $displayData);
?>
			<div class="fwmg-more-block">
				<a href="javascript:" class="fwk-margin-left" data-layout="categories" data-target=".fwmg-galleries .fwmg-grid-container:last-child" data-selector=".fwmg-grid-item" data-items-per-page="<?php echo (int)$view->subcategoriesPagination->limit; ?>" data-total="<?php echo (int)$view->subcategoriesPagination->total; ?>" data-order="<?php echo esc_attr($view->subcategories_order); ?>" data-tmpl="<?php echo esc_attr($view->params->get('template', 'common')); ?>"><span fwk-icon="download"></span> <?php echo fwgHelper::jtext('FWMG_LOAD'); ?> <span></span> <?php echo fwgHelper::jtext('FWMG_MORE'); ?></a>
				<span class="fwmg-gf-counter"><span><?php echo count($view->subcategories); ?></span> <?php echo fwgHelper::jtext('FWMG_OF'); ?> <?php echo (int)$view->subcategoriesPagination->total; ?></span>
				<div fwk-spinner style="display:none;"></div>
			</div>
<?php
	}
}
?>
        </div>
<?php
if ($show_ordering or $show_limit) {
?>
        <div class="fwmg-galleries-filters fwk-text-center@s fwk-text-right@m fwk-width-1-4@m">
            <form action="<?php echo Uri::getInstance()->toString(); ?>" method="post">
<?php
	if ($show_ordering) {
?>
    			<div class="fwk-button-group">
    				<?php echo HTMLHelper::_('select.genericlist', array(
    					HTMLHelper::_('select.option', 'ordering', fwgHelper::jtext('FWMG_ORDERING'), 'id', 'name'),
    					HTMLHelper::_('select.option', 'new', fwgHelper::jtext('FWMG_NEWEST_FIRST'), 'id', 'name'),
    					HTMLHelper::_('select.option', 'old', fwgHelper::jtext('FWMG_OLDEST_FIRST'), 'id', 'name'),
    					HTMLHelper::_('select.option', 'alpha', fwgHelper::jtext('FWMG_ALPHABETICALLY'), 'id', 'name'),
    				), 'subcategories_order', 'class="fwk-select" onchange="this.form.submit();"', 'id', 'name', $view->subcategories_order); ?>
    			</div>
<?php
	}
	if ($show_limit) {
?>
                <div class="fwk-button-group fwk-margin-small-left">
                    <?php echo HTMLHelper::_('select.genericlist', $opts, 'subcategorieslimit', 'class="fwk-select" fwk-tooltip="'.htmlspecialchars(fwgHelper::jtext('FWMG_LIMIT')).'" onchange="this.form.submit();"', 'id', 'name', $view->subcategoriesPagination->limit); ?>
                </div>
<?php
	}
?>
            </form>
		</div>
<?php
}
?>
    </div>
</div>
