<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

$view = $displayData['view'];
$row = $displayData['row'];
$link = $displayData['link'];

if ($view->params->get('show_gallery_item_name', 1)) {
?>
<div class="fwmg-grid-item-name">
    <a href="<?php echo $link; ?>" title="<?php echo esc_attr($row->name); ?>">
        <?php echo esc_html($row->name); ?></a>
</div>
<?php
}
if ($view->params->get('show_gallery_item_counter', 1)) {
?>
<div class="fwmg-grid-item-stats">
<?php
    if ($row->_qty) {
?>
    <span class="fwmg-grid-item-stats-galleries">
        <span fwk-icon="folder"></span> <?php echo (int)$row->_qty; ?>
    </span>
<?php
    }
    if ($row->_images_qty) {
?>
    <span class="fwmg-grid-item-stats-images">
        <span fwk-icon="image"></span> <?php echo (int)$row->_images_qty; ?>
    </span>
<?php
    }
?>
    <?php echo fwgHelper::escPluginsOutput(implode('', $view->app->triggerEvent('ongetCategoryListExtraCounters', array('com_fwgallery', $row)))); ?>
</div>
<?php
}

if ($view->params->get('show_gallery_item_update_date', 1)) {
?>
<div class="fwmg-grid-item-update"><span fwk-icon="calendar"></span> <?php echo fwgHelper::encodeDate($row->updated); ?></div>
<?php
}
?>
<?php
if ($view->params->get('show_gallery_item_owner', 1)) {
?>
<div class="fwmg-grid-item-owner"><span fwk-icon="user"></span> <?php echo esc_html($row->_user_name); ?></div>
<?php
}

if ($view->params->get('show_gallery_item_description', 1)) {
?>
<div class="fwmg-grid-item-description"><?php echo fwgHelper::stripTags($row->descr, $view->params->get('description_length', 20)); ?></div>
<?php
}

$view->app->triggerEvent('onshowCategoriesListingExtraFields', array('com_fwgallery', $displayData));
