<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Uri\Uri;

$view = $displayData['view'];
$pagination_type = $view->params->get('files_pagination_type', 'standard');
$show_ordering = $view->params->get('show_files_ordering', 0);
$show_limit = $view->params->get('show_files_limit', 0);
$opts = null;
if ($show_limit) {
	$opts = fwgHelper::getLimitOptions(
		$view->params->get('files_columns', 4),
		$view->params->get('files_rows', 4),
		$view->params->get('files_grid', 'standard'),
		$view->filesPagination->limit,
		$view->filesPagination->total
	);
	$show_limit = (bool)$opts;
}
?>
<div class="fwmg-files-footer">
    <div class="fwk-grid-small"<?php if ($show_limit or $show_ordering) { ?> fwk-grid<?php } ?>>
        <div class="fwmg-files-pagination fwk-text-center@s fwk-text-left@m<?php if ($show_limit or $show_ordering) { ?> fwk-width-3-4@m<?php } ?>">
<?php
if ($pagination_type and $view->filesPagination->total > $view->filesPagination->limit) {
	if ($pagination_type != 'ajax') {
?>
            <?php echo $view->getPaginationLinks($view->filesPagination, array('showLimitBox'=>false, 'showLimitStart'=>false)); ?>
<?php
	} else {
		echo fwgHelper::loadTemplate('listing.pagination_scripts', $displayData);
?>
			<div class="fwmg-more-block">
				<a href="javascript:" class="fwk-margin-left" data-layout="files" data-target=".fwmg-files .fwmg-grid-container:last-child" data-selector=".fwmg-grid-item" data-items-per-page="<?php echo (int)$view->filesPagination->limit; ?>" data-total="<?php echo (int)$view->filesPagination->total; ?>" data-order="<?php echo esc_attr($view->files_order); ?>" data-gids="<?php echo esc_attr(implode(',', (array)$view->params->get('gids'))); ?>" data-tmpl="<?php echo esc_attr($view->params->get('template')); ?>"><span fwk-icon="download"></span> <?php echo fwgHelper::jtext('FWMG_LOAD'); ?> <span></span> <?php echo fwgHelper::jtext('FWMG_MORE'); ?></a>
				<span class="fwmg-gf-counter"><span><?php echo count($view->files); ?></span> <?php echo fwgHelper::jtext('FWMG_OF'); ?> <?php echo (int)$view->filesPagination->total; ?></span>
				<div fwk-spinner style="display:none;"></div>
			</div>
<?php
	}
}
?>
        </div>
<?php
if ($show_ordering or $show_limit) {
?>
        <div class="fwmg-files-filters fwk-text-center@s fwk-text-right@m fwk-width-1-4@m">
            <form action="<?php echo Uri::getInstance()->toString(); ?>" method="post">
<?php
    if ($show_ordering) {
?>
    			<div class="fwk-button-group">
    				<?php echo HTMLHelper::_('select.genericlist', array(
    					HTMLHelper::_('select.option', 'ordering', fwgHelper::jtext('FWMG_ORDERING'), 'id', 'name'),
    					HTMLHelper::_('select.option', 'new', fwgHelper::jtext('FWMG_NEWEST_FIRST'), 'id', 'name'),
    					HTMLHelper::_('select.option', 'old', fwgHelper::jtext('FWMG_OLDEST_FIRST'), 'id', 'name'),
    					HTMLHelper::_('select.option', 'alpha', fwgHelper::jtext('FWMG_ALPHABETICALLY'), 'id', 'name'),
    				), 'files_order', 'class="fwk-select" onchange="this.form.submit();"', 'id', 'name', $view->files_order); ?>
    			</div>
<?php
    }
    if ($show_limit) {
?>
                <div class="fwk-button-group fwk-margin-small-left">
                    <?php echo HTMLHelper::_('select.genericlist', $opts, 'fileslimit', 'class="fwk-select" fwk-tooltip="'.htmlspecialchars(fwgHelper::jtext('FWMG_LIMIT')).'" onchange="this.form.submit();"', 'id', 'name', $view->filesPagination->limit); ?>
                </div>
<?php
    }
?>
            </form>
        </div>
<?php
}
?>
    </div>
</div>
