<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\Registry\Registry;

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/lightgallery.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/lightgallery.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-fullscreen.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-zoom.min.js');

$view = $displayData['view'];

$params = $view->params;
$active_menu = $view->app->getMenu()->getActive();
$menu_params = $active_menu?$active_menu->getParams():new Registry();

$view->_cat_width = $params->get('image_width_cover', 300);
$view->_cat_height = $params->get('image_height_cover', 300);
$view->_img_width = $params->get('image_width_listing', 300);
$view->_img_height = $params->get('image_height_listing', 300);

$classes = array();
$cat_ratio = round(100*$view->_cat_height/$view->_cat_width);
$img_ratio = round(100*$view->_img_height/$view->_img_width);
if ($cat_ratio != 75) {
	$classes[] = '#fwgallery .fwmg-galleries .fwmg-grid-item-image-wrapper::before {padding-top: '.$cat_ratio.'%!important;}';
}
if ($img_ratio != 75) {
	$classes[] = '#fwgallery .fwmg-files .fwmg-grid-item-image-wrapper::before {padding-top: '.$img_ratio.'%!important;}';
}
if ($classes) {
?>
<style type="text/css">
<?php echo implode("\n", $classes); ?>
</style>
<?php
}
if ($menu_params->get('show_page_heading', 1)) {
?>
<h1><?php echo $menu_params->get('page_heading', $menu_params->get('page_title')); ?></h1>
<?php
}
if ($view->files) {
    $buff = array();
    foreach ($view->files as $file) {
        if (!isset($buff[$file->category_id])) {
            $buff[$file->category_id] = array();
        }
        $buff[$file->category_id][] = $file;
    }
	$num = 0;
    foreach ($buff as $category_id=>$files) {
		$view->category = null;
		$descr_right = false;
        if ($view->subcategories) {
            foreach ($view->subcategories as $category) {
                if ($category->id == $category_id) {
					$view->category = $category;
					break;
                }
            }
        }
        $view->files = $files;
		if ($view->category) {
			$view->params = new fwgParams($view->category->params, fwgHelper::getParentGalleries($view->category->parent));
			$view->params->set('show_files_ordering', false);
			$view->params->set('show_files_limit', false);

			$view->open_as_popup = ($view->params->get('file_open_as') == 'popup');
			if (!$view->open_as_popup) {
				$view->app->triggerEvent('onCheckFileOpenAsPopup', array('com_fwgallery', &$view->open_as_popup, $view));
			}
?>
			<div id="fwgallery" class="fwk-scope fwmg-design-<?php echo esc_attr($view->params->get('template')); ?>">
<?php
			echo fwgHelper::loadTemplate('listing.top_category', $displayData);

			if (!$num) {
				if ($params->get('show_gallery_breadcrumbs', 1) and $view->path) {
?>
<div class="fwmg-gallery-path">
	<span fwk-icon="folder"></span>
<?php
if ($view->path) {
	foreach ($view->path as $i => $step) {
		if ($i) {
			?> &gt; <?php
		}
		?><a href="<?php echo $step->link; ?>"><?php echo esc_html($step->name); ?></a><?php
	}
}
?>
</div>
<?php
				}
			}

			$descr_right = ($params->get('gallery_descr_position', 'top') != 'top' and !empty($view->category->descr) and $params->get('show_gallery_description', 1));

			if ($descr_right) {
?>
	<div fwk-grid>
		<div class="fwk-width-3-4@m">
<?php
			}
		}
        echo fwgHelper::loadTemplate('listing.files', $displayData);
		if ($view->category) {
			if ($descr_right) {
?>
		</div>
		<div class="fwk-width-1-4@m">
			<?php echo fwgHelper::escPluginsOutput($view->category->descr); ?>
		</div>
	</div>
<?php
			}
?>
	</div>
<?php
			$view->app->triggerEvent('onshowListingGoogleData', array('com_fwgallery', $view));
		}
		$num++;
    }
}
if (!empty($view->open_as_popup)) {
?>
<div id="fwmg-one-file" class="fwk-modal-container" fwk-modal>
	<div class="fwk-modal-dialog modal-huge" role="document">
		<div class="fwk-modal-header">
			<h5 class="fwk-modal-title"></h5>
			<button class="fwk-modal-close-default" type="button" fwk-close></button>
		</div>
		<div class="fwk-modal-body"></div>
	</div>
</div>
<?php
}
