<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\Registry\Registry;

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/lightgallery.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/lightgallery.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-fullscreen.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-zoom.min.js');

$view = $displayData['view'];

$params = $view->params;
$active_menu = $view->app->getMenu()->getActive();
$menu_params = $active_menu?$active_menu->getParams():new Registry();

$view->_cat_width = $params->get('image_width_cover', 300);
$view->_cat_height = $params->get('image_height_cover', 300);
$view->_img_width = $params->get('image_width_listing', 300);
$view->_img_height = $params->get('image_height_listing', 300);

$classes = array();
$cat_ratio = round(100*$view->_cat_height/$view->_cat_width);
$img_ratio = round(100*$view->_img_height/$view->_img_width);
if ($cat_ratio != 75) {
	$classes[] = '#fwgallery .fwmg-galleries .fwmg-grid-item-image-wrapper::before {padding-top: '.$cat_ratio.'%!important;}';
}
if ($img_ratio != 75) {
	$classes[] = '#fwgallery .fwmg-files .fwmg-grid-item-image-wrapper::before {padding-top: '.$img_ratio.'%!important;}';
}
if ($classes) {
?>
<style type="text/css">
<?php echo implode("\n", $classes); ?>
</style>
<?php
}
if ($menu_params->get('show_page_heading', 1)) {
?>
<h1><?php echo $menu_params->get('page_heading', $menu_params->get('page_title')); ?></h1>
<?php
}
$all_cats = array();
?>
<div id="fwgallery" class="fwcss fwk-scope">
    <div class="fwmg-top-categories">
<?php
if ($view->subcategories) {
	foreach ($view->subcategories as $cat) {
?>
        <button type="button" class="fwk-button fwk-button-secondary" data-filter="<?php echo esc_attr($cat->id); ?>"><?php echo esc_html($cat->name); ?></button>
<?php
/** @todo show subcategories buttons as well */
        $all_cats[] = $cat;
	}
	$view->subcategories = null;
}
?>
    </div>
    <div class="fwmg-cascading-grid-files">
    </div>
</div>
<script>
var cats = [];
<?php
foreach ($all_cats as $cat) {
	?>cats.push({id:<?php echo (int)$cat->id; ?>,name:'<?php echo esc_js(preg_replace('#[^a-z0-9]#', '-', strtolower($cat->name))); ?>'});<?php
}
?>

document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$('.fwmg-top-categories button').click(function(ev) {
		ev.preventDefault();
		$('.fwmg-top-categories button').removeClass('active');
		var $btn = $(this).addClass('active');
		var filter = $btn.data('filter');

		var $list = $('.fwmg-cascading-grid-files');

		if (filter == 'all') {
			window.location.hash = '';
		} else if (isNaN(filter)) {
			window.location.hash = '#'+filter;
		} else {
			for (var i = 0; i < cats.length; i++) {
				if (cats[i].id == filter) {
					window.location.hash = '#'+cats[i].name;
					break;
				}
			}
		}
		$list.html('<div fwk-spinner="ratio: 3"></div>').load('<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=fwgallery&format=raw&Itemid=0', false); ?>', {
			id: filter,
			layout: 'load_files'
		});
	});

	var menu_clicked = false;
	var hash = window.location.hash.toString().replace('#', '');
	if (hash != '') {
		var $btn = $('.fwmg-top-categories button[data-filter="'+hash+'"]');
		if ($btn.length) {
			menu_clicked = true;
			$btn.click();
		} else {
			for (var i = 0; i < cats.length; i++) {
				if (cats[i].name == hash) {
					menu_clicked = true;
					$('.fwmg-top-categories button[data-filter="'+cats[i].id+'"]').click();
					break;
				}
			}
		}
	}
	if (!menu_clicked) {
		$('.fwmg-top-categories button:first').click();
	}
	})(jQuery);
});
</script>
