<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/lightgallery.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/lightgallery.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-fullscreen.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-zoom.min.js');

$view = $displayData['view'];

$params = $view->params;
$descr_right = ($params->get('gallery_descr_position', 'top') != 'top' and !empty($view->category->descr) and $params->get('show_gallery_description', 1));

$view->_cat_width = $params->get('image_width_cover', 300);
$view->_cat_height = $params->get('image_height_cover', 300);
$view->_img_width = $params->get('image_width_listing', 300);
$view->_img_height = $params->get('image_height_listing', 300);

$classes = array();
$cat_ratio = round(100*$view->_cat_height/$view->_cat_width);
$img_ratio = round(100*$view->_img_height/$view->_img_width);
if ($cat_ratio != 75) {
	$classes[] = '#fwgallery .fwmg-galleries .fwmg-grid-item-image-wrapper::before {padding-top: '.$cat_ratio.'%!important;}';
}
if ($img_ratio != 75) {
	$classes[] = '#fwgallery .fwmg-files .fwmg-grid-item-image-wrapper::before {padding-top: '.$img_ratio.'%!important;}';
}
if ($classes) {
?>
<style type="text/css">
<?php echo implode("\n", $classes); ?>
</style>
<?php
}
if ($params->get('show_page_heading', 0)) {
?>
<h1 data-title="<?php echo esc_attr($params->get('page_heading', $params->get('page_title'))); ?>"><?php echo $params->get('page_heading', $params->get('page_title')); ?></h1>
<?php
}
?>
<div id="fwgallery" class="fwcss fwk-scope fwmg-design-<?php echo esc_attr($params->get('template', 'common')); ?>">
<?php
if ($view->category->name and $params->get('show_category_info', 1)) {
    echo fwgHelper::loadTemplate('listing.top_category', $displayData);
}
if ($params->get('show_gallery_breadcrumbs', 1) and $view->path) {
?>
<div class="fwmg-gallery-path">
	<span fwk-icon="folder"></span>
<?php
if ($view->path) {
	foreach ($view->path as $i => $step) {
		if ($i) {
			?> &gt; <?php
		}
		?><a href="<?php echo fwgHelper::route($step->link); ?>"><?php echo esc_html($step->name); ?></a><?php
	}
}
?>
</div>
<?php
}
if ($descr_right) {
?>
	<div fwk-grid>
		<div class="fwk-width-3-4@m">
<?php
}
$view->app->triggerEvent('onshowListingTopInfo', array('com_fwgallery', $view));
if ($view->subcategories) {
    echo fwgHelper::loadTemplate('listing.categories', $displayData);
}
if ($view->files) {
    echo fwgHelper::loadTemplate('listing.files', $displayData);
}
if ($descr_right) {
?>
		</div>
		<div class="fwk-width-1-4@m">
			<?php echo fwgHelper::escPluginsOutput($view->category->descr); ?>
		</div>
	</div>
<?php
}
if (!empty($view->open_as_popup)) {
?>
    <div id="fwmg-one-file" class="fwk-modal-container" fwk-modal>
        <div class="fwk-modal-dialog" role="document">
			<div class="fwk-modal-header">
				<h5 class="fwk-modal-title"></h5>
				<button class="fwk-modal-close-default" type="button" fwk-close></button>
			</div>
			<div class="fwk-modal-body"></div>
        </div>
    </div>
<?php
}
?>
</div>
<script>
var fwmg_alert_default_title = '<?php echo esc_js(fwgHelper::jtext('FWMG_NOTICE')); ?>';
</script>
<?php
$view->app->triggerEvent('onshowListingGoogleData', array('com_fwgallery', $view));
