<?php
/**
 * FWG Map Module 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\HTML\HTMLHelper;

$uri = Uri::getInstance();
HTMLHelper::script('https://maps.google.com/maps/api/js?key='.$params->get('google_map_key'));
HTMLHelper::script('components/com_fwgallery/assets/js/markerclusterer.js');

$id = rand();
?>
<div id="mod-fwmg-map-<?php echo $id; ?>" class="mod-fwmg-map" style="width:100%;height:<?php echo $height; ?>px;"></div>
<script type="text/javascript">
var map_<?php echo $id; ?>;
var info_<?php echo $id; ?>;
var markers_<?php echo $id; ?> = [];
document.addEventListener('DOMContentLoaded', function() {
	map_<?php echo $id; ?> = new google.maps.Map(document.getElementById('mod-fwmg-map-<?php echo $id; ?>'), {mapTypeId: google.maps.MapTypeId.ROADMAP, scrollwheel: false});

	var myoverlay = new google.maps.OverlayView();
	myoverlay.draw = function () {
		this.getPanes().markerLayer.id='fwmg-markers-layer';
	};
	myoverlay.setMap(map_<?php echo $id; ?>);

	var bounds = new google.maps.LatLngBounds();
<?php
foreach ($plist as $row) {
?>
	var myLatLng = new google.maps.LatLng(<?php echo $row->latitude; ?>, <?php echo $row->longitude; ?>);
	bounds.extend(myLatLng);
	map_<?php echo $id; ?>.initialZoom = true;
	map_<?php echo $id; ?>.fitBounds(bounds);

	var marker = new google.maps.Marker({
	      position: myLatLng,
	      title:'<?php echo addcslashes($row->name, "'"); ?>',
		  icon: '<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=fwgallery&layout=img&format=raw&id='.$row->id.'&w=80&h=60', false, -2); ?>',
		  link: '<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=fwgallery&id='.$row->id.':'.OutputFilter::stringURLSafe($row->name), false)); ?>',
		  labelClass: 'fwmg-icon-wrapper'
	});
	google.maps.event.addListener(marker, 'click', function() {
		window.location.href = this.link;
	});
	markers_<?php echo $id; ?>.push(marker);
<?php
}
foreach ($flist as $row) {
?>
	var myLatLng = new google.maps.LatLng(<?php echo $row->latitude; ?>, <?php echo $row->longitude; ?>);
	bounds.extend(myLatLng);
	map_<?php echo $id; ?>.initialZoom = true;
	map_<?php echo $id; ?>.fitBounds(bounds);

	var marker = new google.maps.Marker({
	      position: myLatLng,
	      title:'<?php echo addcslashes($row->name, "'"); ?>',
		  icon: '<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=item&layout=img&format=raw&id='.$row->id.'&w='.$params->get('th_width', 40).'&h='.$params->get('th_height', 30), false, -2); ?>',
		  link: '<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=item&id='.$row->id.':'.OutputFilter::stringURLSafe($row->name), false)); ?>',
		  labelClass: 'fwmg-icon-wrapper'
	});
	google.maps.event.addListener(marker, 'click', function() {
		window.location.href = this.link;
	});
	markers_<?php echo $id; ?>.push(marker);
<?php
}
?>
	var mcOptions = {gridSize: 50, maxZoom: 15};
	var mc = new MarkerClusterer(map_<?php echo $id; ?>, markers_<?php echo $id; ?>, mcOptions);

	google.maps.event.addListener(map_<?php echo $id; ?>, 'zoom_changed', function() {
	    zoomChangeBoundsListener =
	        google.maps.event.addListener(map_<?php echo $id; ?>, 'bounds_changed', function(event) {
	            if (this.getZoom() > 15 && this.initialZoom == true) {
	                this.setZoom(15);
	                this.initialZoom = false;
	            }
		        google.maps.event.removeListener(zoomChangeBoundsListener);
		    });
	});
	google.maps.event.addDomListener(window, "resize", function() {
		var center = map_<?php echo $id; ?>.getCenter();
		google.maps.event.trigger(map_<?php echo $id; ?>, "resize");
		map_<?php echo $id; ?>.setCenter(center);
	});
});
</script>
