<?php
/**
 * FW Gallery Slideshow 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Filter\OutputFilter;

HTMLHelper::stylesheet('modules/mod_fwg_slideshow/assets/css/layerslider.css');
HTMLHelper::stylesheet('components/com_fwgallery/assets/css/style.css');
HTMLHelper::stylesheet('components/com_fwgallery/assets/css/all.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('modules/mod_fwg_slideshow/assets/js/greensock.js');
HTMLHelper::script('modules/mod_fwg_slideshow/assets/js/layerslider.transitions.js');
HTMLHelper::script('modules/mod_fwg_slideshow/assets/js/layerslider.kreaturamedia.jquery.js');
?>
<div id="layerslider-singlework-thumbs" class="ls-fullheight ls-nobullets" style="width: 100%; height: <?php echo $height; ?>px;">
	<a class="big-gallery-link" href="#">
<?php
foreach ($list as $row) {
	$gal_link = fwgHelper::route('index.php?option=com_fwgallery&view=fwgallery&id='.$row->category_id.':'.OutputFilter::stringURLSafe($row->_category_name));
	$img_link = fwgHelper::route('index.php?option=com_fwgallery&view=item&id='.$row->id.':'.OutputFilter::stringURLSafe($row->name));
?>
		<div class="ls-slide" data-link="<?php echo $gal_link; ?>" data-image-link="<?php echo $img_link; ?>" data-title="<?php if ($params->get('display_title')) echo htmlspecialchars($row->name); ?>" data-descr="<?php if ($params->get('display_descr')) echo htmlspecialchars($row->descr); ?>" data-ls="slidedelay: 5000; <?php echo $effects; ?>">
			<img src="<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=item&layout=img&format=raw&w=1200&id='.$row->id); ?>" class="ls-bg" alt="background"/>
		</div>
<?php
}
?>
	</a>
<?php
if ($params->get('display_gallery_link')) {
?>
	<div class="ls-mental-back2gallery">
		<a href="#" aria-hidden="true" class="icon_grid-2x2"></a>
	</div>
<?php
}
if ($params->get('display_slideshow_button')) {
?>
	<div class="ls-mental-slideshow">
		<button class="icon_play"></button>
	</div>
<?php
}
if ($params->get('display_share') or $params->get('display_title') or $params->get('display_descr')) {
?>
	<div class="ls-mental-bottombar">
<?php
	if ($params->get('display_share')) {
?>
		<div class="mb-social">
		   <p><?php echo fwgHelper::jtext('FWMG_Share'); ?></p>
           <a target="_blank" href="https://twitter.com/intent/tweet?url=<?php echo $share_link; ?>&amp;text=<?php echo $share_name; ?>"><i class="fab fa-twitter"></i></a>
           <a target="_blank" href="https://www.facebook.com/sharer.php?u=<?php echo $share_link; ?>"><i class="fab fa-facebook"></i></a>
           <a target="_blank" href="https://plus.google.com/share?url=<?php echo $share_link; ?>"><i class="fab fa-google-plus"></i></a>
           <a target="_blank" href="https://pinterest.com/pin/create/bookmarklet/?url=<?php echo $share_link; ?>&amp;description=<?php echo $share_name; ?>"><i class="fab fa-pinterest"></i></a>
           <a target="_blank" href="https://www.tumblr.com/widgets/share/tool?canonicalUrl=<?php echo $share_link; ?>&amp;title=<?php echo $share_link; ?>"><i class="fab fa-tumblr"></i></a>
		</div>
<?php
	}
	if ($params->get('display_title') or $params->get('display_descr')) {
?>
		<div id="lsmb-title"></div>
<?php
	}
}
?>
	</div>
</div> <!-- layerslider -->
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    // Single Work with thumbnails
    $('#layerslider-singlework-thumbs').layerSlider({
		sublayerContainer : 1170,
		skin: 'mental',
		skinsPath: '<?php echo Uri::root(true); ?>/modules/mod_fwg_slideshow/assets/skins/',
		showBarTimer        : true,
		showCircleTimer     : false,
		pauseOnHover: false,
		autoStart: false,
		responsive: true,
		responsiveUnder: 960,
<?php
if ($params->get('display_preview')) {
?>
		thumbnailNavigation: 'always',
<?php
}
?>
		tnWidth: 170,
		tnHeight: 110,
		tnActiveOpacity: 100,
		tnInactiveOpacity: 65,
		tnContainerWidth: '80%',
		cbAnimStart: function(data){
			var $img = data.nextLayer;
			$('#lsmb-title').html('<a href="'+$img.data('image-link')+'">'+$img.data('title')+'</a><div class="lsmb-desc">'+$img.data('descr')+'</div>');
			$('.ls-mental-back2gallery a').attr('href', $img.data('link'));
			$('a.big-gallery-link').attr('href', $img.data('image-link'));
		}
    });
	$('button.icon_play').click(function() {
		var $butt = $(this);
		if ($butt.hasClass('icon_stop')) {
			$butt.removeClass('icon_stop');
			$('#layerslider-singlework-thumbs').layerSlider('stop');
		} else {
			$butt.addClass('icon_stop');
			$('#layerslider-singlework-thumbs').layerSlider('start');
		}
	});
<?php
if ($params->get('auto_run')) {
?>
	$('button.icon_play').click();
<?php
}
?>
	})(jQuery);
});
</script>
