<?php
/**
 * FW Gallery Carousel Module 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;

?>
<div id="fwmg-carousel-<?php echo $id; ?>">
    <carousel-3d :controls-visible="true" :autoplay="true" :autoplay-timeout="5000" :display="<?php echo $qty; ?>">
<?php
foreach ($list as $i=>$row) {
	$descr = '';
	if ($params->get('display_galleryname')) $descr = fwgHelper::jtext('FWMG_Gallery').': <a href="'.Route::_('index.php?option=com_fwgallery&view=gallery&id='.$row->category_id.':'.OutputFilter::stringURLSafe($row->_gallery_name)).'">'.$row->_gallery_name.'</a>';
	if ($params->get('display_username') and $row->_user_name) $descr .= ($descr?'<br/>':'').fwgHelper::jtext('FWMG_Author').': '.$row->_user_name;
	if ($params->get('display_imagename')) $descr .= ($descr?'<br/>':'').fwgHelper::jtext('FWMG_Image').': '.$row->name;
	if ($params->get('display_imagedate')) $descr .= ($descr?'<br/>':'').fwgHelper::jtext('FWMG_Date').': '.HTMLHelper::date($row->created);
	if ($params->get('display_imageviews')) $descr .= ($descr?'<br/>':'').fwgHelper::jtext('FWMG_Hits').': '.(int)$row->hits;
?>
        <slide :index="<?php echo $i; ?>">
            <figure>
                <?php if ($display_iconnew and $row->_is_new) { ?><span class="fwmg-icon-new"></span><?php } ?>
                <a href="<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=item&id='.$row->id.':'.OutputFilter::stringURLSafe($row->name).'&format=raw'); ?>" class="fwmg-modal">
                    <img src="<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=item&layout=img&id='.$row->id.'&w='.$width.'&h='.$height.'&format=raw'); ?>"  alt="<?php echo htmlspecialchars($row->name); ?>" />
                </a>
                <figcaption>
                    <?php echo $descr; ?>
                </figcaption>
            </figure>
        </slide>
<?php
}
?>
    </carousel-3d>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
    new Vue({
        el: '#fwmg-carousel-<?php echo $id; ?>',
        data: {
            slides: <?php echo count($list); ?>
        },
        components: {
            'carousel-3d': window['carousel-3d'].Carousel3d,
            'slide': window['carousel-3d'].Slide
        }
    });
});
</script>
