<?php

/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Uri\Uri;

HTMLHelper::_('behavior.core');

$view = $displayData['view'];
$exts = array('jpg', 'jpeg', 'png', 'gif');
Factory::getApplication()->triggerEvent('ongetAffordableExts', array('com_fwgallery', &$exts));
echo fwgHelper::loadTemplate('site.admin.messages', $displayData, FWMG_PLUGINS_PATH.'admin/layouts');
$max_size = $view->upload_max_filesize;
$post_size = $view->post_max_size;
?>
<div class="fwmg-management-header">
	<div class="fwmg-management-header-text">
		<?php echo fwgHelper::jtext('FWMG_HEADER_BATCH'); ?>
	</div>
</div>
<div id="fwmg-batch-upload">
	<form action="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=batch')); ?>" method="post" name="batchForm" id="batchForm" enctype="multipart/form-data" fwk-margin>
		<div class="fwk-flex">
			<label class="fwk-width-1-3@m">
				<?php echo fwgHelper::jtext('FWMG_Select_Destination_Gallery'); ?>:
			</label>
			<div class="fwk-width-2-3@m">
				<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'category', $view->category, 'class="fwk-select"', false, fwgHelper::jtext('FWMG_SELECT_CATEGORY')); ?>
				<?php /*echo HTMLHelper::_('select.genericlist', array_merge(array(
					HTMLHelper::_('select.option', '', '', 'id', 'treename')
				), $view->categories), 'category', 'class="required fwk-select"', 'id', 'treename', $view->category, 'fwmg-batch-category');*/ ?>
			</div>
		</div>
		<div class="fwk-flex">
			<label class="fwk-width-1-3@m">
				<?php echo fwgHelper::jtext('FWMG_UPLOAD_PUBLISHED'); ?>:
			</label>
			<div class="fwk-width-2-3@m">
				<?php echo HTMLHelper::_('fwView.radioGroup', 'published', 1, array(
					'wrapper_class' => 'fwk-width-expand',
					'buttons' => array(array(
						'active_class' => 'fwk-button-success',
						'title' => fwgHelper::jtext('JYES'),
						'value' => 1
					), array(
						'active_class' => 'fwk-button-danger',
						'title' => fwgHelper::jtext('JNO'),
						'value' => 0
					))
				)); ?>
			</div>
		</div>

		<?php echo fwgHelper::jtext('FWMG_DRAG_AND_DROP_IMAGES_TO_UPLOAD'); ?>:
		<div id="fwmg-batch-uploader"></div>
		<br />

		<div class="fwmg-batch-button">
			<a class="fwk-button fwk-button-success" href="javascript:" id="fwmg-save-button" onclick="batch_submitbutton('install');">
				<span title="<?php echo fwgHelper::jtext('FWMG_Upload'); ?>" fwk-icon="save"></span>
				<?php echo fwgHelper::jtext('FWMG_Upload'); ?>
			</a>
		</div>
		<input type="hidden" name="task" value="" />
	</form>
</div>
<script>
var fwmg_uploaded_files = [];
var fwmg_uploading_counter_success = fwmg_uploading_counter_error = 0;
var max_file_size = <?php echo (int)$max_size; ?>;
var max_post_size = <?php echo (int)$post_size; ?>

function fwmg_file_queue_upload(form, i = 0) {

	var $button = jQuery('#fwmg-save-button');
	var formdata = new FormData();
	formdata.append('published', form.published.value);
	formdata.append('category_id', form.category.value);

	formdata.append('group', 'fwgallery');
	formdata.append('plugin', 'admin');
	formdata.append('format', 'json');
	formdata.append('layout', 'batchupload');

	formdata.append('images[]', fwmg_uploaded_files[i]);

	jQuery.ajax({
		url: '<?php echo fwgHelper::route('index.php?option=com_ajax', false); ?>',
		type: 'post',
		dataType: 'json',
		processData: false,
		contentType: false,
		data: formdata
	}).done(function(data) {
		if (data.data && data.data[0]) {
			if (data.data[0].msgs && data.data[0].msgs.length) {
				for (var j = 0; j < data.data[0].msgs.length; j++) {
					fwmg_alert(data.data[0].msgs[j].msg);
				}
			}
		}
		jQuery('#fwmg-batch-uploader-drop-zone .fwmg-file-row:eq(' + i + ')').hide(300);
		if (fwmg_uploaded_files.length > i + 1) {
			fwmg_file_queue_upload(form, i + 1);
		} else {
			jQuery('#fwmg-batch-wait-img').remove();
			$button.attr('disabled', false);
			jQuery('#fwmg-batch-uploader-drop-zone .fwmg-file-row a').click();
/*				location = jQuery('#batchForm').attr('action');*/
		}
	});
}
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		window.batch_submitbutton = function(task) {
			var form = document.batchForm;
			if ((task == 'install')) {
				if (form.category.value == 0) {
					fwmg_alert('<?php echo fwgHelper::jtext('FWMG_SELECT_GALLERY_FIRST', true); ?>');
					return;
				}
				if (typeof(window.FileReader) == 'undefined') {
					var files_added = false;
					$('input[type=file]', form).each(function(index, input) {
						if (input.value != '') files_added = true;
					});
					if (!files_added) {
						fwmg_alert('<?php echo fwgHelper::jtext('FWMG_NOTHING_TO_UPLOAD', true); ?>');
						return false;
					}
				} else {
					if (fwmg_uploaded_files.length > 0) {
						var button = $('#fwmg-save-button');
						if (button.length) {
							button.attr('disabled', true);
							var img = $('<div id="fwmg-batch-wait-img" fwk-spinner></div>');
							button.after(img);
						}
						fwmg_file_queue_upload(form, 0);
					} else {
						fwmg_alert('<?php echo fwgHelper::jtext('FWMG_NOTHING_TO_UPLOAD', true); ?>');
					}
					return false;
				}
			}
		}
	})(jQuery);
});

function handleFileInput(input) {
	var form = document.batchForm;

	var div = jQuery('<div class="fwk-flex"></div>');
	jQuery(form).append(div);
	div.append(jQuery('<div class="fwk-width-5-6">' + input.val() + '</div>'));
	div.append(input);
	input.css('display', 'none');
	var button = jQuery('<div class="fwk-width-1-6"><button type="button" class="fwk-button fwk-button-danger btn-small" onclick="jQuery(this).parent().parent().remove();">-</button></div>');
	div.append(button);

	var input = jQuery('<input type="file" name="images[]" />');
	jQuery(form).append(input);
	input.change(function() {
		handleFileInput(jQuery(this));
	});
}
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		var form = document.batchForm;
		var bu = $('#fwmg-batch-uploader');
		if (typeof(window.FileReader) == 'undefined') {
			var input = $('<input type="file" name="images[]" />');
			$(form).append(input);
			input.change(function() {
				handleFileInput($(this));
			});
		} else {
			var div = $('<div id="fwmg-batch-uploader-wrapper"></div>');
			bu.append(div);
			var fr = $('<div id="fwmg-batch-uploader-drop-zone"></div>');
			div.append(fr);
			fr.html('<?php echo fwgHelper::jtext('FWMG_OR_DRAG_FILES_HERE', true); ?>');

			fr[0].ondragover = function() {
				fr.addClass('fwmg-drag-over');
				return false;
			};
			fr[0].ondragleave = function() {
				fr.removeClass('fwmg-drag-over');
				return false;
			};
			fr[0].ondrop = function(event) {
				event.preventDefault();
				fr.removeClass('fwmg-drag-over');
				fr.addClass('fwmg-drag-drop');

				var uploading_size = 0;
				for (var i = 0; i < fwmg_uploaded_files.length; i++) {
					uploading_size += fwmg_uploaded_files[i].size;
				}

				for (var i = 0; i < event.dataTransfer.files.length; i++) {
					var file = event.dataTransfer.files[i];
					if (file.name.match(/\.(<?php echo implode('|', $exts); ?>)$/i)) {
						if (file.size <= max_file_size) {
							if ((file.size + uploading_size) < max_post_size) {
								if (fr.html() == '<?php echo fwgHelper::jtext('FWMG_OR_DRAG_FILES_HERE', true); ?>') fr.html('');
								fr.css({
									'background-image': 'none',
									'line-height': '16px',
									'text-align': 'left'
								});
								var row = $('<div class="fwmg-file-row">' + file.name + '</div>');
								fr.append(row);
								var remove_button = $('<a href="javascript:" title="<?php echo fwgHelper::jtext('FWMG_REMOVE', true); ?>"><img src="<?php echo Uri::root(true) ?>/administrator/components/com_fwgallery/assets/images/delete16.png" alt="delete"/></a>');
								row.append(remove_button);
								var span = $('<span class="fwmg-file-size">' + humanFileSize(file.size) + '</span>');
								row.append(span);
								remove_button.click(function() {
									var current_button = this;
									var num = 0;
									var count = 0;
									$('.fwmg-file-row a').each(function(index, button) {
										if (button == current_button) num = index;
										count++;
									});
									if (fwmg_uploaded_files[num]) {
										fwmg_uploaded_files.splice(num, 1);
										$(current_button).parent().remove();
									}
									if (count == 1) {
										fr.html('<?php echo fwgHelper::jtext('FWMG_OR_DRAG_FILES_HERE', true); ?>');
										fr.css({
											'background-image': '',
											'line-height': '200px',
											'text-align': 'center'
										});
									}
								});
								fwmg_uploaded_files.push(file);

								uploading_size += file.size;
							} else {
								fwmg_alert(file.name + ' - <?php echo fwgHelper::jtext('FWMG_MAX_POST_SIZE_LIMIT_REACHED', true); ?>');
							}
						} else {
							fwmg_alert(file.name + ' - <?php echo fwgHelper::jtext('FWMG_FILE_TOO_BIG', true); ?>');
						}
					} else {
						fwmg_alert(file.name + ' - <?php echo fwgHelper::jtext('FWMG_NOT_ALLOWED_EXTENSION', true); ?>');
					}
				}
			}
			var input = $('<input type="file" multiple name="files[]" id="fwmg-upload-input" />');
			bu.append($('<p><?php echo fwgHelper::sprintf('FWMG_ALLOWED_FILES_TYPES', implode(', ', $exts)); ?>; <?php echo fwgHelper::jtext('FWMG_MAX_FILE_SIZE'); ?>: <?php echo fwgHelper::humanFileSize($max_size); ?>, <?php echo fwgHelper::jtext('FWMG_POST_SIZE_LIMIT'); ?>: <?php echo fwgHelper::humanFileSize($post_size); ?></p><span><?php echo fwgHelper::jtext('FWMG_SELECT_IMAGES', true); ?>&nbsp;</span>')).append(input);

			input[0].onchange = function(event) {
				event.preventDefault();

				var uploading_size = 0;
				for (var i = 0; i < fwmg_uploaded_files.length; i++) {
					uploading_size += fwmg_uploaded_files[i].size;
				}

				for (var i = 0; i < event.target.files.length; i++) {
					var file = event.target.files[i];
					if (file.name.match(/\.(<?php echo implode('|', $exts); ?>)$/i)) {
						if (file.size <= max_file_size) {
							if ((file.size + uploading_size) < max_post_size) {
								if (fr.html() == '<?php echo fwgHelper::jtext('FWMG_OR_DRAG_FILES_HERE', true); ?>') fr.html('');
								fr.css({
									'background-image': 'none',
									'line-height': '16px',
									'text-align': 'left'
								});
								var row = $('<div class="fwmg-file-row">' + file.name + '</div>');
								fr.append(row);
								var remove_button = $('<a href="javascript:" title="<?php echo fwgHelper::jtext('FWMG_REMOVE', true); ?>"><img src="<?php echo Uri::root(true) ?>/administrator/components/com_fwgallery/assets/images/delete16.png" alt="delete"/></a>');
								row.append(remove_button);
								var span = $('<span class="fwmg-file-size">' + humanFileSize(file.size) + '</span>');
								row.append(span);
								remove_button.click(function() {
									var current_button = this;
									var num = 0;
									var count = 0;
									$('.fwmg-file-row a').each(function(index, button) {
										if (button == current_button) num = index;
										count++;
									});
									if (fwmg_uploaded_files[num]) {
										fwmg_uploaded_files.splice(num, 1);
										$(current_button).parent().remove();
									}
									if (count == 1) {
										fr.html('<?php echo fwgHelper::jtext('FWMG_OR_DRAG_FILES_HERE', true); ?>');
										fr.css({
											'background-image': '',
											'line-height': '200px',
											'text-align': 'center'
										});
									}
								});
								fwmg_uploaded_files.push(file);

								uploading_size += file.size;
							} else {
								fwmg_alert(file.name + ' - <?php echo fwgHelper::jtext('FWMG_MAX_POST_SIZE_LIMIT_REACHED', true); ?>');
							}
						} else {
							fwmg_alert(file.name + ' - <?php echo fwgHelper::jtext('FWMG_FILE_TOO_BIG', true); ?>');
						}
					} else {
						fwmg_alert(file.name + ' - <?php echo fwgHelper::jtext('FWMG_NOT_ALLOWED_EXTENSION', true); ?>');
					}
				}
			}
		}
	})(jQuery);
});

function humanFileSize(size) {
	var i = Math.floor(Math.log(size) / Math.log(1024));
	return (size / Math.pow(1024, i)).toFixed(2) * 1 + ' ' + ['B', 'kB', 'MB', 'GB', 'TB'][i];
};
</script>