<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;

$view = $displayData['view'];

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/jquery.datetimepicker.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::_('behavior.core');
HTMLHelper::_('behavior.formvalidator');
HTMLHelper::_('formbehavior.chosen', 'select.select-choices');
HTMLHelper::script('components/com_fwgallery/assets/js/jquery.datetimepicker.full.min.js');
echo fwgHelper::loadTemplate('site.admin.messages', $displayData, FWMG_PLUGINS_PATH.'admin/layouts');
$editor = fwgHelper::getEditor();
?>
<div class="fwcss fwk-scope">
	<div class="fwmg-management-header">
		<div class="fwmg-management-header-text">
			<?php echo $view->object->id?fwgHelper::sprintf('FWMG_HEADER_CATEGORY_EDIT', $view->escape($view->object->name)):fwgHelper::jtext('FWMG_HEADER_NEW_CATEGORY'); ?>
		</div>
	</div>
	<div class="mb-4">
		<button type="button" class="fwk-button fwk-button-success" id="fwmg-category-save" onclick="Joomla.submitbutton('save')">
            <span fwk-icon="check" fwk-icon="<?php echo fwgHelper::jtext('FWMG_Save'); ?>"></span>
			<?php echo fwgHelper::jtext('FWMG_Save'); ?>
		</button>
		<button type="button" class="fwk-button" onclick="Joomla.submitbutton('cancel')">
            <span fwk-icon="close" fwk-tooltip="<?php echo fwgHelper::jtext($view->object->id?'FWMG_Close':'FWMG_Cancel'); ?>"></span>
			<?php echo fwgHelper::jtext($view->object->id?'FWMG_Close':'FWMG_Cancel'); ?>
		</button>
<?php
if ($view->object->id) {
    $displayData['view']->category = $view->object->id;
?>
		<button type="button" class="fwk-button" fwk-toggle="target: #fwmg-batch">
			<span fwk-tooltip="<?php echo esc_attr(fwgHelper::jtext('FWMG_BATCH_UPLOAD')); ?>" fwk-icon="upload"></span>
			<?php echo fwgHelper::jtext('FWMG_BATCH_UPLOAD'); ?>
		</button>
<?php
}
?>
	</div>
<form action="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection')); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="form-validate">
    <ul fwk-tab>
        <li class="fwk-active">
            <a href="#fwmg-gallery-general"><?php echo fwgHelper::jtext('FWMG_GENERAL'); ?></a>
        </li>
        <li>
            <a href="#fwmg-gallery-design"><?php echo fwgHelper::jtext('FWMG_DESIGN'); ?></a>
        </li>
    </ul>
    <div class="fwk-switcher">
        <div>
            <div class="fwa-main-body">
                <div class="fwa-mb-cardbox">
					<!-- Genral -->
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_GENERAL_SETTINGS'); ?></div>
						</div>
						<div class="fwk-card-body" fwk-margin>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_NAME'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<input class="fwk-input" type="text" name="name" value="<?php echo $view->escape($view->object->name); ?>">
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_NAME_CONTENT')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_PUBLISHED'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('fwView.radioGroup', 'published', $view->object->id?$view->object->published:1, array(
										'wrapper_class' => 'fwk-width-expand',
										'buttons' => array(array(
											'active_class' => 'fwk-button-success',
											'title' => fwgHelper::jtext('JYES'),
											'value' => '1'
										), array(
											'active_class' => 'fwk-button-danger',
											'title' => fwgHelper::jtext('JNO'),
											'value' => '0'
										))
									)); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_PUBLISHED_CONTENT'); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_PARENT'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('fwsgCategory.parent', $view->object, 'parent', 'class="fwk-select"'); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_PARENT_CONTENT')); ?>"></span>
								</div>
							</div>
<?php
		$view->app->triggerEvent('onshowCategoryEditExtraFields', array('com_fwgallery', $view->object));
?>
                            <div class="fwk-flex">
                                <div class="fwk-width-2-5@s">
                                    <?php echo fwgHelper::jtext('FWMG_COVER_TYPE'); ?>
                                </div>
                                <div class="fwk-width-3-5@s fwk-flex">
                                    <?php echo HTMLHelper::_('fwView.radioGroup', 'media', $view->object->media?$view->object->media:'none', array(
                                        'wrapper_class' => 'fwk-width-expand',
                                        'buttons' => array(array(
                                            'active_class' => 'fwk-button-success',
                                            'title' => fwgHelper::jtext('FWMG_IMAGE'),
                                            'value' => 'none'
                                        ), array(
                                            'active_class' => 'fwk-button-success',
                                            'title' => fwgHelper::jtext('FWMG_SELF_HOSTED'),
                                            'value' => 'mp4'
                                        ), array(
                                            'active_class' => 'fwk-button-success',
                                            'title' => 'YouTube',
                                            'value' => 'youtube'
                                        ), array(
                                            'active_class' => 'fwk-button-success',
                                            'title' => 'Vimeo',
                                            'value' => 'vimeo'
                                        ))
                                    )); ?>
                                    <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_COVER_TYPE_HINT')); ?>"></span>
                                </div>
                            </div>

                            <div class="fwmg-media fwmg-vimeo fwmg-youtube" style="display:none;" fwk-grid>
                                <div class="fwk-width-2-5@s">
                                    <?php echo fwgHelper::jtext('FWMG_VIDEO_ID'); ?>
                                </div>
                                <div class="fwk-width-3-5@s fwk-flex">
                                    <input class="fwk-input" type="text" name="remote_code" value="<?php if ($view->object->media != 'mp4') echo $view->escape($view->object->media_code); ?>" />
                                    <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_VIDEO_ID_DESCR')); ?>"></span>
                                </div>
                            </div>
                            <div class="fwmg-media fwmg-mp4 fwmg-none">
                                <div class="col-form-label clearfix">
                                    <?php echo fwgHelper::jtext('FWMG_COVER_FILE'); ?>
                                    <span class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_COVER_FILE_HINT')); ?>"></span>
                                </div>
                                <div id="fwmg-image-container" class="no-gutters fwk-child-width-1-2@l" fwk-grid>
                                    <div>
										<img class="img-thumbnail" src="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=fwgallery&layout=img&format=raw&w=266&h=200&id='.$view->object->id)); ?>" />
                                    </div>
                                    <div>
                                        <div class="fwk-grid-collapse fwk-grid-match fwk-margin-bottom" fwk-grid>
                                            <div class="fwk-width-expand" fwk-form-custom>
                                                <input type="file" id="fwmg-image" name="image" />
                                                <input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo fwgHelper::jtext('FWMG_CHOOSE_FILE'); ?>" disabled="">
                                            </div>
                                            <div class="fwk-width-auto">
                                                <button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo fwgHelper::jtext('FWMG_UPLOAD'); ?></button>
                                            </div>
                                        </div>
                                        <div class="text-muted"><small><?php echo fwgHelper::sprintf('FWMG_MAX_IMAGE_SIZE_LONG', ini_get('post_max_size')); ?></small></div>
                                        <div class="mt-5">
                                            <button type="button" class="fwk-button fwk-button-default fwk-button-danger fwmg-remove"<?php if (!$view->object->sys_filename) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWMG_REMOVE'); ?></button>
                                            <?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
                                                'url' => fwgHelper::route('index.php?option=com_ajax&group=fwgallery&plugin=admin', false),
                                                'button' => '#fwmg-image-container .fwmg-remove',
                                                'image' => '#fwmg-image-container img',
                                                'layout' => 'category_image_delete'
                                            )); ?>
                                        </div>
                                    </div>
                                    <?php echo HTMLHelper::_('fwView.handleUploadButton', array(
										'url' => fwgHelper::route('index.php?option=com_ajax&group=fwgallery&plugin=admin', false),
										'button' => '#fwmg-image-container .fwmg-upload',
                                        'remove_button' => '#fwmg-image-container .fwmg-remove',
										'input' => '#fwmg-image',
										'image' => '#fwmg-image-container img',
										'exts' => array('gif', 'jpg', 'jpeg', 'png'),
										'layout' => 'category_image_upload'
									)); ?>
                                </div>
                            </div>
                            <div class="fwmg-media fwmg-mp4" style="display:none;" fwk-grid>
                                <div class="fwk-width-2-5@s">
                                    <?php echo fwgHelper::jtext('FWMG_VIDEO_FILE'); ?>
                                </div>
                                <div class="fwk-width-3-5@s fwk-flex" id="fwmg-video-container">
                                    <div>
                                        <div class="fwk-margin-bottom">
<?php
$video_exists = fwgHelper::fileExists($view->object->media_code);
if ($video_exists) {
?>
                                            <strong><?php echo $view->object->media_code; ?></strong> <span><?php echo fwgHelper::humanFileSize($view->object->_video_size); ?></span>
<?php
} else {
?>
                                            <strong></strong> <span></span>
<?php
}
?>
                                        </div>
                                        <div class="fwk-grid-collapse fwk-grid-match fwk-margin-bottom fwk-margin-bottom" fwk-grid>
                                            <div class="fwk-width-expand" fwk-form-custom>
                                                <input type="file" id="fwmg-video" name="file" />
                                                <input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo fwgHelper::jtext('FWMG_CHOOSE_FILE'); ?>" disabled="">
                                            </div>
                                            <div class="fwk-width-auto">
                                                <button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo fwgHelper::jtext('FWMG_UPLOAD'); ?></button>
                                            </div>
                                        </div>
                                        <div class="text-muted"><small><?php echo fwgHelper::sprintf('FWMG_MAX_VIDEO_SIZE_LONG', ini_get('post_max_size')); ?></small></div>
                                        <?php echo HTMLHelper::_('fwView.handleUploadButton', array(
                                            'url' => fwgHelper::route('index.php?option=com_ajax&group=fwgallery&plugin=admin', false),
                                            'button' => '#fwmg-video-container .fwmg-upload',
                                            'input' => '#fwmg-video',
                                            'image' => '#fwmg-video-container img',
                                            'exts' => array('mp4'),
                                            'layout' => 'category_video_upload',
                                            'callback' => 'function(data) {
	$progress_bar.remove();
	$button.attr(\'disabled\', false);

	var $parent = $input.parent();
	$input.next().html(\''.fwgHelper::jtext('FWMG_CHOOSE_FILE', false).'\');

	var input_html = $parent.html();
	$parent.html(input_html);

	if (data && data.data && data.data[0]) {
        data = data.data[0];
		if (data.id) {
			$(\'input[name="oid"]\').val(data.id);
		}
        if (data.media_code) {
            $(\'#fwmg-video-container strong:eq(0)\').html(data.media_code);
        }
        if (data._video_size) {
            $(\'#fwmg-video-container span:eq(0)\').html(data._video_size);
        }

		if (data.msg) {
			var $msg = $(\'<div class="fwk-alert fwk-alert-warning alert-dismissible fade show">\
<button type="button" class="close" data-dismiss="alert" aria-label="Close">\
<span aria-hidden="true">&times;</span>\
</button>\
\'+data.msg+\'</div>\');
			$button.before($msg);
			$(\'button\', $msg).click(function() {
				$msg.remove();
			});
			setTimeout(function() {
				$msg.remove();
			}, 3000);
		}
	}
}'
                                        )); ?>
                                        <button type="button" class="fwk-button fwk-button-danger"<?php if (!$video_exists) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWMG_REMOVE'); ?></button>
                                        <?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
                                            'url' => fwgHelper::route('index.php?option=com_ajax&group=fwgallery&plugin=admin', false),
                                            'button' => '#fwmg-video-container .fwk-button-danger',
                                            'image' => '#fwmg-video-container img',
                                            'layout' => 'category_video_delete',
                                            'callback' => 'function(data) {
	$img.remove();
	$button.attr(\'disabled\', false);
	if (data && data.data && data.data[0]) {
        data = data.data[0];
		if (data.id) {
			$(\'#fwmg-video-container .fwk-margin-bottom\').find(\'span,strong\').html(\'\');
		}
		if (data.msg) fwmg_alert(data.msg);
	}
}'
                                        )); ?>
                                    </div>
                                    <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_VIDEO_FILE_DESCR')); ?>"></span>
                                </div>
                            </div>

							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_CREATE_DATE'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<div class="fwk-group-date">
										<input class="fwk-input" type="text" name="created" value="<?php echo $view->object->id?substr($view->object->created, 0, 16):HTMLHelper::date('now', 'Y-m-d H:i'); ?>">
                                        <button class="fwk-button" type="button"><span fwk-icon="calendar"></span></button>
									</div>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_CREATE_DATE_CONTENT')); ?>"></span>
								</div>
							</div>
<?php
if ($view->current_user->authorise('core.login.admin')) {
?>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_OWNER'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadUsers(), 'user_id', 'class="fwk-select"', 'id', 'name', $view->object->user_id); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_OWNER_CONTENT')); ?>"></span>
								</div>
							</div>
<?php
}
?>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_ACCESS'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadviewlevels(), 'access', 'class="fwk-select"', 'id', 'name', $view->object->access); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ACCESS_CONTENT')); ?>"></span>
								</div>
							</div>
						</div>
					</div>
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?></div>
						</div>
						<div class="fwk-card-body" fwk-margin>
							<?php echo $editor->display('descr', $view->object->descr, '100%', 200, 60, 5); ?>
						</div>
					</div>
                </div>
            </div>
        </div>
        <!-- FWSG Gallery Design -->
        <div>
            <div class="fwa-main-body">
                <div class="fwa-mb-cardbox">
                        <!-- Gallery Layout -->
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_GALLERY_LAYOUT'); ?></div>
                                <div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_GALLERY_LAYOUT_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_name]', $view->object->params->get('show_gallery_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_NAME_CONTENT')); ?>"></span>
                                    </div>
                                </div>
<?php
		$view->app->triggerEvent('onshowCategoryEditCategoryDesignExtraFields', array('com_fwgallery', $view->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_description]', $view->object->params->get('show_gallery_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_DESCRIPTION_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_GALLERY_BREADCRUMBS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_breadcrumbs]', $view->object->params->get('show_gallery_breadcrumbs', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_GALLERY_BREADCRUMBS_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_COLUMNS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', '1', '1', 'id', 'name'),
                                            HTMLHelper::_('select.option', '2', '2', 'id', 'name'),
                                            HTMLHelper::_('select.option', '3', '3', 'id', 'name'),
                                            HTMLHelper::_('select.option', '4', '4', 'id', 'name'),
                                            HTMLHelper::_('select.option', '5', '5', 'id', 'name'),
                                            HTMLHelper::_('select.option', '6', '6', 'id', 'name'),
                                        ), 'params[gallery_columns]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('gallery_columns', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_COLUMNS_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_LIMIT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_limit]', $view->object->params->get('show_gallery_limit', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_LIMIT_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_GALLERIES_PER_PAGE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <input class="fwk-input" type="text" name="params[galleries_per_page]" value="<?php echo $view->escape($view->object->params->get('galleries_per_page', 3)); ?> " />
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_GALLERIES_PER_PAGE_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_ORDERING'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_ordering]', $view->object->params->get('show_gallery_ordering', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_ORDERING_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_DEFAULT_ORDERING'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'ordering', fwgHelper::jtext('FWMG_ORDERING'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'aplhabetically', fwgHelper::jtext('FWMG_APLHABETICALLY'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'newest', fwgHelper::jtext('FWMG_NEWEST_FIRST'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'oldest', fwgHelper::jtext('FWMG_OLDEST_FIRST'), 'id', 'name'),
                                        ), 'params[gallery_default_ordering]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('gallery_default_ordering', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DEFAULT_ORDERING_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_PAGINATION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_pagination]', $view->object->params->get('show_gallery_pagination', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_PAGINATION_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_PAGINATION_TYPE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[gallery_pagination_type]', $view->object->params->get('gallery_pagination_type', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_STANDARD'),
                                                'value' => 'standard'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_AJAX_LOAD_MORE'),
                                                'value' => 'ajax'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_PAGINATION_TYPE_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- Gallery Elements -->
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_GALLERY_LISTING_DESIGN'); ?></div>
                                <div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_GALLERY_LISTING_DESIGN_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_THEME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getThemesList()), 'params[template]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('template', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_THEME_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_SHOW_ITEM_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getLayoutsList()), 'params[gallery_layout]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('gallery_layout', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_ITEM_INFO_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_ON_HOVER_EFFECT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'none', fwgHelper::jtext('FWMG_NONE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'kenburns', fwgHelper::jtext('FWMG_KENBURNS'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'enlarge', fwgHelper::jtext('FWMG_ENLARGE'), 'id', 'name'),
                                        ), 'params[gallery_hover]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('gallery_hover', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ON_HOVER_EFFECT_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_name]', $view->object->params->get('show_gallery_item_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_NAME_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_ITEMS_COUNTER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_counter]', $view->object->params->get('show_gallery_item_counter', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_ITEMS_COUNTER_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_description]', $view->object->params->get('show_gallery_item_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_DESCRIPTION_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_LAST_UPDATE_DATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_gallery_item_update_date]', $view->object->params->get('show_gallery_item_update_date', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_LAST_UPDATE_DATE_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="fwk-card fwk-card-default fwk-card-grey">
                            <div class="fwk-card-header">
                                <div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_LISTING_ITEM_DESIGN'); ?></div>
                                <div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_LISTING_ITEM_DESIGN_HINT'); ?></div>
                            </div>
                            <div class="fwk-card-body" fwk-margin>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_ITEM_OPENS_AS'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[file_open_as]', $view->object->params->get('file_open_as', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_LIGHTBOX'),
                                                'value' => 'popup'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_PAGE'),
                                                'value' => 'link'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ITEM_OPENS_AS_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_SHOW_ITEM_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
											HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name')
										), fwgHelper::getLayoutsList()), 'params[file_layout]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('file_layout', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_ITEM_INFO_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_ON_HOVER_EFFECT'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('select.genericlist', array(
                                            HTMLHelper::_('select.option', 'def', fwgHelper::jtext('FWMG_DEFAULT'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'none', fwgHelper::jtext('FWMG_NONE'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'kenburns', fwgHelper::jtext('FWMG_KENBURNS'), 'id', 'name'),
                                            HTMLHelper::_('select.option', 'enlarge', fwgHelper::jtext('FWMG_ENLARGE'), 'id', 'name'),
                                        ), 'params[file_hover]', 'class="fwk-select"', 'id', 'name', $view->object->params->get('file_hover', 'def')); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ON_HOVER_EFFECT_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_NAME'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_name]', $view->object->params->get('show_file_name', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_NAME_CONTENT')); ?>"></span>
                                    </div>
                                </div>
<?php
		$view->app->triggerEvent('onshowCategoryEditItemDesignExtraFields', array('com_fwgallery', $view->object));
?>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_description]', $view->object->params->get('show_file_description', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DESCRIPTION_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_LAST_UPDATE_DATE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_update]', $view->object->params->get('show_file_update', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_LAST_UPDATE_DATE_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_OWNER'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_owner]', $view->object->params->get('show_file_owner', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_OWNER_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_DOWNLOAD_BUTTON'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_download]', $view->object->params->get('show_file_download', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOWNLOAD_BUTTON_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_ITEM_INFO'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_file_info]', $view->object->params->get('show_file_info', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ITEM_INFO_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_PAGINATION'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[show_files_pagination]', $view->object->params->get('show_files_pagination', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_SHOW'),
                                                'value' => '1'
                                            ), array(
                                                'active_class' => 'fwk-button-danger',
                                                'title' => fwgHelper::jtext('FWMG_HIDE'),
                                                'value' => '0'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_SHOW_PAGINATION_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                                <div class="fwk-flex">
                                    <div class="fwk-width-2-5@s">
                                        <?php echo fwgHelper::jtext('FWMG_PAGINATION_TYPE'); ?>
                                    </div>
                                    <div class="fwk-width-3-5@s fwk-flex">
                                        <?php echo HTMLHelper::_('fwView.radioGroup', 'params[files_pagination_type]', $view->object->params->get('files_pagination_type', 'def'), array(
                                            'wrapper_class' => 'fwk-width-expand',
                                            'buttons' => array(array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_DEFAULT'),
                                                'value' => 'def'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_STANDARD'),
                                                'value' => 'standard'
                                            ), array(
                                                'active_class' => 'fwk-button-success',
                                                'title' => fwgHelper::jtext('FWMG_AJAX_LOAD_MORE'),
                                                'value' => 'ajax'
                                            ))
                                        )); ?>
                                        <span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_PAGINATION_TYPE_CONTENT')); ?>"></span>
                                    </div>
                                </div>
                            </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <input type="hidden" name="oid" value="<?php echo $view->object->id; ?>" />
    <input type="hidden" name="task" value="" />
<?php
foreach ($view->fields as $field) {
	if ($view->$field) {
?>
    <input type="hidden" name="<?php echo $field; ?>" value="<?php echo $view->escape($view->$field); ?>" />
<?php
	}
}
?>
</form>

<div id="fwmg-batch" class="fwk-modal-container" fwk-modal>
  <div class="fwk-modal-dialog" role="document">
      <div class="fwk-modal-header">
        <h5 class="fwk-modal-title"><?php echo fwgHelper::jtext('FWMG_BATCH_UPLOAD'); ?></h5>
        <button class="fwk-modal-close-default" type="button" fwk-close></button>
      </div>
      <div class="fwk-modal-body">
        <?php echo fwgHelper::loadTemplate('site.admin.batch', $displayData, FWMG_PLUGINS_PATH.'admin/layouts/'); ?>
      </div>
  </div>
</div>

</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
        $('input[name="media"]').change(function() {
            var media = this.value;
            $('.fwmg-media').hide();
            $('.fwmg-'+media).show();
        }).change();
        $('input[name="created"]').datetimepicker({
            format: 'Y-m-d H:i'
        });
        $('input[name="created"]').next().click(function() {
            $('input[name="created"]').focus();
        });
        $('.fwmg-management-tabs a.nav-link').click(function(ev) {
            ev.stopPropagation();
            ev.preventDefault();
            var $link = $(this);
            $link.closest('.nav').find('.nav-item.active').removeClass('active');
            $link.parent().addClass('active');
            $link.closest('.nav').find('a.nav-link').each(function() {
                if (this == $link[0]) {
                    $($link.attr('href')).show();
                } else {
                    $($(this).attr('href')).hide();
                }
            });
        });
        Joomla.submitbutton = function(task) {
            var form = document.adminForm;
            if (task == 'cancel') {
                location = form.action;
                return;
            }
            if ((task == 'apply' || task == 'save') && !document.formvalidator.isValid(form)) {
                fwmg_alert('<?php echo fwgHelper::jtext('FWMG_NOT_ALL_REQUIRED_FIELDS_FILLED', true); ?>');
            } else {
                var $wait = $('<div fwk-spinner></div>');
                var $btn = $('#fwmg-category-save').attr('disabled', true);
                $btn.after($wait);
                var fd = new FormData(form);
                fd.append('layout', 'category_save');
                fd.append('group', 'fwgallery');
                fd.append('plugin', 'admin');
                fd.append('format', 'json');
                fd.append('task', '');
                $.ajax({
                    url: '<?php echo Route::_('index.php?option=com_ajax', false); ?>',
                    type: 'post',
                    dataType: 'json',
                    processData: false,
                    contentType: false,
                    data: fd
                }).done(function (data) {
                    if (data.data && data.data.length) {
                        data = data.data[0];
                    }
                    if (data.msgs) {
                        for (var i = 0; i < data.msgs.length; i++) {
                            fwmg_alert(data.msgs[i].msg, '', data.msgs[i].status);
                        }
                    }
                    if (data.result && task == 'save') {
                        location = form.action;
                    }
                }).always(function() {
                    $btn.attr('disabled', false);
                    $wait.remove();
                });
            }
        }
	})(jQuery);
});
</script>
