<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;

$view = $displayData['view'];
echo fwgHelper::loadTemplate('site.admin.messages', $displayData, FWMG_PLUGINS_PATH.'admin/layouts');

HTMLHelper::_('behavior.core');
?>
<div>
	<div class="fwmg-management-header">
		<div class="fwmg-management-header-text">
			<?php echo fwgHelper::jtext('FWMG_HEADER_CATEGORIES'); ?>
		</div>
	</div>
	<div class="mb-4">
<?php
if ($view->params->get('allow_new_galleries', 1)) {
?>
		<a class="fwk-button fwk-button-success fwk-margin-right" href="javascript:Joomla.submitbutton('add');">
			<span fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_New'); ?>" fwk-icon="plus" class="fwk-margin-small-right"></span>
			<?php echo fwgHelper::jtext('FWMG_New'); ?>
		</a>
<?php
}
?>
		<a class="fwk-button fwk-margin-right" href="javascript:if(document.adminForm.boxchecked.value==0){fwmg_alert('<?php echo fwgHelper::jtext('FWMG_MAKE_SELECTION_EDIT', true); ?>');}else{Joomla.submitbutton('edit')}">
			<span fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_Edit'); ?>" fwk-icon="file-edit" class="fwk-margin-small-right"></span>
			<?php echo fwgHelper::jtext('FWMG_Edit'); ?>
		</a>
		<a class="fwk-button fwk-margin-right" href="javascript:if(document.adminForm.boxchecked.value==0){fwmg_alert('<?php echo fwgHelper::jtext('FWMG_MAKE_SELECTION_PUBLISH', true); ?>');}else{Joomla.submitbutton('publish'); }">
			<span fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_Publish'); ?>" fwk-icon="eye" class="fwk-margin-small-right"></span>
			<?php echo fwgHelper::jtext('FWMG_Publish'); ?>
		</a>
		<a class="fwk-button fwk-margin-right" href="javascript:if(document.adminForm.boxchecked.value==0){fwmg_alert('<?php echo fwgHelper::jtext('FWMG_MAKE_SELECTION_UNPUBLISH', true); ?>');}else{Joomla.submitbutton('unpublish'); }">
			<span fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_Unpublish'); ?>" fwk-icon="eye-slash" class="fwk-margin-small-right"></span>
			<?php echo fwgHelper::jtext('FWMG_Unpublish'); ?>
		</a>
		<a class="fwk-button fwk-button-danger" href="javascript:if(document.adminForm.boxchecked.value==0){fwmg_alert('<?php echo fwgHelper::jtext('FWMG_MAKE_SELECTION_DELETE', true); ?>');}else if (confirm('<?php echo fwgHelper::jtext('FWMG_ARE_YOU_SURE', true); ?>')) {Joomla.submitbutton('remove')}">
			<span fwk-icon="close" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_Delete'); ?>" class="fwk-margin-small-right"></span>
			<?php echo fwgHelper::jtext('FWMG_Delete'); ?>
		</a>
	</div>
	<form action="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=category')); ?>" method="post" name="adminForm" id="adminForm">
		<div class="mb-4 fwa-filter-bar fwk-child-width-1-2@m" fwk-grid>
			<div>
				<div class="fwk-position-relative">
					<span class="fwk-form-icon fwk-text-green" fwk-icon="icon: search"></span>
					<input type="text" class="fwk-input" name="search" placeholder="<?php echo fwgHelper::jtext('FWMG_SEARCH_NAME_OR_ID'); ?>" value="<?php echo $view->escape($view->search); ?>" />
				</div>
			</div>
		</div>
		<div class="table-responsive">
		<table class="fwk-table fwk-table-striped">
		    <thead>
		        <tr>
					<th><input name="toggle" class="fwk-checkbox" value="" onclick="Joomla.checkAll(this);" type="checkbox"></th>
					<th><?php echo fwgHelper::jtext('FWMG_COVER'); ?></th>
					<th><?php echo fwgHelper::jtext('FWMG_ID'); ?> - <?php echo fwgHelper::jtext('FWMG_NAME'); ?></th>
					<th><?php echo fwgHelper::jtext('FWMG_ITEMS'); ?></th>
					<th class="fwk-text-center"><?php echo fwgHelper::jtext('FWMG_PUBLISHED'); ?></th>
		        </tr>
		    </thead>
		    <tbody>
<?php
if ($view->list) {
    foreach ($view->list as $num=>$project) {
?>
		        <tr>
					<td><div class="form-check"><?php echo preg_replace('#<label.*</label>#msi', '', HTMLHelper::_('grid.id', $num, $project->id, !($view->isadmin or $project->user_id == $view->user->id))); ?></div></td>
					<td><img class="img-thumbnail" src="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=fwgallery&layout=img&format=raw&w=80&h=60&id='.$project->id)); ?>"></td>
		            <td>
<?php
		if ($view->isadmin or $project->user_id == $view->user->id) {
?>
	                	<a href="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=category_edit&cid[]='.$project->id.$view->extra_link)); ?>">
	                    	<?php echo $project->id; ?> - <?php echo $project->treename; ?>
	                	</a>
<?php
		} else {
?>
                    	<?php echo $project->id; ?> - <?php echo $project->treename; ?>
<?php
		}
?>
						<div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_OWNER'); ?>: <?php echo $project->_user_name ?></div>
						<div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_CREATED'); ?>: <?php echo HTMLHelper::date($project->created, 'd M Y H:i'); ?></div>
						<div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_ACCESS'); ?>: <?php echo $project->_group_name?$project->_group_name:fwgHelper::jtext('FWMG_Guests'); ?></div>
<?php
		$view->app->triggerEvent('onshowCategoryListExtraFields', array('com_fwgallery', $project));
?>
		            </td>
					<td>
						<span fwk-icon="photo-video"></span> <?php echo $project->_images_qty; ?>
						<?php echo implode('', $view->app->triggerEvent('ongetCategoryAdminListExtraCounters', array('com_fwgallery', $project))); ?>
					</td>
		            <td class="fwk-text-center">
<?php
		if ($view->isadmin or $project->user_id == $view->user->id) {
?>
						<a class="fwk-icon-button fwk-alert-<?php if ($project->published) { ?>success<?php } else { ?>danger<?php } ?>" title="<?php echo $view->escape(fwgHelper::jtext($project->published?'FWMG_PUBLISHED':'FWMG_UNPUBLISHED')); ?>"
							href="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=category&task='.($project->published?'un':'').'publish&cid[]='.$project->id)); ?>" fwk-icon="<?php if($project->published) { ?>check<?php } else { ?>close<?php } ?>">
						</a>
<?php
		} else {
?>
						<span class="btn-sm fwk-text-<?php if($project->published) { ?>success<?php } else { ?>danger<?php } ?>">
							<span fwk-icon="<?php if($project->published) { ?>check<?php } else { ?>close<?php } ?>"></span>
						</span>
<?php
		}
?>
					</td>
		        </tr>
<?php
    }
} else {
?>
				<tr>
					<td colspan="5"><?php echo fwgHelper::jtext('FWMG_NO_GALLERIES'); ?></td>
				</tr>
<?php
}
?>
		    </tbody>
		</table>
		</div>
		<div class="pagination fwmg-pagination">
			<?php echo $view->getPaginationLinks($view->pagination, array('showLimitBox'=>false, 'showLimitStart'=>false)); ?>
		</div>
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
	</form>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	Joomla.submitbutton = function(task) {
		var form = document.adminForm;
		if (task == 'add') {
			location = '<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=category_edit&cid[]=0'.$view->extra_link, false); ?>';
		} else if (task == 'edit') {
			var cid = 0;
			if (task == 'edit') {
				$('input[name="cid[]"]').each(function() {
					if (this.checked) {
						cid = this.value;
						return;
					}
				});
			}
			location = '<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=usersection'.$view->extra_link.'&layout=category_edit&cid[]=', false); ?>'+cid;
		} else {
			form.task.value = task;
			form.submit();
		}
	}
	})(jQuery);
});
</script>
