<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;

$view = $displayData['view'];

HTMLHelper::_('behavior.core');
HTMLHelper::_('behavior.formvalidator');
HTMLHelper::_('formbehavior.chosen', 'select.select-choices');

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/jquery.datetimepicker.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/jquery.datetimepicker.full.min.js');
echo fwgHelper::loadTemplate('site.admin.messages', $displayData, FWMG_PLUGINS_PATH.'admin/layouts');
$editor = fwgHelper::getEditor();

$max_size = $view->upload_max_filesize;
$post_size = $view->post_max_size;
?>
<div class="fwcss fwk-scope">
	<div class="fwmg-management-header">
		<div class="fwmg-management-header-text">
			<?php echo fwgHelper::sprintf('FWMG_HEADER_IMAGE_EDIT', $view->escape($view->object->name)); ?>
		</div>
	</div>
	<div>
		<div>
			<button type="button" class="fwk-button fwk-button-primary fwk-button-success fwk-margin-right" id="fwmg-file-save" onclick="Joomla.submitbutton('save')">
				<span fwk-icon="check" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_Save'); ?>"></span>
				<?php echo fwgHelper::jtext('FWMG_Save'); ?>
			</button>
			<button type="button" class="fwk-button" onclick="Joomla.submitbutton('cancel')">
				<span fwk-icon="close" fwk-tooltip="<?php echo fwgHelper::jtext($view->object->id?'FWMG_Close':'FWMG_Cancel'); ?>"></span>
				<?php echo fwgHelper::jtext($view->object->id?'FWMG_Close':'FWMG_Cancel'); ?>
			</button>
		</div>
	</div>
	<br/>
	<form action="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=image')); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="form-validate">
	<div>
		<div class="fwa-main-body">
			<div class="fwa-mb-cardbox">
				<div class="fwk-card fwk-card-default fwk-card-grey">
					<div class="fwk-card-header">
						<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_IMAGE'); ?></div>
						<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_MAX_FILE_SIZE'); ?>: <?php echo fwgHelper::humanFileSize($max_size); ?>, <?php echo fwgHelper::jtext('FWMG_POST_SIZE_LIMIT'); ?>: <?php echo fwgHelper::humanFileSize($post_size); ?></div>
					</div>
					<div class="fwk-card-body" id="fwmg-image-container">
						<div class="fwk-margin-bottom">
							<img src="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=item&layout=img&format=raw&w=491&h=300&id='.$view->object->id)); ?>" />
							<button type="button" class="fwk-button fwk-button-danger fwmg-remove"<?php if (!$view->object->_sys_filename) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWMG_REMOVE'); ?></button>
							<?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
								'url' => fwgHelper::route('index.php?option=com_ajax&group=fwgallery&plugin=admin', false),
								'button' => '#fwmg-image-container .fwmg-remove',
								'image' => '#fwmg-image-container img',
								'layout' => 'image_delete'
							)); ?>
						</div>
						<div class="fwk-flex">
							<div class="fwk-width-expand" fwk-form-custom>
								<input type="file" id="fwmg-image" name="image" />
								<input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo fwgHelper::jtext('FWMG_CHOOSE_FILE'); ?>" disabled="">
							</div>
							<div class="fwk-width-auto">
								<button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo fwgHelper::jtext('FWMG_UPLOAD'); ?></button>
							</div>
						</div>
<?php
$response_code = '$(\'input[name="name"]\').val(data.name);$(\'input[name="alias"]\').val(data.alias);';
$view->app->triggerEvent('ongetResponseJsForUploadedImage', array('com_fwgallery', &$response_code));
?>
						<?php echo HTMLHelper::_('fwView.handleUploadButton', array(
							'url' => fwgHelper::route('index.php?option=com_ajax&group=fwgallery&plugin=admin', false),
							'button' => '#fwmg-image-container .fwmg-upload',
							'remove_button' => '#fwmg-image-container .fwmg-remove',
							'input' => '#fwmg-image',
							'image' => '#fwmg-image-container img',
							'exts' => array('gif', 'jpg', 'jpeg', 'png'),
							'layout' => 'image_upload',
							'response_code' => $response_code
						)); ?>
					</div>
				</div>

					<!-- Genral -->
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_GENERAL_SETTINGS'); ?></div>
						</div>
						<div class="fwk-card-body" fwk-margin>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_NAME'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<input class="fwk-input" name="name" value="<?php echo $view->escape($view->object->name); ?>" type="text">
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_NAME_IMAGE_DESCR')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_PUBLISHED'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('fwView.radioGroup', 'published', $view->object->published, array(
										'wrapper_class' => 'fwk-width-expand',
										'buttons' => array(array(
											'active_class' => 'fwk-button-success',
											'title' => fwgHelper::jtext('JYES'),
											'value' => 1
										), array(
											'active_class' => 'fwk-button-danger',
											'title' => fwgHelper::jtext('JNO'),
											'value' => 0
										))
									)); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_PUBLISHED_IMAGE_DESCR')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_GALLERY'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', $view->categories, 'category_id', 'class="fwk-select"', 'id', 'name', $view->object->category_id?$view->object->category_id:$view->category); ?>&nbsp;&nbsp;&nbsp;
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_GALLERY_IMAGE_DESCR')); ?>"></span>
								</div>
							</div>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_COPYRIGHT'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<textarea class="fwk-textarea" name="copyright" rows="2"><?php echo $view->escape($view->object->copyright); ?></textarea>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_COPYRIGHT_HINT')); ?>"></span>
								</div>
							</div>
<?php
		$view->app->triggerEvent('onshowFileEditExtraFields', array('com_fwgallery', $view->object));
?>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_UPLOAD_DATE'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<div class="fwk-group-date">
										<input class="fwk-input" type="text" name="created" value="<?php echo substr($view->object->created, 0, 16); ?>">
										<button class="fwk-button" type="button"><span fwk-icon="calendar"></span></button>
									</div>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_UPLOAD_DATE_IMAGE_DESCR')); ?>"></span>
								</div>
							</div>
<?php
if ($view->current_user->authorise('core.login.admin')) {
?>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_OWNER'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadUsers(), 'user_id', 'class="fwk-select"', 'id', 'name', $view->object->user_id); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_OWNER_IMAGE_DESCR')); ?>"></span>
								</div>
							</div>
<?php
}
?>
							<div class="fwk-flex">
								<div class="fwk-width-2-5@s">
									<?php echo fwgHelper::jtext('FWMG_ACCESS'); ?>
								</div>
								<div class="fwk-width-3-5@s fwk-flex">
									<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadviewlevels(), 'access', 'class="fwk-select"', 'id', 'name', $view->object->access); ?>
									<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ACCESS_IMAGE_DESCR')); ?>"></span>
								</div>
							</div>
						</div>
					</div>

					<!-- Descripton -->
					<div class="fwk-card fwk-card-default fwk-card-grey">
						<div class="fwk-card-header">
							<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?></div>
						</div>
						<div class="fwk-card-body" fwk-margin>
							<?php echo $editor->display('descr', $view->object->descr, '100%', 200, 60, 7); ?>
						</div>
					</div>
<?php
		$view->app->triggerEvent('onshowFileEditExtraCards', array('com_fwgallery', $view->object));
?>

			</div>
		</div>
	</div>
    <input type="hidden" name="oid" value="<?php echo $view->object->id; ?>" />
    <input type="hidden" name="type" value="image" />
    <input type="hidden" name="task" value="" />
<?php
foreach ($view->fields as $field) {
	if ($view->$field) {
?>
	<input type="hidden" name="<?php echo $field; ?>" value="<?php echo $view->escape($view->$field); ?>" />
<?php
	}
}
?>
	</form>
</div>
<script type="text/javascript">
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    $('input[name="created"]').datetimepicker({
        format: 'Y-m-d H:i'
    });
    $('input[name="created"]').next().click(function() {
        $('input[name="created"]').focus();
    });
	Joomla.submitbutton = function(task) {
		var form = document.adminForm;
		if (task == 'cancel') {
			location = form.action;
			return;
		}
		if ((task == 'apply' || task == 'save') && !document.formvalidator.isValid(form)) {
			fwmg_alert('<?php echo fwgHelper::jtext('FWMG_NOT_ALL_REQUIRED_FIELDS_FILLED', true); ?>');
		} else {
			var $wait = $('<div fwk-spinner></div>');
			var $btn = $('#fwmg-file-save').attr('disabled', true);
			$btn.after($wait);
			var fd = new FormData(form);
			fd.append('layout', 'file_save');
			fd.append('group', 'fwgallery');
			fd.append('plugin', 'admin');
			fd.append('format', 'json');
			fd.append('task', '');
			$.ajax({
				url: '<?php echo Route::_('index.php?option=com_ajax', false); ?>',
				type: 'post',
				dataType: 'json',
				processData: false,
				contentType: false,
				data: fd
			}).done(function (data) {
				if (data.data && data.data.length) {
					data = data.data[0];
				}
				if (data.msgs) {
					for (var i = 0; i < data.msgs.length; i++) {
						fwmg_alert(data.msgs[i].msg, '', data.msgs[i].status);
					}
				}
				if (data.result && task == 'save') {
					location = form.action;
				}
			}).always(function() {
				$btn.attr('disabled', false);
				$wait.remove();
			});
		}
	}
	})(jQuery);
});
</script>
