<?php
/**
 * FW Gallery Import Plugin 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::_('behavior.formvalidator');
HTMLHelper::_('formbehavior.chosen', 'select.select-choices');

$view = $displayData['view'];
$plg_params = $displayData['plg_params'];
$redirect_uri = $displayData['redirect_uri'];

/* fb */
$fb_user = $displayData['fb_user'];
$fb_galleries = $displayData['fb_galleries'];
$fb_errors = $displayData['fb_errors'];
?>
<div class="fwk-card fwk-card-default fwk-card-grey">
	<div class="fwk-card-header">
		<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB'); ?><span fwk-icon="facebook" class="fwk-margin-left"></span></div>
		<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_HINT'); ?></div>
	</div>
	<div class="fwk-card-body" fwk-margin>
		<?php if ($fb_errors) { ?><div class="fwk-alert fwk-alert-warning"><?php echo implode('<br />', $fb_errors); ?></div><?php } ?>
<?php
if (empty($fb_user['id'])) {
?>
        <form class="form-validate">
			<div class="fwk-alert fwk-alert-info">
				<div class="font-weight-bold fwk-margin-small-bottom"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APP'); ?></div>
				<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APP_HINT'); ?>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APPID'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-fb-app-id" class="fwk-input required" name="app_id" autocomplete="off" />
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APPID_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APPSECRET'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-fb-app-secret" class="fwk-input required" name="app_secret" autocomplete="off" />
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APPSECRET_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APPURI'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-in-app-uri" class="fwk-input" disabled="disabled" value="<?php echo $redirect_uri; ?>" />
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_APPURI_HINT')); ?>"></span>
				</div>
			</div>
			<button type="button" id="fwmg-fb-import-button" class="fwk-button fwk-button-success">
				<?php echo fwgHelper::jtext('FWMG_ADMIN_PLGIMPORT_FB_BTNLINK'); ?>
			</button>
        </form>
<?php
} else {
?>
		<form action="index.php?option=com_ajax&amp;format=raw" method="post" name="logoutForm" id="fw-facebook-logout">
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_ACCOUNT'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<div>
						<strong><?php echo $fb_user['name']; ?></strong>
						<button type="button" class="fwk-button fwk-margin-left" name="logout_button"><?php echo fwgHelper::jtext('FWGPF_LOG_OUT'); ?></button>
					</div>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_ACCOUNT_HINT')); ?>"></span>
				</div>
			</div>
			<input type="hidden" name="group" value="fwgallery" />
			<input type="hidden" name="plugin" value="import" />
			<input type="hidden" name="subtask" value="fb_logout" />
		</form>
		<form action="index.php?option=com_ajax&amp;format=raw" method="post" name="adminForm" id="fw-facebook-images-form-import">
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_FOLDER'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<?php echo HTMLHelper::_('select.genericlist', (array)$fb_galleries, 'facebook_gallery_id', 'class="fwk-select"', 'id', 'name'); ?>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_FOLDER_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_CATEGORY'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'gallery_id', 0, 'class="fwk-select"', false, fwgHelper::jtext('FWMG_ADMIN_PLGIMPORT_FB_CATEGORY_NEW')); ?>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_FB_CATEGORY_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-alert fwk-alert-warning fwk-text-center" id="fwgallery-facebookimages-step-import-notice" style="display:none;">
				<?php echo fwgHelper::jtext('FWGPF_PLEASE_WAIT_WHILE_YOUR_PHOTOS'); ?>.
				<div class="fwk-margin-small-top" id="fwgallery-facebookimages-step-import-1"></div>
			</div>
			<div class="fwk-text-right">
				<button type="button" class="fwk-button fwk-button-primary" name="import_button"><span fwk-icon="import" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWGPF_IMPORT'); ?></button>
				<button type="button" class="fwk-button fwk-button-danger ml-4" name="stop_button" style="display:none;"><?php echo fwgHelper::jtext('FWGPF_STOP'); ?></button>
			</div>
			<input type="hidden" name="group" value="fwgallery" />
			<input type="hidden" name="plugin" value="import" />
			<input type="hidden" name="step" value="1" />
			<input type="hidden" name="number" value="0" />
			<input type="hidden" name="stop" value="0" />
			<input type="hidden" name="subtask" value="fb_import" />
		</form>
<?php
}
?>
	</div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
<?php
if (empty($fb_user['id'])) {
?>
	var $sys_msg = $('#system-message-container');
	if (!$sys_msg.length) {
		$sys_msg = $('<div/>', {
			id: 'system-message-container'
		});
		$('form:has("#fwmg-fb-import-button")').before($sys_msg);
	}
	$('#fwmg-fb-import-button').click(function() {
		var form = this.form;
		if (document.formvalidator.isValid(form)) {
			$.ajax({
				url: '<?php echo fwgHelper::route('index.php?option=com_ajax', false) ?>',
				dataType: 'json',
				data: {
					format: 'json',
					group: 'fwgallery',
					plugin: 'import',
					subtask: 'fb_get_login_link',
					app_id: form.app_id.value,
					app_secret: form.app_secret.value,
					link: '<?php echo $redirect_uri; ?>',
					is_site: 1
				}
			}).done(function(data) {
				if (data.data && data.data[0] && data.data[0].result) {
					location = data.data[0].result;
				}
			});
		}
	});
<?php
} else {
?>
	var $form_logout = $('#fw-facebook-logout');
	if ($form_logout.length) {
		$('button[name="logout_button"]', $form_logout).click(function() {
            $.ajax({
                'url': $form_logout.attr('action'),
                'method': 'post',
                'dataType': 'script',
                'data': $form_logout.serialize()+'&is_site=1'
            });
		});
	}
	var $form_import = $('#fw-facebook-images-form-import');
	$('button[name="stop_button"]', $form_import).click(function() {
        this.form.stop.value = 1;
    });
	$('button[name="import_button"]', $form_import).click(function() {
        var msg = '<?php echo fwgHelper::jtext('FWGPF_ARE_YOU_SURE_YOU_WANT_TO_IMPORT', true); ?> ';
        msg += this.form.facebook_gallery_id.options[this.form.facebook_gallery_id.selectedIndex].text;
        msg += ' <?php echo fwgHelper::jtext('FWGPF_ALBUM_FROM_FACEBOOK_TO', true); ?> ';
        if (this.form.gallery_id.selectedIndex > 0) msg += this.form.gallery_id.options[this.form.gallery_id.selectedIndex].text;
        else msg += this.form.facebook_gallery_id.options[this.form.facebook_gallery_id.selectedIndex].text;
		if (confirm(msg+' <?php echo fwgHelper::jtext('FWGPF_GALLERY'); ?>?')) {
            $('#fwgallery-facebookimages-step-import-notice').css('display', '');
			$('#fwgallery-facebookimages-step-import-1').html(' - <div fwk-spinner></div>');
            $(this.form.stop_button).css('display', '');
			$(this.form.import_button).attr('disabled', true);
			this.form.step.value = 1;
			this.form.stop.value = 0;
            $.ajax({
                'url': $form_import.attr('action'),
                'method': 'post',
                'dataType': 'script',
                'data': $form_import.serialize()+'&is_site=1'
            });
		}
	});
<?php
}
?>
	})(jQuery);
});
</script>
<?php
/* google */
$goo_user = $displayData['goo_user'];
$goo_link = $displayData['goo_link'];
$goo_galleries = $displayData['goo_galleries'];
$goo_errors = $displayData['goo_errors'];
?>
<div class="fwk-card fwk-card-default fwk-card-grey">
	<div class="fwk-card-header">
		<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE'); ?><span fwk-icon="google" class="fwk-margin-left"></span></div>
		<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_HINT'); ?></div>
	</div>
	<div class="fwk-card-body" fwk-margin>
		<?php if ($goo_errors) { ?><div class="fwk-alert fwk-alert-warning"><?php echo implode('<br />', $goo_errors); ?></div><?php } ?>
<?php
if (empty($goo_user['id'])) {
?>
		<form class="form-validate">
			<div class="fwk-alert fwk-alert-info">
				<div class="font-weight-bold fwk-margin-small-bottom"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENT'); ?></div>
				<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENT_HINT'); ?>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENTID'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-pi-app-id" class="fwk-input required" name="app_id" autocomplete="off" />
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENTID_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENTSECRET'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-pi-app-secret" class="fwk-input required" name="app_secret" autocomplete="off" />
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENTSECRET_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENTURI'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-in-app-uri" class="fwk-input" disabled="disabled" value="<?php echo $redirect_uri; ?>" />
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CLIENTURI_HINT')); ?>"></span>
				</div>
			</div>
			<button type="button" id="fwmg-pi-import-button" class="fwk-button fwk-button-success">
				<?php echo fwgHelper::jtext('FWGPI_PICASA_LOGIN'); ?>
			</button>
		</form>
<?php
} else {
?>
		<form action="index.php?option=com_ajax" method="post" name="logoutForm" id="fw-picasa-logout">
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_ACCOUNT'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<div>
						<strong><?php echo $goo_user['name']; ?></strong>
						<button type="button" class="fwk-button fwk-margin-left" name="logout_button"><?php echo fwgHelper::jtext('FWGPI_LOG_OUT'); ?></button>
					</div>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_ACCOUNT_HINT')); ?>"></span>
				</div>
			</div>
			<input type="hidden" name="plugin" value="import" />
			<input type="hidden" name="subtask" value="goo_logout" />
			<input type="hidden" name="format" value="raw" />
			<input type="hidden" name="group" value="fwgallery" />
		</form>

		<form action="index.php?option=com_ajax" method="post" name="adminForm" id="fw-picasa-images-form-import">
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_FOLDER'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<?php echo HTMLHelper::_('select.genericlist', (array)$goo_galleries, 'picasa_gallery_id', 'class="fwk-select"', 'id', 'name'); ?>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_FOLDER_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CATEGORY'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'gallery_id', 0, 'class="fwk-select"', false, fwgHelper::jtext('FWMG_ADMIN_PLGIMPORT_GOOGLE_CATEGORY_NEW')); ?>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_GOOGLE_CATEGORY_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-alert fwk-alert-warning fwk-text-center" id="fwgallery-picasaimport-step-import-notice" style="display:none;">
				<?php echo fwgHelper::jtext('FWGPI_PLEASE_WAIT_WHILE_YOUR_PHOTOS'); ?>.
				<div class="fwk-margin-small-top" id="fwgallery-picasaimport-step-import-1"></div>
			</div>
			<div class="fwk-text-right">
				<button type="button" class="fwk-button fwk-button-primary" name="import_button"><span fwk-icon="import" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWGPI_IMPORT'); ?></button>
				<button type="button" class="fwk-button fwk-button-danger ml-4" name="stop_button" style="display:none;"><?php echo fwgHelper::jtext('FWGPI_STOP'); ?></button>
			</div>
			<input type="hidden" name="plugin" value="import" />
			<input type="hidden" name="step" value="1" />
			<input type="hidden" name="group" value="fwgallery" />
			<input type="hidden" name="number" value="0" />
			<input type="hidden" name="stop" value="0" />
			<input type="hidden" name="format" value="raw" />
			<input type="hidden" name="subtask" value="goo_import" />
			<div style="clear:all"></div>
		</form>
<?php
}
?>
	</div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
<?php
if (empty($goo_user['id'])) {
?>
	var $sys_msg = $('#system-message-container');
	if (!$sys_msg.length) {
		$sys_msg = $('<div/>', {
			id: 'system-message-container'
		});
		$('form:has("#fwmg-pi-import-button")').before($sys_msg);
	}
	$('#fwmg-pi-import-button').click(function() {
		var form = this.form;
		if (document.formvalidator.isValid(form)) {
			$.ajax({
				url: '<?php echo fwgHelper::route('index.php?option=com_ajax', false) ?>',
				dataType: 'json',
				data: {
					format: 'json',
					group: 'fwgallery',
					plugin: 'import',
					subtask: 'goo_get_login_link',
					app_id: form.app_id.value,
					app_secret: form.app_secret.value,
					link: '<?php echo $redirect_uri; ?>',
					is_site: 1
				}
			}).done(function(data) {
				if (data.data && data.data[0] && data.data[0].result) {
					location = data.data[0].result;
				}
			});
		}
	});
<?php
} else {
?>
	var $form_logout = $('#fw-picasa-logout');
	if ($form_logout.length) {
		$('button[name="logout_button"]', $form_logout).click(function() {
            $.ajax({
                'url': $form_logout.attr('action'),
                'method': 'post',
                'dataType': 'script',
                'data': $form_logout.serialize()+'&is_site=1'
            });
		});
	}
	var $form_import = $('#fw-picasa-images-form-import');
	$('button[name="stop_button"]', $form_import).click(function() {
        this.form.stop.value = 1;
    });
	$('button[name="import_button"]', $form_import).click(function() {
        var msg = '<?php echo fwgHelper::jtext('FWGPI_ARE_YOU_SURE_YOU_WANT_TO_IMPORT', true); ?> ';
        msg += this.form.picasa_gallery_id.options[this.form.picasa_gallery_id.selectedIndex].text;
        msg += ' <?php echo fwgHelper::jtext('FWGPI_ALBUM_FROM_picasa_TO', true); ?> ';
        if (this.form.gallery_id.selectedIndex > 0) msg += this.form.gallery_id.options[this.form.gallery_id.selectedIndex].text;
        else msg += this.form.picasa_gallery_id.options[this.form.picasa_gallery_id.selectedIndex].text;
		if (confirm(msg+' <?php echo fwgHelper::jtext('FWGPI_GALLERY'); ?>?')) {
            $('#fwgallery-picasaimport-step-import-notice').css('display', '');
			$('#fwgallery-picasaimport-step-import-1').html(' - <div fwk-spinner></div>');
            $(this.form.stop_button).css('display', '');
			$(this.form.import_button).attr('disabled', true);
			this.form.step.value = 1;
			this.form.stop.value = 0;
            $.ajax({
                'url': $form_import.attr('action'),
                'method': 'post',
                'dataType': 'script',
                'data': $form_import.serialize()+'&is_site=1'
            });
		}
	});
<?php
}
?>
	})(jQuery);
});
</script>
<?php
/* instagram */
$in_user = $displayData['in_user'];
$in_link = $displayData['in_link'];
$in_errors = $displayData['in_errors'];
?>
<div class="fwk-card fwk-card-default fwk-card-grey">
	<div class="fwk-card-header">
		<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM'); ?><span fwk-icon="instagram" class="fwk-margin-left"></span></div>
		<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_HINT'); ?></div>
	</div>
	<div class="fwk-card-body" fwk-margin>
		<?php if ($in_errors) { ?><div class="fwk-alert fwk-alert-warning"><?php echo implode('<br />', $in_errors); ?></div><?php } ?>
<?php
if (empty($in_user['id'])) {
?>
		<form class="form-validate">
			<div class="fwk-alert fwk-alert-info">
				<div class="font-weight-bold fwk-margin-small-bottom"><?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_APP'); ?></div>
				<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_APP_HINT'); ?>
			</div>
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWGPI_INSTAGRAM_ACCESS_TOKEN'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<input type="text" id="fwmg-in-app-token" class="fwk-input required" name="access_token" autocomplete="off" />
				</div>
			</div>
			<button type="button" id="fwmg-in-import-button" class="fwk-button fwk-button-success">
				<?php echo fwgHelper::jtext('FWGPI_INSTAGRAM_STORE_TOKEN'); ?>
			</button>
		</form>
<?php
} else {
?>
		<form action="index.php?option=com_ajax" method="post" name="logoutForm" id="fw-instagram-logout">
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_ACCOUNT'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<div>
						<strong><?php echo $in_user['username']; ?></strong>
						<button type="button" class="fwk-button fwk-margin-left" name="logout_button"><?php echo fwgHelper::jtext('FWGPI_LOG_OUT'); ?></button>
					</div>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_ACCOUNT_HINT')); ?>"></span>
				</div>
			</div>
			<input type="hidden" name="plugin" value="import" />
			<input type="hidden" name="subtask" value="in_logout" />
			<input type="hidden" name="group" value="fwgallery" />
			<input type="hidden" name="format" value="raw" />
		</form>
		<form action="index.php?option=com_ajax" method="post" name="adminForm" id="fw-instagram-images-form-import">
			<div class="fwk-flex">
				<div class="fwk-width-2-5@s">
					<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_CATEGORY'); ?>
				</div>
				<div class="fwk-width-3-5@s fwk-flex">
					<?php echo HTMLHelper::_('fwsgCategory.getCategories', 'gallery_id', 0, 'class="fwk-select"', false); ?>
					<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_PLGIMPORT_INSTAGRAM_CATEGORY_HINT')); ?>"></span>
				</div>
			</div>
			<div class="fwk-alert fwk-alert-warning fwk-text-center" id="fwgallery-instagramimport-step-import-notice" style="display:none;">
				<?php echo fwgHelper::jtext('FWGPI_PLEASE_WAIT_WHILE_YOUR_PHOTOS'); ?>.
				<div class="my-1" id="fwgallery-instagramimport-step-import-1"></div>
			</div>
			<div class="fwk-text-right">
				<button type="button" class="fwk-button fwk-button-primary" name="import_button"><span fwk-icon="import" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWGPI_INSTAGRAM_IMPORT'); ?></button>
				<button type="button" class="fwk-button fwk-button-danger ml-4" name="stop_button" style="display:none;"><?php echo fwgHelper::jtext('FWGPI_STOP'); ?></button>
			</div>
			<input type="hidden" name="plugin" value="import" />
			<input type="hidden" name="step" value="1" />
			<input type="hidden" name="subtask" value="in_import" />
			<input type="hidden" name="number" value="0" />
			<input type="hidden" name="stop" value="0" />
			<input type="hidden" name="group" value="fwgallery" />
			<input type="hidden" name="format" value="raw" />
		</form>
<?php
}
?>
	</div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
<?php
if (empty($in_user['id'])) {
?>
	var $in_sys_msg = $('#in-message-container');
	if (!$in_sys_msg.length) {
		$in_sys_msg = $('<div/>', {
			id: 'in-message-container',
			class: 'alert alert-error',
			style: 'display:none;'
		});
		$('form:has("#fwmg-in-import-button")').before($in_sys_msg);
	}
	$('#fwmg-in-import-button').click(function() {
		var form = this.form;
		if (document.formvalidator.isValid(form)) {
			$.ajax({
				url: '<?php echo fwgHelper::route('index.php?option=com_ajax', false) ?>',
				dataType: 'json',
				data: {
					format: 'json',
					group: 'fwgallery',
					plugin: 'import',
					subtask: 'in_store_token',
					access_token: form.access_token.value,
					is_site: 1
				}
			}).done(function(data) {
				if (data.data && data.data[0]) {
					if (data.data[0].result) {
						location.reload();
					}
					if (data.data[0].msg) {
						$in_sys_msg.html(data.data[0].msg).show(300);
						setTimeout(function() {
							$in_sys_msg.hide(300);
						}, 3000);
					}
				}
			});
		}
	});
<?php
} else {
?>
	var $form_logout = $('#fw-instagram-logout');
	if ($form_logout.length) {
		$('button[name="logout_button"]', $form_logout).click(function() {
            $.ajax({
                'url': $form_logout.attr('action'),
                'method': 'post',
                'dataType': 'script',
                'data': $form_logout.serialize()+'&is_site=1'
            });
		});
	}
	var $form_import = $('#fw-instagram-images-form-import');
	$('button[name="stop_button"]', $form_import).click(function() {
        this.form.stop.value = 1;
    });
	$('button[name="import_button"]', $form_import).click(function() {
        var msg = '<?php echo fwgHelper::jtext('FWGPI_ARE_YOU_SURE_YOU_WANT_TO_IMPORT', true); ?> ';
        msg += ' <?php echo fwgHelper::jtext('FWGPI_ALBUM_FROM_INSTAGRAM_TO', true); ?> ';
        msg += this.form.gallery_id.options[this.form.gallery_id.selectedIndex].text;
		if (confirm(msg+' <?php echo fwgHelper::jtext('FWGPI_GALLERY'); ?>?')) {
            $('#fwgallery-instagramimport-step-import-notice').css('display', '');
			$('#fwgallery-instagramimport-step-import-1').html(' - <div fwk-spinner></div>');
            $(this.form.stop_button).css('display', '');
			$(this.form.import_button).attr('disabled', true);
			this.form.step.value = 1;
			this.form.stop.value = 0;
            $.ajax({
                'url': $form_import.attr('action'),
                'method': 'post',
                'dataType': 'script',
                'data': $form_import.serialize()+'&is_site=1'
            });
		}
	});
<?php
}
?>
	})(jQuery);
});
</script>

