<?php
/**
 * FW Gallery Slideshow Layout Plugin 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Filter\OutputFilter;

$view = $displayData['view'];

$id = rand();
$show_big_image = $view->params->get('slideshow_show_big_image', '1');
$position = $view->params->get('slideshow_position', 'bottom');
$is_horizontal = in_array($position, array('top', 'bottom'))?1:0;
$prev_btn = $is_horizontal?'left':'up';
$next_btn = $is_horizontal?'right':'down';

$image_sizing = $view->params->get('slideshow_sizing');
if ($image_sizing != 'fit') {
	$image_sizing = 'fill';
}
$pause = $view->params->get('slideshow_pause', 5);
if (!$pause) {
	$pause = 5;
}
$pause *= 1000;

$big_image_height = $view->params->get('slideshow_height', 800);
if (!$big_image_height) $big_image_height = 800;
$small_image_width = $small_image_height = $view->params->get('slideshow_thumb', 80);
if (!$small_image_width) {
	$small_image_width = $small_image_height = 80;
}
$small_image_size = 'th';
$big_image_size='';
$items = array();

if ($view->params->get('slideshow_subcategoryfiles', 'add') == 'show' and $view->params->get('slideshow_show_subcategories', 1) and !empty($view->subcategories)) {
    echo fwgHelper::loadTemplate('listing.categories', $displayData);
}
?>
<style type="text/css">
<?php
if ($position != 'none') {
	$img_style = ($position == 'top' or $position == 'bottom')?'height':'width';
?>
#mod-fwmg-slideshow-<?php echo $id; ?> .mod-fwmg-slideshow-thumb-img {
	<?php echo $img_style; ?>:<?php echo $small_image_width + 10; ?>px;
}
<?php
}
?>
@media screen and (max-width: 991px) {
	#mod-fwmg-slideshow-<?php echo $id; ?>,
	#mod-fwmg-slideshow-<?php echo $id; ?> .mod-fwmg-slideshow-big-wrapper {
		height: <?php echo ($buff=$view->params->get('slideshow_height_large', 600))?$buff:600; ?>px!important;
	}
}
@media screen and (max-width: 767px) {
	#mod-fwmg-slideshow-<?php echo $id; ?>,
	#mod-fwmg-slideshow-<?php echo $id; ?> .mod-fwmg-slideshow-big-wrapper {
		height: <?php echo ($buff=$view->params->get('slideshow_height_medium', 400))?$buff:400; ?>px!important;
	}
}
@media screen and (max-width: 575px) {
	#mod-fwmg-slideshow-<?php echo $id; ?>,
	#mod-fwmg-slideshow-<?php echo $id; ?> .mod-fwmg-slideshow-big-wrapper {
		height: <?php echo ($buff=$view->params->get('slideshow_height_small', 250))?$buff:250; ?>px!important;
	}
}
</style>
<div id="fwg">
	<div id="mod-fwmg-slideshow-<?php echo $id; ?>" class="mod-fwmg-slideshow thumbnail-position-<?php echo $position; ?>" style="height:<?php echo $big_image_height; ?>px;">
<?php
$active_num = 0;
if ($view->files) {
	foreach ($view->files as $i=>$row) {
		if (!empty($view->active_item_id) and $view->active_item_id == $row->id) {
			$active_num = $i;
		}

		$view->item = $row;
		$view->link = fwgHelper::route('index.php?option=com_fwgallery&view=item&id='.$row->id.':'.OutputFilter::stringURLSafe($row->name).'&files_order='.$view->files_order.((!empty($view->subcategory_id) and $view->subcategory_id != $row->category_id)?('&cid='.$view->subcategory_id):''));
		$item = array(
			'id' => $row->id,
			'name' => $row->name,
			'link' => $view->link
		);
		if ($show_big_image) {
			$item['html'] = preg_replace('#\s+#', ' ', fwgHelper::loadTemplate('site.slideshowview.big_item', array(
				'view'=>$view,
				'image_sizing'=>$image_sizing,
				'big_image_height'=>$big_image_height
			), FWMG_PLUGINS_PATH.'slideshowview/layouts'));
		}
		if ($position != 'none') {
			$item['thumb'] = fwgHelper::route('index.php?option=com_fwgallery&view=item&layout=img&format=raw&h='.$small_image_height.'&id='.$row->id.':'.OutputFilter::stringURLSafe($row->name));
		}
		$items[] = $item;
	}
}
if ($show_big_image) {
?>
        <div class="mod-fwmg-slideshow-big-wrapper fwmg-slideshow-image-<?php echo $image_sizing; ?>">
<?php
	if ($items) {
?>
			<div class="mod-fwmg-slideshow-big-image" style="height:100%;opacity:0;"></div>
		    <div class="mod-fwmg-slideshow-big-image active" style="height:100%;">
<?php
		echo $items[$active_num]['html'];
?>
		    </div>
<?php
	}
?>
        </div>
		<div class="mod-fwmg-slideshow-big-move-prev"><span fwk-icon="chevron-left"></span></div>
		<div class="mod-fwmg-slideshow-big-move-next"><span fwk-icon="chevron-right"></span></div>
<?php
}
if ($position != 'none') {
?>
		<div class="mod-fwmg-slideshow-thumb-wrpper">
			<div class="mod-fwmg-slideshow-thumb-move-prev"><span <?php if ($is_horizontal) { ?>class="fwk-position-center" <?php } ?>fwk-icon="chevron-<?php echo $prev_btn; ?>"></span></div>
			<div class="mod-fwmg-slideshow-thumb-film">
			</div>
			<div class="mod-fwmg-slideshow-thumb-move-next"><span <?php if ($is_horizontal) { ?>class="fwk-position-center" <?php } ?>fwk-icon="chevron-<?php echo $next_btn; ?>"></span></div>
		</div>
<?php
}	
?>
		<div class="mod-fwmg-slideshow-bar-timer"></div>
<?php
if ($show_big_image) {
?>
		<div class="mod-fwmg-slideshow-controls">
			<button type="button" class="fwmg-expand" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_SLIDESHOWVIEWPLG_SITE_BTN_FULLSCREEN'); ?>"><span fwk-icon="expand"></span></button>
			<button type="button" class="fwmg-fit-fill" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_SLIDESHOWVIEWPLG_SITE_BTN_FIT'); ?>"><span fwk-icon="arrows-h"></span></button>
			<button type="button" class="fwmg-bg-color" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_SLIDESHOWVIEWPLG_SITE_BTN_BACKGROUND'); ?>"><span fwk-icon="send-backward"></span></button>
			<button type="button" class="fwmg-descr active" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_SLIDESHOWVIEWPLG_SITE_BTN_INFO'); ?>"><span fwk-icon="info-circle"></span></button>
			<button type="button" class="fwmg-thumbs active" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_SLIDESHOWVIEWPLG_SITE_BTN_THUMBS'); ?>"><span fwk-icon="th"></span></button>
			<button type="button" class="fwmg-play-stop" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_SLIDESHOWVIEWPLG_SITE_BTN_PLAY'); ?>"><span fwk-icon="play"></span></button>
		</div>
<?php
}
?>
	</div>
</div>
<script>
<?php
if (!empty($view->is_html)) {
?>
document.addEventListener('DOMContentLoaded', function() {
<?php
} else {
?>
setTimeout(function()  {
<?php
}
?>
	(function($) {
		var fwgs<?php echo $id; ?> = new fwmg_slideshow($('#mod-fwmg-slideshow-<?php echo $id; ?>'), {
			slideshow: {
				pause: <?php echo $pause; ?>,
				is_autostart: <?php echo (int)$view->params->get('slideshow_autostart', '1'); ?>
			},
			nav: {
				is_enabled: <?php echo ($position == 'none')?0:1; ?>,
				is_horizontal: <?php echo $is_horizontal; ?>,
				is_buttons: <?php echo ($view->params->get('slideshow_navigation', 'buttons') == 'buttons')?1:0 ?>
			},
			base_url: '<?php echo Uri::root(true); ?>',
			files_order: '<?php echo $view->files_order; ?>',
			menu_id: <?php echo (int)$view->app->input->getInt('Itemid'); ?>,
			gids: [<?php echo implode(',', (array)$view->params->get('gids')); ?>],
			effect: '<?php echo $view->params->get('_slideshow_effect_', 'fade:1:1'); ?>',
			bg: '<?php echo $image_sizing; ?>',
			items: JSON.parse('<?php echo addcslashes(str_replace(array('\r', '\n', '\t', '> <', '\\"'), array('', '', '', '><', '\\\\"'), json_encode($items, JSON_INVALID_UTF8_IGNORE)), "'"); ?>'),
			limitstart: <?php echo (int)$view->filesPagination->limitstart; ?>,
			total: <?php echo (int)$view->filesPagination->total; ?>,
<?php
if (!empty($view->active_item_id)) {
?>
			active_item_id: <?php echo (int)$view->active_item_id; ?>,
<?php
}
?>
		});
		$(window).resize(function() {
			fwgs<?php echo $id; ?>.checkNav();
		});
	})(jQuery);
<?php
if (!empty($view->is_html)) {
?>
});
<?php
} else {
?>
}, 500);
<?php
}
?>
</script>
<?php

$view->files = $view->subcategories = null;