<?php
/**
 * FW Super Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Uri\Uri;

ToolbarHelper::title(fwgHelper::jtext('FWMG_FWGALLERY'));

fwgButtonsHelper::apply();
fwgButtonsHelper::save();
fwgButtonsHelper::cancel();

$view = $displayData['view'];
$row = $view->object;
$editor = fwgHelper::getEditor();

$max_size = $view->upload_max_filesize;
$post_size = $view->post_max_size;

HTMLHelper::_('behavior.core');
HTMLHelper::_('behavior.formvalidator');
HTMLHelper::_('formbehavior.chosen', 'select.select-choices');

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/jquery.datetimepicker.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/jquery.datetimepicker.full.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/jquery.maskedinput.min.js');
?>
<div class="fwcss fwk-scope">
	<div class="fwmg-management-header">
		<div class="fwmg-management-header-text">
			<?php echo $row->id?fwgHelper::sprintf('FWMG_HEADER_VIDEO_EDIT',$view->escape($row->name)):fwgHelper::jtext('FWMG_NEW_VIDEO'); ?>
		</div>
	</div>
	<div>
		<div>
			<button type="button" class="fwk-button fwk-button-primary fwk-button-success fwk-margin-right" id="fwmg-file-save" onclick="Joomla.submitbutton('save')">
				<span fwk-icon="check" fwk-tooltip="<?php echo fwgHelper::jtext('FWMG_Save'); ?>"></span>
				<?php echo fwgHelper::jtext('FWMG_Save'); ?>
			</button>
			<button type="button" class="fwk-button" onclick="Joomla.submitbutton('cancel')">
				<span fwk-icon="close" fwk-tooltip="<?php echo fwgHelper::jtext($view->object->id?'FWMG_Close':'FWMG_Cancel'); ?>"></span>
				<?php echo fwgHelper::jtext($view->object->id?'FWMG_Close':'FWMG_Cancel'); ?>
			</button>
		</div>
	</div>
	<br/>
	<form action="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=video')); ?>" id="adminForm" name="adminForm" method="post" enctype="multipart/form-data">
		<div>
			<div class="fwa-main-body">
				<div class="fwa-mb-cardbox">

						<!-- Video -->
						<div class="fwk-card fwk-card-default fwk-card-grey">
							<div class="fwk-card-header">
								<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_VIDEO'); ?></div>
								<div class="fwk-text-muted"><?php echo fwgHelper::jtext('FWMG_MAX_FILE_SIZE'); ?>: <?php echo fwgHelper::humanFileSize($max_size); ?>, <?php echo fwgHelper::jtext('FWMG_POST_SIZE_LIMIT'); ?>: <?php echo fwgHelper::humanFileSize($post_size); ?></div>
							</div>
							<div class="fwk-card-body" fwk-margin>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_TYPE'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'media', empty($row->_video_media)?'youtube':$row->_video_media, array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
												'active_class' => 'fwk-button-success',
												'title' => fwgHelper::jtext('FWMG_SELF_HOSTED'),
												'value' => 'mp4'
											), array(
												'active_class' => 'fwk-button-success',
												'title' => 'YouTube',
												'value' => 'youtube'
											), array(
												'active_class' => 'fwk-button-success',
												'title' => 'Vimeo',
												'value' => 'vimeo'
											))
										)); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_VIDEO_TYPE_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwmg-remote-video" fwk-grid>
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_VIDEO_ID'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input class="fwk-input" type="text" name="remote_code" value="<?php if (@$row->_video_media != 'mp4') echo $view->escape(@$row->_video_code); ?>" />
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_VIDEO_ID_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwmg-local-video" fwk-grid>
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_VIDEO_FILE'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex" id="fwmg-video-container">
										<div>
											<div class="fwk-margin-bottom">
<?php
$video_exists = plgFwGalleryTypeVideo::isVideoExists($row);
if ($video_exists) {
?>
												<strong><?php echo $row->_video_filename; ?></strong> <span><?php echo fwgHelper::humanFileSize($row->_video_size); ?></span>
<?php
} else {
?>
												<strong></strong> <span></span>
<?php
}
?>
												<button type="button" class="fwk-button fwk-button-danger"<?php if (!$video_exists) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWMG_REMOVE'); ?></button>
												<?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
													'url' => fwgHelper::route('index.php?option=com_ajax', false),
													'button' => '#fwmg-video-container .fwk-button-danger',
													'image' => '#fwmg-video-container img',
													'layout' => 'delete',
													'post_data' => array(
														'group' => 'fwgallerytype',
														'plugin' => 'video'
													),
													'callback' => 'function(data) {
	$img.remove();
	$button.attr(\'disabled\', false);

	if (data && data.data && data.data[0]) {
		data = data.data[0];
		if (data.result) {
			$(\'#fwmg-video-container .fwk-margin-bottom\').find(\'span,strong\').html(\'\');
			$button.attr(\'hidden\', true);
		}
		if (data.msg) fwmg_alert(data.msg);
	}
}'
												)); ?>
											</div>
											<div class="fwk-flex">
												<div class="fwk-width-expand" fwk-form-custom>
													<input type="file" id="fwmg-video" name="file" />
													<input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo fwgHelper::jtext('FWMG_CHOOSE_FILE'); ?>" disabled="">
												</div>
												<div class="fwk-width-auto">
													<button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo fwgHelper::jtext('FWMG_UPLOAD'); ?></button>
												</div>
											</div>
											<div class="text-muted"><small><?php echo fwgHelper::sprintf('FWMG_MAX_VIDEO_SIZE_LONG', ini_get('post_max_size')); ?></small></div>
											<?php echo HTMLHelper::_('fwView.handleUploadButton', array(
												'url' => fwgHelper::route('index.php?option=com_ajax', false),
												'button' => '#fwmg-video-container .fwmg-upload',
												'input' => '#fwmg-video',
												'image' => '#fwmg-video-container img',
												'exts' => array('mp4'),
												'post_data' => array(
													'group' => 'fwgallerytype',
													'plugin' => 'video'
												),
												'layout' => 'upload',
												'callback' => 'function(data) {
	$progress_bar.remove();
	$button.attr(\'disabled\', false);

	var $parent = $input.parent();
	$parent.next().html(\''.fwgHelper::jtext('FWMG_CHOOSE_FILE', false).'\');

	var input_html = $parent.html();
	$parent.html(input_html);

	if (data && data.data && data.data[0]) {
		data = data.data[0];
		if (data.result) {
			if (data.result.id) {
				$(\'input[name="oid"]\').val(data.result.id);
			}
			if (data.result.filename) {
				$(\'#fwmg-video-container strong:eq(0)\').html(data.result.filename);
				$(\'#fwmg-video-container .fwk-button-danger\').attr(\'hidden\', false);
			}
			if (data.result.video_size) {
				$(\'#fwmg-video-container span:eq(0)\').html(data.result.video_size);
			}
		}

		if (data.msg) {
			var $msg = $(\'<div class="fwk-alert fwk-alert-warning alert-dismissible fade show">\
<button type="button" class="close" data-dismiss="alert" aria-label="Close">\
<span aria-hidden="true">&times;</span>\
</button>\
\'+data.msg+\'</div>\');
			$button.before($msg);
			$(\'button\', $msg).click(function() {
				$msg.remove();
			});
			setTimeout(function() {
				$msg.remove();
			}, 3000);
		}
	}
}'
											)); ?>
										</div>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_VIDEO_FILE_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_VIDEO_PREVIEW'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex" id="fwmg-image-container">
										<div>
											<div class="fwk-margin-bottom">
												<img src="<?php echo Uri::root(true); ?>/index.php?option=com_fwgallery&amp;view=item&amp;layout=img&amp;format=raw&amp;w=491&amp;h=300&amp;id=<?php echo $row->id; ?>&amp;rand=<?php echo rand(); ?>" />
												<button type="button" class="fwk-button fwk-button-default fwk-button-danger fwmg-remove"<?php if (!$view->object->_sys_filename) { ?> hidden<?php } ?>><span fwk-icon="trash" class="fwk-margin-right"></span><?php echo fwgHelper::jtext('FWMG_REMOVE'); ?></button>
												<?php echo HTMLHelper::_('fwView.handleRemoveButton', array(
													'url' => fwgHelper::route('index.php?option=com_ajax', false),
													'button' => '#fwmg-image-container .fwmg-remove',
													'image' => '#fwmg-image-container img',
													'post_data' => array(
														'group' => 'fwgallery',
														'plugin' => 'admin'
													),
													'layout' => 'image_delete'
												)); ?>
											</div>
											<div class="fwk-flex">
												<div class="fwk-width-expand" fwk-form-custom>
													<input type="file" id="fwmg-image" name="image" />
													<input class="fwk-input fwk-width-expand fwk-height-1-1" type="text" placeholder="<?php echo fwgHelper::jtext('FWMG_CHOOSE_FILE'); ?>" disabled="">
												</div>
												<div class="fwk-width-auto">
													<button type="button" class="fwk-button fwk-button-primary fwmg-upload"><?php echo fwgHelper::jtext('FWMG_UPLOAD'); ?></button>
												</div>
											</div>
											<div class="text-muted"><small><?php echo fwgHelper::sprintf('FWMG_MAX_IMAGE_SIZE_LONG', ini_get('post_max_size')); ?></small></div>
											<?php echo HTMLHelper::_('fwView.handleUploadButton', array(
												'url' => fwgHelper::route('index.php?option=com_ajax', false),
												'button' => '#fwmg-image-container .fwmg-upload',
												'remove_button' => '#fwmg-image-container .fwmg-remove',
												'input' => '#fwmg-image',
												'image' => '#fwmg-image-container img',
												'exts' => array('gif', 'jpg', 'jpeg', 'png'),
												'post_data' => array(
													'group' => 'fwgallery',
													'plugin' => 'admin'
												),
												'layout' => 'image_upload'
											)); ?>
										</div>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_VIDEO_PREVIEW_DESCR')); ?>"></span>
									</div>
								</div>
							</div>
						</div>

						<!-- Genral -->
						<div class="fwk-card fwk-card-default fwk-card-grey">
							<div class="fwk-card-header">
								<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_GENERAL_SETTINGS'); ?></div>
							</div>
							<div class="fwk-card-body" fwk-margin>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_NAME'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input class="fwk-input" name="name" value="<?php echo $view->escape($row->name); ?>" type="text">
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_NAME_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_PUBLISHED'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('fwView.radioGroup', 'published', $row->id?$row->published:1, array(
											'wrapper_class' => 'fwk-width-expand',
											'buttons' => array(array(
												'active_class' => 'fwk-button-success',
												'title' => fwgHelper::jtext('JYES'),
												'value' => 1
											), array(
												'active_class' => 'fwk-button-danger',
												'title' => fwgHelper::jtext('JNO'),
												'value' => 0
											))
										)); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_PUBLISHED_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_GALLERY'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('select.genericlist', $view->categories, 'category_id', 'class="fwk-select"', 'id', 'name', $view->object->category_id?$view->object->category_id:$view->category); ?>&nbsp;&nbsp;&nbsp;
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_GALLERY_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_COPYRIGHT'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<textarea class="fwk-textarea" name="copyright" rows="2"><?php echo $view->escape($view->object->copyright); ?></textarea>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DOC_ADMIN_FILEEDIT_SECTION_GENERAL_COPYRIGHT_HINT')); ?>"></span>
									</div>
								</div>

<?php
		$view->app->triggerEvent('onshowFileEditExtraFields', array('com_fwgallery', $row));
?>

								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_UPLOAD_DATE'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<div class="fwk-group-date">
											<input class="fwk-input" type="text" name="created" value="<?php echo substr($row->created, 0, 16); ?>">
											<button class="fwk-button" type="button"><span fwk-icon="calendar"></span></button>
										</div>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_UPLOAD_DATE_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_ACCESS'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<?php echo HTMLHelper::_('select.genericlist', fwgHelper::loadviewlevels(), 'access', 'class="fwk-select"', 'id', 'name', $row->access); ?>
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_ACCESS_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
							</div>
						</div>
						<div class="fwk-card fwk-card-default fwk-card-grey">
							<div class="fwk-card-header">
								<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_SIZE_AND_DURATION'); ?></div>
							</div>
							<div class="fwk-card-body" fwk-margin>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_WIDTH'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input class="fwk-input" name="width" value="<?php echo $view->escape(@$row->_video_width); ?>" type="text">
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_WIDTH_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_HEIGHT'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input class="fwk-input" name="height" value="<?php echo $view->escape(@$row->_video_height); ?>" type="text">
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_HEIGHT_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
								<div class="fwk-flex">
									<div class="fwk-width-2-5@s">
										<?php echo fwgHelper::jtext('FWMG_DURATION'); ?>
									</div>
									<div class="fwk-width-3-5@s fwk-flex">
										<input class="fwk-input" type="text" name="duration" value="<?php echo @$row->_video_duration; ?>">
										<span fwk-icon="info" class="fwk-margin-left" fwk-tooltip="<?php echo $view->escape(fwgHelper::jtext('FWMG_DURATION_VIDEO_DESCR')); ?>"></span>
									</div>
								</div>
							</div>
						</div>

						<!-- Descripton -->
						<div class="fwk-card fwk-card-default fwk-card-grey">
							<div class="fwk-card-header">
								<div class="fwk-card-title"><?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?></div>
							</div>
							<div class="fwk-card-body" fwk-margin>
								<?php echo $editor->display('descr', $row->descr, '100%', 200, 60, 7); ?>
							</div>
						</div>
<?php
		$view->app->triggerEvent('onshowFileEditExtraCards', array('com_fwgallery', $row));
?>

				</div>
			</div>
		</div>
		<input type="hidden" name="oid" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="type" value="video" />
<?php
foreach ($view->fields as $field) {
	if ($view->$field) {
?>
		<input type="hidden" name="<?php echo $field; ?>" value="<?php echo $view->escape($view->$field); ?>" />
<?php
	}
}
?>
	</form>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    $('input[name="media"]').change(function() {
        if (this.value == 'mp4') {
            $('.fwmg-local-video').show();
            $('.fwmg-remote-video').hide();
        } else {
            $('.fwmg-local-video').hide();
            $('.fwmg-remote-video').show();
        }
    }).change();
    $('input[name="created"]').datetimepicker({
        format: 'Y-m-d H:i'
    });
    $('input[name="created"]').next().click(function() {
        $('input[name="created"]').focus();
    });
    $('input[name="duration"]').mask('99:99:99');
	Joomla.submitbutton = function(task) {
		var form = document.adminForm;
		if (task == 'cancel') {
			location = form.action;
			return;
		}
		if ((task == 'apply' || task == 'save') && !document.formvalidator.isValid(form)) {
			fwmg_alert('<?php echo fwgHelper::jtext('FWMG_NOT_ALL_REQUIRED_FIELDS_FILLED', true); ?>');
		} else {
			var $wait = $('<div fwk-spinner></div>');
			var $btn = $('#fwmg-file-save').attr('disabled', true);
			$btn.after($wait);
			var fd = new FormData(form);
			fd.append('layout', 'file_save');
			fd.append('group', 'fwgallery');
			fd.append('plugin', 'admin');
			fd.append('format', 'json');
			fd.append('task', '');
			$.ajax({
				url: '<?php echo Route::_('index.php?option=com_ajax', false); ?>',
				type: 'post',
				dataType: 'json',
				processData: false,
				contentType: false,
				data: fd
			}).done(function (data) {
				if (data.data && data.data.length) {
					data = data.data[0];
				}
				if (data.msgs) {
					for (var i = 0; i < data.msgs.length; i++) {
						fwmg_alert(data.msgs[i].msg, '', data.msgs[i].status);
					}
				}
				if (data.result && task == 'save') {
					location = form.action;
				}
			}).always(function() {
				$btn.attr('disabled', false);
				$wait.remove();
			});
		}
	}
    })(jQuery);
});
</script>
