<?php
/**
 * FW Super Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;

fwgButtonsHelper::addNew();
fwgButtonsHelper::editList();
fwgButtonsHelper::deleteList(fwgHelper::jtext('FWMG_ARE_YOU_SURE'));
fwgButtonsHelper::publish();
fwgButtonsHelper::unpublish();

HTMLHelper::_('formbehavior.chosen', 'select.select-choices');

$view = $displayData['view'];
?>
<div class="fwmg-management-header">
	<div class="fwmg-management-header-text">
		<?php echo fwgHelper::jtext('FWMG_HEADER_VIDEOS'); ?>
	</div>
</div>
<div class="mb-4">
    <a class="fwk-button fwk-button-success fwk-margin-right" href="javascript:Joomla.submitbutton('add');">
        <span fwk-tootip="<?php echo fwgHelper::jtext('FWMG_New'); ?>" fwk-icon="plus" class="fwk-margin-small-right"></span>
        <?php echo fwgHelper::jtext('FWMG_New'); ?>
    </a>
    <a class="fwk-button fwk-margin-right" href="javascript:if(document.adminForm.boxchecked.value==0){alert('<?php echo fwgHelper::jtext('FWMG_make_selection_edit', true); ?>');}else{Joomla.submitbutton('edit')}">
        <span fwk-tootip="<?php echo fwgHelper::jtext('FWMG_Edit'); ?>" fwk-icon="file-edit" class="fwk-margin-small-right"></span>
        <?php echo fwgHelper::jtext('FWMG_Edit'); ?>
    </a>
    <a class="fwk-button fwk-margin-right" href="javascript:if(document.adminForm.boxchecked.value==0){alert('<?php echo fwgHelper::jtext('FWMG_MAKE_SELECTION_PUBLISH', true); ?>');}else{Joomla.submitbutton('publish'); }">
        <span fwk-tootip="<?php echo fwgHelper::jtext('FWMG_Publish'); ?>" fwk-icon="eye" class="fwk-margin-small-right"></span>
        <?php echo fwgHelper::jtext('FWMG_Publish'); ?>
    </a>
    <a class="fwk-button fwk-margin-right" href="javascript:if(document.adminForm.boxchecked.value==0){alert('<?php echo fwgHelper::jtext('FWMG_MAKE_SELECTION_UNPUBLISH', true); ?>');}else{Joomla.submitbutton('unpublish'); }">
        <span fwk-tootip="<?php echo fwgHelper::jtext('FWMG_Unpublish'); ?>" fwk-icon="eye-slash" class="fwk-margin-small-right"></span>
        <?php echo fwgHelper::jtext('FWMG_Unpublish'); ?>
    </a>
    <a class="fwk-button fwk-button-danger" href="javascript:if(document.adminForm.boxchecked.value==0){alert('<?php echo fwgHelper::jtext('FWMG_make_selection_delete', true); ?>');}else if (confirm('<?php echo fwgHelper::jtext('FWMG_ARE_YOU_SURE', true); ?>')) {Joomla.submitbutton('remove')}">
        <span fwk-icon="close" fwk-tootip="<?php echo fwgHelper::jtext('FWMG_Delete'); ?>" class="fwk-margin-small-right"></span>
        <?php echo fwgHelper::jtext('FWMG_Delete'); ?>
    </a>
</div>
<form action="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=video')); ?>" id="adminForm" name="adminForm" method="post">
    <div class="mb-4 fwa-filter-bar fwk-child-width-1-2@m" fwk-grid>
        <div>
			<div class="fwk-position-relative">
    			<span class="fwk-form-icon fwk-text-green" fwk-icon="icon: search"></span>
                <input class="fwk-input" name="search" placeholder="<?php echo fwgHelper::jtext('FWMG_SEARCH_NAME_OR_ID'); ?>" type="text" value="<?php echo $view->escape($view->search); ?>" />
            </div>
        </div>
        <div>
            <?php echo HTMLHelper::_('select.genericlist', array_merge(array(
                HTMLHelper::_('select.option', '', fwgHelper::jtext('FWMG_Select_gallery'), 'id', 'treename')
            ), $view->categories), 'category', 'onchange="this.form.limitstart.value=0;this.form.submit();" class="fwk-select"', 'id', 'treename', $view->category); ?>
        </div>
    </div>
	<div class="table-responsive">
        <table class="fwk-table fwk-table-striped fwmg-admin-images">
            <thead>
                <tr>
                    <th><input name="toggle" class="fwk-checkbox" value="" onclick="Joomla.checkAll(this);" type="checkbox"></th>
                    <th style="width:120px;"><?php echo fwgHelper::jtext('FWMG_PREVIEW'); ?></th>
                    <th><?php echo fwgHelper::jtext('FWMG_ID'); ?> - <?php echo fwgHelper::jtext('FWMG_NAME'); ?></th>
                    <th><?php echo fwgHelper::jtext('FWMG_DESCRIPTION'); ?></th>
                    <th><?php echo fwgHelper::jtext('FWMG_ORDER'); ?> <a href="javascript:" class="fwk-icon-button" onclick="Joomla.saveorder(<?php echo (int)count($view->list)-1; ?>, 'saveorder')" fwk-icon="save"></a></th>
    				<th class="fwk-text-center"><?php echo fwgHelper::jtext('FWMG_HITS'); ?></th>
                    <th class="fwk-text-center"><?php echo fwgHelper::jtext('FWMG_PUBLISHED'); ?></th>
                </tr>
            </thead>
            <tbody>
<?php
if ($view->list) {
    $num = 0;
	$app = Factory::getApplication();
    foreach ($view->list as $row) {
?>

                <tr>
                    <td><div class="form-check"><?php echo preg_replace('#<label.*</label>#msi', '', HTMLHelper::_('grid.id', $num, $row->id )); ?></div></td>
                    <td>
                        <img class="img-thumbnail" src="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=item&layout=img&format=raw&id='.$row->id.'&w=80&h=60&rand='.rand())); ?>">
                    </td>
                    <td>
                        <a href="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=video_edit&cid[]='.$row->id.$view->extra_link)); ?>">
                            <?php echo $row->id; ?> - <?php echo $row->name; ?>
                        </a>
    					<div class="fwk-text-small"><?php if ($row->_video_media) { echo $row->_video_media; ?>: <?php } echo ($row->_video_media == 'mp4')?$row->_video_filename:$row->_video_code; ?></div>
                        <div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_OWNER'); ?>: <?php echo $row->_user_name ?></div>
                        <div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_UPLOADED'); ?>: <?php echo HTMLHelper::date($row->created, 'd M Y H:i'); ?></div>
    					<div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_ACCESS'); ?>: <?php echo $row->access?$row->_group_name:fwgHelper::jtext('FWMG_PUBLIC'); ?></div>
    					<div class="fwk-text-small"><?php echo fwgHelper::jtext('FWMG_GALLERY'); ?>: <?php echo $row->_category_name ?></div>
<?php
		$app->triggerEvent('onshowFileListExtraFields', array('com_fwgallery', $row));
?>
                    </td>
                    <td class="fwk-text-small"><?php echo fwgHelper::stripTags($row->descr, 100, true); ?></td>
                    <td class="order">
                        <?php echo HTMLHelper::_('fwView.orderingListLinks', array(
                            'num' => $num,
                            'value' => $row->ordering,
                            'display_up' => ($num > 0),
                            'display_down' => (($num + 1) < count($view->list))
                        )); ?>
                    </td>
    				<td class="fwk-text-center"><?php echo $row->hits; ?></td>
                    <td class="fwk-text-center">
                        <a title="<?php echo $view->escape(fwgHelper::jtext($row->published?'FWMG_PUBLISHED':'FWMG_UNPUBLISHED')); ?>"
							href="<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_fwgallery&view=usersection&task='.($row->published?'un':'').'publish&cid[]='.$row->id.$view->extra_link)); ?>"
							class="fwk-icon-button fwk-alert-<?php if ($row->published) { ?>success<?php } else { ?>danger<?php } ?>" fwk-icon="<?php if ($row->published) { ?>check<?php } else { ?>close<?php } ?>">
                        </a>
                    </td>
                </tr>
<?php
        $num++;
    }
} else {
?>
                <tr>
                    <td colspan="8">
<?php
    echo fwgHelper::jtext($view->search?'FWMG_NO_VIDEOS_FOUND':'FWMG_NO_VIDEOS');
?>
                    </td>
                </tr>
<?php
}
?>
            </tbody>
        </table>
	</div>

    <div class="pagination fwmg-pagination">
        <?php echo $view->getPaginationLinks($view->pagination, array('showLimitBox'=>false, 'showLimitStart'=>false)); ?>
    </div>
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="boxchecked" value="" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
        Joomla.submitbutton = function(task) {
            console.log(task);
            var form = document.adminForm;
            if (task == 'add') {
                location = '<?php echo fwgHelper::route('index.php?option=com_fwgallery&view=usersection&layout=video_edit'.$view->extra_link, false); ?>';
            } else if (task == 'edit') {
                var cid = 0;
                if (task == 'edit') {
                    $('input[name="cid[]"]').each(function() {
                        if (this.checked) {
                            cid = this.value;
                            return;
                        }
                    });
                }
                location = '<?php echo fwgHelper::route($view->extra_link.'&layout=video_edit&cid[]=', false); ?>'+cid;
            } else {
                form.task.value = task;
                form.submit();
            }
        }
        if (!$('#adminForm input[name="limitstart"]').length) {
			$('#adminForm').append($('<input type="hidden" name="limitstart">'));
		}
		$('input[name="search"]').keyup(function(ev) {
			if (ev.keyCode == 13) {
				this.form.submit();
			}
		});
		$('input[name="cid[]"]').on('click change', function() {
			var $row = $(this).closest('tr');
			if (this.checked) {
				$row.addClass('fwk-selected-row');
			} else {
				$row.removeClass('fwk-selected-row');
			}
		});
		$('input[name="toggle"]').click(function() {
			$('input[name="cid[]"]').trigger('change');
		});
    })(jQuery);
});
</script>
