<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

$row = $displayData['row'];

$average = ($row->_positive_rating_count > 0)?round($row->_rating_sum/$row->_positive_rating_count, 1):0;
?>
<div class="fwmg-rating <?php if (!empty($displayData['rating_class'])) { ?> <?php echo $displayData['rating_class']; } ?>" data-id="<?php echo $row->id; ?>" data-value="<?php echo $average; ?>"<?php if ($row->_is_user_voted) { ?> data-rating-status="voted"<?php } ?>>
<?php
for ($i = 1; $i < 6; $i++) {
    $icon = '';
    if ($i <= $average) {
        $icon = 'star-solid';
    } elseif ($i - 1 < $average) {
        $icon = 'star-half';
    } else {
        $icon = 'star-empty';
    }
?><a href="javascript:"><span fwk-icon="<?php echo $icon; ?>"></span></a><?php
}
?>
    <span><?php echo $average; ?> <?php echo fwgHelper::jtext('FWMG_OF'); ?> <?php echo $row->_positive_rating_count; ?> <?php echo fwgHelper::jtext('FWMG_VOTES') ?></span>
</div>
<?php
if (!defined('FWRE_VOTE_STARS_LOADED')) {
	define('FWRE_VOTE_STARS_LOADED', true);
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
		$(document).on('mouseenter', '.fwmg-rating a', function(ev) {
			ev.stopImmediatePropagation();
			var $el = $(this);
			var $wrapper = $el.closest('.fwmg-rating');
			if (!$wrapper.data('request')) {
				do {
					$el.find('span').attr('fwk-icon', 'star-solid');
					$el = $el.prev();
				} while ($el.length);
			}
		}).on('mouseleave', '.fwmg-rating a', function(ev) {
			ev.stopImmediatePropagation();
			var $el = $(this);
			var $wrapper = $el.closest('.fwmg-rating');
			if (!$wrapper.data('request')) {
				var val = $wrapper.data('value');
				$wrapper.find('a').each(function(index) {
					var $el = $(this);
					var fraction = val - index;
					if (fraction > 0 && fraction < 1) {
						$el.find('span').attr('fwk-icon', 'star-half');
					} else if (val <= index) {
						$el.find('span').attr('fwk-icon', 'star-empty');
					} else {
						$el.find('span').attr('fwk-icon', 'star-solid');
					}
				});
			}
		}).on('click', '.fwmg-rating a', function(ev) {
			ev.stopImmediatePropagation();
			var link = this;
			var $el = $(this);
			var $wrapper = $el.closest('.fwmg-rating');
			if (!$wrapper.data('request')) {
				var $img = $('<div class="fwk-margin-left" fwk-spinner></div>');
				$wrapper.data('request', true).append($img);
				var id = $wrapper.data('id');
				if (id) {
					var val = $('a', $wrapper).index(link) +  1;
					$.ajax({
						url: '<?php echo fwgHelper::checkLink(fwgHelper::route('index.php?option=com_ajax')); ?>',
						type: 'post',
						dataType: 'json',
						data: {
							format: 'json',
							group: 'fwgallery',
							plugin: 'vote',
							vote_layout: 'stars',
							value: val,
							id: id,
              				is_site: 1
						}
					}).done(function(data) {
						$wrapper.data('request', false);
						$img.remove();
						if (data.data && data.data[0]) {
							if (data.data[0].html) {
								$wrapper.replaceWith($(data.data[0].html));
							}
							if (data.data[0].msg) fwmg_alert(data.data[0].msg);
						}
					});
				}
			}
		});
	})(jQuery);
});
</script>
<?php
}
