<?php
/**
 * FW Gallery 4.0.0
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.com/ Official website
 **/

defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\HTML\HTMLHelper;

HTMLHelper::stylesheet('components/com_fwgallery/assets/css/lightgallery.min.css');
HTMLHelper::_('jquery.framework');
HTMLHelper::script('components/com_fwgallery/assets/js/lightgallery.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-fullscreen.min.js');
HTMLHelper::script('components/com_fwgallery/assets/js/lg-zoom.min.js');

$view = $displayData['view'];
?>
<div id="fwgallery" class="fwcss fwk-scope">
	<div class="fwmg-page-header">
    	<h2 itemprop="headline" data-title="<?php echo fwgHelper::jtext('FWMG_FRONT_END_MANAGER'); ?>"><?php echo fwgHelper::jtext('FWMG_FRONT_END_MANAGER'); ?></h2>
	</div>
	<div class="fwmg-management-body">
		<div class="fwmg-management-section">
			<?php $view->app->triggerEvent('onshowUserSection', array('com_fwgallery', $view)); ?>
		</div>
	</div>
</div>
<?php
if ($view->user->id) {
?>
<div id="fwmg-change-password" fwk-modal>
	<div class="fwk-modal-dialog">
		<div class="fwk-modal-header">
			<h5 class="fwk-modal-title"><?php echo fwgHelper::jtext('FWMG_CHANGE_PASSWORD'); ?></h5>
			<button class="fwk-modal-close-default" type="button" fwk-close></button>
		</div>
		<form>
			<div class="fwk-modal-body">
				<div class="form-group fwk-child-width-1-2@m" fwk-grid>
					<div>
						<?php echo fwgHelper::jtext('FWMG_CURRENT_PASSWORD'); ?>
					</div>
					<div>
						<input type="password" class="fwk-input" name="password" />
					</div>
				</div>
				<div class="form-group fwk-child-width-1-2" fwk-grid>
					<div>
						<?php echo fwgHelper::jtext('FWMG_NEW_PASSWORD'); ?>
					</div>
					<div>
						<input type="password" class="fwk-input" name="password1" />
					</div>
				</div>
				<div class="form-group fwk-child-width-1-2" fwk-grid>
					<div>
						<?php echo fwgHelper::jtext('FWMG_RETYPE_NEW_PASSWORD'); ?>
					</div>
					<div>
						<input type="password" class="fwk-input" name="password2" />
					</div>
				</div>
			</div>
			<div class="fwk-modal-footer">
				<button type="button" class="fwk-button fwk-button-secondary fwk-modal-close"><?php echo fwgHelper::jtext('FWMG_CLOSE'); ?></button>
				<button type="button" class="fwk-button fwk-button-primary"><?php echo fwgHelper::jtext('FWMG_CHANGE_PASSWORD'); ?></button>
			</div>
		</form>
	</div>
</div>
<script>
var fwmg_alert_default_title = '<?php echo esc_js(fwgHelper::jtext('FWMG_NOTICE')); ?>';
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$('.fwmg-management-panel-section a:has(\'[fwk-icon="lock"]\')').click(function() {
		fwkUIkit.modal('#fwmg-change-password').show();
	});
	$('#fwmg-change-password button.fwk-button-primary').click(function() {
		var form = this.form;
		var fields = ['password', 'password1', 'password2'];
		for (var i = 0; i < fields.length; i++) {
			if (form[fields[i]].value.trim() == '') {
				alert('<?php echo fwgHelper::jtext('FWMG_ALL_FIELDS_REQUIRED'); ?>');
				return;
			}
		}
		var $btn = $(this).attr('disabled', true);
		$.ajax({
			dataType: 'json',
			data: {
				format: 'json',
				view: 'usersection',
				layout: 'change_password',
				password: form.password.value,
				password1: form.password1.value,
				password2: form.password2.value,
              	is_site: 1
			}
		}).done(function(data) {
			$btn.attr('disabled', false);
			if (data.result) {
				var $popup = $('#fwmg-change-password');
				$popup.find('input').val('');
				fwkUIkit.modal($popup[0]).hide();
			}
			if (data.msg) {
				alert(data.msg);
			}
		});
	});
	})(jQuery);
});
</script>
<?php
}
